//----------------------------------------------------------------------------
//  Project Colorhls
//  
//  Copyright  1999. All Rights Reserved.
//
//  SUBSYSTEM:    Colorhls Application
//  FILE:         colorhlsapp.h
//  AUTHOR:       Dieter Windau
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TColorhlsApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(colorhlsapp_h)
#define colorhlsapp_h

#if !defined(OWL_OPENSAVE_H)
#include <owl/opensave.h>
#endif

#include "colorhlsapp.rh"

//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame
{
  public:
    TSDIDecFrame(TWindow* parent, LPCTSTR title, TWindow* clientWnd,
      bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();
};    //{{TSDIDecFrame}}

//{{TApplication = TColorhlsApp}}
class TColorhlsApp : public TApplication
{
  public:
    TColorhlsApp();
    virtual ~TColorhlsApp();

//{{TColorhlsAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{TColorhlsAppVIRTUAL_END}}

//{{TColorhlsAppRSP_TBL_BEGIN}}
  protected:
    void CmHelpAbout();
//{{TColorhlsAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TColorhlsApp);
};    //{{TColorhlsApp}}

#endif  // colorhlsapp_h sentry.
