
/*******************************************************************************
 *    box.cpp  (C++ Class)
 *    By Pau Herrero Vias
 *    Micelab 2005
 ******************************************************************************/

#include "box.h"
#include <fstream.h>

//******************************************************************************
//******************       CONSTRUCTORS         ********************************
//******************************************************************************

box::box ()
{
 XIndex=0;
 YIndex=1;
 Consistent=iperhaps;
 Contract=true;
 p[0][0]=0;
 p[0][1]=0;
 p[1][0]=0;
 p[1][1]=0;
}//-----------------------------------------------------------------------------

box::box (int Dim)
{Vars.resize(Dim);
 XIndex=0;
 YIndex=1;
 Consistent=iperhaps;
 Contract=true;

}//-----------------------------------------------------------------------------

box::box (const box &B)
{Vars.resize(Vars.size());
 Vars=B.Vars;
 Twin=B.Twin;
 XIndex=B.XIndex;
 YIndex=B.YIndex;
 Consistent=B.Consistent;
 Contract=B.Contract;
 p[0][0]=B.p[0][0];
 p[0][1]=B.p[0][1];
 p[1][0]=B.p[1][0];
 p[1][1]=B.p[1][1];
 t=B.t;

}//----------------------------------------------------------------------------

//******************************************************************************
//******************       DESTRUCTOR          *********************************
//******************************************************************************

box::~box (){}

//------------------------------------------------------------------------------

/*###########################
  Acces to members Class
/###########################*/

deque<variable>& box::GetVars(void)
{return Vars;
}//-----------------------------------------------------------------------------

twin& box::GetTwin(void)
{return Twin;
}//-----------------------------------------------------------------------------

int box::GetXIndex(void)
{return XIndex;
}//-----------------------------------------------------------------------------

int box::GetYIndex(void)
{return YIndex;
}//-----------------------------------------------------------------------------

iboolean box::GetConsistent(void)
{return Consistent;
}//-----------------------------------------------------------------------------

bool box::GetContract(void)
{return Contract;
}//-----------------------------------------------------------------------------

void box::SetVars(deque<variable>& VS)
{Vars=VS;
}//-----------------------------------------------------------------------------

void box::SetTwin(twin& TW)
{Twin=TW;
}//-----------------------------------------------------------------------------

void box::SetXIndex(int XI)
{XIndex=XI;
}//-----------------------------------------------------------------------------

void box::SetYIndex(int YI)
{YIndex=YI;
}//-----------------------------------------------------------------------------

void box::SetConsistent(iboolean C)
{Consistent=C;
}//-----------------------------------------------------------------------------

void box::SetContract(bool C)
{Contract=C;
}//-----------------------------------------------------------------------------

//******************************************************************************
//******************    MEMBER FUNCTIONS      **********************************
//******************************************************************************

// Access Operator ([])
variable& box::operator[] (int i)
{return Vars[i];
}//-----------------------------------------------------------------------------

box& box::operator=(const box &B)
{Vars.resize(Vars.size());
 Vars=B.Vars;
 Twin=B.Twin;
 XIndex=B.XIndex;
 YIndex=B.YIndex;
 Consistent=B.Consistent;
 Contract=B.Contract;
 p[0][0]=B.p[0][0];
 p[0][1]=B.p[0][1];
 p[1][0]=B.p[1][0];
 p[1][1]=B.p[1][1];
 t=B.t;
 return *this;
}//-----------------------------------------------------------------------------


box operator&&(const box &b1, const box &b2)
{ box Box(b1.GetVars().size());
  for(int i=0;i<b1.GetVars().size();i++)
  {Box[i].SetIval(b1.operator [](i).GetIval() && b2.operator [](i).GetIval());}
  return Box;
}//------------------------------------------------------------------------------

box operator||(const box &b1, const box &b2)
{
  box Box(b1.GetVars().size());
  for(int i=0;i<b1.GetVars().size();i++)
  {Box[i].SetIval(b1.operator [](i).GetIval() || b2.operator [](i).GetIval());}
  return Box;
}//------------------------------------------------------------------------------

bool operator==(const box &b1, const box &b2)
{ bool Equal=true;
  for(int i=0;i<b1.GetVars().size();i++)
  {if(b1.operator [](i).GetIval()==b2.operator [](i).GetIval())
   {Equal=true;}
   else
   {Equal=false;
    break;}
  }
  return Equal;
}//------------------------------------------------------------------------------

void box::Print(fstream &fout)
{fout << "\n" << "Box:";
    for(int i=0;i< this->Vars.size() ;i++)
        {fout  << "\n" << this->Vars[i].GetName() << "=" << this->Vars[i].GetIval();}
    //fout << "\n" << "Twin=" << this->Twin;
}// ----------------------------------------------------------------------------

bool box::IsEpsBigger(box &X,double Eps)
{
 bool Bigger=false;
 double Diff;
 for(int i=0;i<this->Vars.size();i++)
  {
  ivalDb a=X.Vars[i].GetIval();
  ivalDb b=this->Vars[i].GetIval();
   Diff=FDLIBM::fabs(Width(X.Vars[i].GetIval())-Width(this->Vars[i].GetIval()));
   if(!IsNaN(Diff) && Diff>Eps)
   {Bigger=true;
    break;}
   else
    {Bigger=false;}
  }
 return Bigger;
}// ----------------------------------------------------------------------------

void box::AssignIval(box &X)
{
 for(int i=0;i<this->Vars.size();i++)
 {this->Vars[i]=X.Vars[i];}
}// ----------------------------------------------------------------------------

