/*******************************************************************************
 *    box.h
 ******************************************************************************/

#ifndef __BOX__
#define __BOX__

#include "variable.h"
#include "twin.h"
#include "iboolean.h"
#include <deque>

class box
{
public:
	deque<variable> Vars;
        twin Twin;
        int XIndex;
        int YIndex;
        iboolean Consistent;
        bool Contract;
        int p[2][2];
        ivalDb t;

public:
	box ();
        box (int Dim);
	box (const box&);
	~box ();

	variable& operator[] (int);
        box& operator=(const box &B);

/*###########################
  Acces to members Class
/###########################*/

        deque<variable>& GetVars(void);
        twin& GetTwin(void);
        int GetXIndex(void);
        int GetYIndex(void);
        iboolean GetConsistent(void);
        bool GetContract(void);

        void SetVars(deque<variable>&);
        void SetTwin(twin&);
        void SetXIndex(int);
        void SetYIndex(int);
        void SetConsistent(iboolean);
        void SetContract(bool);

        void Print(fstream &fout);
        void Dual(void);
        bool IsEpsBigger(box &X,double Eps);
        void AssignIval(box &X);

//******************************************************************************
//******************    OVERLOADED OPERATORS      ******************************
//******************************************************************************

friend box operator&&(const box &x, const box &y);
friend box operator||(const box &x, const box &y);
friend bool operator==(const box &x, const box &y);

friend ostream&     operator <<(ostream& ,const box&);

//******************************************************************************
//******************    MEMBER FUNCTIONS      **********************************
//******************************************************************************

};
#endif
