// Herramienta de Dosificacin
// Maira Alejandra Garca Jaramillo
// Ultima fecha de modificacin: 29 de Enero de 2008
// MiceLab 


//---------------------------------------------------------------------------
#include "windows.h"
#include "ColorHLS.h"
//#include <vcl.h>
#pragma hdrstop

#include "FSParser.h"
#include "Unit1_hovorkaprueba.h"
#include "matrix.h"
#include <iostream.h>
#include "time.h"
#include "vector.h"

#include <fstream>
#include "math.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

char* File;
char* Func;

//fstar *Problem1;
//fstar *Problem; //PRUEBA
//vector<fstar> Problem;
//qsi QSI;
//int pos_fstar;
box Lbox[5000];
int maxbox;
double x0;
double y0;
double z0;
vector< vector<int> > buffer;
double factor;
ivalDb screen;
int box_in;
int box_out;
int pixel_in;
int pixel_out;
double par1,par2,par3,par4;
//matrix mv;

// Declaracin

int  incertidumbre_k, incertidumbre_tmg, incertidumbre_dg;

double aleatori[23][16000]; // Guardo los valores aleatorios generados
double BW, kabs, f;

//---------------------------------------------------------------------------
// Variables globales

int t_simul, t_insulina, t_comida;
double h, Vg;
int multi, marcaqsto;

// Modelo Hovorka
double   vg, vi,  tmi, ke, peso, ub, Ibasal;
ivalDb egp0, fc01, fr, fc02, ag, tmg;
ivalDb  ka[3], kb[3], k12, Sit, Sid, Sie;

// Modelo Cobelli
ivalDb kp3, Vm0, Vmx, kp1,a,b1, ki, kmax, kmin;
double b, d, Vi, p2U;
double kp2, ke1, ke2, Fcns, k1, k2;
double EGPb, Ib, Gpb;
double ka1d, ka2, kd;

// Modelo Bergman
ivalDb p1, p2, p3, p4,  n, Gb_B;

// Modelo Panunzi
ivalDb Kxgi;
int tg;
double  gamma, G1, Tigmax, Kxi;

// Modelo Wilinska
ivalDb ka1, kw, Kxiw;



//---------------------------------------------------------------------------
// Matrices globales

// Declaracin matriz que contiene los datos de la insulina exgena
ivalDb** insulina;



//---------------------------------------------------------------------------
/*
// Archivo f*
 FILE *festrella;
 AnsiString FSTAR="funcion.txt";
 AnsiString cadena[16], paso[11];
 AnsiString  paso_q1[500],  paso_i[500], paso_x1[500], paso_x2[500], paso_x3[500], paso_q2[500], paso_ug[500], paso_f01[500], paso_fr[500];
*/
//---------------------------------------------------------------------------

// Main

int main(int argc, char* argv[])
{
 Application->Initialize();
 Application->CreateForm(__classid(TForm1), &Form1);
 Application->Run();
}
//----------------------------------------------------------------------------
/*
// FUNCION PARA EL CALCULO DE LA FSTAR

ivalDb estrella(AnsiString  parametro, ivalDb I2, ivalDb *X, int num_cadena)
{
ivalDb F_1;
                FILE *festrella;
                AnsiString FSTAR="funcion.txt";

                festrella= fopen(FSTAR.c_str(), "w+");
                //Creacin del archivo para el llamado a la F*
                fprintf(festrella, "%s", "Algorithm=FSTAR;");
                fprintf(festrella, "%s", "\n");
                //cadena[0]="%;";
                cadena[4]=parametro+"=["+FloatToStr(I2.Inf)+","+FloatToStr(I2.Sup)+"];";
                cadena[8]="Epsilon=0.001;";
                cadena[9]="Tolerance=1e-3;";
                cadena[10]="Time=0.5;";
                cadena[11]="Optim=0;";
                cadena[12]="Solution=1;";

                int f=0;
                  for (f=0; f<num_cadena; f++)
                        {
                        fprintf(festrella, "%s", cadena[f]);
                        fprintf(festrella, "%s", "\n");
                        }
                  for (f=0; f<8; f++)
                        {
                        fprintf(festrella, "%s", "%"+paso[f]);
                        fprintf(festrella, "%s", "\n");
                        }

             //Funcin para la cul se va a calcular F*
             fclose(festrella);

             box B;
             fstream fout;
             RunParser("funcion",Problem[0]);
             Problem[0].Run(B,fout);

               // Guarda los valores del clculo de la externa
               F_1.Inf=Problem[0].GetTwin().GetOut().Inf;
               F_1.Sup=Problem[0].GetTwin().GetOut().Sup;
               Problem[0].~fstar();

               *X=ivalDb(F_1.Inf,F_1.Sup);  // Intervalo respuesta
}

 */
//---------------------------------------------------------------------------

// FUNCIN PARA EL CLCULO DE LA ABSORCIN DE GLUCOSA CON ENTRADA IMPULSIONAL
// Entradas (dg: carbohidratos ingeridos, t: minuto de simulacin, t1: minuto en el que inicia la ingesta)
// Salidas  (*UG: salida con la absorcin de glucosa)

ivalDb abs_glucosa_impulsional(ivalDb dg, double t, double t1,  ivalDb *UG)

{

 ivalDb F_1;

 // Absorcin de Glucosa Hovorka Original  (mmol/min)
   if(t<t1)   // Verifica si ha ingerido alimentos
        *UG=0;
   else
        if(incertidumbre_tmg==1) // Si tmg tiene incertidumbre el clculo debe ser realizado mediante la fstar
          {
                // Clculo realizado con la F* cuando tmg es intervalar
                /*
                cadena[1]="dg=["+FloatToStr(dg.Inf)+","+FloatToStr(dg.Sup)+"];";
                cadena[2]="ag=["+FloatToStr(ag.Inf)+","+FloatToStr(ag.Sup)+"];";
                cadena[3]="tmg=["+FloatToStr(tmg.Inf)+","+FloatToStr(tmg.Sup)+"];";
                cadena[5]="%";
                cadena[6]="%";
                cadena[7]="%";
                cadena[13]="f:=((dg*ag*(("+FloatToStr(t)+"-"+FloatToStr(t1)+"+1)*"+FloatToStr(h)+"))*exp(-(("+FloatToStr(t)+"-"+FloatToStr(t1)+"+1)*"+FloatToStr(h)+")/tmg))/pow(tmg,2);";

                FILE *festrella;
                AnsiString FSTAR="funcion.txt";

                festrella= fopen(FSTAR.c_str(), "w+");
                //Creacin del archivo para el llamado a la F*
                fprintf(festrella, "%s", "Algorithm=FSTAR;");
                fprintf(festrella, "%s", "\n");
                cadena[0]="%;";
                cadena[4]="%";
                cadena[8]="Epsilon=0.001;";
                cadena[9]="Tolerance=1e-3;";
                cadena[10]="Time=0.5;";
                cadena[11]="Optim=0;";
                cadena[12]="Solution=1;";
                int f1=0;
                  for (f1=0; f1<14; f1++)
                        {
                        fprintf(festrella, "%s", cadena[f1]);
                        fprintf(festrella, "%s", "\n");
                        }

             //Funcin para la cul se va a calcular F*
                fclose(festrella);
                box B;
                fstream fout;
                RunParser("funcion", Problem[0]);
                Problem[0].Run(B,fout);

               //Guarda los valores del clculo de fstar
                F_1.Inf=Problem[0].GetTwin().GetOut().Inf;
                F_1.Sup=Problem[0].GetTwin().GetOut().Sup;
                Problem[0].~fstar();

                *UG=F_1; // Guarda el valor de la absorcin de glucosa
                */
          }
        else
                {
                // Clculo racional de la absorcin de glucosa
                *UG=((dg*ag*((t-t1+1)*h))*exp(-((t-t1+1)*h)/tmg))/(pow(tmg,2));
                // Clculo de la absorcin de glucosa de acuerdo a
                }
 }
//---------------------------------------------------------------------------


// FUNCION PARA EL CALCULO DE LA ABSORCIN DE GLUCOSA CON ENTRADA PULSO
// Entrada:(dg: carbohidratos ingeridos, t: minuto de simulacin
// t1: minuto en el que inicia la ingesta, t2: minuto en el que finaliza la ingesta)
// Salida: (*UG: salida con la absorcin de glucosa)

ivalDb abs_glucosa_escalon(ivalDb dg, double t, double t1, double t2, ivalDb *UG)
{
   ivalDb UG1, UG2;

   //Conversin de la ingestin de comida g a mmol
   //dg=dg*1000/180;

     //Expresin del modelo gastrointestinal formulado para entrada pulso
     if (t<t1) // Si no ha ingerido alimentos
        *UG=0;
     else
        if ((t>=t1) && (t<t2))  // Clculo entre el inicio y finalizacin de la ingesta
                *UG=((ag*dg)/((t2-t1)*h))*((-(t+1-t1)/tmg)*exp(-(t+1-t1)/tmg)-exp(-(t+1-t1)/tmg)+1);
        else
           if (t>=t2)  //  Clculo cuando ha finalizado la ingesta
              {
                UG1=((1)/((t2-t1)*h))*((-(t+1-t1)/tmg)*exp(-(t+1-t1)/tmg)-exp(-(t+1-t1)/tmg)+1);
                UG2=((1)/((t2-t1)*h))*((-(t+1-t2)/tmg)*exp(-(t+1-t2)/tmg)-exp(-(t+1-t2)/tmg)+1);
                *UG=ag*dg*(UG1-UG2);
              }
}


//---------------------------------------------------------------------------

// Modelo de Vaciado Gstrico DallaMan 2007

ivalDb abs_glucosa_dallaman (  int t_durcomida, ivalDb qsto, ivalDb qsto_m,
                                ivalDb qsto1, ivalDb qsto2, ivalDb qgut,
                                ivalDb ra, ivalDb D, ivalDb ingestar,
                                ivalDb *Qsto, ivalDb *Qsto1,
                                ivalDb *Qsto2, ivalDb *Qgut, ivalDb *Ra,
                                ivalDb *Kempt)
{

ivalDb residuo, kempt;
ivalDb alpha, beta, valkmax;


residuo=qsto_m+(ingestar*t_durcomida);    // Comida que esta en el estmago

if (residuo>0)  // Hay comida en el estomago
  {
   alpha=5/(2.0*residuo*(1-b));  beta= 5/(2.0*d*residuo);
   valkmax=(tanh(alpha*(qsto-b*residuo))-tanh(beta*(qsto-d*residuo))+2);
   if ((qsto_m>0)&&(marcaqsto==1)) // Hay multiincidencia
    {alpha=5/(2.0*(1-b));     beta= 5/(2.0*d);
     kempt=kmin+((kmax-kmin)/2.0)*(tanh(alpha*(qsto/(qsto_m+ingestar*t_durcomida)-b))-tanh(beta*(qsto/(qsto_m+Du(ingestar*t_durcomida))-d))+2);
     marcaqsto=0;
    }
   else
    {alpha=5/(2.0*(1-b));     beta= 5/(2.0*d);
     kempt=kmin+((kmax-kmin)/2.0)*(tanh(alpha*(Du(qsto)/(qsto_m+ingestar*t_durcomida)-b))
            -tanh(beta*(qsto/(qsto_m+Du(ingestar*t_durcomida))-d))+2);

     *Qsto2=qsto2*(1-kempt*h)+(kmax*qsto1*h);
    }
  }
else
   {
    kempt=kmax;
    *Qsto2=qsto2+kmax*h*(qsto1-Du(qsto2));
   }

// Tasa de presencia de Glucosa
*Qsto1=qsto1*(1-kmax*h)+D*h;
*Qsto=*Qsto1+*Qsto2;
*Qgut=kempt*qsto2*h+qgut*(1-kabs*h);
*Ra=(*Qgut*f*kabs)/BW;
*Kempt=kempt;



}

//---------------------------------------------------------------------------

// FUNCION PARA EL CALCULO DE LA INFUSIN DE INSULINA (HOVORKA 04)
// Entrada:(u: cantidad de infusin de insulina; s1, s2: dos compartimentos
// concatenados que representan la absorcin subcutanea de insulina de corta accin)
// Salida: (*Ui: salida de la absorcin de insulina; *S1, *S2: Absorcin de;
// insulina de corta acccin administrada subcutneamente)

ivalDb abs_insulina_hovorka(ivalDb u, ivalDb s1, ivalDb s2, ivalDb *Ui, ivalDb *S1, ivalDb *S2)
{
/*
   *S1=u*h-s1*((h/tmi)-1);      //S1 Absorcin de insulina de corta acccin administrada subcutneamente
   *S2=s2*(1-(h/tmi))+h*s1/tmi; //S2 Absorcin de insulina de corta acccin administrada subcutneamente
   *Ui=s2/tmi;                  // Absorcin de Insulina con Hovorka
*/
   *S1=s1+h*(u-(Du(s1)/(tmi)));   //S1 Absorcin de insulina de corta acccin administrada subcutneamente
//   *S2=s2+(h/(tmi))*(s1-Du(s2));  //S2 Absorcin de insulina de corta acccin administrada subcutneamente
   *S2=s2+h*(s1/tmi-Du(s2)/(tmi));  //S2 Absorcin de insulina de corta acccin administrada subcutneamente
   *Ui=s2/tmi;                  // Absorcin de Insulina con Hovorka

}

//---------------------------------------------------------------------------

// FUNCION PARA EL CALCULO DE LA INFUSIN DE INSULINA (DALLA MAN 07)
// Entrada:(u: cantidad de infusin de insulina; s1, s2: dos compartimentos
// concatenados que representan la absorcin subcutanea de insulina de corta accin)
// Salida: (*Ui: salida de la absorcin de insulina; *S1, *S2: Absorcin de;
// insulina de corta acccin administrada subcutneamente)

ivalDb abs_insulina_dallaman(ivalDb u, ivalDb s1, ivalDb s2, ivalDb *S, ivalDb *S1, ivalDb *S2)
{
   *S1=s1+h*(u-(kd+ka1d)*Du(s1));   	//S1 Insulina polimerica en el tejido subcutneo
   *S2=s2+h*(kd*s1-ka2*Du(s2));  		//S2 Insulina monomerica en el tejido subcutneo
   *S=ka1d*s1+ka2*s2;                  		// Absorcin subcutnea de Insulina 

}

//---------------------------------------------------------------------------


// FUNCION PARA CARGAR LOS DATOS DE INSULINA (TARIN 05)
// Entrada:(i: minuto de simulacin; cant_insulina: cantidad de inyeccin de insulina)
// Salida: (*Iex: salida de la absorcin de insulina)

ivalDb ins_exogena(int t, int cant_insulina, int tipo_ins, ivalDb *Iex)
{
   // Modelo Insulina Exgena (UPV)

   if (t==0)  // Cargo los datos de insulina
   {

        // Matriz con los valores de cada inyeccin de insulina
        insulina=new ivalDb* [40]; // Guarda 40 Valores de Iex
        for (int m = 0; m < 40; m++)
        insulina[m] = new ivalDb [t_simul+1+3630];

        ///Modelo de Insulina // Guarda los valores de Iex
        // Valores de 1 a 25IU de Insulina Exogena (Basal+Bolus)
        int cont1=0, cont2=0;
        double ins;
        long length;
        char dosis[100];
        FILE *fileinsulina;
        AnsiString archivoi;
        if (tipo_ins==1)
                archivoi="dosificacion_trabajo_25_5U.txt";        // Bolus + Basal
        else    archivoi="dosificacion_trabajo_bolus_25_5U.txt";  // Bolus sin basal
        fileinsulina= fopen(archivoi.c_str(), "r");
        if(!fileinsulina)
                 ShowMessage(" no existe");
           for (cont1=0; cont1<(t_simul+3615); cont1++)
                for(cont2=0; cont2<40; cont2++)
                {
                   length = ftell(fileinsulina);
                   fseek(fileinsulina, length, SEEK_SET);
                   fscanf(fileinsulina,  "%s", dosis);
                   insulina[cont2][cont1+1]=StrToFloat(dosis);
                }
        fclose(fileinsulina);
    }

      if (t>0)
                *Iex=insulina[cant_insulina-1][t+1+3614];
      else      *Iex=0;


}

//---------------------------------------------------------------------------

// Tasa de presencia de Glucosa DallaMan 2007

ivalDb cinet_insulina_cobelli ( ivalDb i1, double m1, double m2, double m3, double m4,
                                ivalDb ii, ivalDb id, ivalDb ip, ivalDb il, ivalDb iex,
                                ivalDb ki, double Ib,  ivalDb x,
                                ivalDb *Il, ivalDb *Ip, ivalDb *I, ivalDb *X, ivalDb *I1,
                                ivalDb *Id)
{

// Cintica de la Insulina
*Il=-(h*(m1+m3)-1)*il+m2*ip*h;         // Masa de insulina en el higado
*Ip=-(h*(m2+m4)-1)*ip+m1*il*h+iex;     // Masa de insulina en plasma
*I=ip/Vi;                               // Concentracin de insulina en plasma

// Accin sobre la produccin de insulina

*I1=i1+ki*h*(ii-Du(i1));
*Id=id+ki*h*(i1-Du(id));
*X=x*(1-p2U*h)+p2U*(ii-Ib);    // Fluido intersticial
  
}

//---------------------------------------------------------------------------



//FUNCIN DEL MODELO ENDGENO MEDIANTE CLCULO RACIONAL (PARAMETROS CON INCERTIDUMBRE)
// Entradas: (ui: cantidad de insulina, q1: masa de glucosa en el compartimento accesible;
// q2: masa de glucosa en el compartimento no accesible, I: concentracin de insulina;
// x1, x2, x3: efectos de la insulina; g: concentracin de glucosa en sangre;
// ug: absorcin de glucosa; t: minuto de simulacin)
// Salidas: (*Q1: masa de glucosa en el compartimento accesible,
// *Q2: masa de glucosa en el compartimento no accesible;
// *I1: concentracin de insulina; *X1, *X2 y *X3: efectos de la insulina;
// *G: concentracin de glucosa; *F01: Flujo de glucosa no
// insulino dependiente; *FR: eliminacin de glucosa renal)

ivalDb endogeno_hovorka (int paciente, ivalDb ui, ivalDb q1, ivalDb q2, ivalDb I, ivalDb x1,
                              ivalDb x2, ivalDb x3, ivalDb s, ivalDb g, ivalDb ug,
                              int t, double f01, ivalDb *Q1, ivalDb *Q2, ivalDb *I1, ivalDb *X1,
                              ivalDb *X2, ivalDb *X3, ivalDb *S, ivalDb *G)
{
ivalDb FC, vmin, B, f01c, vmin_ini1, vmin_ini2, vmin_1, vmin_2;
double  f;
AnsiString  parameter;


  //Valor para f01c inferior
   if (q1.Inf<4.5*vg)
       f01c.Inf=(f01*q1.Inf)/(4.5*vg);
   else
       f01c.Inf=f01;

   //Valor para f01c superior
   if (q1.Sup<4.5*vg)
       f01c.Sup=(f01*q1.Sup)/(4.5*vg);
   else
       f01c.Sup=f01;

   //Valor para fr inferior
   if (q1.Inf<9*vg)
       fr.Inf=0;
   else
       fr.Inf=0.003*q1.Inf-0.027*vg;

   //Valor para fr superior
   if (q1.Sup<9*vg)
       fr.Sup=0;
   else
       fr.Sup=0.003*q1.Sup-0.027*vg;

   // Valor para FC
   if (q1<4.5*vg)
        FC= f01/(4.5*vg);
   else if ((q1>=(4.5*vg))&&(q1<=(9*vg)))
        FC=0;
   else 0.003;


        //Restriccin
        vmin=min(1/(k12+x1+FC),1/(k12+x2)); // Restriccin para el clculo optimal

        if (t==0)// Restricciones para el instante inicial
                {
                vmin_ini1=min(1/(f01/(4.5*vg)+(x1*x2)/(k12+x2)),1/(k12+x1));
                vmin_ini2=min(vmin_ini1,(1+x1/(k12+x2))/(f01/(4.5*vg)+x2*x1/(k12+x2)));
                }
        else    {
                vmin_1=min(1/(k12+x1+f01/(4.5*vg)),1/(k12+x1));
                vmin_2=min(vmin_1,1/x2);
                }

        // Verificacin de restricciones para el clculo optimal
        if((h>vmin)&&(h>vmin_ini2)&&(h>vmin_2))
                if ((t>0)&&(x2<f01/(4.5*vg)))
          {ShowMessage("Funcion no montona");}
               {
                 //Clculo Racional (Modelo endgeno)
                 B=ug+egp0*(1-x3);
                 *Q1=q1*(1-h*(k12+x1))-h*(Du(f01c)+Du(fr))+(h*s*k12)+(h*B);
                 *S=q1*h*Du(x2)-h*(Du(f01c)+Du(fr))+s*(1-(h*x2))+B*h;
                 *Q2=*S-Du(*Q1);
               }
      
        *G=q1/vg;  //G(t) Concentracin de Glucosa  (mmol/dl)

        *I1=(ui/vi)*h-I*((ke*h)-1)+ub*h;       // Concentracin de glucosa en sangre (mU/(L*min))
                
        // SUBSISTEMA DE ACCION DE LA INSULINA
        *X1=x1*(1-(ka[0]*h))+((ka[0]*Sit*h)*I);  // Efecto de la insulina en el transporte de glucosa (1/min)
        *X2=x2*(1-(ka[1]*h))+((ka[1]*Sid*h)*I);  // Efecto de la insulina en la disposicin de glucosa (1/min)
        *X3=x3*(1-(ka[2]*h))+((ka[2]*Sie*h)*I);  // Efecto de la insulina en la produccin de glucosa endgena (1/min)


       // *F01=f01c;
       // *FR=fr;
}
//---------------------------------------------------------------------------
//FUNCIN DEL MODELO ENDGENO DE COBELLI
// Entradas: (ui: cantidad de insulina, q1: masa de glucosa en el compartimento accesible;
// q2: masa de glucosa en el compartimento no accesible, I: concentracin de insulina;
// x1, x2, x3: efectos de la insulina; g: concentracin de glucosa en sangre;
// ug: absorcin de glucosa; t: minuto de simulacin)
// Salidas: (*Q1: masa de glucosa en el compartimento accesible,
// *Q2: masa de glucosa en el compartimento no accesible;
// *I1: concentracin de insulina; *X1, *X2 y *X3: efectos de la insulina;
// *G: concentracin de glucosa; *F01: Flujo de glucosa no
// insulino dependiente; *FR: eliminacin de glucosa renal)

ivalDb endogeno_cobelli (ivalDb gp, ivalDb gt, ivalDb Ra, ivalDb Id, ivalDb Vmt,
                         ivalDb Kmt, ivalDb *Gp, ivalDb *Gt, ivalDb *G)
{
ivalDb Uii;

        // Utilizacin total de glucosa
        Uii=Fcns;

        // Validacin de Excrecin renal
        if (gp>ke2)
                *Gp=gp*(h*(-kp2-ke1)+(1-k1*h))+h*(EGPb+kp2*Gpb+kp3*(Ib-Id)+Ra-Uii+(ke1*ke2)+gt*k2);
        else
                *Gp=gp*(h*(-kp2)+(1-k1*h))+h*(EGPb+kp2*Gpb+kp3*(Ib-Id)+Ra-Uii+gt*k2);

        *Gt=h*(k1*gp-Vmt/(Kmt/Du(gt)+1))+gt*(1-k2*h);
        *G=gp/Vg;


}
//---------------------------------------------------------------------------

ivalDb endogeno_bergman(ivalDb g, ivalDb x, ivalDb i1, ivalDb gb, ivalDb ib, ivalDb Iex,
                        ivalDb D, double Vg_b, double Vi_b, ivalDb *G, ivalDb *X, ivalDb *I)
{
// De acuerdo a Dua 2006
/*
*G=g*(1-p1-x)-(x*gb)+(D/Vg_b);    // Concentracin de glucosa en plasma
*X=x*(1-p2)+p3*i1;              // Concentracin de insulina en el compartimento remoto
*I=-n*(Du(i1)+ib)+i1+(Iex/Vi_b);  // Concentracin de insulina en plasma
*/
// De acuerdo a Roy 2007
//*G=p1*h*(gb-Du(g))+g*(1-x*h)+(D/Vg_b);    // Concentracin de glucosa en plasma
*G=p1*h*(Gb_B-Du(g))+g*(1-x*h)+(D/Vg_b);    // Concentracin de glucosa en plasma
*X=x*(1-p2*h)+p3*h*(i1-ib);              // Concentracin de insulina en el compartimento remoto
*I=i1*(1-n*h)+(p4*Iex*h);  // Concentracin de insulina en plasma



}
//---------------------------------------------------------------------------

ivalDb endogeno_panunzi (ivalDb g, ivalDb i1, ivalDb Gb, ivalDb Ib, ivalDb Iex,
                         ivalDb D, ivalDb G_tg, int t, double Vg_p, double Vi_p,
                         ivalDb *G, ivalDb *I)
{
*G=g*(1-(Kxgi*i1*h))+(Du(Kxgi)*Ib*g*h)+(D/Vg_p); // Concentracin de glucosa en sangre

if (t>=tg)
        *I=i1*(1-Kxi*h)+(Tigmax/Vi_p)*(1/(pow(G1/(Du(G_tg)),gamma)+1))+(Iex/Vi_p); // Concentracin de Insulina en plasma
else    *I=i1*(1-Kxi*h)+(Tigmax/Vi_p)*(1/(pow(G1/(Gb),gamma)+1))+(Iex/Vi_p);
}
//---------------------------------------------------------------------------

ivalDb endogeno_panunzi_modificado (ivalDb g, ivalDb x, ivalDb iw, ivalDb D,  int t,
                                    double Vg_d, ivalDb Tgh, ivalDb *G, ivalDb *X)
{
//*G=g*(1-h*Kxgi*x)+h*(Tgh/Vg_d+D);     // Concentracin de glucosa en sangre
//*X=x*(1-Kxi)+h*iw*Kxi;

*G=g+h*(-Kxgi*x*Du(g)+Tgh/Vg_d+(D/Vg_d));
*X=x-Kxi*h*(Du(x)-iw);



}

//---------------------------------------------------------------------------


// CALCULO DE LA DOSIS INICIAL
// Entrada:(GC: Glucosa capilar; CHO: cantidad de carbohidratos (gr) ingeridos
// Salida: (*DI: Dosis Inicial, *II: Instante inicial de inyeccin)

ivalDb dosis_inicial(double GC, double CHO, double *DI, double *II)
{

double TDD=40; //Cantidad de insulina total inyectada en un dia (IU)
double GOmax=8.39, GOmin=3.9, R500=0, R2000=0, factor;

//Clculo de la Regla 500 (Ratio CHO)
R500=500/TDD;
//Clculo de la Regla 2000 (Sensibilidad Insulina)
R2000=2000/TDD;

// Valida en que nivel se encuentra la glucosa capilar respecto a la Glucosa
// Objetivo(Normalglucemia)
if (GC < GOmin){                *DI=(CHO/R500)+((GC-GOmin)/R2000);  }
if (GC > GOmax){                *DI=(CHO/R500)+((GC-GOmax)/R2000);  }
if ((GC<=GOmax)&&(GC>=GOmin)){  *DI=(CHO/R500);                     }

// Rendondea el valor de la dosis inicial
*DI=ceil(*DI);

/* Propuesta modificando los datos del Samfyc y proponiendo indice
if (GC<(80/18)){                                *II=0;          }
else if (GC>=(200/18)){                         *II=60;         }
else {factor=ceil((ceil(GC*18)-80)/10);         *II=factor*5;   }
*/

// Clculo del Instante Inicial de Inyeccin (Tomado de Samfyc)
// Verificando el valor de la glucosa capilar se determina el instante de
// inyeccin
if (GC<(80/18)){                        *II=0;      }
if ((GC>= (80/18))&&(GC<(140/18))){     *II=30;     }
if ((GC>=(140/18))&&(GC<(180/18))){     *II=45;     }
if ((GC>=(180/18))&&(GC<(200/18))){     *II=60;     }
if (GC>=(200/18)){                      *II=60;     }

}
//---------------------------------------------------------------------------

// FUNCION DONDE SE ESTABLECEN LAS CONDICIONES INICIALES, SE DEFINEN LAS VARIABLES
// SE ESTABLECE EL PASO DE DISCRETIZACIN, Y SE CONFIGURA LAS OPCIONES DE
// CALCULO PARA EL METABOLISMO DE LA GLUCOSA

//---------------------------------------------------------------------------
// Generacin de Montecarlos

ivalDb montecarlo ( ivalDb aleatori1, ivalDb aleatori2, ivalDb aleatori3, ivalDb aleatori4,
                    ivalDb aleatori5, ivalDb aleatori6, ivalDb aleatori7, ivalDb aleatori8,
                    ivalDb aleatori9, ivalDb aleatori10, ivalDb aleatori11, ivalDb aleatori12,
                    ivalDb aleatori13, ivalDb aleatori14, ivalDb aleatori15, ivalDb aleatori16, ivalDb aleatori17,
                    int tipo_distribucion, int vari, int num_aleatori, ivalDb *Aleatori1, ivalDb  *Aleatori2,
                    ivalDb *Aleatori3, ivalDb *Aleatori4, ivalDb *Aleatori5, ivalDb  *Aleatori6, ivalDb *Aleatori7,
                    ivalDb *Aleatori8, ivalDb *Aleatori9, ivalDb *Aleatori10, ivalDb *Aleatori11, ivalDb  *Aleatori12,
                    ivalDb *Aleatori13, ivalDb *Aleatori14, ivalDb *Aleatori15, ivalDb *Aleatori16, ivalDb  *Aleatori17)
{

double i_s=0, r1=0;

        //srand((unsigned)time(0));

        // Parmetros con incertidumbre
        ivalDb  porcentaje[17], incerti[17],  destipif;
        double tipif_i=0, desv=0, tipif_s=0, media=0, desv_i=0, desv_s=0;
        incerti[0]=aleatori1;  incerti[1]=aleatori2;
        incerti[2]=aleatori3;  incerti[3]=aleatori4;
        incerti[4]=aleatori5;  incerti[5]=aleatori6;
        incerti[6]=aleatori7;  incerti[7]=aleatori8;
        incerti[8]=aleatori9;  incerti[9]=aleatori10;
        incerti[10]=aleatori11; incerti[11]=aleatori12;
        incerti[12]=aleatori13; incerti[13]=aleatori14;
        incerti[14]=aleatori15; incerti[15]=aleatori16;
        incerti[16]=aleatori17;

        porcentaje[0]=0; porcentaje[1]=0; porcentaje[2]=0; porcentaje[3]=0;
        porcentaje[4]=0; porcentaje[5]=0; porcentaje[6]=0; porcentaje[7]=0;
        porcentaje[8]=0; porcentaje[9]=0; porcentaje[10]=0; porcentaje[11]=0;
        porcentaje[12]=0; porcentaje[13]=0; porcentaje[14]=0; porcentaje[15]=0;
        porcentaje[16]=0;

                        for (int aleatorio=0; aleatorio<num_aleatori; aleatorio++)//Generacin de valores aleatorios
                        {
                          i_s= incerti[aleatorio].Sup-incerti[aleatorio].Inf;
                        if(i_s>0.1E-10)   //Verifico si hay incertidumbre
                              {
                               // Establezco la semilla
                               srand((unsigned) rand());
                               //srand((unsigned)time(0));
                               // Generacin de valor aleatorio
                                r1 = ( (double)rand() / ((double)(RAND_MAX)+(double)(1)) );

                               // Guardo el valor generado
                               aleatori[aleatorio][vari]=r1;

                                //Validacin del valor generado
                                for (int k=0;k<vari;k++)
                                {
                                if ((r1==aleatori[aleatorio][k])&&(vari>1))
                                  {
                                        srand((unsigned) rand());
                                        //srand((unsigned)time(0));
                                           r1 = ( (double)rand() / ((double)(RAND_MAX)+(double)(1)) );
                                        break;
                                   }
                               }

                               if (tipo_distribucion==1)
                               // Para distribucin uniforme
                               porcentaje[aleatorio]=incerti[aleatorio].Inf+(incerti[aleatorio].Sup-incerti[aleatorio].Inf)*r1;


                               if (tipo_distribucion==2)
                               {
                               // Guardo el valor generado
                               aleatori[aleatorio][vari]=r1;

                               // Generar valor aleatorio con distribucin normal
                               // Media
                               media=(incerti[aleatorio].Sup+incerti[aleatorio].Inf)/2;
                               desv_i=incerti[aleatorio].Inf-media;
                               desv_s=incerti[aleatorio].Sup-media;
                               // Clculo de la desviacin estandar
                               desv=sqrt((desv_i*desv_i)+(desv_s*desv_s));
                               // Valor tipificado
                               tipif_i=(incerti[aleatorio].Inf-((incerti[aleatorio].Sup+incerti[aleatorio].Inf)/2))/desv;
                               tipif_s=(incerti[aleatorio].Sup-((incerti[aleatorio].Sup+incerti[aleatorio].Inf)/2))/desv;
                               porcentaje[aleatorio]=tipif_i+(tipif_s-tipif_i)*r1;

                               // Valor destipificado
                               destipif=porcentaje[aleatorio]*desv+media;
                               porcentaje[aleatorio]=destipif;
                               }

                               if ((porcentaje[aleatorio].Sup>incerti[aleatorio].Sup)||(porcentaje[aleatorio].Inf<incerti[aleatorio].Inf))
                               {if(incerti[aleatorio].Sup==incerti[aleatorio].Inf)
                                ShowMessage("Valor fuera de rango");
                               }
                              }
                        else
                              porcentaje[aleatorio]=incerti[aleatorio].Inf;
                        } // Finaliza for aleatorio

                       *Aleatori1=porcentaje[0]; *Aleatori2=porcentaje[1];
                       *Aleatori3=porcentaje[2]; *Aleatori4=porcentaje[3];
                       *Aleatori5=porcentaje[4]; *Aleatori6=porcentaje[5];
                       *Aleatori7=porcentaje[6]; *Aleatori8=porcentaje[7];
                       *Aleatori9=porcentaje[8]; *Aleatori10=porcentaje[9];
                       *Aleatori11=porcentaje[10]; *Aleatori12=porcentaje[11];
                       *Aleatori13=porcentaje[12]; *Aleatori14=porcentaje[13];
                       *Aleatori15=porcentaje[14]; *Aleatori16=porcentaje[15];
                       *Aleatori17=porcentaje[16];

}
//---------------------------------------------------------------------------


void __fastcall TForm1::GeneralClick(TObject *Sender)
{
// Declaracin de variables generales

int n_montecarlos, canti_insulina, paciente, tipo_distribucion;
int endogeno, abs_insulina, abs_glucosa;
int i, variacion, tipo_insulina;
ivalDb comida, ingestar, qsto, Vmt, Kmt, Xb;
double incertidumbre[7], f01, factor=0;
double  m3, m2, CL, HEb, m4, m1, Ipb, Ilb, Km0, Gb, Gtb, ic;
double Vi_b, Vg_b, Vi_p, Vg_p, Ib_b;
ivalDb G_tg, Xb_b;
ivalDb tempo[4], monte[5];
double GR[4][12], h_i[4];  // Variables para guardar el valor de glucosa y el tiempo en las mtricas
int glu0=0, glu1=0, glu2=0, glu3=0, k=0, dr=0, t_duracion;
int ncomida=0, cgrupos=0, ncomida_f=0;  // Para comidas mixtas

double parametrocm[9][300];


double temp_absglucosa;

// Entrada datos

// Introduce el tiempo de simulacin en minutos
AnsiString  iter= InputBox("Input Box", "Tiempo de simulacin en minutos", "0");

multi=1; //Valor dado por el paso de discretizacin
h=1;     // Paso de discretizacin

t_simul=StrToInt(iter)*multi; //Tiempo de simulacin, afectado por el paso de discretizacin

// Matriz donde se guardaran los valores de cada variable
// Las filas identifican la variable y las columnas cada minuto
int fila=21;
int columna=t_simul+1;
ivalDb** g;
    g = new ivalDb* [fila];
    for (int m = 0; m < fila; m++)
      g[m] = new ivalDb [columna];
    //Matriz con el nombre de cada variable   Hovorka
    //g[1][i]=Q1 g[2][i]=Q2 g[3][i]=I   g[4][i]=x1  g[5][i]=x2    g[6][i]=x3  g[7][i]=S1
    //g[8][i]=S2 g[9][i]=g  g[10][i]=ug g[11][i]=ui g[12][i]=fc01 g[13][i]=fr g[14][i]=S


      for(k=0;k<4; k++)
       {
       for(dr=0; dr<12; dr++) // Variable para la impresin de las mtricas
        {GR[k][dr]=0;}
         h_i[k]=0;
       }
         dr=0; k=0;


////////////////////////////////////////////////////////////////////////////////

// DATOS PACIENTE Y TERAPIA
// Datos para pruebas actuales
ncomida=1;             // Nmero de grupo de comidas mixtas
cgrupos=4;             // Cantidad de grupos de comidas mixtas
paciente=2;             //

// Seleccin de modelos
endogeno=3;              // 1: Hovorka; 2: Cobelli; 3: Bergman; 4: Panunzi
abs_insulina=3;          // 1: Hovorka; 2: Tarn;  3:Dalla Man
tipo_insulina=1;         // 1: Basal+Bolus; 2: Bolus   Solo para el modelo de Tarn
abs_glucosa=4;           // 1: Hovorka impulsional; 2: Hovorka pulso;  3: DallaMan; 4: Librera de comidas mixtas


// Otras entradas
comida=60;              // gr
t_comida=1;             // min
canti_insulina=9;       // Cantidad de insulina IU

// Establecer incertidumbre
// Montecarlo
n_montecarlos=00;       // Nmero de montecarlos
tipo_distribucion=1;    // 1: Uniforme;  2: Normal

// Modelo Dallaman
incertidumbre[0]= 7.5;     //  comida
incertidumbre[1]= 0;     //  ki Dallaman
incertidumbre[2]= 4;     //  kp3          // n Bergman
incertidumbre[3]= 5;     //  Vmx, Vm0     // Kxgi Panunzi
incertidumbre[4]= 0;     //  Sit Hovorka  // p1 Bergman
incertidumbre[5]= 0;     //  Sid Hovorka  // p2 Bergman
incertidumbre[6]= 0;     //  Sie Hovorka  // p3 Bergman



////////////////////////////////////////////////////////////////////////////////


// Parmetros de modelos
if ((endogeno==1)||(abs_glucosa==1)||(abs_glucosa==2))
{
// Asigna los valores a los parmetros de 5 pacientes y 1 paciente Medio
// Tomados de Hovorka et al. (2002)

// Declaracin parmetros
double parametroh[11][14];

// Toma desde el archivo parametros_hovorka los parametros de cada paciente

        int pac=0, cont3=0;
        long length;
        char paramet[100];
        FILE *fileparametroh;
        AnsiString archivoph="parametros_hovorka_ajustados basal.txt";
        fileparametroh= fopen(archivoph.c_str(), "r");
        if(!fileparametroh)
                 ShowMessage(" no existe");
           for(cont3=0; cont3<15; cont3++) // Cantidad parmetros
                for (pac=0; pac<12; pac++)  // Numero de pacientes
                {
                   length = ftell(fileparametroh);
                   fseek(fileparametroh, length, SEEK_SET);
                   fscanf(fileparametroh,  "%s", paramet);
                   if ((cont3>0)&&(pac>0))
                        parametroh[pac][cont3]=StrToFloat(paramet);
                }
        fclose(fileparametroh);

//Parmetros comunes del Modelo
        vi=parametroh[paciente+1][10];
        BW=parametroh[paciente+1][11];
        g[8][0]=parametroh[paciente+1][14];
        //vi=0.12*BW;     // Volumen de distribucin de la Insulina (L)
        ke=0.138;       // Eliminacin de insulina en plasma (min^-1)
        Ibasal=0;       // Utilizando el modelo de Tarn
        ub=ke*Ibasal;   // Flujo de Insulina Basal
        Ibasal=parametroh[paciente+1][12];  /// PRUEBA BORRAR

        ag=0.8;         // Biodisponibilidad de carbohidratos (unitless)
        tmg=40;         // Tasa de aparicin mxima de glucosa en el compartimiento accesible de glucosa (min)
        tmi=55;         // Tiempo de absorcin de insulina subcutnea (min)
        factor=1;       // para pasar de mmol a mg/dl

        // Parmetros identificados
        //vi=5.0985;      // Volumen de distribucin de la Insulina (L)
        //ke=0.2560;      // Eliminacin de insulina en plasma (min^-1)
        ke=parametroh[paciente+1][13];  /// PRUEBA BORRAR


// Parmetros para cada paciente
        vg=parametroh[paciente+1][1]*BW;   // L            Volumen de distribucin de la Glucosa
        f01=parametroh[paciente+1][2]*BW;  // mmol/min     Flujo de glucosa no insulino dependiente
        k12=parametroh[paciente+1][3];     // min-^1       Tasa de trasferencia
        ka[0]=parametroh[paciente+1][4];   // min-^1       Tasa de desactivacin
        ka[1]=parametroh[paciente+1][5];   // min-^1       Tasa de desactivacin
        ka[2]=parametroh[paciente+1][6];   // min-^1       Tasa de desactivacin
        Sit=parametroh[paciente+1][7];     // mU/Lmin      Sensibilidad de la distribucin de insulina
        Sid=parametroh[paciente+1][8];     // mU/Lmin      Sensibilidad al deshecho de la insulina
        Sie=parametroh[paciente+1][9];     // mU/L         Sensibilidad al EGP de la insulina

}

// Modelo de Cobelli
if ((endogeno==2)||(abs_glucosa==3)||(abs_insulina==3))
{
double parametroc[11][28];
//double EGPb, Ib, Gb, Vg, Vi, Sb,ic;
//double Ipb,   Km0, k2, k1, p2u, m1, m5, CL, HEb, m2, m4, m6;
//double m3, Ilb,  kp2, Gpb, ke1, ke2, Fcns, Gtb, HE, incertidumbre[4], n_montecarlos,variacion;
//ivalDb E, Vmt, Kmt, Kmx, Uii, Uid, U, alpha, beta, Ra, ingesta_r, qsto, residuo;


// Parmetros tomados de DallaMan et al. (2007)
// Toma desde el archivo parametros los parametros de cada paciente

        int pac=0, cont3=0;
        long length;
        char paramet[100];
        FILE *fileparametro;
        AnsiString archivop="parametros_cobelli.txt";
        fileparametro= fopen(archivop.c_str(), "r");
        if(!fileparametro)
                 ShowMessage(" no existe");
           for(cont3=0; cont3<28; cont3++)
                for (pac=0; pac<11; pac++)
                {
                   length = ftell(fileparametro);
                   fseek(fileparametro, length, SEEK_SET);
                   fscanf(fileparametro,  "%s", paramet);
                   if ((cont3>0)&&(pac>0))
                        parametroc[pac][cont3]=StrToFloat(paramet);
                }
        fclose(fileparametro);


// Asigna los valores a los parmetros de 2 pacientes
// Parmetros comunes
                // Tasa de aparicin de comida en plasma
                f=0.90;         // sin unidad             Fraccin de absorcin intestinal
                // Excrecin de glucosa
                ke1=0.0005;     // min-1 (Valor normal)   Tasa de filtracin glomerular
                ke2=339;        // mg/kg (Valor normal)   Umbral de glucosa renal
                Fcns=1;         // mg/kg/min              Absorcin de glucosa por el cerebro y globulos rojos
                HEb=0.6;        // sin unidad   Secrecin de insulina basal

if (abs_insulina==3)
{
//Parmetros insulina
			ka1d=parametroc[paciente][25];
			ka2=parametroc[paciente][26];
			kd=parametroc[paciente][27];
}

if ((endogeno==2)||(abs_glucosa==3))
// Parmetros propios de cada paciente
{
paciente=paciente;
                // Entrada
                BW=parametroc[paciente][1];      // kg           Peso del paciente
                EGPb=parametroc[paciente][2];    // mg/kg/min    Produccin de glucosa endgena
                Ib=parametroc[paciente][3];      // pmol/l       Insulina basal
                Xb=parametroc[paciente][22];
                //Ib=0;
                Gb=parametroc[paciente][4];      // mg/dl
                // De utilizacin
                Vmx=parametroc[paciente][12];    // mg/kg/min per pmol/l
                Km0=parametroc[paciente][13];    // mg/kg
                p2U=parametroc[paciente][16];    // min-1        Tasa constante de accin de insulina
                Vi=parametroc[paciente][11];     // l/kg         Volumen de distribucin de Insulina
                // Cintica de la Glucosa
                k2=parametroc[paciente][14];     // min-1        Parmetros de cambio entre Gp y Gt
                k1=parametroc[paciente][15];     // min-1        Parmetros de cambio entre Gt y Gp
                Vg=parametroc[paciente][10];     // dl/kg        Volumen de distribucin de glucosa
                // Cintica de la insulina
                m1=parametroc[paciente][17];     // min-1        Parmetro de cambio entre Il y Ip
                CL=parametroc[paciente][18];     // min-1
                m2=parametroc[paciente][23];
                m4=parametroc[paciente][24];
                // Produccin de Glucosa
                ki=parametroc[paciente][19];     // min-1
                kp2=parametroc[paciente][20];    // min-1                  Efectiviad de la glucosa en el higado
                kp3=parametroc[paciente][21];    // mg/kg/min per pmol/l   Amplitud de la accin de insulina en el higado
                factor=18;                        // para pasar de mmol a mg/dl
} 

}

// Modelo de Bergman
if (endogeno==3)
{
// Declaracin parmetros
double parametrob[11][11];

// Toma desde el archivo parametros_bergman los parametros de cada paciente

        int pac=0, cont3=0;
        long length;
        char paramet[100];
        FILE *fileparametrob;
        AnsiString archivopb="parametros_bergman_ajustados.txt";
        fileparametrob= fopen(archivopb.c_str(), "r");
        if(!fileparametrob)
                 ShowMessage(" no existe");
           for(cont3=0; cont3<11; cont3++) // Cantidad parmetros
                for (pac=0; pac<12; pac++)  // Numero de pacientes
                {
                   length = ftell(fileparametrob);
                   fseek(fileparametrob, length, SEEK_SET);
                   fscanf(fileparametrob,  "%s", paramet);
                   if ((cont3>0)&&(pac>0))
                        parametrob[pac][cont3]=StrToFloat(paramet);
                }
        fclose(fileparametrob);
        // Parmetros del modelo minimal presentados en Dua et al. (2006)
        /*
        p1=0;                   // min^-1 Tasa constante insulino independiente de glucosa en msculos, higado y tejido adiposo
        p2=0.025;               // min^-1 Tasa de disminucin del consumo de glucosa en el tejido
        p3=0.000013;            // L/mU min^2 Tasa constante del incremento insulino-dependiente de la capacidad de consumo en el tejido
        Vi_b=12;                  // L Volumen de distribucin de insulina
        Vg_b=92.6;              // dL
        */

       // Parmetros del modelo minimal presentados en Roy. (2007) (Ajustados con SAAM para paciente 5 UVa)
        p1=parametrob[paciente+1][1];     // min^-1 Tasa constante insulino independiente de glucosa en msculos, higado y tejido adiposo
        p2=parametrob[paciente+1][2];     // min^-1 Tasa de disminucin del consumo de glucosa en el tejido
        p3=parametrob[paciente+1][3];     // L/mU min^2 Tasa constante del incremento insulino-dependiente de la capacidad de consumo en el tejido
        p4=parametrob[paciente+1][4];     // 1/ml Volumen de distribucin de insulina
        n=parametrob[paciente+1][5];      // 1/min
        Vg_b=parametrob[paciente+1][6];                  // dL  Tasa de eliminacin de insulina
        g[8][0]=parametrob[paciente+1][7];
        BW=parametrob[paciente+1][8];
        Ib_b=parametrob[paciente+1][9];
        Xb_b=parametrob[paciente+1][10];


        // Parmetro tomado de Bergman et al. (1981)
        //n=0.23;                 // min^-1 Tasa de eliminacin de insulina
        factor=18;              // para pasar de mmol a mg/dl

}

// Modelo de Panunzi
if (endogeno==4)
{
// Parmetros del modelo
Vg_p=0.152;                // (L kg/Bw)    Volumen de distribucin de glucosa
//Id=41.79;                // (pM mM-1)
tg=19*multi;               // (min)
Kxgi=1.43*1e-4;            // (min-1 pM-1)
Kxi=0.101;                 // (min-1)
gamma=2.464;               // (#)
G1=9;                      // (mM)
Vi_p=0.25;                 // L(kgBW-1)   Volumen de distribucin de insulina
factor=1;                  // para pasar de mmol a mg/dl
}

////////////////////////////////////////////////////////////////////////////////
// CARGA DE DATOS COMIDA MIXTA
{

// Toma desde el archivo comidas_mixtas los valores de la comida

        int ncomi=0, comi=0;
        long length;
        char vcomida[100];
        FILE *fileparametrocm;
        AnsiString archivopcm="comidas_mixtas.txt";
        fileparametrocm= fopen(archivopcm.c_str(), "r");
        if(!fileparametrocm)
                 ShowMessage("no existe");
           for(ncomi=0; ncomi<t_simul; ncomi++) // Minutos de las comidas
                for (comi=0; comi<(cgrupos*2); comi++)  // Numero de comidas
                {
                   length = ftell(fileparametrocm);
                   fseek(fileparametrocm, length, SEEK_SET);
                   fscanf(fileparametrocm,  "%s", vcomida);
                   if ((comi>=0)&&(ncomi>=0))
                        parametrocm[comi][ncomi]=StrToFloat(vcomida);
                }
        fclose(fileparametrocm);

       // Comidas mixtas
      //Estos valores sern cargados dentro del ciclo de la simulacin
}



////////////////////////////////////////////////////////////////////////////////

// Calculo de concentracin de glucosa  de acuerdo a cada modelo escogido

double cant_insulina, cant_insul, cant_insul1, cant_insul2, t_comi,  t_ins, t_insu, t_infusion;
double t_com, t_com1, t_com2;
ivalDb u;

// Clculo de dosis e instante de inyeccin inicial
 dosis_inicial(g[9][0].Inf, comida.Inf, &cant_insul, &t_com);

// Determina en que rango de cantidad de insulina e instante de inyeccin realiza la bsqueda
if (cant_insul>3){  cant_insul1=((cant_insul*2)-1)-(3*2); cant_insul2=((cant_insul*2)-1)+(3*2)+1; } else if (cant_insul==3) {cant_insul1=1; cant_insul2=12;} else {cant_insul1=(cant_insul*2)-1; cant_insul2=((cant_insul*2)-1)+(3*2)+1;}
if (t_com>30){ t_com1=t_com-30;  } else { t_com1=0; };     // Tiempo Inicial para la comida
if (t_com<90) t_com2=t_com+35; else t_com2=125;            // Tiempo Final para la comida


// Datos para prueba (Clculo con una sola cantidad de insulina e instante de inyeccin)
cant_insul1=1; cant_insul2=2;
//t_com1=0; t_com2=65; // Original
t_com1=1; t_com2=10; // Prueba
//t_ins=0; //Para cuando hay hipoglucemia


////////////// Declaracin archivos salida datos /////////////////////////////
 // Archivo de salida de datos de comida
 // Archivo en el cual se guardan los resultados y se imprime el infimo y supremo de la matriz v de cada variable
 int  n1=0, l=0, c1=0, marca=0;
 FILE *out_glucosa;
 AnsiString name="glucosa_"+FloatToStr(comida.Inf)+".m";
 out_glucosa= fopen(name.c_str(), "w+");

//Vector que se crea para guardar el nombre de las variables en la impresin en el archivo de salida
 char line[10], line2[10];
 AnsiString imp[2]={"g_i_","g_s_"};

  // Archivo de salida de los datos generados con Montecarlo
  FILE *out_montecarlo;
  // Impresin datos montecarlo
  AnsiString name1="montecarlo_"+FloatToStr(comida.Inf)+".m";
  out_montecarlo= fopen(name1.c_str(), "w+");

///////////////////////////////////////////////////////////////////////////////


for (cant_insulina=cant_insul1; cant_insulina<cant_insul2; cant_insulina++)// Tres inyecciones de insulina bolus
{
  for (t_comi=t_com1; t_comi<t_com2; t_comi=(t_comi+15))  // Variacin tiempo de comida cada 15 min
    {
       for (variacion=0; variacion<=n_montecarlos; variacion++)  // Calcula n_montecarlos
        {

                if (t_ins==1) // Asigna los instantes de insulina
                        {t_insu=t_comi;
                         t_comida=0;      }
               else     {t_comida=t_comi;
                         t_insu=t_ins;    }

           for (i=0; i<t_simul; i++)
            {

             ///////////////////////////////////////////////////////////////////////////////////////



                if (abs_glucosa==1)  // Modelo de absorcin de glucosa Hovorka impulsional
                {
                        g[10][0]=0;
                        if ((i==0)&&(variacion==0))
                        { g[18][0]=comida*1000/180; // Conversin de los CHO (gr) a mmol
                          g[18][0]=ivalDb(g[18][0].Inf*(1-(incertidumbre[0]/100.0)),g[18][0].Sup*(1+(incertidumbre[0]/100.0)));
                          monte[0]=g[18][0];
                        }
                        
                        abs_glucosa_impulsional(g[18][0],i,t_comida,&g[10][i+1]);
                }

                if (abs_glucosa==2)  // Modelo de absorcin de glucosa Hovorka escalon
                {       if ((i==0)&&(variacion==0))
                        { g[18][0]=comida*1000/180; // Conversin de los CHO (gr) a mmol
                          g[18][0]=ivalDb(g[18][0].Inf*(1-(incertidumbre[0]/100.0)),g[18][0].Sup*(1+(incertidumbre[0]/100.0)));
                          monte[0]=g[18][0];
                        }
                        
                        abs_glucosa_escalon(g[18][0], i, t_comida, t_comida, &g[10][i+1]);
                }

                if (abs_glucosa==3) // Modelo gastrointestinal de DallaMan
                {
                t_duracion=15;
                if ((i==0))
                {       g[18][0]=0;
                        g[1][0]= 0; /* Qsto  */  g[2][0]= 0; /* Qsto1 */
                        g[3][0]= 0; /* Qsto2 */  g[4][0]= 0; /* Qgut  */
                        g[10][0]= 0; /* Ra */    g[18][0]=0; /* D     */
                        marcaqsto=0;  qsto=0;
                 }

                // Validacin comidas
                  if ((i>=t_comida)&&(i<(t_comida+t_duracion)))
                     {if ((i==t_comida)||(variacion==0))
                           {g[18][i+1]=(comida*1000)/((t_comida+t_duracion)-t_comida); // Pasar de gr a mg y dividir en el tiempo de comida
                            g[18][i+1]=ivalDb((g[18][i+1].Inf-(g[18][i+1].Inf*incertidumbre[0]/100.0)),(g[18][i+1].Inf+(g[18][i+1].Inf*incertidumbre[0]/100.0))); // Asignacin de incertidumbre
                            //g[18][i+1]=ivalDb(g[18][i+1].Inf*0.95,g[18][i+1].Inf*0.95); // Asignacin de incertidumbre
                            monte[4]=g[18][i+1];}
                      else g[18][i+1]=g[18][i];
                      ingestar=g[18][i+1];
                    if ((i==t_comida)&&(g[1][i]>0))
                       {qsto=g[1][i].Inf;
                        marcaqsto=1;}
                       }
                  else    {g[18][i+1]=0;}

                  
                        abs_glucosa_dallaman (  t_duracion, g[1][i], qsto, g[2][i], g[3][i], g[4][i],
                                                g[10][i], g[18][i], ingestar,  &g[1][i+1], &g[2][i+1],
                                                &g[3][i+1], &g[4][i+1], &g[10][i+1], &g[5][i+1]);


                        // Asignando incertidumbre a Ra
                        g[10][i+1]=ivalDb(g[10][i+1].Inf*0.925, g[10][i+1].Sup*1.075);
                        /*
                        if (g[10][i+1].Inf>0)
                        {if  (g[10][i+1].Inf<0.2)  g[10][i+1]=ivalDb(g[10][i+1].Inf- g[10][i+1].Inf, g[10][i+1].Sup+0.2);
                         else                      g[10][i+1]=ivalDb(g[10][i+1].Inf-0.2, g[10][i+1].Sup+0.2);
                        }
                         */
                }

                if (abs_glucosa==4)  // Comidas mixtas
                {  
                 ncomida_f=ncomida+(ncomida-1); 
                 g[10][i].Inf=parametrocm[ncomida_f-1][i];
                 g[10][i].Sup=parametrocm[ncomida_f][i];
                }



               ///////////////////////////////////////////////////////////////////////////////////////

                if (abs_insulina==1)  // Modelo de absorcin de insulina  de Hovorka
                {       t_infusion=20;  // tiempo que tarda en darse la infusin
                        if (i==0)
                        {  g[14][0]=tmi*(0);            //S1 Absorcin subcutnea de insulina
                           g[15][0]=g[14][0];           //S2 Absorcin subcutnea de insulina
                           g[17][0]=g[15][0]/tmi;       //Ui Tasa de absorcin de insulina
                        }
                        if ((i>=0)&&(i<=t_infusion))
                           {u=(cant_insulina*1000)/20.0;
                            abs_insulina_hovorka(u, g[14][i], g[15][i], &g[17][i+1], &g[14][i+1], &g[15][i+1]);}
                        else g[17][i+1]=0;
                        ub=ke*10; //Flujo de Insulina Basal

                }

                if (abs_insulina==2)  // Modelo de absorcin de insulina  de Tarn
                {
                  //if (i==0) g[17][0]=0;

                 ins_exogena(i, paciente, tipo_insulina, &g[17][i]); // Borrar solo es para prueba
                 //ins_exogena(i, cant_insulina, tipo_insulina, &g[17][i]);

                }

                if (abs_insulina==3)  // Modelo de absorcin de insulina  de Dalla Man
                {       t_infusion=15;  // tiempo que tarda en darse la infusin
                        if (i==0)
                        {  g[19][0]=g[20][0]/(kd+ka1d);            //S1 Absorcin subcutnea de insulina
                           g[20][0]=(g[19][0]*kd)/ka2;           //S2 Absorcin subcutnea de insulina
                           g[17][0]=0;       //S Tasa de absorcin de insulina
                        }
                        if ((i>=0)&&(i<=t_infusion))
                           abs_insulina_dallaman(u, g[19][i], g[20][i], &g[17][i+1], &g[19][i+1], &g[20][i+1]);
                        else g[17][i+1]=0;
                        

                }

               ///////////////////////////////////////////////////////////////////////////////////////
               
                if (endogeno==1) // Modelo endgeno de Hovorka
                {
                 if ((i==0)&&(variacion==0))
                 {
                 Ibasal=Ibasal/6.0;
                 g[8][0]=g[8][0]/18.00;/* G  */        g[5][0]=g[8][0]*vg;;  /* q1 */
                 g[7][0]=Ibasal;       /* I  */        g[9][0]=Sit*g[7][0];  /* x1 */
                 g[11][0]=Sid*g[7][0]; /* x2 */        g[12][0]=Sie*g[7][0]; /* x3 */


                 // Valores Iniciales de fc01 y fr
                 if (g[8][0]>=4.5)  fc01=f01;   else  fc01=(f01*g[8][0])/4.5;
                 if (g[8][0]>=9)    fr=0.003*(g[8][0]-9)*vg;   else     fr=0;

                 egp0=(fc01+(g[5][0]*g[9][0])*(1-(k12/(k12+g[11][0])))+fr-g[10][0])/(1-g[12][0]); // EGP0 Puntual(calculado con los valores nominales de Sit, Sid y Sie)

                 if ((incertidumbre[4]>0)||(incertidumbre[5]>0)||(incertidumbre[6]>0))
                 {
                 // Asignacin de incertidumbre
                 Sit=ivalDb(Sit.Inf*(1-(incertidumbre[4]/100.0)),Sit.Sup*(1+(incertidumbre[4]/100.0)));
                 Sid=ivalDb(Sid.Inf*(1-(incertidumbre[5]/100.0)),Sid.Sup*(1+(incertidumbre[5]/100.0)));
                 Sie=ivalDb(Sie.Inf*(1-(incertidumbre[6]/100.0)),Sie.Sup*(1+(incertidumbre[6]/100.0)));
                 }
                 g[6][0]=(g[9][0]*g[5][0])/(k12+g[11][0]); //Q2 basal (mmol)
                 g[13][0]=(g[8][0]*vg)+(Du(g[9][0])*g[5][0]/(Du(k12)+g[11][0])); // Valor de S en estado de equilibrio

                 }


                 if (variacion==0)
                 {
                 //g[10][i]=g[10][i]*BW/180.0;   // Conversin de unidades para la absorcin de glucosa
                 //g[17][i]=g[17][i]*(BW/6.0);  // Pasar de pmol a mU    (Modelo Cobelli)
                 }

                 endogeno_hovorka(paciente, g[17][i]*(BW/6.0), g[5][i], g[6][i], g[7][i], g[9][i], g[11][i],
                                  g[12][i], g[13][i], g[8][i], g[10][i]*BW/180.0, i, f01, &g[5][i+1], &g[6][i+1],
                                  &g[7][i+1], &g[9][i+1], &g[11][i+1], &g[12][i+1], &g[13][i+1],
                                  &g[8][i+1]);
                }


                if (endogeno==2) // Modelo endgeno de Cobelli
                {
                       if ((i==0)&&(variacion==0))
                       {

                        Ipb=Ib*Vi;
                        // Insulina en Plasma

                        // Los valores de m2 y m4 han sido reemplazados por los establecidos en los parmetros
                        // de UVa, ya que el clculo realizando mediante las funciones no coincidia con el valor
                        // tomado en UVa en el instante inicial
                        //m2=3*CL/(5*HEb*(Vi*BW));       // min-1    Parmetro de cambio entre Ip y Il
                        //m4=2*CL/(5*(Vi*BW));           // min-1

                        m3=HEb*m1/(1-HEb);             // min-1
                        Ilb=Ipb*m2/(m1+m3);            // pmol/kg

                        Gpb=Gb*Vg;     //

                        // Clculos sin excrecin de glucosa (Diabtico)
                        Gtb=(Fcns-EGPb+k1*Gpb)/k2;
                        Vm0=(EGPb-Fcns)*(Km0+Gtb)/Gtb;
                        kp1=EGPb+kp2*Gpb+kp3*Ib;
                        // Insulina Basal
                        ic=(m2+m4)*Ipb-m1*Ilb;

                        g[6][0]= Gpb;    /* Gp  */   g[7][0]= Gtb; /* // Gt */
                        g[8][0]= Gb;     /* G   */   g[9][0]= Ilb; /* // Il */
                        g[11][0]=Ipb;    /* Ip  */   g[12][0]=Ib;  /* // I  */
                        g[13][0]=Xb;     /* X   */   g[14][0]=Ib;  /* // I1 */
                        g[15][0]=Ib;     /* Id  */
                        //g[17][0]=0;   /* // Iex*/
                       
					 if ((incertidumbre[1]>0)||(incertidumbre[2]>0)||(incertidumbre[3]>0))
                        {
                        // Asignar incertidumbre
                        ki=ivalDb(ki.Inf*(1-(incertidumbre[1]/100.0)),ki.Sup*(1+(incertidumbre[1]/100.0)));
                        kp3=ivalDb(kp3.Inf*(1-(incertidumbre[2]/100.0)),kp3.Sup*(1+(incertidumbre[2]/100.0)));
                        Vmx=ivalDb(Vmx.Inf*(1-(incertidumbre[3]/100.0)),Vmx.Sup*(1+(incertidumbre[3]/100.0)));
                        //Vm0=ivalDb(Vm0.Inf*(1-(incertidumbre[3]/100.0)),Vm0.Sup*(1+(incertidumbre[3]/100.0)));
                        Vm0=ivalDb(Vm0.Inf*0.93,Vm0.Sup*1.07);
                        //p2U=ivalDb(p2U.Inf*0.98,p2U.Sup*1.02);
                        monte[0]=ki;  monte[1]=kp3;  monte[2]=Vmx;  monte[3]=Vm0;
                        }
              }

                        Vmt=Vm0+Vmx*g[13][i];
                        Kmt=Km0;


                        //g[17][i+1]=(g[17][i+1]*6/BW)+ic; // Insulina  Exgena  (De mu a pmol/kg)   BORRAR COMENTARIO

                        cinet_insulina_cobelli ( g[14][i], m1, m2, m3, m4,
                                        g[12][i], g[15][i], g[11][i], g[9][i], g[17][i],
                                        ki, Ib,  g[13][i],
                                        &g[9][i+1], &g[11][i+1], &g[12][i+1], &g[13][i+1], &g[14][i+1],
                                        &g[15][i+1]);

                        endogeno_cobelli ( g[6][i], g[7][i], g[10][i], g[15][i],
                                           Vmt, Kmt, &g[6][i+1], &g[7][i+1], &g[8][i+1]);
                }

                if (endogeno==3) // Modelo endgeno de Bergman
                {
                      if ((i==0)&&(variacion==0))
                        {

                        g[11][0]=Xb_b; /* X */
                        g[7][0]=0;     /* I */

                        g[7][0]=Ib_b/6.0;;
                        Gb_B=g[8][0];


                        if ((incertidumbre[4]>0)||(incertidumbre[5]>0)||(incertidumbre[6]>0))
                        {
                        // Asignacin de incertidumbre
                        p1=ivalDb(p1.Inf*(1-(incertidumbre[4]/100.0)),p1.Sup*(1+(incertidumbre[4]/100.0)));
                        p2=ivalDb(p2.Inf*(1-(incertidumbre[5]/100.0)),p2.Sup*(1+(incertidumbre[5]/100.0)));
                        p3=ivalDb(p3.Inf*(1-(incertidumbre[6]/100.0)),p3.Sup*(1+(incertidumbre[6]/100.0)));
                        n=ivalDb(n.Inf*(1-(incertidumbre[2]/100.0)),n.Sup*(1+(incertidumbre[2]/100.0)));
                        monte[0]=p1;  monte[1]=p2;  monte[2]=p3;  monte[3]=n;
                        Gb_B=ivalDb(g[8][0].Inf*0.93,g[8][0].Inf*1.07);  // Incertidumbre en la glucosa basal
                        }
                        }
                        g[10][i]=g[10][i]*BW;   // Conversin de unidades para la absorcin de glucosa
                        g[17][i]=(g[17][i]*BW)/6.0;    // Pasar de pmol a mU    (Modelo Cobelli)
                        //g[10][i]=0;


                        endogeno_bergman(  g[8][i], g[11][i], g[7][i], g[8][0],
                                           g[7][0], g[17][i], g[10][i], Vg_b,
                                           Vi_b, &g[8][i+1], &g[11][i+1], &g[7][i+1]);
                }

                if (endogeno==4) // Modelo endgeno de Panunzi
                {
                        if ((i==0)&&(variacion==0))
                        {
                        g[8][0]=4.44;   /* G */  g[7][0]=10;  /* I */
                        Tigmax=Kxi*g[7][0].Inf*Vi_p*(pow((G1/g[8][0].Inf),gamma)+1);
                        // Asignacin de incertidumbre
                        Kxgi=ivalDb(Kxgi.Inf*(1-(incertidumbre[3]/100.0)),Kxgi.Sup*(1+(incertidumbre[3]/100.0)));
                        monte[0]=Kxgi;
                        }

                        g[10][i+1]=g[10][i+1]/180.0;   // Conversin de unidades para la absorcin de glucosa   a mmol
                        g[17][i+1]=g[17][i+1]/6;       // Conversin a pM
                        if (i>=tg) G_tg=g[8][i-tg]; else G_tg=0;

 
                        endogeno_panunzi (g[8][i], g[7][i], g[8][0], g[7][0], g[17][i],
                                          g[10][i], G_tg, i, Vg_p, Vi_p, &g[8][i+1], &g[7][i+1]);
                }

                ///////////////////////////////////////////////////////////////////////////////////////
                if (variacion==0)
                ///// CALCULO DE RIESGO
                {               if((g[8][i+1].Inf<=2*factor)&&(h_i[0]==0))//hipoglucemia severa inicial
                                   { h_i[0]=1; GR[0][glu0]=g[8][i+1].Inf; glu0++; GR[0][glu0]=i+1; glu0++;}

                                if((g[8][i+1].Inf>2*factor)&&(h_i[0]==1)&&(g[8][i+1].Inf<2.4*factor))
                                    { h_i[0]=0; GR[0][glu0]=g[8][i].Inf; glu0++; GR[0][glu0]=i; glu0++;}    //hipoglucemia severa final
                                else if((g[8][i+1].Inf>2*factor)&&(h_i[1]==0)&&(g[8][i+1].Inf<=3.9*factor))
                                   { h_i[1]=1; GR[1][glu1]=g[8][i+1].Inf; glu1++; GR[1][glu1]=i+1; glu1++;} //hipoglucemia moderada inicial

                                if(((g[8][i+1].Inf>3.9*factor)&&(h_i[1]==1)&&(g[8][i+1].Inf<4.3*factor))||((g[8][i+1].Inf<=2*factor)&&(h_i[1]==1)))
                                   { h_i[1]=0; GR[1][glu1]=g[8][i].Inf; glu1++;  GR[1][glu1]=i; glu1++; }   //hipoglucemia moderada final

                               if((g[8][i+1].Sup>=13.9*factor) && (h_i[2]==0))
                                   { h_i[2]=1; GR[2][glu2]=g[8][i+1].Sup; glu2++; GR[2][glu2]=i+1; glu2++;} //hiperglucemia severa inicial

                               if((g[8][i+1].Sup<13.9*factor)&&(h_i[2]==1) && (g[8][i+1].Sup>12*factor))
                                   { h_i[2]=0; GR[2][glu2]=g[8][i].Sup; glu2++; GR[2][glu2]=i; glu2++;}     //hiperglucemia severa final

                               else if((g[8][i+1].Sup>=8.39*factor)&&(h_i[3]==0)&&(g[8][i+1].Sup<13.9*factor))
                                   { h_i[3]=1; GR[3][glu3]=g[8][i+1].Sup; glu3++; GR[3][glu3]=i+1; glu3++;} //hiperglucemia moderada inicial

                                if(((g[8][i+1].Sup<8.39*factor)&&(h_i[3]==1)&&(g[8][i+1].Sup>8*factor))||((g[8][i+1].Sup>13.9*factor)&&(h_i[3]==1)))
                                   { h_i[3]=0; GR[3][glu3]=g[8][i].Sup; glu3++; GR[3][glu3]=i; glu3++;}     //hiperglucemia moderada final
                   }
                   ///////////////////////////////////////////////////////////////////////////////////////

            } // Finaliza for i




///////////////////////////////////////////////////////////////////////////////
// Impresin de Resultados

  c1=7;  //salida
  for (n1=0; n1<2; n1++)
   {
       if (variacion==0)
        { fprintf(out_glucosa, "%s",imp[n1]+FloatToStr(cant_insulina)+"_0_"+FloatToStr(t_comida)+"=[");
          fprintf(out_glucosa, " ");}
      // else if ((variacion<=n_montecarlos)&&(marca==0)&&(n1==0))  // Impresin datos Montecarlo
     //  else if ((variacion==1)&&(marca==0))  // Impresin datos Montecarlo
      //  { fprintf(out_montecarlo, "%s", "monte_"+FloatToStr(canti_insulina)+"_0_"+FloatToStr(t_comida)+"=[");
       //   fprintf(out_montecarlo, " ");}

     for (l=0; l<(t_simul/multi); l++)
     {
       if (marca==0)
          {
           if (variacion==0)
           {       fprintf(out_glucosa, "%E", g[1+c1][l*multi+1].Inf);
                   fprintf(out_glucosa, " ");}
           /*
		else {  // Impresin datos Montecarlo
                   fprintf(out_montecarlo, "%E", g[1+c1][l*multi+1].Inf);
                   fprintf(out_montecarlo, " ");}
          */
           if((c1!=10))
           {g[1+c1][l*multi+1].Inf=0;}
           }
       else
          {
          if (variacion==0)
           {    fprintf(out_glucosa, "%E", g[1+c1][l*multi+1].Sup);
                fprintf(out_glucosa, " ");
           if((c1!=10))
            g[1+c1][l*multi+1].Sup=0;
          }
          }
     } // Finaliza for l
      if (marca==0)   marca=1;
      else
        {
                marca=0;
                c1=c1+1;
                if (c1==6)
                   c1=c1+2;
        }

     if (variacion==0)
        {  fprintf(out_glucosa, "];");
           fprintf(out_glucosa, "\n");}
      // Impresin datos Montecarlo
     /*
      else if ((marca==0)&&(variacion<(n_montecarlos)))
        {  fprintf(out_montecarlo, ";");
           fprintf(out_montecarlo, " ");}
     else if ((variacion==n_montecarlos)&&(marca==0))
             {  fprintf(out_montecarlo, "]");
           fprintf(out_montecarlo, "\n");}
     */
  } // Finaliza for n

     //Impresin de datos de hiper e hipoglucemia
       if (variacion==0)
       {        fprintf(out_glucosa, "%s", "datos_int_"+FloatToStr(cant_insulina)+"_0_"+FloatToStr(t_comi)+"=[ ");

       for(k=0; k<4; k++)
        {
        for(dr=0; dr<12; dr++)
         {
          if(variacion==0)
                {fprintf(out_glucosa, "%E", GR[k][dr]);
                 fprintf(out_glucosa, " ");
                 GR[k][dr]=0;
                 }
         } // Finaliza for d
         if (variacion==0)
                fprintf(out_glucosa, ";");
          h_i[k]=0;
         } // Finaliza for k
         if (variacion==0)
                fprintf(out_glucosa, "];");
          k=0; dr=0; glu0=0; glu1=0; glu2=0; glu3=0;
        }

        }// Finaliza for variacion
     } // Finaliza for t_comi
} // Finaliza for cant_insulina



  fclose(out_glucosa);
  delete g;
  ShowMessage("Proceso Terminado");


        
}
//---------------------------------------------------------------------------


