// Herramienta de Dosificacin
// Maira Alejandra Garca Jaramillo
// Ultima fecha de modificacin: 29 de Enero de 2008
// MiceLab 


//---------------------------------------------------------------------------
#include "windows.h"
#include "ColorHLS.h"
//#include <vcl.h>
#pragma hdrstop

#include "FSParser.h"
#include "Unit1.h"
#include "matrix.h"
#include <iostream.h>
#include "time.h"
#include "vector.h"

#include <fstream>
#include "math.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

char* File;
char* Func;

//fstar *Problem1;
fstar *Problem;
//vector<fstar> Problem;
qsi QSI;
//int pos_fstar;
box Lbox[10000];
int maxbox;
double x0;
double y0;
double z0;
vector< vector<int> > buffer;
double factor;
ivalDb screen;
int box_in;
int box_out;
int pixel_in;
int pixel_out;
double par1,par2,par3,par4;
matrix mv;

// Declaracin
double   vg, vi,  tmi,h, ke, peso, ub, f01;
int multi, incertidumbre_k, incertidumbre_tmg, incertidumbre_dg;
ivalDb  ka[3], kb[3], k12, Sit, Sid, Sie,dg,u;
ivalDb egp0, fc01, fr, fc02, ag, tmg;
double aleatori[7][5000]; // Guardo los valores aleatorios generados
double BW, kabs, f;


// Archivo f*
 FILE *festrella;
 AnsiString FSTAR="funcion.txt";
 AnsiString cadena[16], paso[11];
 AnsiString  paso_q1[500],  paso_i[500], paso_x1[500], paso_x2[500], paso_x3[500], paso_q2[500], paso_ug[500], paso_f01[500], paso_fr[500];

//---------------------------------------------------------------------------

// Main

int main(int argc, char* argv[])
{
 Application->Initialize();
 Application->CreateForm(__classid(TForm1), &Form1);
 Application->Run();
}
//----------------------------------------------------------------------------

// FUNCION PARA EL CALCULO DE LA FSTAR

ivalDb estrella(AnsiString  parametro, ivalDb I2, ivalDb *X, int num_cadena)
{
ivalDb F_1;
                FILE *festrella;
                AnsiString FSTAR="funcion.txt";

                festrella= fopen(FSTAR.c_str(), "w+");
                //Creacin del archivo para el llamado a la F*
                fprintf(festrella, "%s", "Algorithm=FSTAR;");
                fprintf(festrella, "%s", "\n");
                //cadena[0]="%;";
                cadena[4]=parametro+"=["+FloatToStr(I2.Inf)+","+FloatToStr(I2.Sup)+"];";
                cadena[8]="Epsilon=0.001;";
                cadena[9]="Tolerance=1e-3;";
                cadena[10]="Time=0.5;";
                cadena[11]="Optim=0;";
                cadena[12]="Solution=1;";

                int f=0;
                  for (f=0; f<num_cadena; f++)
                        {
                        fprintf(festrella, "%s", cadena[f]);
                        fprintf(festrella, "%s", "\n");
                        }
                  for (f=0; f<8; f++)
                        {
                        fprintf(festrella, "%s", "%"+paso[f]);
                        fprintf(festrella, "%s", "\n");
                        }

             //Funcin para la cul se va a calcular F*
             fclose(festrella);

             box B;
             fstream fout;
             RunParser("funcion",Problem[0]);
             Problem[0].Run(B,fout);

               // Guarda los valores del clculo de la externa
               F_1.Inf=Problem[0].GetTwin().GetOut().Inf;
               F_1.Sup=Problem[0].GetTwin().GetOut().Sup;
               Problem[0].~fstar();

               *X=ivalDb(F_1.Inf,F_1.Sup);  // Intervalo respuesta       
}

//---------------------------------------------------------------------------

// FUNCIONES PARA EL MODELO ENDOGENO

// Entradas: (ui: cantidad de insulina, q1: masa de glucosa en el compartimento accesible;
// q2: masa de glucosa en el compartimento no accesible, I: concentracin de insulina;
// x1, x2, x3: efectos de la insulina; g: concentracin de glucosa en sangre;
// ug: absorcin de glucosa; t: minuto de simulacin)
// Salidas: (*Q1: masa de glucosa en el compartimento accesible,
// *Q2: masa de glucosa en el compartimento no accesible;
// *I1: concentracin de insulina; *X1, *X2 y *X3: efectos de la insulina;
// *G: concentracin de glucosa; *F01: Flujo de glucosa no
// insulino dependiente; *FR: eliminacin de glucosa renal)
//---------------------------------------------------------------------------

// CALCULO DEL MODELO ENDOGENO (CON PARAMETROS PUNTUALUALES) 

ivalDb endogeno_puntual(ivalDb ui, ivalDb q1, ivalDb q2, ivalDb I, ivalDb x1,
                        ivalDb x2, ivalDb x3, ivalDb g, ivalDb ug, ivalDb *Q1,
                        ivalDb *Q2, ivalDb *I1, ivalDb *X1, ivalDb *X2,
                        ivalDb *X3, ivalDb *G, ivalDb *F01, ivalDb *FR)
{
ivalDb I1_1, X1_1, X2_2, X3_3;
double  f;
AnsiString  parameter;

   // Valores de fc01 y fr
   if (g>=4.5)  // Clculo del valor de Fc01 de acuerdo a la concentracin de glucosa en sangre
       fc01=f01;
   else fc01=(f01*g)/4.5;
    

   // Clculo del valor de fr de acuerdo a la concentracin de glucosa en sangre
   if (g>=9) fr=0.003*(g-9)*vg;
   else      fr=0;


        // METABOLISMO DE LA GLUCOSA
        *Q1=-fc01*h+q1*(1-x1*h)+(k12*q2-fr+ug+(egp0*(1-x3)))*h;  // Masa de glucosa en sangre en el compartimiento accesible (mmol)
        *Q2=x1*q1*h+q2*(1-k12*h-x2*h); //q2 Masa de Glucosa (mmol)
        *G=q1/vg;  //G(t) Concentracin de Glucosa  (mmol/dl)

        // CONCENTRACIN DE INSULINA EN PLASMA
        *I1=(ui/vi)*h-I*((ke*h)-1)+ub*h;  // Concentracin de glucosa en sangre (mU/(L*min))

        // SUBSISTEMA DE ACCION DE LA INSULINA
        *X1=x1*(1-(ka[0]*h))+(ka[0]*Sit*I*h);   // Efecto de la insulina en el transporte de glucosa (1/min)
        *X2=x2*(1-(ka[1]*h))+(ka[1]*Sid*I*h);   // Efecto de la insulina en la disposicin de glucosa (1/min)
        *X3=x3*(1-(ka[2]*h))+(ka[2]*Sie*I*h);   // Efecto de la insulina en la produccin de glucosa endgena (1/min)


        *F01=fc01;
        *FR=fr;
    }
//---------------------------------------------------------------------------

//FUNCIN DEL MODELO ENDGENO MEDIANTE CLCULO RACIONAL (PARAMETROS CON INCERTIDUMBRE)

ivalDb endogeno_intervalar_m (ivalDb ui, ivalDb q1, ivalDb q2, ivalDb I, ivalDb x1,
                              ivalDb x2, ivalDb x3, ivalDb s, ivalDb g, ivalDb ug,
                              int t, ivalDb *Q1, ivalDb *Q2, ivalDb *I1, ivalDb *X1,
                              ivalDb *X2, ivalDb *X3, ivalDb *S, ivalDb *G,
                              ivalDb *F01, ivalDb *FR)
{
ivalDb FC, vmin, B, f01c, vmin_ini1, vmin_ini2, vmin_1, vmin_2;
double  f;
AnsiString  parameter;


  //Valor para f01c inferior
   if (q1.Inf<4.5*vg)
       f01c.Inf=(f01*q1.Inf)/(4.5*vg);
   else
       f01c.Inf=f01;

   //Valor para f01c superior
   if (q1.Sup<4.5*vg)
       f01c.Sup=(f01*q1.Sup)/(4.5*vg);
   else
       f01c.Sup=f01;

   //Valor para fr inferior
   if (q1.Inf<9*vg)
       fr.Inf=0;
   else
       fr.Inf=0.003*q1.Inf-0.027*vg;

   //Valor para fr superior
   if (q1.Sup<9*vg)
       fr.Sup=0;
   else
       fr.Sup=0.003*q1.Sup-0.027*vg;

   // Valor para FC
   if (q1<4.5*vg)
        FC= f01/(4.5*vg);
   else if ((q1>=(4.5*vg))&&(q1<=(9*vg)))
        FC=0;
   else 0.003;


        //Restriccin
        vmin=min(1/(k12+x1+FC),1/(k12+x2)); // Restriccin para el clculo optimal

        if (t==0)// Restricciones para el instante inicial
                {
                vmin_ini1=min(1/(f01/(4.5*vg)+(x1*x2)/(k12+x2)),1/(k12+x1));
                vmin_ini2=min(vmin_ini1,(1+x1/(k12+x2))/(f01/(4.5*vg)+x2*x1/(k12+x2)));
                }
        else    {
                vmin_1=min(1/(k12+x1+f01/(4.5*vg)),1/(k12+x1));
                vmin_2=min(vmin_1,1/x2);
                }

        // Verificacin de restricciones para el clculo optimal
        if((h>vmin)&&(h>vmin_ini2)&&(h>vmin_2))
                if ((t>0)&&(x2<f01/(4.5*vg)))
          {ShowMessage("Funcion no montona");}
               {
                 //Clculo Racional (Modelo endgeno)
                 B=ug+egp0*(1-x3);
                 *Q1=q1*(1-h*(k12+x1))-h*(Du(f01c)+Du(fr))+(h*s*k12)+(h*B);
                 *S=q1*h*Du(x2)-h*(Du(f01c)+Du(fr))+s*(1-(h*x2))+B*h;
                 *Q2=*S-Du(*Q1);
               }
      
        *G=q1/vg;  //G(t) Concentracin de Glucosa  (mmol/dl)

        *I1=(ui/vi)*h-I*((ke*h)-1)+ub*h;       // Concentracin de glucosa en sangre (mU/(L*min))
                
        // SUBSISTEMA DE ACCION DE LA INSULINA
        *X1=x1*(1-(ka[0]*h))+(ka[0]*Sit*I*h);  // Efecto de la insulina en el transporte de glucosa (1/min)
        *X2=x2*(1-(ka[1]*h))+(ka[1]*Sid*I*h);  // Efecto de la insulina en la disposicin de glucosa (1/min)
        *X3=x3*(1-(ka[2]*h))+(ka[2]*Sie*I*h);  // Efecto de la insulina en la produccin de glucosa endgena (1/min)


        *F01=f01c;
        *FR=fr;
}
//---------------------------------------------------------------------------

//FUNCIN DEL MODELO ENDGENO CALCULADO MEDIANTE LA FSTAR (PARAMETROS CON INCERTIDUMBRE)

ivalDb endogeno_intervalar(ivalDb ui, ivalDb q1, ivalDb q2, ivalDb I, ivalDb x1,
                           ivalDb x2, ivalDb x3, ivalDb g, ivalDb ug, ivalDb *Q1,
                           ivalDb *Q2, ivalDb *I1, ivalDb *X1, ivalDb *X2,
                           ivalDb *X3, ivalDb *G, ivalDb *F01, ivalDb *FR)
{
ivalDb fr1, fc01, F_1, I1_1, X1_1, X2_2, X3_3;
double  f;
AnsiString  parameter;

ivalDb Q_1;

        fr1=((0.003*vg)/2)*((q1/vg)-9+sqrt(pow((q1/vg)-9,2)));          // Funcin para el clculo de la eliminacin de glucosa renal
        fc01=((f01/9)*((q1/vg)-4.5-sqrt(pow((q1/vg)-4.5,2))))+f01;      // Funcin para el clculo de Fc01
        *F01=fc01;
        *FR=fr1;

        *G=q1/vg;  //G(t) Concentracin de Glucosa  (mmol/dl)
        *Q2=x1*q1*h+q2*(1-k12*h-x2*h); //q2 Masa de Glucosa (mmol)

        // Crea el archivo para el clculo de q1 mediante la fstar
        cadena[1]="x1=["+FloatToStr(x1.Inf)+","+FloatToStr(x1.Sup)+"];";
        cadena[2]="x3=["+FloatToStr(x3.Inf)+","+FloatToStr(x3.Sup)+"];";
        cadena[3]="q2=["+FloatToStr(q2.Inf)+","+FloatToStr(q2.Sup)+"];";
        cadena[5]="ug=["+FloatToStr(ug.Inf)+","+FloatToStr(ug.Sup)+"];";
        cadena[6]="k12=["+FloatToStr(k12.Inf)+","+FloatToStr(k12.Sup)+"];";
        cadena[7]="egp0=["+FloatToStr(egp0.Inf)+","+FloatToStr(egp0.Sup)+"];";
        cadena[13]="Sie=["+FloatToStr(Sie.Inf)+","+FloatToStr(Sie.Sup)+"];";
        cadena[14]="x2=["+FloatToStr(x2.Inf)+","+FloatToStr(x2.Sup)+"];";

        // Funcin de q1 con la incorporacin de la funcin para el clculo de Fc01 y Fr
        cadena[15]="f:=-(("+FloatToStr(f01)+"/9)*((q1/"+FloatToStr(vg)+")-"+FloatToStr(4.5)+"-sqrt(pow((q1/"+FloatToStr(vg)+")-"+FloatToStr(4.5)+",2)))+"+FloatToStr(f01)+")*"+FloatToStr(h)+"+q1*(1-x1*"+FloatToStr(h)+")+(k12*q2-(0.003*"+FloatToStr(vg)+")/2*((q1/"+FloatToStr(vg)+")-9+sqrt(pow((q1/"+FloatToStr(vg)+")-9,2)))+ug+egp0*(1-x3))*"+FloatToStr(h)+";";

        // Llamado a la fstar y clculo de q1
        cadena[0]="%;";
        estrella("q1", q1, &F_1,16);
        *Q1=F_1;


        /*
        // Clculo de Fc01 y Fr mediante la F*
        // Cdigo empleado para comparar los resultados arrojados por Fr y Fc01 
        cadena[15]="f:=(("+FloatToStr(f01)+"/9)*((q1/"+FloatToStr(vg)+")-4.5-sqrt(pow((q1/"+FloatToStr(vg)+")-4.5,2))))+"+FloatToStr(f01)+";";
        estrella("q1", q1, &F_1,16);
        *F01=F_1;
        cadena[15]="f:=((0.003*"+FloatToStr(vg)+")/2)*((q1/"+FloatToStr(vg)+")-9+sqrt(pow((q1/"+FloatToStr(vg)+")-9,2)));";
        estrella("q1", q1, &F_1,16);
        *FR1=F_1;
        */

        if(incertidumbre_k==1)   // Verifica que parmetros tienen incertidumbre
        {
        // Sistemas Cooperativos para el clculo de I, x1, x2 y x3, Jorge Bondia
        I1_1.Inf=(-ke*(I.Inf)+(ui.Inf/vi)+ub)*h+I.Inf;
        X1_1.Inf=(kb[0].Inf*I.Inf-ka[0].Sup*x1.Inf)*h+x1.Inf;
        X2_2.Inf=(kb[1].Inf*I.Inf-ka[1].Sup*x2.Inf)*h+x2.Inf;
        X3_3.Inf=(kb[2].Inf*I.Inf-ka[2].Sup*x3.Inf)*h+x3.Inf;

        I1_1.Sup=(-ke*(I.Sup)+(ui.Sup/vi)+ub)*h+I.Sup;
        X1_1.Sup=(kb[0].Sup*I.Sup-ka[0].Inf*x1.Sup)*h+x1.Sup;
        X2_2.Sup=(kb[1].Sup*I.Sup-ka[1].Inf*x2.Sup)*h+x2.Sup;
        X3_3.Sup=(kb[2].Sup*I.Sup-ka[2].Inf*x3.Sup)*h+x3.Sup;

        *I1=ivalDb(I1_1.Inf, I1_1.Sup);
        *X1=ivalDb(X1_1.Inf, X1_1.Sup);
        *X2=ivalDb(X2_2.Inf, X2_2.Sup);
        *X3=ivalDb(X3_3.Inf, X3_3.Sup);
        }
        else
        {
        *I1=(ui/vi)*h-I*((ke*h)-1)+ub*h;//ui=Iex(basal+bolus)
        *X1=x1*(1-ka[0]*h)+Sit*ka[0]*I*h;
        *X2=x2*(1-ka[1]*h)+Sid*ka[1]*I*h;
        *X3=x3*(1-ka[2]*h)+Sie*ka[2]*I*h;
        }
}


//---------------------------------------------------------------------------

// FUNCIN PARA EL CLCULO DE LA ABSORCIN DE GLUCOSA CON ENTRADA IMPULSIONAL
// Entradas (dg: carbohidratos ingeridos, t: minuto de simulacin, t1: minuto en el que inicia la ingesta)
// Salidas  (*UG: salida con la absorcin de glucosa)

ivalDb abs_glucosa_impulsional(ivalDb dg, double t, double t1, ivalDb *UG)
{
 ivalDb F_1;

 // Absorcin de Glucosa Hovorka Original  (mmol/min)
   if(t<t1)   // Verifica si ha ingerido alimentos
        *UG=0;
   else
        if(incertidumbre_tmg==1) // Si tmg tiene incertidumbre el clculo debe ser realizado mediante la fstar
          {
                // Clculo realizado con la F* cuando tmg es intervalar
                cadena[1]="dg=["+FloatToStr(dg.Inf)+","+FloatToStr(dg.Sup)+"];";
                cadena[2]="ag=["+FloatToStr(ag.Inf)+","+FloatToStr(ag.Sup)+"];";
                cadena[3]="tmg=["+FloatToStr(tmg.Inf)+","+FloatToStr(tmg.Sup)+"];";
                cadena[5]="%";
                cadena[6]="%";
                cadena[7]="%";
                cadena[13]="f:=((dg*ag*(("+FloatToStr(t)+"-"+FloatToStr(t1)+"+1)*"+FloatToStr(h)+"))*exp(-(("+FloatToStr(t)+"-"+FloatToStr(t1)+"+1)*"+FloatToStr(h)+")/tmg))/pow(tmg,2);";

                FILE *festrella;
                AnsiString FSTAR="funcion.txt";

                festrella= fopen(FSTAR.c_str(), "w+");
                //Creacin del archivo para el llamado a la F*
                fprintf(festrella, "%s", "Algorithm=FSTAR;");
                fprintf(festrella, "%s", "\n");
                cadena[0]="%;";
                cadena[4]="%";
                cadena[8]="Epsilon=0.001;";
                cadena[9]="Tolerance=1e-3;";
                cadena[10]="Time=0.5;";
                cadena[11]="Optim=0;";
                cadena[12]="Solution=1;";
                int f1=0;
                  for (f1=0; f1<14; f1++)
                        {
                        fprintf(festrella, "%s", cadena[f1]);
                        fprintf(festrella, "%s", "\n");
                        }

             //Funcin para la cul se va a calcular F*
                fclose(festrella);
                box B;
                fstream fout;
                RunParser("funcion", Problem[0]);
                Problem[0].Run(B,fout);

               //Guarda los valores del clculo de fstar
                F_1.Inf=Problem[0].GetTwin().GetOut().Inf;
                F_1.Sup=Problem[0].GetTwin().GetOut().Sup;
                Problem[0].~fstar();

                *UG=F_1; // Guarda el valor de la absorcin de glucosa

          }
        else    // Clculo racional de la absorcin de glucosa
                *UG=((dg*ag*((t-t1+1)*h))*exp(-((t-t1+1)*h)/tmg))/(pow(tmg,2));

 }
//---------------------------------------------------------------------------

// FUNCION PARA EL CALCULO DE LA ABSORCIN DE GLUCOSA CON ENTRADA PULSO
// Entrada:(dg: carbohidratos ingeridos, t: minuto de simulacin
// t1: minuto en el que inicia la ingesta, t2: minuto en el que finaliza la ingesta)
// Salida: (*UG: salida con la absorcin de glucosa)

ivalDb abs_glucosa_escalon(ivalDb dg, double t, double t1, double t2, ivalDb *UG)
{
   ivalDb UG1, UG2;

   //Conversin de la ingestin de comida g a mmol
   dg=dg*1000/180;

     //Expresin del modelo gastrointestinal formulado para entrada pulso
     if (t<t1) // Si no ha ingerido alimentos
        *UG=0;
     else
        if ((t>=t1) && (t<t2))  // Clculo entre el inicio y finalizacin de la ingesta
                *UG=((ag*dg)/((t2-t1)*h))*((-(t+1-t1)/tmg)*exp(-(t+1-t1)/tmg)-exp(-(t+1-t1)/tmg)+1);
        else
           if (t>=t2)  //  Clculo cuando ha finalizado la ingesta
              {
                UG1=((1)/((t2-t1)*h))*((-(t+1-t1)/tmg)*exp(-(t+1-t1)/tmg)-exp(-(t+1-t1)/tmg)+1);
                UG2=((1)/((t2-t1)*h))*((-(t+1-t2)/tmg)*exp(-(t+1-t2)/tmg)-exp(-(t+1-t2)/tmg)+1);
                *UG=ag*dg*(UG1-UG2);
              }
}

//---------------------------------------------------------------------------


// Modelo de Vaciado Gstrico DallaMan 2007

ivalDb abs_glucosa(ivalDb qsto1, ivalDb qsto2, ivalDb qgut, ivalDb ra,
                   ivalDb kempt, ivalDb D, int h, ivalDb kmax, ivalDb kmin,
                   ivalDb *Qsto1, ivalDb *Qsto2,  ivalDb *Qgut, ivalDb *Ra)
{

// Tasa de presencia de Glucosa
*Qsto1=qsto1*(1-kmax*h)+D;
*Qsto2=qsto2*(1-kempt*h)+Du(kmax)*qsto1*h;
*Qgut=qgut*(1-kabs*h)+kempt*qsto2*h;
*Ra=(f*kabs*qgut)/BW;

}

//---------------------------------------------------------------------------

// FUNCION PARA EL CALCULO DE LA INFUSIN DE INSULINA (HOVORKA 04)
// Entrada:(u: cantidad de infusin de insulina; s1, s2: dos compartimentos
// concatenados que representan la absorcin subcutanea de insulina de corta accin)
// Salida: (*Ui: salida de la absorcin de insulina; *S1, *S2: Absorcin de;
// insulina de corta acccin administrada subcutneamente)

ivalDb abs_insulina(ivalDb u, ivalDb s1, ivalDb s2, ivalDb *Ui, ivalDb *S1, ivalDb *S2)
{
   *S1=u*h-s1*((h/tmi)-1);      //S1 Absorcin de insulina de corta acccin administrada subcutneamente
   *S2=s2*(1-(h/tmi))+h*s1/tmi; //S2 Absorcin de insulina de corta acccin administrada subcutneamente
   *Ui=s2/tmi;                  // Absorcin de Insulina con Hovorka
}

//---------------------------------------------------------------------------

// Tasa de presencia de Glucosa DallaMan 2007

ivalDb cinet_insulina(ivalDb i1, double m1, double m2, double m3, double m4,
                      ivalDb ii, int h, ivalDb kmax, ivalDb kmin,  ivalDb id,
                      ivalDb ip, ivalDb il, ivalDb iex, double Vi,  ivalDb ki,
                      double Ib, double p2U, ivalDb x, ivalDb *Il, ivalDb *Ip,
                      ivalDb *I, ivalDb *X, ivalDb *I1, ivalDb *Id)
{

// Cintica de la Insulina
*Il=-(h*(m1+m3)-1)*il+m2*ip*h;         // Masa de insulina en el higado
*Ip=-(h*(m2+m4)-1)*ip+m1*il*h+iex;     // Masa de insulina en plasma
*I=ip/Vi;                               // Concentracin de insulina en plasma

// Accin sobre la produccin de insulina

*I1=i1+ki*h*(ii-Du(i1));
*Id=id+ki*h*(i1-Du(id));  
*X=x*(1-p2U*h)+p2U*(ii-Ib);    // Fluido intersticial
  
}
//---------------------------------------------------------------------------

// Generacin de Montecarlos

ivalDb montecarlo_cobelli ( ivalDb kp3, ivalDb vmx, ivalDb vm0, ivalDb ki, int vari, ivalDb *Kp3,
                    ivalDb *Vmx, ivalDb *Vm0, ivalDb *Ki)
{

double i_s, r1;
        // Establezco la semilla
        //srand((unsigned)time(0));

        // Parmetros con incertidumbre
        ivalDb  porcentaje[4], incerti[4];
        incerti[0]=kp3;  incerti[1]=vmx; incerti[2]=vm0; incerti[3]=ki;


                        for (int aleatorio=0; aleatorio<4; aleatorio++)//Generacin de valores aleatorios
                        {
                          i_s= incerti[aleatorio].Sup-incerti[aleatorio].Inf;
                        if(i_s>0.1E-10)   //Verifico si hay incertidumbre
                              {
                              srand((unsigned)rand());
                               // Generar valor aleatoreio con distribucin uniforme
                               r1 = ( (double)rand() / ((double)(RAND_MAX)+(double)(1)) );

                               for(int k=0;k<vari;k++)
                               {
                               if ((r1==aleatori[aleatorio][k])&&(vari>1))
                               {srand((unsigned)rand());
                                r1= ( (double)rand() / ((double)(RAND_MAX)+(double)(1)) );
                                break;
                               }
                               }
                               porcentaje[aleatorio]=incerti[aleatorio].Inf+(incerti[aleatorio].Sup-incerti[aleatorio].Inf)*r1;

                               // Guardo el valor generado
                               aleatori[aleatorio][vari]=r1;
                               if ((porcentaje[aleatorio].Sup>incerti[aleatorio].Sup)||(porcentaje[aleatorio].Inf<incerti[aleatorio].Inf))
                                ShowMessage("Valor fuera de rango");
                              }
                        else
                              porcentaje[aleatorio]=incerti[aleatorio].Inf;
                        } // Finaliza for aleatorio

                       *Kp3=porcentaje[0]; *Vmx=porcentaje[1]; *Vm0=porcentaje[2]; *Ki=porcentaje[3];
}
//---------------------------------------------------------------------------
// Generacin de Montecarlos

ivalDb montecarlo ( ivalDb sit, ivalDb sid, ivalDb sie, ivalDb dg, ivalDb v4, ivalDb v5,
                    ivalDb v6,  int vari, ivalDb *Sit, ivalDb *Sid, ivalDb *Sie, ivalDb *Dg,
                    ivalDb *V4, ivalDb *V5, ivalDb *V6)
{

double i_s=0, r1=0;

        //srand((unsigned)time(0));

        // Parmetros con incertidumbre
        ivalDb  porcentaje[7], incerti[7],  destipif;
        double tipif_i=0, desv=0, tipif_s=0, media=0, desv_i=0, desv_s=0;
        incerti[0]=sit;  incerti[1]=sid; incerti[2]=sie; incerti[3]=dg;
        incerti[4]=v4;   incerti[5]=v5;  incerti[6]=v6;



                        for (int aleatorio=0; aleatorio<7; aleatorio++)//Generacin de valores aleatorios
                        {
                          i_s= incerti[aleatorio].Sup-incerti[aleatorio].Inf;
                        if(i_s>0.1E-10)   //Verifico si hay incertidumbre
                              {
                               // Establezco la semilla
                               srand((unsigned) rand());
                               //srand((unsigned)time(0));
                               // Generar valor aleatorio con distribucin uniforme
                               r1 = ( (double)rand() / ((double)(RAND_MAX)+(double)(1)) );
                               //Validacin del valor generado
                               for (int k=0;k<vari;k++)
                               {
                               if ((r1==aleatori[aleatorio][k])&&(vari>1))
                                 {  srand((unsigned) rand());
                                   r1 = ( (double)rand() / ((double)(RAND_MAX)+(double)(1)) );
                                   break;
                                 }
                               }
                               // Para distribucin uniforme
                               porcentaje[aleatorio]=incerti[aleatorio].Inf+(incerti[aleatorio].Sup-incerti[aleatorio].Inf)*r1;
                               /*
                               // Guardo el valor generado
                               aleatori[aleatorio][vari]=r1;
                               
                               // Generar valor aleatorio con distribucin normal
                               // Media
                               media=(incerti[aleatorio].Sup+incerti[aleatorio].Inf)/2;
                               desv_i=incerti[aleatorio].Inf-media;
                               desv_s=incerti[aleatorio].Sup-media;
                               // Clculo de la desviacin estandar
                               desv=sqrt((desv_i*desv_i)+(desv_s*desv_s));
                               // Valor tipificado
                               tipif_i=(incerti[aleatorio].Inf-((incerti[aleatorio].Sup+incerti[aleatorio].Inf)/2))/desv;
                               tipif_s=(incerti[aleatorio].Sup-((incerti[aleatorio].Sup+incerti[aleatorio].Inf)/2))/desv;
                               porcentaje[aleatorio]=tipif_i+(tipif_s-tipif_i)*r1;

                               // Valor destipificado
                               destipif=porcentaje[aleatorio]*desv+media;
                               porcentaje[aleatorio]=destipif;

                               */
                               if ((porcentaje[aleatorio].Sup>incerti[aleatorio].Sup)||(porcentaje[aleatorio].Inf<incerti[aleatorio].Inf))
                               {if(incerti[aleatorio].Sup==incerti[aleatorio].Inf)
                                ShowMessage("Valor fuera de rango");
                               }
                              }
                        else
                              porcentaje[aleatorio]=incerti[aleatorio].Inf;
                        } // Finaliza for aleatorio

                       *Sit=porcentaje[0]; *Sid=porcentaje[1]; *Sie=porcentaje[2]; *Dg=porcentaje[3];
                       *V4=porcentaje[4];  *V5=porcentaje[5];  *V6=porcentaje[6];
}
//---------------------------------------------------------------------------
// CALCULO DE LA DOSIS INICIAL
// Entrada:(GC: Glucosa capilar; CHO: cantidad de carbohidratos (gr) ingeridos
// Salida: (*DI: Dosis Inicial, *II: Instante inicial de inyeccin)

ivalDb dosis_inicial(double GC, double CHO, double *DI, double *II)
{

double TDD=40; //Cantidad de insulina total inyectada en un dia (IU)
double GOmax=8.39, GOmin=3.9, R500=0, R2000=0, factor;

//Clculo de la Regla 500 (Ratio CHO)
R500=500/TDD;
//Clculo de la Regla 2000 (Sensibilidad Insulina)
R2000=2000/TDD;

// Valida en que nivel se encuentra la glucosa capilar respecto a la Glucosa
// Objetivo(Normalglucemia)
if (GC < GOmin){                *DI=(CHO/R500)+((GC-GOmin)/R2000);  }
if (GC > GOmax){                *DI=(CHO/R500)+((GC-GOmax)/R2000);  }
if ((GC<=GOmax)&&(GC>=GOmin)){  *DI=(CHO/R500);                     }

// Rendondea el valor de la dosis inicial
*DI=ceil(*DI);

/* Propuesta modificando los datos del Samfyc y proponiendo indice
if (GC<(80/18)){                                *II=0;          }
else if (GC>=(200/18)){                         *II=60;         }
else {factor=ceil((ceil(GC*18)-80)/10);         *II=factor*5;   }
*/

// Clculo del Instante Inicial de Inyeccin (Tomado de Samfyc)
// Verificando el valor de la glucosa capilar se determina el instante de
// inyeccin
if (GC<(80/18)){                        *II=0;      }
if ((GC>= (80/18))&&(GC<(140/18))){     *II=30;     }
if ((GC>=(140/18))&&(GC<(180/18))){     *II=45;     }
if ((GC>=(180/18))&&(GC<(200/18))){     *II=60;     } 
if (GC>=(200/18)){                      *II=60;     }

}
//---------------------------------------------------------------------------

// FUNCION DONDE SE ESTABLECEN LAS CONDICIONES INICIALES, SE DEFINEN LAS VARIABLES
// SE ESTABLECE EL PASO DE DISCRETIZACIN, Y SE CONFIGURA LAS OPCIONES DE
// CALCULO PARA EL METABOLISMO DE LA GLUCOSA

// MODELO HOVORKA ET AL 2004

void __fastcall TForm1::Button5Click(TObject *Sender)
{
// Declaracin de Variables
int t_simul,i, im, t_insu, t_ins, Ibasal, paciente, tipo_simulacion, cant_aleatorios, n_montecarlos;
int tipo_ingesta, tipo_ins_exogena, t_inicial, t_comida, tipo_modelo,d, k, aleatorio, variacion;
int glu0=0, glu1=0, glu2=0, glu3=0, cant_insulina, t_comi, condiciones_inic, incertidumbre[4];
double c,cant_insul, cant_insul1, cant_insul2, t_com, t_com1, t_com2, range, i_total[400];
double incer_montecarlo, porcentaje[8]; // Variables para el clculo montecarlo
ivalDb x1, x2, x3, ingesta, vcomida, Sid1, Sie1, ingesta1, Sit1;
double G[4][12], h_i[4];  // Variables para guardar el valor de glucosa y el tiempo en las mtricas
ivalDb incert[7];

///////////////////// OJO BORRAR
double prueba[10];

//double G_hs[2], G_hm[2], G_S[2], G_M[2]; // Variables para guardar los valores de glucosa en las mtricas
//int T_hs[2], T_hm[2], T_S[2], T_M[2], h_i=0; // Variables para guardar el tiempo en las mtricas

 double CTime;                                  // Tiempo de clculo
 clock_t CStart = clock();                      // Iniciar el reloj
 clock_t CStop;                                 // Parar el reloj

// Introduce el tiempo de simulacin en minutos
AnsiString  iter= InputBox("Input Box", "Tiempo de simulacin en minutos", "0");

      for(k=0;k<4; k++)
       {
       for(d=0; d<12; d++) // Variable para la impresin de las mtricas
        {G[k][d]=0;}
         h_i[k]=0;
       }
         d=0; k=0;

multi=1; //Valor dado por el paso de discretizacin
h=1;     // Paso de discretizacin

t_simul=StrToInt(iter)*multi; //Tiempo de simulacin, afectado por el paso de discretizacin


//Creando la matriz donde se guardara el resultado de q1, q2, i, x1, x2, x3, g, ug, ui, fc01, fr
// La matriz es declarada como intervalo
// Las filas identifican la variable y las columnas cada minuto
int fila=15;
int columna=t_simul+1;

ivalDb** v;
    v = new ivalDb* [fila];
    for (int m = 0; m < fila; m++)
      v[m] = new ivalDb [columna];
    //Matriz con el nombre de cada variable
    //v[1][i]=Q1 v[2][i]=Q2 v[3][i]=I   v[4][i]=x1  v[5][i]=x2    v[6][i]=x3  v[7][i]=S1
    //v[8][i]=S2 v[9][i]=g  v[10][i]=ug v[11][i]=ui v[12][i]=fc01 v[13][i]=fr v[14][i]=S


ivalDb** insulina;
    // Matriz con los valores de cada inyeccin de insulina
    insulina = new ivalDb* [40]; // Guarda 40 Valores de Iex
    for (int m = 0; m < 40; m++)
      insulina[m] = new ivalDb [columna+3630];


ivalDb* dal;
dal= new ivalDb [columna];          

double gluco_max[401], gluco_min[401];  // Guarda el valor de glucosa mximo y
                                        // minimo resultante de las simulaciones montecarlo

// Establecer incertidumbres
/*
n_montecarlos=10;
incertidumbre[0]=0;    // 0: Incertidumbre en el parmetro Sit
incertidumbre[1]=0;    // 1: Incertidumbre en el parmetro Sid
incertidumbre[2]=0;    // 2: Incertidumbre en el parmetro Sie
incertidumbre[3]=30;   // 3: Incertidumbre en el parmetro Dg
 */

// Datos de Entrada
Ibasal=0;               // Insulina Basal
paciente=2;             // Paciente del cul se tomarn los parmetros
peso=66;                // Peso del paciente en kg
dg=0;                   // Cantidad de carbohidratos ingeridos (gr)
tipo_simulacion=2;      // 1 Puntual     / 2 Intervalar
tipo_modelo=2;          // 1 Hovorka con F*      / 2 Clculo Racional / 3 Hovorka Puntual
tipo_ingesta=3;         // 1 Impulsional / 2 Pulso  / 3 DallaMan
tipo_ins_exogena=2;     // 1 Hovorka (Ui)   / 2 IEX (UPV)
incertidumbre_tmg=2;    // 1 tmg intervalar / 2 tmg puntual
incertidumbre_dg=1;     // 1 dg intervalar / 2 dg puntual
incertidumbre_k=2;      // 1 k intervalar / 2 s intervalar  / 3 k y s puntual
incertidumbre[0]=11;  // 0: Incertidumbre en el parmetro Sit
incertidumbre[1]=0;  // 1: Incertidumbre en el parmetro Sid
incertidumbre[2]=0;  // 2: Incertidumbre en el parmetro Sie
incertidumbre[3]=0; // 3: Incertidumbre en el parmetro Dg
incer_montecarlo=0;     // 0: Sin simulacin Montecarlo 1: Con simulacin Montecarlo
n_montecarlos=00;   // Cantidad de simulaciones montecarlo que sern generadas
condiciones_inic=1;     // 1: 80 mg/dl   / 2: 150 mg/dl   / 3: 250 mg/dl   / 4: 100 mg/dl
vcomida=60;             // Cantidad de carbohidratos ingeridos (una sola comida)

/*
// Guarda los valores aleatorios generados
double** aleatorio;
    // Matriz con los valores de cada valor aleatorio generado
    aleatorio = new double* [7]; // Guarda 7 variables
    for (int m = 0; m < 7; m++)
      aleatorio[m] = new double [n_montecarlos];
*/
//Parmetros del Modelo
vi=0.12*peso; //Volumen de distribucin de la Insulina (L)
ag=0.8; //Biodisponibilidad de carbohidratos (unitless)
tmg=40; //Tasa de aparicin mxima de glucosa en el compartimiento accesible de glucosa (min)
tmi=55; //Tiempo de absorcin de insulina subcutnea (min)
ke=0.138;  //Eliminacin de insulina en plasma (min^-1)
ub=ke*Ibasal; //Flujo de Insulina Basal

if (incertidumbre_tmg==1) // Verifica si hay incertidumbre en el tiempo mximo de absorcin de CHO
                          // y en la biodisponibilidad de CHO
{
ag=ivalDb(ag.Inf*0.90, ag.Sup*1.10);
tmg=ivalDb(tmg.Inf*0.90, tmg.Sup*1.10);
}

// Asigna los valores a los parmetros de 5 pacientes y 1 paciente Medio
// Tomados de Hovorka et al. (2002)

      switch (paciente) {
         case 0 :    /* PARAMETROS MEDIOS */
                vg=0.16*peso; //Volumen de distribucin de la Glucosa (L)
                f01=0.0097*peso;  //Flujo de glucosa no insulino dependiente  (mmol/min)
                k12=0.066; //Tasa de trasferencia (min-^1)
                ka[0]=0.006; //Tasa de desactivacin (min-^1)
                ka[1]=0.06;  //Tasa de desactivacin (min-^1)
                ka[2]=0.03;  //Tasa de desactivacin (min-^1)
                Sit=0.00512; //Sensibilidad de la distribucin de insulina (mU/Lmin)
                Sid=0.00082; //Sensibilidad al deshecho de la insulina (mU/Lmin)
                Sie=0.052;   //Sensibilidad al EGP de la insulina  (mU/L)
                //egp0=0.0161*peso; //Valor tomado del modelo de Hovorka (mmol/min)
                break;
         case  1:  /* PARAMETROS PACIENTE 1 */
                vg=0.18*peso;  //Volumen de distribucin de la Glucosa (L)
                f01=0.0121*peso;  //Flujo de glucosa no insulino dependiente  (mmol/min)
                k12=0.0343; //Tasa de trasferencia (min-^1)
                ka[0]=0.0031; //Tasa de desactivacin (min-^1)
                ka[1]=0.0752; //Tasa de desactivacin (min-^1)
                ka[2]=0.0472; //Tasa de desactivacin (min-^1)
                Sit=29.4e-4;//0.00294; //Sensibilidad de la distribucin de insulina (mU/Lmin)
                Sid=0.9e-4;//0.0009; //Sensibilidad al deshecho de la insulina (mU/Lmin)
                Sie=401e-4;//0.0401;  //Sensibilidad al EGP de la insulina  (mU/L)
                break;
         case  2:   /* PARAMETROS PACIENTE 2 */
                vg=0.13*peso;  //Volumen de distribucin de la Glucosa (L)
                f01=0.0075*peso;  //Flujo de glucosa no insulino dependiente  (mmol/min)
                k12=0.0871; //Tasa de trasferencia (min-^1)
                ka[0]=0.0157; //Tasa de desactivacin (min-^1)
                ka[1]=0.0231; //Tasa de desactivacin (min-^1)
                ka[2]=0.0143; //Tasa de desactivacin (min-^1)
                Sit=18.7e-4;//0.00187; //Sensibilidad de la distribucin de insulina (mU/Lmin)
                Sid=6.1e-4;//0.00061; //Sensibilidad al deshecho de la insulina (mU/Lmin)
                Sie=379e-4;//0.0379;  //Sensibilidad al EGP de la insulina  (mU/L)
                break;
         case  3:   /* PARAMETROS PACIENTE 3 */
                vg=0.22*peso;  //Volumen de distribucin de la Glucosa (L)
                f01=0.0103*peso;  //Flujo de glucosa no insulino dependiente  (mmol/min)
                k12=0.0863; //Tasa de trasferencia (min-^1)
                ka[0]=0.0029; //Tasa de desactivacin (min-^1)
                ka[1]=0.0495; //Tasa de desactivacin (min-^1)
                ka[2]=0.0691; //Tasa de desactivacin (min-^1)
                Sit=81.2e-4;//0.00812; //Sensibilidad de la distribucin de insulina (mU/Lmin)
                Sid=20.1e-4;//0.000201; //Sensibilidad al deshecho de la insulina (mU/Lmin)
                Sie=578e-4;//0.0578;  //Sensibilidad al EGP de la insulina  (mU/L)
                break;
         case  4:  /* PARAMETROS PACIENTE 4 */
                vg=0.14*peso;  //Volumen de distribucin de la Glucosa (L)
                f01=0.0119*peso;  //Flujo de glucosa no insulino dependiente  (mmol/min)
                k12=0.0968; //Tasa de trasferencia (min-^1)
                ka[0]=0.0088; //Tasa de desactivacin (min-^1)
                ka[1]=0.0302; //Tasa de desactivacin (min-^1)
                ka[2]=0.0118; //Tasa de desactivacin (min-^1)
                Sit=0.00861; //Sensibilidad de la distribucin de insulina (mU/Lmin)
                Sid=0.00047; //Sensibilidad al deshecho de la insulina (mU/Lmin)
                Sie=0.0720;  //Sensibilidad al EGP de la insulina  (mU/L)
                break;
         case  5:  /* PARAMETROS PACIENTE 5 */
                vg=0.14*peso;  //Volumen de distribucin de la Glucosa (L)
                f01=0.0071*peso;  //Flujo de glucosa no insulino dependiente  (mmol/min)
                k12=0.0390; //Tasa de trasferencia (min-^1)
                ka[0]=0.0007; //Tasa de desactivacin (min-^1)
                ka[1]=0.1631; //Tasa de desactivacin (min-^1)
                ka[2]=0.0114; //Tasa de desactivacin (min-^1)
                Sit=72.4e-4; //Sensibilidad de la distribucin de insulina (mU/Lmin)
                Sid=15.3e-4; //Sensibilidad al deshecho de la insulina (mU/Lmin)
                Sie=961e-4;  //Sensibilidad al EGP de la insulina  (mU/L)
                break;
         case  6: /* PARAMETROS PACIENTE 6 */
                vg=0.13*peso;  //Volumen de distribucin de la Glucosa (L)
                f01=0.0092*peso;  //Flujo de glucosa no insulino dependiente  (mmol/min)
                k12=0.0458; //Tasa de trasferencia (min-^1)
                ka[0]=0.0017; //Tasa de desactivacin (min-^1)
                ka[1]=0.0689; //Tasa de desactivacin (min-^1)
                ka[2]=0.0285; //Tasa de desactivacin (min-^1)
                Sit=0.00191; //Sensibilidad de la distribucin de insulina (mU/Lmin)
                Sid=0.00022; //Sensibilidad al deshecho de la insulina (mU/Lmin)
                Sie=0.0081;  //Sensibilidad al EGP de la insulina  (mU/L)
                }


// Condiciones de Equilibrio
  //Insulina Basal
  v[3][0]=8;

  x1=Sit*v[3][0];
  x2=Sid*v[3][0];
  x3=Sie*v[3][0];

if(incertidumbre_k==1) // Verifica que parmetros tienen incertidumbre
        {
        ka[0]=ivalDb(ka[0].Inf*0.98,ka[0].Sup*1.02);
        ka[1]=ivalDb(ka[1].Inf*0.98,ka[1].Sup*1.02);
        ka[2]=ivalDb(ka[2].Inf*0.98,ka[2].Sup*1.02);
        }
if(incertidumbre_k==2)
        {
        Sit=ivalDb(Sit.Inf*(1-(incertidumbre[0]/100.0)),Sit.Sup*(1+(incertidumbre[0]/100.0)));
        Sid=ivalDb(Sid.Inf*(1-(incertidumbre[1]/100.0)),Sid.Sup*(1+(incertidumbre[1]/100.0)));
        Sie=ivalDb(Sie.Inf*(1-(incertidumbre[2]/100.0)),Sie.Sup*(1+(incertidumbre[2]/100.0)));
        if (n_montecarlos>0) // Asigna incertidumbre para el clculo de las montecarlos
           {     incert[0]=Sit;  incert[1]=Sid;   incert[2]=Sie;}
        }

  // Calculo los valores de las tasas de desactivacin
  kb[0]=ka[0]*Sit;
  kb[1]=ka[1]*Sid;
  kb[2]=ka[2]*Sie;
  secureFpu();

  // Valor de la Glucosa Capilar
  v[9][0]=StrToFloat(EdtCapilar->Text);;

  // Valores en estado de equilibrio (Basales)
  v[4][0]=Sit*v[3][0];  //x1  basal
  v[5][0]=Sid*v[3][0];  //x2  basal
  v[6][0]=Sie*v[3][0];  //x3  basal

  u=0;//Valor de la inyeccin de insulina

  v[7][0]=tmi*u;    //S1 Absorcin subcutnea de insulina
  v[8][0]=v[7][0];  //S2 Absorcin subcutnea de insulina
  v[11][0]=v[8][0]/tmi; //Ui Tasa de absorcin de insulina


        // Datos para establecer condiciones iniciales (Dependiendo de la glucosa capilar inicial)
                switch (condiciones_inic)
                {
                case 1 :  //Valores condiciones inciales  para Glucosa Capilar de  80 mg/dl
                        v[3][0]=16.8188;     v[4][0]=0.021198;    v[5][0]=0.0065267;     v[6][0]=0.4370178;
                        v[9][0]=80/18.00;  //Valor de glucosa capilar
                        break;
                case 2 :  //Valores condiciones inciales  para Glucosa Capilar de 150 mg/dl
                        v[3][0]=16.81877;    v[4][0]=0.021199;  v[5][0]=0.0065267;  v[6][0]=0.4370178;
                        v[9][0]=150/18.00;  //Valor de glucosa capilar
                        break;
                case 3 :  //Valores condiciones inciales  para Glucosa Capilar de 250 mg/dl
                        v[3][0]=16.592864;   v[4][0]=0.019825;    v[5][0]=0.006217208;   v[6][0]=0.406559;
                        v[9][0]=220/18.00;  //Valor de glucosa capilar
                        break;
                case 4 :  //Valores condiciones inciales  para Glucosa Capilar de 100 mg/dl
                        v[3][0]=16.81877;    v[4][0]=0.021199;    v[5][0]=0.00652671;    v[6][0]=0.4370178;
                        v[9][0]=100/18.00;;  //Valor de glucosa capilar
                }

        // Asigna incertidumbre a las respectivas variables
        v[4][0]=ivalDb(v[4][0].Inf*(1-(incertidumbre[0]/100.0)), v[4][0].Inf*(1+(incertidumbre[0]/100.0))); // Incertidumbre en el valor inicial de X_1
        v[5][0]=ivalDb(v[5][0].Inf*(1-(incertidumbre[1]/100.0)), v[5][0].Inf*(1+(incertidumbre[1]/100.0))); // Incertidumbre en el valor inicial de X_2
        v[6][0]=ivalDb(v[6][0].Inf*(1-(incertidumbre[2]/100.0)), v[6][0].Inf*(1+(incertidumbre[2]/100.0))); // Incertidumbre en el valor inicial de X_3
        ingesta=ivalDb(vcomida.Inf*(1-(incertidumbre[3]/100.0)), vcomida.Sup*(1+(incertidumbre[3]/100.0))); // Incertidumbre para la ingesta
        ingesta=ingesta*1000/180; // Conversin de los CHO (gr) a mmol

   v[10][0]=0; //(Ug) Glucosa exgena
   v[1][0]=v[9][0]*vg; //Q1 basal (mmol)

   v[2][0]=(v[4][0]*v[1][0])/(k12+v[5][0]); //Q2 basal (mmol)

   v[14][0]=(v[9][0]*vg)+(Du(v[4][0])*v[1][0]/(Du(k12)+v[5][0])); // Valor de S en estado de equilibrio

   // Valores Iniciales de fc01 y fr
   if (v[9][0]>=4.5)
       fc01=f01;
   else
       fc01=(f01*v[9][0])/4.5;

   // Clculo de Fr
   if (v[9][0]>=9)
       fr=0.003*(v[9][0]-9)*vg;
   else
       fr=0;

   v[12][0]=fc01;  //fc01
   v[13][0]=fr;  //fr


   //Produccin de Glucosa endgena.
   egp0=(fc01+(v[1][0]*x1)*(1-(k12/(k12+x2)))+fr-v[10][0])/(1-x3); // EGP0 Puntual(calculado con los valores nominales de Sit, Sid y Sie)


   // Modelo Insulina Exgena (UPV)
   if(tipo_ins_exogena==2)
        {
        ///Modelo de Insulina // Guarda los valores de Iex
        // Valores de 1 a 25IU de Insulina Exogena (Basal+Bolus)
        int cont1=0, cont2=0;
        double ins;
        long length;
        char dosis[100];
        FILE *fileinsulina;
        AnsiString archivoi="dosificacion_trabajo_25_5U.txt";
        fileinsulina= fopen(archivoi.c_str(), "r");
        if(!fileinsulina)
                 ShowMessage(" no existe");
           for (cont1=0; cont1<(t_simul+3615); cont1++)
//           for (cont1=0; cont1<(t_simul+1); cont1++)
                for(cont2=0; cont2<40; cont2++)
//                for(cont2=0; cont2<1; cont2++)
           //(!feof(fileinsulina))
                {
               // fscanf(fileinsulina, "%s\t%s\t%s\t%s\t%s", dosis0, dosis1, dosis2, dosis3, dosis4);
                   length = ftell(fileinsulina);
                   fseek(fileinsulina, length, SEEK_SET);
                   fscanf(fileinsulina,  "%s", dosis);
                   insulina[cont2][cont1+1]=StrToFloat(dosis);
                }
        fclose(fileinsulina);
        }

      if ((vcomida==0)&&(tipo_ingesta==2)) // Itinerario de comidas
      {
      ///MODELO GASTROINTESTINAL HOVORKA CON ENTRADA PULSO
        // Toma desde el archivo comida los datos de la cantidad de carbohidratos ingeridos
        // el tiempo de inicio y fin de cada comida, y llama a la funcin en la que se calcula la absorcin de glucosa

        char comida[100], tiempo1[100], tiempo2[100], incertidumbre[10];
        int cont=0, t=0;

        tmg=tmg/h; //De acuerdo al paso de discretizacin
        FILE *filecomida;
        AnsiString archivoc="comida_dosificacion3_3.txt";
        filecomida= fopen(archivoc.c_str(), "r");
        if(!filecomida)
                 ShowMessage(" no existe");

           while (!feof(filecomida))
                {
                fscanf(filecomida, "%s\t%s\t%s\t%s", tiempo1, tiempo2, comida, incertidumbre);
                          if(incertidumbre_dg==1)
                                ingesta=ivalDb(StrToFloat(comida)-StrToFloat(incertidumbre),StrToFloat(comida)+StrToFloat(incertidumbre));
                          else
                                   ingesta=StrToFloat(comida);
                                   ingesta=ingesta*1000/180;

                           for (t=0; t<t_simul; t++)
                        {
                         if(tipo_ingesta==1)
                                if (cont==8)// Varia el tiempo de la comida del dia 3
                                   {t_comida=StrToFloat(tiempo1)+5;
                                   // Validacin de la glucosa capilar, para el clculo de los indices
                                        if ((v[9][0]>=3.8888)&&(v[9][0]<=13.3333))
                                                t_inicial=t_comida; // El area se calcula desde to a to+6
                                        else
                                                t_inicial=t_comida+60;} // El area se calcula desde to+1 a to+6
                                else
                                        {t_comida=StrToFloat(tiempo1);
                                        abs_glucosa_impulsional(ingesta,t,t_comida,&v[14][t+1]);}
                          else
                                abs_glucosa_escalon(ingesta,t,StrToFloat(t_comida),StrToFloat(tiempo2),&v[14][t+1]);


                                //Guarda el valor de la absorcin de glucosa en cada paso
                                if (cont==0)
                                        v[10][t+1]=v[14][t+1];
                                else
                                        //Guarda el valor de la absorcin de glucosa en cada comida (Acumula)
                                        {v[10][t+1]=v[10][t+1]+v[14][t+1];}
                        }

                        ingesta=0;
                        cont++;

                }
                fclose(filecomida);
                t=0;
                cont=0;
             }



  // Datos tomados del Modelo Gastrointestinal de DallaMan
   if (tipo_ingesta==3)
        {
        ///Modelo de DallaMan// Guarda los valores de Ra
        int cont3=0;
        char comidali[100], comidals[100];
        FILE *filedallaman;
        AnsiString archivod="comida_dallaman_5.txt";
        filedallaman= fopen(archivod.c_str(), "r");
        if(!filedallaman)
                 ShowMessage(" no existe");
           for (cont3=0; cont3<(t_simul); cont3++)
                //for(cont4=0; cont4<2; cont4++)

           //(!feof(fileinsulina))
                {
                fscanf(filedallaman, "%s\t%s", comidali, comidals);
                   dal[cont3].Inf=StrToFloat(comidali);
                   dal[cont3].Sup=StrToFloat(comidals);
                }
        fclose(filedallaman);
        }


double index[2], recta;
index[0]=0;
index[1]=0;
index[2]=0;


///  Modelo Endgeno Hovorka et al. (2004)
//   Clculo por el mtodo de euler Se discretiza con t=h min, h es el valor de dicho tiempo

 i=0;
 t_comida=0;

 // Clculo de dosis e instante de inyeccin inicial
 dosis_inicial(v[9][0].Inf, vcomida.Inf, &cant_insul, &t_com);
 t_ins=0;



 // Archivo de salida de datos de glucosa
 // Archivo en el cual se guardan los resultados y se imprime el infimo y supremo de la matriz v de cada variable
 int  marca=0, n=0, l=0, c1=0;
 FILE *out_glucosa;

         AnsiString name="glucosa_"+FloatToStr(vcomida.Inf)+".m";
         out_glucosa= fopen(name.c_str(), "w+");

  //Vector que se crea para guardar el nombre de las variables en la impresin en el archivo de salida
  char line[10], line2[10];
  AnsiString imp[2]={"g_i_","g_s_"};
  //AnsiString imp[18]={"q1_i", "q1_s", "q2_i", "q2_s", "i_i", "i_s", "x1_i", "x1_s", "x2_i", "x2_s", "x3_i", "x3_s", "g_i_","g_s_", "ug_i", "ug_s", "ui_i", "ui_s"};

  // Archivo de salida de los datos generados con Montecarlo
  FILE *out_montecarlo, *out_montecarlo1;

  // Impresin datos montecarlo
  AnsiString name1="montecarlo_"+FloatToStr(vcomida.Inf)+".m";
  out_montecarlo= fopen(name1.c_str(), "w+");

   AnsiString name2="riesgo_montecarlo_"+FloatToStr(vcomida.Inf)+".m";
  out_montecarlo1= fopen(name2.c_str(), "w+");

// Determina en que rango de cantidad de insulina e instante de inyeccin realiza la bsqueda
if (cant_insul>3){  cant_insul1=((cant_insul*2)-1)-(3*2); cant_insul2=((cant_insul*2)-1)+(3*2)+1; } else if (cant_insul==3) {cant_insul1=1; cant_insul2=12;} else {cant_insul1=(cant_insul*2)-1; cant_insul2=((cant_insul*2)-1)+(3*2)+1;}
if (t_com>30){ t_com1=t_com-30;  } else { t_com1=0; };     // Tiempo Inicial para la comida
if (t_com<90) t_com2=t_com+35; else t_com2=125;            // Tiempo Final para la comida



// Datos para prueba (Clculo con una sola cantidad de insulina e instante de inyeccin)
//cant_insul1=9; cant_insul2=10;
//t_com1=0; t_com2=65; // Original
//t_com1=0; t_com2=10; // Prueba
//t_ins=0; //Para cuando hay hipoglucemia

for (cant_insulina=cant_insul1; cant_insulina<cant_insul2; cant_insulina++)// Tres inyecciones de insulina bolus
{
//for (t_ins=0; t_ins<2; t_ins++)  // Variacin tiempo de inyeccin cada 5 min
//{
for (t_comi=t_com1; t_comi<t_com2; t_comi=(t_comi+15))  // Variacin en Sid, Sie,Dg. Puntual
{
for (variacion=0; variacion<=n_montecarlos; variacion++)  // Calcula n_montecarlos
{
                if (t_ins==1) // Asigna los instantes de insulina
                        {
                         t_insu=t_comi;
                         t_comida=0;
                        }
                else
                        {
                         t_comida=t_comi;
                         t_insu=t_ins;
                        }

                // Datos para establecer condiciones iniciales (Dependiendo de la glucosa capilar inicial)
                switch (condiciones_inic)
                {
                case 1 :  //Valores condiciones inciales  para Glucosa Capilar de  80 mg/dl
                        v[3][0]=16.8188;     v[4][0]=0.021198;    v[5][0]=0.0065267;     v[6][0]=0.4370178;
                        v[9][0]=80/18.00;  //Valor de glucosa capilar
                        break;
                case 2 :  //Valores condiciones inciales  para Glucosa Capilar de 150 mg/dl
                        v[3][0]=16.81877;    v[4][0]=0.021199;  v[5][0]=0.0065267;  v[6][0]=0.4370178;
                        v[9][0]=150/18.00;  //Valor de glucosa capilar
                        break;
                case 3 :  //Valores condiciones inciales  para Glucosa Capilar de 250 mg/dl
                        v[3][0]=16.592864;   v[4][0]=0.019825;    v[5][0]=0.006217208;   v[6][0]=0.406559;
                        v[9][0]=220/18.00;  //Valor de glucosa capilar
                        break;
                case 4 :  //Valores condiciones inciales  para Glucosa Capilar de 100 mg/dl
                        v[3][0]=16.81877;    v[4][0]=0.021199;    v[5][0]=0.00652671;    v[6][0]=0.4370178;
                        v[9][0]=100/18.00;;  //Valor de glucosa capilar
                }


                if((n_montecarlos>0)&&(variacion==0))
                {       fprintf(out_montecarlo, "%s", "monte_"+FloatToStr(cant_insulina)+"_0_"+FloatToStr(t_comi)+"=[");
                        fprintf(out_montecarlo, " ");
                        fprintf(out_montecarlo1, "%s", "riesgo_monte_"+FloatToStr(cant_insulina)+"_0_"+FloatToStr(t_comi)+"=[ ");
                }

       // Clcula las variables del modelo endgeno para t_simul minutos
       for (i=0; i<t_simul; i++)
        {

                if((variacion==0)&&(i==0))
                {

                // Asigna incertidumbre a las respectivas variables
                v[4][0]=ivalDb(v[4][0].Inf*(1-(incertidumbre[0]/100.0)), v[4][0].Inf*(1+(incertidumbre[0]/100.0))); // Incertidumbre en el valor inicial de X_1
                v[5][0]=ivalDb(v[5][0].Inf*(1-(incertidumbre[1]/100.0)), v[5][0].Inf*(1+(incertidumbre[1]/100.0))); // Incertidumbre en el valor inicial de X_2
                v[6][0]=ivalDb(v[6][0].Inf*(1-(incertidumbre[2]/100.0)), v[6][0].Inf*(1+(incertidumbre[2]/100.0))); // Incertidumbre en el valor inicial de X_3
                ingesta=ivalDb(vcomida.Inf*(1-(incertidumbre[3]/100.0)), vcomida.Sup*(1+(incertidumbre[3]/100.0))); // Incertidumbre para la ingesta
                ingesta=ingesta*1000/180; // Conversin de los CHO (gr) a mmol

                // Generacin del infimo y el superior para cada parametro o variable que contenga incertidumbre
                if (n_montecarlos>0)
                {
                        incert[3]=ingesta; incert[4]=v[4][0];  incert[5]=v[5][0]; incert[6]=v[6][0];
                        Sit=incert[0];   Sid=incert[1];  Sie=incert[2];
                        // Recalcula los valores de Q2 y S
                        v[2][0]=(v[4][0]*v[1][0])/(k12+v[5][0]); //Q2 basal (mmol)
                        v[14][0]=(v[9][0]*vg)+(Du(v[4][0])*v[1][0]/(Du(k12)+v[5][0])); // Valor de S en estado de equilibrio
                        // Verificacin de aleatorios

                }
                }


                // Generacin de Montecarlos
                if((variacion>0)&&(i==0))
                {
                        montecarlo (incert[0], incert[1],  incert[2], incert[3], incert[4], incert[5], incert[6],  variacion, &Sit, &Sid, &Sie, &ingesta,
                                    &v[4][0], &v[5][0], &v[6][0]);
                        // Recalcula los valores de Q2 y S
                        v[2][0]=(v[4][0]*v[1][0])/(k12+v[5][0]); //Q2 basal (mmol)
                        v[14][0]=(v[9][0]*vg)+(Du(v[4][0])*v[1][0]/(Du(k12)+v[5][0])); // Valor de S en estado de equilibrio
                        //prueba[variacion-1]=ingesta.Inf;


                } // Fin if variacion

               if (vcomida>0)
               {
               //Verifica si la absorcin de glucosa ser calculada mediante la funcin impulsional o escaln
               if(tipo_ingesta==1)
                        abs_glucosa_impulsional(ingesta,i,t_comida,&v[10][i+1]);
               if(tipo_ingesta==2)
                        abs_glucosa_escalon(ingesta, i, t_comida, t_comida, &v[10][i+1]);
               if(tipo_ingesta==3)
                        if (i>=t_comida) v[10][i+1]=dal[i-t_comida]*peso/180.0; else  v[10][i+1]=0;
               }
                // Verifica si la absorcin de insulina ser calculada por medio la funcin Ui  Hovorka(04)
                if(tipo_ins_exogena==1)
                        {
                        u=ivalDb(0,0);
                        t_insu=20;
                        if ((i>=0)&&(i<=t_insu))
                           u=12*1000/t_insu;
                        abs_insulina(u, v[7][i], v[8][i], &v[11][i+1], &v[7][i+1], &v[8][i+1]);
                        }//Finaliza if tipo_ins_exogena
                 else
                        {
                        v[11][i+1]=0;
                        if(i>=t_insu)
                        v[11][i+1]=insulina[cant_insulina-1][i+1+3614];
                        //v[11][i+1]=insulina[cant_insulina-1][i+1];
                        }
                         v[7][i+1]=0;
                         v[8][i+1]=0;

                if(tipo_simulacion==1)
                       {
                        endogeno_puntual(v[11][i], v[1][i],v[2][i],v[3][i],v[4][i],v[5][i],v[6][i], v[9][i], v[10][i], &v[1][i+1], &v[2][i+1], &v[3][i+1], &v[4][i+1], &v[5][i+1], &v[6][i+1],&v[9][i+1], &v[12][i+1], &v[13][i+1]);
                        v[7][i+1]=0;
                        v[12][i+1]=fc01;
                        v[13][i+1]=fr;
                       } //Finaliza if tipo_ins_simulacion
                else
                       { // Validacin modelo a utilizar
                       if (tipo_modelo==1)
                        {
                         endogeno_intervalar(v[11][i], v[1][i],v[2][i],v[3][i],v[4][i],v[5][i],v[6][i], v[9][i], v[10][i], &v[1][i+1], &v[2][i+1], &v[3][i+1], &v[4][i+1], &v[5][i+1], &v[6][i+1],&v[9][i+1], &v[12][i+1], &v[13][i+1]);
                         v[7][i+1]=0;
                        }
                       else
                         endogeno_intervalar_m(v[11][i], v[1][i],v[2][i],v[3][i],v[4][i],v[5][i],v[6][i], v[14][i], v[9][i], v[10][i], i, &v[1][i+1], &v[2][i+1], &v[3][i+1], &v[4][i+1], &v[5][i+1], &v[6][i+1], &v[14][i+1], &v[9][i+1], &v[12][i+1], &v[13][i+1]);
                       } // Finaliza if tipo_modelo


                        //Validacin Mtrica1
                                if((v[9][i+1].Inf<=2)&&(h_i[0]==0))//hipoglucemia severa inicial
                                   { h_i[0]=1; G[0][glu0]=v[9][i+1].Inf; glu0++; G[0][glu0]=i+1; glu0++;}

                                if((v[9][i+1].Inf>2)&&(h_i[0]==1)&&(v[9][i+1].Inf<2.4))
                                    { h_i[0]=0; G[0][glu0]=v[9][i].Inf; glu0++; G[0][glu0]=i; glu0++;}    //hipoglucemia severa final
                                else if((v[9][i+1].Inf>2)&&(h_i[1]==0)&&(v[9][i+1].Inf<=3.9))
                                   { h_i[1]=1; G[1][glu1]=v[9][i+1].Inf; glu1++; G[1][glu1]=i+1; glu1++;} //hipoglucemia moderada inicial

                                if(((v[9][i+1].Inf>3.9)&&(h_i[1]==1)&&(v[9][i+1].Inf<4.3))||((v[9][i+1].Inf<=2)&&(h_i[1]==1)))
                                   { h_i[1]=0; G[1][glu1]=v[9][i].Inf; glu1++;  G[1][glu1]=i; glu1++; }   //hipoglucemia moderada final

                               if((v[9][i+1].Sup>=13.9) && (h_i[2]==0))
                                   { h_i[2]=1; G[2][glu2]=v[9][i+1].Sup; glu2++; G[2][glu2]=i+1; glu2++;} //hiperglucemia severa inicial

                               if((v[9][i+1].Sup<13.9)&&(h_i[2]==1) && (v[9][i+1].Sup>12))
                                   { h_i[2]=0; G[2][glu2]=v[9][i].Sup; glu2++; G[2][glu2]=i; glu2++;}     //hiperglucemia severa final

                               else if((v[9][i+1].Sup>=8.39)&&(h_i[3]==0)&&(v[9][i+1].Sup<13.9))
                                   { h_i[3]=1; G[3][glu3]=v[9][i+1].Sup; glu3++; G[3][glu3]=i+1; glu3++;} //hiperglucemia moderada inicial

                                if(((v[9][i+1].Sup<8.39)&&(h_i[3]==1)&&(v[9][i+1].Sup>8))||((v[9][i+1].Sup>13.9)&&(h_i[3]==1)))
                                   { h_i[3]=0; G[3][glu3]=v[9][i].Sup; glu3++; G[3][glu3]=i; glu3++;}     //hiperglucemia moderada final


                               if(((i>298)&&(G[3][5]>0)&&(G[3][7]==0)&&(G[0][0]>0)))
                                    {G[3][0]=G[3][0];}
                               if(((i>298)&&(G[3][1]==1)&&(G[3][2]==0)))
                                    {G[3][0]=G[3][0];}
                               if(((i>298)&&(G[0][0]>0)&&(G[0][1]==0)&&(G[1][0]>0&&(G[1][1]==0))))
                                     {G[3][0]=G[3][0];}
                               if ((i>84)&&(i<90)&&(G[3][5]>0))
                                    {G[3][0]=G[3][0];}

        }  // Finaliza for i




// IMPRESION DATOS


  // Archivo de salida de datos de Glucosa
  c1=8;
  for (n=0; n<2; n++)
   {
       //fprintf(out_glucosa, "%s",imp[n]+FloatToStr(t_comida)+"_"+FloatToStr(ciclo2)+"=[");
       //fprintf(out_glucosa, "%s",imp[n]+FloatToStr(cant_insulina)+"_"+FloatToStr(t_insu)+"_"+FloatToStr(t_comi)+"=[");
       if (variacion==0)
        { fprintf(out_glucosa, "%s",imp[n]+FloatToStr(cant_insulina)+"_0_"+FloatToStr(t_comi)+"=[");
          fprintf(out_glucosa, " ");}
     //  else if ((variacion<=n_montecarlos)&&(marca==0))  // Impresin datos Montecarlo
     //   { fprintf(out_montecarlo, "%s", "monte_"+FloatToStr(cant_insulina)+"_0_"+FloatToStr(t_comi)+"=[");
     //     fprintf(out_montecarlo, " ");}

     for (l=0; l<(t_simul/multi); l++)
     {
       if (marca==0)
          {
           if (variacion==0)
           {       fprintf(out_glucosa, "%E", v[1+c1][l*multi+1].Inf);
                   fprintf(out_glucosa, " ");}
           else {  // Impresin datos Montecarlo
                   fprintf(out_montecarlo, "%E", v[1+c1][l*multi+1].Inf);
                   fprintf(out_montecarlo, " ");}
           if((c1!=10))
           {v[1+c1][l*multi+1].Inf=0;}
           }
       else
          {
          if (variacion==0)
           {    fprintf(out_glucosa, "%E", v[1+c1][l*multi+1].Sup);
                fprintf(out_glucosa, " ");
           if((c1!=10))
            v[1+c1][l*multi+1].Sup=0;
          }
          if(variacion>0)
          {
          if (l==0)
                // Imprimo los valores q toma para cada montecarlo
                {fprintf(out_montecarlo, "%s","; "+FloatToStr(Sit.Inf)+" "+FloatToStr(Sid.Inf)+" "+FloatToStr(Sie.Inf)+" "+FloatToStr(ingesta.Inf)+
                  " "+FloatToStr(v[4][0].Inf)+" "+FloatToStr(v[5][0].Inf)+" "+FloatToStr(v[6][0].Inf)+" ");
                Sit=0; Sie=0; Sid=0; ingesta=0;
                }
          else if (l>6) fprintf(out_montecarlo, "%s", "0 ");
          }
          }
     } // Finaliza for l
      if (marca==0)
        {
                marca=1;
        }
        else
        {
                marca=0;
                c1=c1+1;
                if (c1==6)
                   c1=c1+2;
        }

     if (variacion==0)
        {  fprintf(out_glucosa, "];");
           fprintf(out_glucosa, "\n");}
      // Impresin datos Montecarlo
     else if ((marca==0)&&(variacion<(n_montecarlos)))
        {  fprintf(out_montecarlo, ";");
           fprintf(out_montecarlo, " ");}
     else if ((variacion==n_montecarlos)&&(marca==0))
             {  fprintf(out_montecarlo, "]");
           fprintf(out_montecarlo, "\n");}




  } // Finaliza for n


     //Impresin de datos de hiper e hipoglucemia

       //fprintf(out_glucosa, "%s", "datos_int_"+FloatToStr(cant_insulina)+"_"+FloatToStr(t_insu)+"_"+FloatToStr(t_comi)+"=[");
       if (variacion==0)
               fprintf(out_glucosa, "%s", "datos_int_"+FloatToStr(cant_insulina)+"_0_"+FloatToStr(t_comi)+"=[ ");


       k=0;
       for(k=0; k<4; k++)
        {
        for(d=0; d<12; d++)
         {
          if(variacion==0)
                {fprintf(out_glucosa, "%E", G[k][d]);
                 fprintf(out_glucosa, " ");
                 G[k][d]=0;
                 }
          else  {
                 fprintf(out_montecarlo1, "%E", G[k][d]);
                 fprintf(out_montecarlo1, " ");
                 G[k][d]=0;}

         } // Finaliza for d
         if (variacion==0)
                fprintf(out_glucosa, ";");
         else   fprintf(out_montecarlo1, ";");
          h_i[k]=0;
         } // Finaliza for k
         if (variacion==0)
                fprintf(out_glucosa, "];");
         else  if (variacion<n_montecarlos)
                {fprintf(out_montecarlo1, ";");}
                else  { fprintf(out_montecarlo1, "]");
                        fprintf(out_montecarlo1, "\n");}

          k=0; d=0; glu0=0; glu1=0; glu2=0; glu3=0;

} // Finaliza for variacion


} //Finaliza for t_comi
           //} //Finaliza for t_insu

} //Finaliza for cant_insulina

 //ShowMessage(FloatToStr(hipos));
 //ShowMessage(FloatToStr(index));
  fclose(out_glucosa);
  fclose(out_montecarlo);
 delete v;
 delete aleatori;
// ShowMessage("Proceso Terminado");
  CStop = clock();                               // Stop Internal Clock.
  CTime=(CStop-CStart)/CLK_TCK;

  ShowMessage("Proceso Terminado en "+FloatToStr(CTime)+" seg");
////////////////////////////////////////////////////////////////////////////////////

}
//---------------------------------------------------------------------------

// MODELO COBELLI ET AL 2007


void __fastcall TForm1::Button1Click(TObject *Sender)
{

// Declaracin de Parmetros
// Declaracin
ivalDb kmax, kmin;

double EGPb, Ib, Gb,  b, d, Vg, Vi, Sb,ic;
double Ipb,   Km0, k2, k1, p2u, m1, m5, CL, HEb, m2, m4, m6;
double m3, Ilb,  kp2, Gpb, ke1, ke2, Fcns, Gtb, HE, incertidumbre[4], n_montecarlos,variacion;
ivalDb kp3, Vm0, Vmx, kp1,a,b1, ki;
ivalDb E, Vmt, Kmt, Kmx, Uii, Uid, U, alpha, beta, Ra, vcomida, ingesta_r, qsto, residuo;
int t_simula, t_ins, mult, itera, i,  com, paciente, c2, k, t_comida;
double parametro[11][22], canti_insulina;
ivalDb incert[4];
double cant_insul, cant_insul1, cant_insul2, t_com1, t_com2, t_com;
double G[4][12], h_i[4];  // Variables para guardar el valor de glucosa y el tiempo en las mtricas
int glu0=0, glu1=0, glu2=0, glu3=0, t_comi, cant_insulina, t_insu;
int s;

// Introduce el tiempo de simulacin en minutos
AnsiString  iteracion= InputBox("Input Box", "Tiempo de simulacin en minutos", "0");

int multi=1; //Valor dado por el paso de discretizacin
int h=1;     // Paso de discretizacin


      for(k=0;k<4; k++)
       {
       for(s=0; s<12; s++) // Variable para la impresin de las mtricas
        {G[k][s]=0;}
         h_i[k]=0;
       }
         s=0; k=0;

t_simula=StrToInt(iteracion)*multi; //Tiempo de simulacin, afectado por el paso de discretizacin

///////////////
vcomida=60;
qsto=0;
ingesta_r=0;
paciente=3;
t_comida=0;

// Establecer incertidumbres
n_montecarlos=00;
incertidumbre[0]=0;    // 0: Incertidumbre en el parmetro kp3
incertidumbre[1]=0;    // 1: Incertidumbre en el parmetro Vmx
incertidumbre[2]=0;    // 2: Incertidumbre en el parmetro Vm0
incertidumbre[3]=0;    // 3: Incertidumbre en el parmetroo ki


// Declaracin variables y parmetros
//Creando la matriz donde se guardaran las variables
// La matriz es declarada como intervalo
// Las filas identifican la variable y las columnas cada minuto
int fila=17;
int columna=t_simula+1;

ivalDb** c;
    c = new ivalDb* [fila];
    for (int m = 0; m < fila; m++)
      c[m] = new ivalDb [columna];
    // Matriz con el nombre de cada variable
    // c[1][i]=qsto c[2][i]=qsto1  c[3][i]=qsto2  c[4][i]=Qut  c[5][i]=Gp   c[6][i]=Gt
    // c[7][i]=G    c[8][i]=Il     c[9][i]=Ip     c[10][i]=I   c[11][i]=X   c[12][i]=I1
    // c[13][i]=Id  c[14][i]=Iex   c[15][i]=Ra

double* gluco_max;
        gluco_max= new double [t_simula];

double* gluco_min;
        gluco_min= new double [t_simula];

ivalDb* dal;
dal= new ivalDb [columna];          
        


ivalDb** insulina;
    // Matriz con los valores de cada inyeccin de insulina
    insulina = new ivalDb* [40]; // Guarda 40 Valores de Iex
    for (int m = 0; m < 40; m++)
      insulina[m] = new ivalDb [columna+3630];


ivalDb* EGP;
EGP= new ivalDb [columna];

ivalDb* D;
D= new ivalDb [columna];
ivalDb* kempt;
kempt= new ivalDb [columna];


///////////////////////  Parmetros  //////////////////////////////////////////

// Toma desde el archivo parametros los parametros de cada paciente

        int pac=0, cont3=0;
        long length;
        char paramet[100];
        FILE *fileparametro;
        AnsiString archivop="parametros.txt";
        fileparametro= fopen(archivop.c_str(), "r");
        if(!fileparametro)
                 ShowMessage(" no existe");
           for(cont3=0; cont3<22; cont3++)
                for (pac=0; pac<11; pac++)
                {
                   length = ftell(fileparametro);
                   fseek(fileparametro, length, SEEK_SET);
                   fscanf(fileparametro,  "%s", paramet);
                   if ((cont3>0)&&(pac>0))
                        parametro[pac][cont3]=StrToFloat(paramet);
                }
        fclose(fileparametro);


// Asigna los valores a los parmetros de 2 pacientes
// Tomados de DallaMan et al. (2007)

// Parmetros comunes
                // Tasa de aparicin de comida en plasma
                f=0.90;         // sin unidad             Fraccin de absorcin intestinal
                // Excrecin de glucosa
                ke1=0.0005;     // min-1 (Valor normal)   Tasa de filtracin glomerular
                ke2=339;        // mg/kg (Valor normal)   Umbral de glucosa renal
                Fcns=1;         // mg/kg/min              Absorcin de glucosa por el cerebro y globulos rojos
                HEb=0.6;        // sin unidad   Secrecin de insulina basal


// Parmetros propios de cada paciente

                // Entrada
                BW=parametro[paciente][1];      // kg           Peso del paciente
                EGPb=parametro[paciente][2];    // mg/kg/min    Produccin de glucosa endgena
                Ib=parametro[paciente][3];      // pmol/l       Insulina basal
                Gb=parametro[paciente][4];      // mg/dl
                // De absorcin
                kabs=parametro[paciente][5];    // min-1        Tasa constante de absorcin intestinal
                kmax=parametro[paciente][6];    // min-1        Tasa mxima de vaciado gstrico
                kmin=parametro[paciente][7];    // min-1        Tasa minima de vaciado gstrico
                b=parametro[paciente][8];       // sin unidad   Porcentaje de dosis para el cual Kempt disminuye
                d=parametro[paciente][9];       // sin unidad
                Vg=parametro[paciente][10];     // dl/kg        Volumen de distribucin de glucosa
                Vi=parametro[paciente][11];     // l/kg         Volumen de distribucin de Insulina
                // De utilizacin
                Vmx=parametro[paciente][12];    // mg/kg/min per pmol/l
                Km0=parametro[paciente][13];    // mg/kg
                k2=parametro[paciente][14];     // min-1        Parmetros de cambio entre Gp y Gt
                k1=parametro[paciente][15];     // min-1        Parmetros de cambio entre Gt y Gp
                p2u=parametro[paciente][16];    // min-1        Tasa constante de accin de insulina
                // Cintica de la insulina
                m1=parametro[paciente][17];     // min-1        Parmetro de cambio entre Il y Ip
                CL=parametro[paciente][18];     // min-1
                // Produccin de Glucosa
                ki=parametro[paciente][19];     // min-1
                kp2=parametro[paciente][20];    // min-1                  Efectiviad de la glucosa en el higado
                kp3=parametro[paciente][21];    // mg/kg/min per pmol/l   Amplitud de la accin de insulina en el higado

                //Vmx=0.0830918;
/////////////////////// Condiciones iniciales  ////////////////////////////////

Gb=80; // Prueba
Ib=0;  // Para utilizar insulina Tarn

Ipb=Ib*Vi;

// Insulina en Plasma
m2=3*CL/(5*HEb*(Vi*BW));       // min-1    Parmetro de cambio entre Ip y Il
m4=2*CL/(5*(Vi*BW));           // min-1
m3=HEb*m1/(1-HEb);             // min-1
Ilb=Ipb*m2/(m1+m3);            // pmol/kg

Gpb=Gb*Vg;     //

// Clculos sin excrecin de glucosa (Diabtico)
Gtb=(Fcns-EGPb+k1*Gpb)/k2;
Vm0=(EGPb-Fcns)*(Km0+Gtb)/Gtb;

kp1=EGPb+kp2*Gpb+kp3*Ib;


/////////    Modelo Insulina Exgena (Tarin et al.) ///////////////////////////
        ///Modelo de Insulina // Guarda los valores de Iex
        // Valores de 1 a 25IU de Insulina Exogena (Basal+Bolus)

        ///Modelo de Insulina // Guarda los valores de Iex
        // Valores de 1 a 25IU de Insulina Exogena (Basal+Bolus)
        int cont1=0, cont2=0;
        double ins;
        char dosis[100];
        FILE *fileinsulina;
        AnsiString archivoi="dosificacion_trabajo_25_5U.txt";
        fileinsulina= fopen(archivoi.c_str(), "r");
        if(!fileinsulina)
                 ShowMessage(" no existe");
           for (cont1=0; cont1<(t_simula+3615); cont1++)
//           for (cont1=0; cont1<(t_simul+1); cont1++)
                for(cont2=0; cont2<40; cont2++)
//                for(cont2=0; cont2<1; cont2++)
           //(!feof(fileinsulina))
                {
               // fscanf(fileinsulina, "%s\t%s\t%s\t%s\t%s", dosis0, dosis1, dosis2, dosis3, dosis4);
                   length = ftell(fileinsulina);
                   fseek(fileinsulina, length, SEEK_SET);
                   fscanf(fileinsulina,  "%s", dosis);
                   insulina[cont2][cont1+1]=StrToFloat(dosis);
                }
        fclose(fileinsulina);
        

///////////////////// LECTURA DE INGESTAS //////////////////////////////////////
// Toma desde el archivo comida los datos de la cantidad de carbohidratos ingeridos
// el tiempo de inicio y fin de cada comida

        int o=0;
        double t_comida1[10], t_comida2[10],ingesta[10];
        char comida[100], tcomida1[100], tcomida2[100];
        FILE *filecomida;
        AnsiString archivoc="comida_cobelli.txt";
        filecomida= fopen(archivoc.c_str(), "r");
        if(!filecomida)
                 ShowMessage(" no existe");

           while (!feof(filecomida))
                {
                fscanf(filecomida, "%s\t%s\t%s", tcomida1, tcomida2, comida);
                t_comida1[o]=StrToFloat(tcomida1);
                t_comida2[o]=StrToFloat(tcomida2);
                ingesta[o]=StrToFloat(comida);
                o=o+1;
                }
                fclose(filecomida);


  // Datos tomados del Modelo Gastrointestinal de DallaMan       

        ///Modelo de DallaMan// Guarda los valores de Ra
        int cont4=0;
        char comidali[100], comidals[100];
        FILE *filedallaman;
        AnsiString archivod="comida_dallaman_5.txt";
        filedallaman= fopen(archivod.c_str(), "r");
        if(!filedallaman)
                 ShowMessage(" no existe");
           for (cont4=0; cont4<(t_simula); cont4++)
                //for(cont4=0; cont4<2; cont4++)

           //(!feof(fileinsulina))
                {
                fscanf(filedallaman, "%s\t%s", comidali, comidals);
                   dal[cont4].Inf=StrToFloat(comidali);
                   dal[cont4].Sup=StrToFloat(comidals);
                }
        fclose(filedallaman);
     



/////////////// Inicializacin variables en estado estacionario ///////////////

c[1][0]= 0;      // Qsto
c[2][0]= 0;      // Qsto1
c[3][0]= 0;      // Qsto2
c[4][0]= 0;      // Qgut
c[5][0]= Gpb;    // Gp
c[6][0]= Gtb;    // Gt
c[7][0]= Gb;     // G
c[8][0]= Ilb;    // Il
c[9][0]= Ipb;    // Ip
c[10][0]=Ib;     // I
c[11][0]=0;      // X
c[12][0]=Ib;     // I1
c[13][0]=Ib;     // Id
EGP[0]=EGPb;     // EGP
c[14][0]=0;
c[15][0]=0;      // Ra


 // Clculo de dosis e instante de inyeccin inicial
 dosis_inicial(c[7][0].Inf/18.0, vcomida.Inf, &canti_insulina, &t_com);
 t_ins=0;


// Determina en que rango de cantidad de insulina e instante de inyeccin realiza la bsqueda
if (canti_insulina>3){  cant_insul1=((canti_insulina*2)-1)-(3*2); cant_insul2=((canti_insulina*2)-1)+(3*2)+1; } else if (canti_insulina==3) {cant_insul1=1; cant_insul2=12;} else {cant_insul1=(canti_insulina*2)-1; cant_insul2=((canti_insulina*2)-1)+(3*2)+1;}
if (t_com>30){ t_com1=t_com-30;  } else { t_com1=0; };     // Tiempo Inicial para la comida
if (t_com<90) t_com2=t_com+35; else t_com2=125;            // Tiempo Final para la comida


// Datos para prueba (Clculo con una sola cantidad de insulina e instante de inyeccin)
cant_insul1=9; cant_insul2=10;
//t_com1=0; t_com2=65; // Original
t_com1=0; t_com2=10; // Prueba
//t_ins=0; //Para cuando hay hipoglucemia

//////////////////// Variables ////////////////////////////////////////////////


com=0;             // Control de comidas

//canti_insulina=9;  // Cantidad de insulina bolus que va a ser inyectada

// Insulina Basal
ic=(m2+m4)*Ipb-m1*Ilb;

////////////// Declaracin archivos salida datos /////////////////////////////
 // Archivo de salida de datos de comida
 // Archivo en el cual se guardan los resultados y se imprime el infimo y supremo de la matriz v de cada variable
 int  marca=0, n=0, l=0, c1=0;
 FILE *out_glucosa;

 AnsiString name="vaciado_"+FloatToStr(vcomida.Inf)+".m";
 out_glucosa= fopen(name.c_str(), "w+");

//Vector que se crea para guardar el nombre de las variables en la impresin en el archivo de salida
char line[10], line2[10];
AnsiString imp[4]={"g_i","g_s", "qsto_i", "qsto_s" };

  // Archivo de salida de los datos generados con Montecarlo
  FILE *out_montecarlo;
  // Impresin datos montecarlo
  AnsiString name1="montecarlo_"+FloatToStr(vcomida.Inf)+".m";
  out_montecarlo= fopen(name1.c_str(), "w+");


for (cant_insulina=cant_insul1; cant_insulina<cant_insul2; cant_insulina++)// Tres inyecciones de insulina bolus
{
for (t_comi=t_com1; t_comi<t_com2; t_comi=(t_comi+15))  // Variacin en Sid, Sie,Dg. Puntual
{

for (variacion=0; variacion<=n_montecarlos; variacion++)  // Calcula n_montecarlos
   {

                       if (t_ins==1) // Asigna los instantes de insulina
                        {
                         t_insu=t_comi;
                         t_comida=0;
                        }
                else
                        {
                         t_comida=t_comi;
                         t_insu=t_ins;
                        }



        // Clcula las variables del modelo endgeno para t_simul minutos
        for (i=0; i<t_simula; i++)
        {
        // Subsistema glucosa
        //EGP[i+1]=kp1-kp2*c[5][i]-kp3*c[13][i]; Ver que pasa
        //EGP[i]=kp1-kp2*c[5][i]-kp3*c[13][i];

        // Validacin de Excrecin renal
        if (c[5][i]>ke2)
                E=ke1*(c[5][i]-ke2);
        else    E=0;

                    if ((i==0)&(variacion==0))
                {
                // Generacin del infimo y el superior para cada parametro o variable que contenga incertidumbre
                incert[0]=ivalDb((kp3.Inf-(kp3.Inf*incertidumbre[0]/100.0)),(kp3.Inf+(kp3.Inf*incertidumbre[0]/100.0)));
                incert[1]=ivalDb((Vmx.Inf-(Vmx.Inf*incertidumbre[1]/100.0)),(Vmx.Inf+(Vmx.Inf*incertidumbre[1]/100.0)));
                incert[2]=ivalDb((Vm0.Inf-(Vm0.Inf*incertidumbre[2]/100.0)),(Vm0.Inf+(Vm0.Inf*incertidumbre[2]/100.0)));
                incert[3]=ivalDb((ki.Inf-(ki.Inf*incertidumbre[3]/100.0)),(ki.Inf+(ki.Inf*incertidumbre[3]/100.0)));
                kp3=incert[0]; Vmx=incert[1]; Vm0=incert[2];   ki=incert[3];
                }


        // Generacin de Montecarlos
        if(((variacion>0)&&(i==0)) || ((variacion>0) && (incert[2].Inf-D[i].Inf)>0.1E-10) && (incert[2].Sup-incert[2].Inf)>0.1E-10)
                {montecarlo_cobelli (incert[0], incert[1],  incert[2], incert[3], variacion, &kp3, &Vmx, &Vm0, &ki);}


        Vmt=Vm0+Vmx*c[11][i];
        Kmt=Km0;

        Uii=Fcns;
        Uid=(Vmt*c[6][i])/(Kmt+c[6][i]);
        U=Uii+Uid;                                         // Utilizacin total de glucosa

        //  18 Septiembre (Clculo intervalar)
        if (c[5][i]>ke2)
                c[5][i+1]=c[5][i]*(h*(-kp2-ke1)+(1-k1*h))+h*(EGPb+kp2*Gpb+kp3*(Ib-c[13][i])+c[15][i]-Uii+(ke1*ke2)+c[6][i]*k2);
        else
                c[5][i+1]=c[5][i]*(h*(-kp2)+(1-k1*h))+h*(EGPb+kp2*Gpb+kp3*(Ib-c[13][i])+c[15][i]-Uii+c[6][i]*k2);

      //  a=Kmt+c[6][i];
      //  b1=(-Kmt*Vmt/(pow(a,2))+(1-k2*h));
      //  if (b1<0)
      //          c[6][i+1]=h*(k1*c[5][i]-Vmt/(Kmt/c[6][i]+1))+c[6][i]*(1-k2*h);
      //  else c[6][i+1]=h*(k1*c[5][i]-Vmt/(Kmt/Du(c[6][i])+1))+c[6][i]*(1-k2*h);

         
         c[6][i+1]=h*(k1*c[5][i]-Vmt*Du(c[6][i])/(Kmt+c[6][i]))+c[6][i]*(1-k2*h);

        ///////

        //c[5][i+1]=h*(EGP[i]+c[15][i]-Uii-E+(k2*c[6][i]))+c[5][i]*(1-k1*h);     // Masa de glucosa en plasma
        //c[6][i+1]=h*(k1*c[5][i]-Uid)+c[6][i]*(1-k2*h);                   // Masa de glucosa en el tejido
        c[7][i+1]=c[5][i]/Vg;
        


        D[0]=0;
        // Validacin comidas
        if ((i>=t_comida1[com])&&(i<t_comida2[com]))
                {D[i+1]=(ingesta[com]*1000)/(t_comida2[com]-t_comida1[com]); // Pasar de gr a mg y dividir en el tiempo de comida
                 ingesta_r=D[i+1];
                if ((i==t_comida1[com])&&(c[1][i]>0))
                        qsto=c[1][i].Inf;
                if (i==t_comida2[com]-1) com=com+1;
                }
        else    D[i+1]=0;


        residuo=qsto+(ingesta_r*4);    // Comida que esta en el estmago

        // Indice de vaciado gstrico
        if (residuo>0)
        {
                alpha=5/(2*residuo*(1-b));
                beta= 5/(2*d*residuo);
                kempt[i]=kmin+((kmax-kmin)/2)*(tanh(alpha*(c[1][i]-b*residuo))-tanh(beta*(c[1][i]-d*residuo))+2);
        }
        else
        kempt[i]=kmax;

        c[14][i+1]=(insulina[cant_insulina-1][i+1+3614]*6/BW)+ic; // Insulina  Exgena  (De mu a pmol/kg)

       // Llama a la funcin de absorcin de glucosa
       //abs_glucosa(c[2][i], c[3][i], c[4][i], c[15][i], kempt[i], D[i],
       //            h, kmax, kmin, &c[2][i+1], &c[3][i+1], &c[4][i+1], &c[15][i+1]);

       // absorcin de glucosa con 5% de Incertidumbre (60gr)
        if (i>=t_comida) c[15][i+1]=dal[i-t_comi]; else  c[15][i+1]=0;


       // Cintica de la insulina
       cinet_insulina (c[12][i], m1, m2, m3, m4, c[10][i], h, kmax, kmin,
                      c[13][i], c[9][i], c[8][i], c[14][i], Vi, ki, Ib, p2u, c[11][i],
                      &c[8][i+1], &c[9][i+1], &c[10][i+1], &c[11][i+1], &c[12][i+1], &c[13][i+1]);


        c[1][i+1]=c[2][i+1]+c[3][i+1];    // Cantidad de glucosa en el estmago


        // Prueba 18 de Septiembre

        //if (c[5][i]>ke2)
        //        c[5][i+1]=c[5][i]*(h*(-kp2-ke1)+(1-k1*h))+h*(EGPb+kp2*Gpb+kp3*(Ib-c[13][i])+c[15][i]-Uii+(ke1*ke2)+c[6][i]*k2);
        //else
        //c[5][i+1]=c[5][i]*(h*(-kp2)+(1-k1*h))+h*(EGPb+kp2*Gpb+kp3*(Ib-c[13][i])+c[15][i]-Uii+c[6][i]*k2);


        //c[5][i+1]=h*((EGPb+kp2*Gpb+kp3*Ib-kp2*c[5][i]-kp3*c[13][i])+c[15][i]-Uii-E+(k2*c[6][i]))+c[5][i]*(1-k1*h);     // Masa de glucosa en plasma



       /*

               EGP[i+1]=kp1-kp2*c[5][i]-kp3*c[13][i];
        kp1=EGPb+kp2*Gpb+kp3*Ib;

        if (c[5][i]>ke2)
                E=ke1*(c[5][i]-ke2);
        else    E=0;

                c[5][i+1]=h*(EGP[i]+c[15][0]-Uii-E+(k2*c[6][i]))+c[5][i]*(1-k1*h);     // Masa de glucosa en plasma
        */

                                //Validacin Mtrica1
                                if((c[7][i+1].Inf<=2*18)&&(h_i[0]==0))//hipoglucemia severa inicial
                                   { h_i[0]=1; G[0][glu0]=c[7][i+1].Inf/18.0; glu0++; G[0][glu0]=i+1; glu0++;}

                                if((c[7][i+1].Inf>2*18)&&(h_i[0]==1)&&(c[7][i+1].Inf<2.4*18))
                                    { h_i[0]=0; G[0][glu0]=c[7][i].Inf/18.0; glu0++; G[0][glu0]=i; glu0++;}    //hipoglucemia severa final
                                else if((c[7][i+1].Inf>2*18)&&(h_i[1]==0)&&(c[7][i+1].Inf<=3.9*18))
                                   { h_i[1]=1; G[1][glu1]=c[7][i+1].Inf/18.0; glu1++; G[1][glu1]=i+1; glu1++;} //hipoglucemia moderada inicial

                                if(((c[7][i+1].Inf>3.9*18)&&(h_i[1]==1)&&(c[7][i+1].Inf<4.3*18))||((c[7][i+1].Inf<=2*18)&&(h_i[1]==1)))
                                   { h_i[1]=0; G[1][glu1]=c[7][i].Inf/18.0; glu1++;  G[1][glu1]=i; glu1++; }   //hipoglucemia moderada final

                               if((c[7][i+1].Sup>=13.9*18) && (h_i[2]==0))
                                   { h_i[2]=1; G[2][glu2]=c[7][i+1].Sup/18.0; glu2++; G[2][glu2]=i+1; glu2++;} //hiperglucemia severa inicial

                               if((c[7][i+1].Sup<13.9*18)&&(h_i[2]==1) && (c[7][i+1].Sup>12*18))
                                   { h_i[2]=0; G[2][glu2]=c[7][i].Sup/18.0; glu2++; G[2][glu2]=i; glu2++;}     //hiperglucemia severa final

                               else if((c[7][i+1].Sup>=8.39*18)&&(h_i[3]==0)&&(c[7][i+1].Sup<13.9*18))
                                   { h_i[3]=1; G[3][glu3]=c[7][i+1].Sup/18.0; glu3++; G[3][glu3]=i+1; glu3++;} //hiperglucemia moderada inicial

                                if(((c[7][i+1].Sup<8.39*18)&&(h_i[3]==1)&&(c[7][i+1].Sup>8*18))||((c[7][i+1].Sup>13.9*18)&&(h_i[3]==1)))
                                   { h_i[3]=0; G[3][glu3]=c[7][i].Sup/18.0; glu3++; G[3][glu3]=i; glu3++;}     //hiperglucemia moderada final



        }  // for t simula


        // Archivo de salida de datos de Glucosa  i-1
       // c1=12; // Salida Id
        c1=6; // Salida glucosa
        com=0;

        if (variacion==0)
        {  // Imprime (superior e inferior)

        for (n=0; n<2; n++)
        {
        //fprintf(out_glucosa, "%s",imp[n]+"_"+FloatToStr(vcomida.Inf)+"=[");
        fprintf(out_glucosa, "%s",imp[n]+"_"+FloatToStr(cant_insulina)+"_0_"+FloatToStr(t_comi)+"=[");
        fprintf(out_glucosa, " ");


     for (l=0; l<(t_simula/multi); l++)
     {
       if (marca==0)
          {
           if (variacion==0)
           {       fprintf(out_glucosa, "%E", c[1+c1][l*multi+1].Inf/18.0);
                   fprintf(out_glucosa, " ");}
           else {  // Impresin datos Montecarlo
                   fprintf(out_montecarlo, "%E", c[1+c1][l*multi+1].Inf/18.0);
                   fprintf(out_montecarlo, " ");}
           if((c1!=10))
           {c[1+c1][l*multi+1].Inf=0;}
           }
       else
          {
          if (variacion==0)
           {    fprintf(out_glucosa, "%E", c[1+c1][l*multi+1].Sup/18.0);
                fprintf(out_glucosa, " ");
           if((c1!=10))
            c[1+c1][l*multi+1].Sup=0;
          }
          }
     } // Finaliza for l


        if (marca==0)
                {marca=1;}
                else
                {
                marca=0;
                c1=c1+1;
                if (c1==1)
                   c1=c1+5;
                }

        fprintf(out_glucosa, "];");
        fprintf(out_glucosa, "\n");
        } // Finaliza for n
        }
        else // Variacin mayor a 1
        { // Imprime las montecarlo
        for (n=0; n<2; n++)
        {
        if ((variacion==1)&&(n==0))
        {fprintf(out_montecarlo, "%s", "monte_1_"+FloatToStr(vcomida.Inf)+"=[");
        fprintf(out_montecarlo, " ");
        /*
        if (n==1)  // Imprime dos variables
          {     fprintf(out_montecarlo, "%s", "monte_2_"+FloatToStr(vcomida.Inf)+"=[");
                fprintf(out_montecarlo, " ");}
        */
        }
        //c2=1+(n*6);
        //Representacion montecarlos
       // c2=13; //salida montecarlosId
        c2=7; //salida montecarlos glucosa
        // Impresin archivo salida datos montecarlo
         for (k=0; k<(t_simula/multi); k++)
             {
               if (n==0)
               {fprintf(out_montecarlo, "%E", c[c2][k*multi+1].Inf);
                fprintf(out_montecarlo, " ");}
               /*
               else
               {fprintf(out_montecarlo, "%E", c[c2][k*multi+1].Inf);
                fprintf(out_montecarlo, " ");}
                */

                if (n==1)
               {
               //Validacin mnima y mxima
               if(variacion==1)
               {gluco_max[k*multi]=c[c2][k*multi+1].Inf;
                gluco_min[k*multi]=c[c2][k*multi+1].Inf;}
               else{
               if(c[c2][k*multi+1].Inf>=gluco_max[k*multi]) // Anlisis mximos
                        gluco_max[k*multi]=c[c2][k*multi+1].Inf;
               if(c[c2][k*multi+1].Inf<=gluco_min[k*multi]) // Anlisis mnimos
                        gluco_min[k*multi]=c[c2][k*multi+1].Inf;
               }
               }
               c[c2][k*multi+1].Inf=0;  c[c2][k*multi+1].Sup=0;
              } //Finaliza el for de k
              if (n==0)
              {fprintf(out_montecarlo, ";");
               fprintf(out_montecarlo, " ");}


        }

       }

            //Impresin de datos de hiper e hipoglucemia

       //fprintf(out_glucosa, "%s", "datos_int_"+FloatToStr(cant_insulina)+"_"+FloatToStr(t_insu)+"_"+FloatToStr(t_comi)+"=[");
       if (variacion==0)
               fprintf(out_glucosa, "%s", "datos_int_"+FloatToStr(cant_insulina)+"_0_"+FloatToStr(t_comi)+"=[ ");


       k=0;
       for(k=0; k<4; k++)
        {
        for(s=0; s<12; s++)
         {
          if(variacion==0)
                {fprintf(out_glucosa, "%E", G[k][s]);
                 fprintf(out_glucosa, " ");
                 G[k][s]=0;
                 }
         } // Finaliza for s
         if (variacion==0)
                fprintf(out_glucosa, ";");
          h_i[k]=0;
         } // Finaliza for k
         if (variacion==0)
                fprintf(out_glucosa, "];");
 

          k=0; s=0; glu0=0; glu1=0; glu2=0; glu3=0;

  } // for montecarlo

                        fprintf(out_montecarlo, "];");
                        fprintf(out_montecarlo, "\n");

                 /*
                        fprintf(out_montecarlo, "%s", "maximo_"+FloatToStr(vcomida.Inf)+"=[");
                        fprintf(out_montecarlo, " ");
                        k=0;
                                  for (k=0; k<(t_simula/multi); k++)
                                {
                                fprintf(out_montecarlo, "%E", gluco_max[k]);
                                fprintf(out_montecarlo, " ");
                                } //Finaliza el for de k

                        fprintf(out_montecarlo, "];");
                        fprintf(out_montecarlo, "\n");
                        fprintf(out_montecarlo, "%s", "minimo_"+FloatToStr(vcomida.Inf)+"=[");
                        fprintf(out_montecarlo, " ");
                        k=0;
                                  for (k=0; k<(t_simula/multi); k++)
                                {
                                fprintf(out_montecarlo, "%E", gluco_min[k]);
                                fprintf(out_montecarlo, " ");
                                } //Finaliza el for de k


                        fprintf(out_montecarlo, "];");
                        fprintf(out_montecarlo, "\n");
                        k=0;
                  */

} //Finaliza for t_comi


} //Finaliza for cant_insulina

  fclose(out_glucosa);
  delete c;
  ShowMessage("Proceso Terminado");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
// Modelo de Bergman
// Febrero 8 de 2009

int multi, t_simul, i, t_comida, tipo_ins_exogena,t_insu, canti_insulina,variacion, ncomidas;
ivalDb p1, p2, p3, n,x1;
double Vi, Vg, Iex,  comida, n_montecarlos, peso;
ivalDb vcomida, ingesta,  incert[5];
int tipo_ingesta, s, k;

double G[4][12], h_i[4];  // Variables para guardar el valor de glucosa y el tiempo en las mtricas
int glu0=0, glu1=0, glu2=0, glu3=0, t_comi, cant_insulina, t_ins;
double cant_insul, cant_insul1, cant_insul2, t_com, t_com1, t_com2;


// Introduce el tiempo de simulacin en minutos
AnsiString  iter= InputBox("Input Box", "Tiempo de simulacin en minutos", "0");

multi=1; //Valor dado por el paso de discretizacin
h=1;     // Paso de discretizacin


      for(k=0;k<4; k++)
       {
       for(s=0; s<12; s++) // Variable para la impresin de las mtricas
        {G[k][s]=0;}
         h_i[k]=0;
       }
         s=0; k=0;            


tipo_ins_exogena=2;
tipo_ingesta=2;         // 1 Hovorka  // 2 DallaMan 
t_insu=0;               // tiempo inyeccin

t_simul=StrToInt(iter)*multi; //Tiempo de simulacin, afectado por el paso de discretizacin

//Creando la matriz donde se guardara el resultado de q1, q2, i, x1, x2, x3, g, ug, ui, fc01, fr
// La matriz es declarada como intervalo
// Las filas identifican la variable y las columnas cada minuto
int fila=7;
int columna=t_simul+1;

ivalDb** b;
    b = new ivalDb* [fila];
    for (int m = 0; m < fila; m++)
      b[m] = new ivalDb [columna];
    //Matriz con el nombre de cada variable
    //b[1][i]=G b[2][i]=X b[3][i]=I   b[4][i]=D

ivalDb* dal;
dal= new ivalDb [columna];    

/*
double** b;
    b = new double* [fila];
    for (int m = 0; m < fila; m++)
      b[m] = new double [columna];
    //Matriz con el nombre de cada variable
    //b[1][i]=G b[2][i]=X b[3][i]=I   b[4][i]=D

*/
ivalDb** insulina;
    // Matriz con los valores de cada inyeccin de insulina
    insulina = new ivalDb* [40]; // Guarda 40 Valores de Iex
    for (int m = 0; m < 40; m++)
      insulina[m] = new ivalDb [columna+3630];

   // Modelo Insulina Exgena (UPV)
   if(tipo_ins_exogena==2)
        {
        ///Modelo de Insulina // Guarda los valores de Iex
        // Valores de 1 a 25IU de Insulina Exogena (Basal+Bolus)
        int cont1=0, cont2=0;
        double ins;
        long length;
        char dosis[100];
        FILE *fileinsulina;
        AnsiString archivoi="dosificacion_trabajo_25_5U.txt";
        fileinsulina= fopen(archivoi.c_str(), "r");
        if(!fileinsulina)
                 ShowMessage(" no existe");
           for (cont1=0; cont1<(t_simul+3615); cont1++)
                for(cont2=0; cont2<40; cont2++)
                {
               // fscanf(fileinsulina, "%s\t%s\t%s\t%s\t%s", dosis0, dosis1, dosis2, dosis3, dosis4);
                   length = ftell(fileinsulina);
                   fseek(fileinsulina, length, SEEK_SET);
                   fscanf(fileinsulina,  "%s", dosis);
                   insulina[cont2][cont1+1]=StrToFloat(dosis);
                }
        fclose(fileinsulina);
        }



  // Datos tomados del Modelo Gastrointestinal de DallaMan
   if (tipo_ingesta==2)
        {
        ///Modelo de DallaMan// Guarda los valores de Ra
        int cont3=0;
        char comidali[100], comidals[100];
        FILE *filedallaman;
        AnsiString archivod="comida_dallaman_5.txt";
        filedallaman= fopen(archivod.c_str(), "r");
        if(!filedallaman)
                 ShowMessage(" no existe");
           for (cont3=0; cont3<(t_simul); cont3++)
                //for(cont4=0; cont4<2; cont4++)

           //(!feof(fileinsulina))
                {
                fscanf(filedallaman, "%s\t%s", comidali, comidals);
                   dal[cont3].Inf=StrToFloat(comidali);
                   dal[cont3].Sup=StrToFloat(comidals);
                }
        fclose(filedallaman);
        }





// Entrada
comida=60;  // gr
vcomida=comida;
//ingesta=comida*1000/180; // Conversin de los CHO (gr) a mmol
ingesta=60;
t_comida=00;
Iex=0;
canti_insulina=9;
n_montecarlos=0000;
ncomidas=1;             // Indica que hay ms de una comida
peso=66;                // kg

incert[0]=0;
/*
// Varias comidas
      if (ncomidas==1) // Itinerario de comidas
      {
      ///MODELO GASTROINTESTINAL HOVORKA CON ENTRADA PULSO
        // Toma desde el archivo comida los datos de la cantidad de carbohidratos ingeridos
        // el tiempo de inicio y fin de cada comida, y llama a la funcin en la que se calcula la absorcin de glucosa

        char comida[100], tiempo1[100], tiempo2[100], incertidumbre[10];
        int cont=0, t=0;

        tmg=tmg/h; //De acuerdo al paso de discretizacin
        FILE *filecomida;
        AnsiString archivoc="comida_bergman.txt";
        filecomida= fopen(archivoc.c_str(), "r");
        if(!filecomida)
                 ShowMessage(" no existe");

           while (!feof(filecomida))
                {
                fscanf(filecomida, "%s\t%s\t%s\t%s", tiempo1, tiempo2, comida, incertidumbre);
                          if(incertidumbre_dg==1)
                                ingesta=ivalDb(StrToFloat(comida)-StrToFloat(incertidumbre),StrToFloat(comida)+StrToFloat(incertidumbre));
                          else
                                   ingesta=StrToFloat(comida);
                                   ingesta=ingesta*1000/180;

                           for (t=0; t<t_simul; t++)
                        {
                         if(tipo_ingesta==1)
                                if (cont==8)// Varia el tiempo de la comida del dia 3
                                   {t_comida=StrToFloat(tiempo1)+5;
                                   // Validacin de la glucosa capilar, para el clculo de los indices
                                        if ((v[9][0]>=3.8888)&&(v[9][0]<=13.3333))
                                                t_inicial=t_comida; // El area se calcula desde to a to+6
                                        else
                                                t_inicial=t_comida+60;} // El area se calcula desde to+1 a to+6
                                else
                                        {t_comida=StrToFloat(tiempo1);
                                        abs_glucosa_impulsional(ingesta,t,t_comida,&v[14][t+1]);}
                          else
                                abs_glucosa_escalon(ingesta,t,StrToFloat(t_comida),StrToFloat(tiempo2),&v[14][t+1]);


                                //Guarda el valor de la absorcin de glucosa en cada paso
                                if (cont==0)
                                        v[10][t+1]=v[14][t+1];
                                else
                                        //Guarda el valor de la absorcin de glucosa en cada comida (Acumula)
                                        {v[10][t+1]=v[10][t+1]+v[14][t+1];}
                        }

                        ingesta=0;
                        cont++;

                }
                fclose(filecomida);
                t=0;
                cont=0;
             }

*/

// Parmetros

/*
//p1=2.96e2;           // min^-1 Tasa constante insulino independiente de glucosa
                     // en msculos, higado y tejido adiposo
//p1=1.13e-2;
//p2=1.86e2;           // min^-1 Tasa de disminucin del consumo de glucosa en el tejido
p2=0.025;
//p3=6.51*1e6*1e-1;    // dL/mU min^2 Tasa constante del incremento insulino-dependiente
                     // de la capacidad de consumo en el tejido
p3=0.000013;
//n=0.23;              // min^-1 Tasa de eliminacin de insulina
//n=5/54.0;
n=0.23;
Vi=12;               // dL
*/

// Parmetros del modelo minimal presentados en Dua et al. (2006)

p1=0;                   // min^-1 Tasa constante insulino independiente de glucosa en msculos, higado y tejido adiposo
p2=0.025;               // min^-1 Tasa de disminucin del consumo de glucosa en el tejido
p3=0.000013;            // L/mU min^2 Tasa constante del incremento insulino-dependiente de la capacidad de consumo en el tejido
Vi=12;                  // L Volumen de distribucin de insulina

// Parmetro tomado de Bergman et al. (1981)

n=0.23;                 // min^-1 Tasa de eliminacin de insulina

// Parmetros modelo gastrointestinal Hovorka

ag=0.8;              // Biodisponibilidad de carbohidratos (unitless)
tmg=40;              // Tasa de aparicin mxima de glucosa en el compartimiento accesible de glucosa (min)
Vg=92.6;             // dL

b[1][0]=80;          // mg/dl Glucosa basal
b[3][0]=0;          // mU/L Insulina basal
b[2][0]=0;
b[4][0]=0;
b[5][0]=0;



// Asigno incertidumbre
//p1=ivalDb(p1.Inf*(1-(incert[0]/100.0)), p1.Inf*(1+(incert[0]/100.0))); // Incertidumbre en el parmetro p1

//p1=ivalDb(p1.Inf*0.90, p1.Sup*0.90);
//p2=iv/alDb(p2.Inf*0.95, p2.Sup*1.05);
//p3=ivalDb(p3.Inf*0.92, p3.Sup*1.08);
//n=ivalDb(n.Inf*0.95, n.Sup*1.05);
ingesta=ingesta*1000;
ingesta=ivalDb(ingesta.Inf*0.95, ingesta.Inf*1.05);


// Pruebas puntuales
//p2=ivalDb(p2.Inf*0.90, p2.Sup*0.90);
//p3=ivalDb(p3.Inf*0.90, p3.Sup*0.90);
//n=ivalDb(n.Inf*0.95, n.Sup*0.95);
//ingesta=ivalDb(ingesta.Inf*1.05, ingesta.Inf*1.05);

//p2=ivalDb(p2.Inf*0.90, p2.Sup*0.90);
//p3=ivalDb(p3.Inf*0.90, p3.Sup*0.90);





////////////////////////   Salida Datos  //////////////////////////////////////
 // Archivo de salida de datos de glucosa
 // Archivo en el cual se guardan los resultados y se imprime el infimo y supremo de la matriz c de cada variable
 int  marca=0, m=0, l=0, c1=0;
 FILE *out_glucosa;
         AnsiString name="glucosa_"+FloatToStr(comida)+".m";
         out_glucosa= fopen(name.c_str(), "w+");

  //Vector que se crea para guardar el nombre de las variables en la impresin en el archivo de salida
  char line[10], line2[10];
  AnsiString imp[2]={"g_i_","g_s_"};

  
// Archivo de salida de los datos generados con Montecarlo
        FILE *out_montecarlo, *out_montecarlo1;
// Impresin datos montecarlo
        AnsiString name1="montecarlo_"+FloatToStr(comida)+".m";
        out_montecarlo= fopen(name1.c_str(), "w+");

 // Clculo de dosis e instante de inyeccin inicial
 dosis_inicial(b[1][0].Inf/18, vcomida.Inf, &cant_insul, &t_com);
 t_ins=0;

// Determina en que rango de cantidad de insulina e instante de inyeccin realiza la bsqueda
if (cant_insul>3){  cant_insul1=((cant_insul*2)-1)-(3*2); cant_insul2=((cant_insul*2)-1)+(3*2)+1; } else if (cant_insul==3) {cant_insul1=1; cant_insul2=12;} else {cant_insul1=(cant_insul*2)-1; cant_insul2=((cant_insul*2)-1)+(3*2)+1;}
if (t_com>30){ t_com1=t_com-30;  } else { t_com1=0; };     // Tiempo Inicial para la comida
if (t_com<90) t_com2=t_com+35; else t_com2=125;            // Tiempo Final para la comida



// Datos para prueba (Clculo con una sola cantidad de insulina e instante de inyeccin)
cant_insul1=16; cant_insul2=25;
//t_com1=0; t_com2=65; // Original
//t_com1=0; t_com2=10; // Prueba
//t_ins=0; //Para cuando hay hipoglucemia


for (canti_insulina=cant_insul1; canti_insulina<cant_insul2; canti_insulina++)// Tres inyecciones de insulina bolus
{
for (t_comi=t_com1; t_comi<t_com2; t_comi=(t_comi+15))  // Variacin en Sid, Sie,Dg. Puntual
{
for (variacion=0; variacion<=n_montecarlos; variacion++)  // Calcula n_montecarlos
{

                       if (t_ins==1) // Asigna los instantes de insulina
                        {
                         t_insu=t_comi;
                         t_comida=0;
                        }
                else
                        {
                         t_comida=t_comi;
                         t_insu=t_ins;
                        }


// Iteracin
for (i=0; i<t_simul; i++)
{

// Concentracin de glucosa en plasma
//b[1][i+1]=p1*(b[1][0]-Du(b[1][i]))+b[1][i]*(1-b[2][i])+(b[4][i]/Vg);

b[1][i+1]=b[1][i]*(1-p1-b[2][i])-(b[2][i]*b[1][0])+(b[4][i]/Vg);

if ((-p1+(1-b[2][i]))<0)
b[1][i+1]=b[1][i+1];
//b[1][i+1]=-p1*(b[1][i]-b[1][0])-b[2][i]*b[1][i]+(b[4][i]/Vg)+b[1][i];




// Concentracin de insulina en el compartimento remoto
//if (i==0)
        //b[2][i+1]=(b[3][i]-Du(b[3][0]));
        b[2][i+1]=b[2][i]*(1-p2)+p3*(b[3][i]-b[3][0]);
        // b[2][i]*(1-p2)p3*
//else    b[2][i+1]=b[2][i]*(1-p2)+p3*(Du(b[3][i])-b[3][0]);


// Insulina
b[5][i+1]=0;
if((i>=t_insu)&&(canti_insulina>0))
b[5][i+1]=insulina[canti_insulina-1][i+1+3614];


// Concentracin de insulina en plasma
b[3][i+1]=-n*(Du(b[3][i])+b[3][0])+b[3][i]+(b[5][i]/Vi);

//b[4][i+1]=0;

// Comida
if(tipo_ingesta==1)
        abs_glucosa_impulsional(ingesta,i,t_comida,&b[4][i+1]);
else    if (tipo_ingesta==2)
              {
                if (i>=t_comida)
                      b[4][i+1]=dal[i-t_comida]*peso;
                else  b[4][i+1]=0;
              }



        // Generacin del infimo y el superior para cada parametro o variable que contenga incertidumbre
        if ((variacion==0)&&(i==0)&&(n_montecarlos>0))
        {
                incert[0]=p1; incert[1]=p2;  incert[2]=p3; incert[3]=n;  incert[4]=ingesta;

                fprintf(out_montecarlo, "%s", "monte_"+FloatToStr(canti_insulina)+"_"+FloatToStr(t_comida)+"=[");
                fprintf(out_montecarlo, " ");

        }


        // Generacin de Montecarlos
        if((variacion>0)&&(i==0))
        {
                montecarlo (incert[0], incert[1],  incert[2], incert[3], incert[4], 0, 0,  variacion, &p1, &p2, &p3, &n, &ingesta, &b[6][i+1], &b[6][i+1]);
        } // Fin if variacion



                                       //Validacin Mtrica1
                                if((b[1][i+1].Inf<=2*18)&&(h_i[0]==0))//hipoglucemia severa inicial
                                   { h_i[0]=1; G[0][glu0]=b[1][i+1].Inf/18.0; glu0++; G[0][glu0]=i+1; glu0++;}

                                if((b[1][i+1].Inf>2*18)&&(h_i[0]==1)&&(b[1][i+1].Inf<2.4*18))
                                    { h_i[0]=0; G[0][glu0]=b[1][i].Inf/18.0; glu0++; G[0][glu0]=i; glu0++;}    //hipoglucemia severa final
                                else if((b[1][i+1].Inf>2*18)&&(h_i[1]==0)&&(b[1][i+1].Inf<=3.9*18))
                                   { h_i[1]=1; G[1][glu1]=b[1][i+1].Inf/18.0; glu1++; G[1][glu1]=i+1; glu1++;} //hipoglucemia moderada inicial

                                if(((b[1][i+1].Inf>3.9*18)&&(h_i[1]==1)&&(b[1][i+1].Inf<4.3*18))||((b[1][i+1].Inf<=2*18)&&(h_i[1]==1)))
                                   { h_i[1]=0; G[1][glu1]=b[1][i].Inf/18.0; glu1++;  G[1][glu1]=i; glu1++; }   //hipoglucemia moderada final

                               if((b[1][i+1].Sup>=13.9*18) && (h_i[2]==0))
                                   { h_i[2]=1; G[2][glu2]=b[1][i+1].Sup/18.0; glu2++; G[2][glu2]=i+1; glu2++;} //hiperglucemia severa inicial

                               if((b[1][i+1].Sup<13.9*18)&&(h_i[2]==1) && (b[1][i+1].Sup>12*18))
                                   { h_i[2]=0; G[2][glu2]=b[1][i].Sup/18.0; glu2++; G[2][glu2]=i; glu2++;}     //hiperglucemia severa final

                               else if((b[1][i+1].Sup>=8.39*18)&&(h_i[3]==0)&&(b[1][i+1].Sup<13.9*18))
                                   { h_i[3]=1; G[3][glu3]=b[1][i+1].Sup/18.0; glu3++; G[3][glu3]=i+1; glu3++;} //hiperglucemia moderada inicial

                                if(((b[1][i+1].Sup<8.39*18)&&(h_i[3]==1)&&(b[1][i+1].Sup>8*18))||((b[1][i+1].Sup>13.9*18)&&(h_i[3]==1)))
                                   { h_i[3]=0; G[3][glu3]=b[1][i].Sup/18.0; glu3++; G[3][glu3]=i; glu3++;}     //hiperglucemia moderada final




}// end for i



  // Archivo de salida de datos de Glucosa
  c1=0;
  for (m=0; m<2; m++)
   {

       if (variacion==0)
       {fprintf(out_glucosa, "%s",imp[m]+FloatToStr(canti_insulina)+"_0_"+FloatToStr(t_comida)+"=[");
        fprintf(out_glucosa, " ");}

     for (l=0; l<(t_simul/multi); l++)
     {
       if (marca==0)
          {
           if (variacion==0)
           {       fprintf(out_glucosa, "%E", b[1+c1][l*multi+1].Inf/18.0);
                   fprintf(out_glucosa, " ");}
           else {  // Impresin datos Montecarlo
                   fprintf(out_montecarlo, "%E", b[1+c1][l*multi+1].Inf/18.0);
                   fprintf(out_montecarlo, " ");}
           if((c1!=10))
           {b[1+c1][l*multi+1].Inf=0;}
           }
       else
          {
          if (variacion==0)
           {    fprintf(out_glucosa, "%E", b[1+c1][l*multi+1].Sup/18.0);
                fprintf(out_glucosa, " ");
           if((c1!=10))
            b[1+c1][l*multi+1].Sup=0;
          }
          }
     } // Finaliza for l
      if (marca==0)
        {
                marca=1;
        }
        else
        {
                marca=0;
                c1=c1+1;
                if (c1==6)
                   c1=c1+2;
        }

     if (variacion==0)
        {  fprintf(out_glucosa, "];");
           fprintf(out_glucosa, "\n");}
      // Impresin datos Montecarlo
     else if ((marca==0)&&(variacion<(n_montecarlos)))
        {  fprintf(out_montecarlo, ";");
           fprintf(out_montecarlo, " ");}
     else if ((variacion==n_montecarlos)&&(marca==0))
             {  fprintf(out_montecarlo, "]");
           fprintf(out_montecarlo, "\n");}




  } // Finaliza for n


             //Impresin de datos de hiper e hipoglucemia


       if (variacion==0)
               fprintf(out_glucosa, "%s", "datos_int_"+FloatToStr(canti_insulina)+"_0_"+FloatToStr(t_comi)+"=[ ");


       k=0;
       for(k=0; k<4; k++)
        {
        for(s=0; s<12; s++)
         {
          if(variacion==0)
                {fprintf(out_glucosa, "%E", G[k][s]);
                 fprintf(out_glucosa, " ");
                 G[k][s]=0;
                 }
         } // Finaliza for s
         if (variacion==0)
                fprintf(out_glucosa, ";");
          h_i[k]=0;
         } // Finaliza for k
         if (variacion==0)
                fprintf(out_glucosa, "];");
 

          k=0; s=0; glu0=0; glu1=0; glu2=0; glu3=0;


 }// Finaliza for variacion

} //Finaliza for t_comi
          

} //Finaliza for cant_insulina


  fclose(out_glucosa);
  delete b;
  ShowMessage("Proceso Terminado");

}
//---------------------------------------------------------------------------






void __fastcall TForm1::GeneralClick(TObject *Sender)
{
// Declaracin de variables generales

int comida, t_comida;
int canti_insulina;
int n_montecarlos;

// Entrada datos

// Introduce el tiempo de simulacin en minutos
AnsiString  iter= InputBox("Input Box", "Tiempo de simulacin en minutos", "0");


comida=60;              // gr
t_comida=0;             // min
canti_insulina=9;       // Cantidad de insulina IU
n_montecarlos=0000;     // Nmero de montecarlos





// Llamado a modelos


// Montecarlos


        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GaetanoClick(TObject *Sender)
{

int  i, z, comida, variacion, t_simul, multi, b5, t_comida, BW;
double b1, b2, b3, b4,  b6, b7, Gb, Ib, Vg, Vi;
int t_insu, canti_insulina;
ivalDb ingesta, sum, b0;

// Introduce el tiempo de simulacin en minutos
AnsiString  iter= InputBox("Input Box", "Tiempo de simulacin en minutos", "0");

multi=1; //Valor dado por el paso de discretizacin
h=1;     // Paso de discretizacin

t_simul=StrToInt(iter)*multi; //Tiempo de simulacin, afectado por el paso de discretizacin


// La matriz es declarada como intervalo
// Las filas identifican la variable y las columnas cada minuto

int fila=6;
int columna=t_simul+1;
ivalDb** g;
    g = new ivalDb* [fila];
    for (int m = 0; m < fila; m++)
      g[m] = new ivalDb [columna];
    //Matriz con el nombre de cada variable
    //g[1][i]=G g[2][i]=I  g[3][i]=I1   g[4][i]=D   g[5][i]=Iex


ivalDb** insulina;
    // Matriz con los valores de cada inyeccin de insulina
    insulina = new ivalDb* [40]; // Guarda 40 Valores de Iex
    for (int m = 0; m < 40; m++)
      insulina[m] = new ivalDb [columna+3630];

   // Modelo Insulina Exgena (UPV)

        ///Modelo de Insulina // Guarda los valores de Iex
        // Valores de 1 a 25IU de Insulina Exogena (Basal+Bolus)
        int cont1=0, cont2=0;
        double ins;
        long length;
        char dosis[100];
        FILE *fileinsulina;
        AnsiString archivoi="dosificacion_trabajo_25_5U.txt";
        fileinsulina= fopen(archivoi.c_str(), "r");
        if(!fileinsulina)
                 ShowMessage(" no existe");
           for (cont1=0; cont1<(t_simul+3615); cont1++)
                for(cont2=0; cont2<40; cont2++)
                {
               // fscanf(fileinsulina, "%s\t%s\t%s\t%s\t%s", dosis0, dosis1, dosis2, dosis3, dosis4);
                   length = ftell(fileinsulina);
                   fseek(fileinsulina, length, SEEK_SET);
                   fscanf(fileinsulina,  "%s", dosis);
                   insulina[cont2][cont1+1]=StrToFloat(dosis);
                }
        fclose(fileinsulina);
        


// Parmetros del modelo
b0=170;         // mg/dl
b1=0.0226;      // min-1
b2=0.0437;      // min-1
b3=2.57;        // pM/(mg/dl)
b4=3.8e-8;      // min-1 pm-1
b5=20;          // min
b6=0.045;       // min-1 pM/(mg/dl)
b7=1.56;        // (mg/dl) min-1
Gb=100;         // mg/dl
Ib=10;
Vi=12.0;                  // L Volumen de distribucin de insulina

// Parmetros modelo gastrointestinal Hovorka

ag=0.8;              // Biodisponibilidad de carbohidratos (unitless)
tmg=40;              // Tasa de aparicin mxima de glucosa en el compartimiento accesible de glucosa (min)
Vg=92.6;       // dl

// Entrada
comida=60;
t_comida=0;
ingesta=comida*1000/180; // Conversin de los CHO (gr) a mmol
variacion=0;
t_insu=0;
canti_insulina=9;
BW=72;  // peso del paciente en kg


// Modelo Glucosa

// Valores iniciales

        b0=(comida*1000)/(Vg*BW);
        b7=b1*Gb+b4*Ib*Gb;
        b6=b2*(Ib/Gb);

        g[1][0]=Gb+b0;
        g[2][0]=Ib+(b3*b0);
        g[3][0]=0;
        g[4][0]=0;
        g[5][0]=0;

////////////////////////   Salida Datos  //////////////////////////////////////
 // Archivo de salida de datos de glucosa
 // Archivo en el cual se guardan los resultados y se imprime el infimo y supremo de la matriz c de cada variable
 int  marca=0, m=0, l=0, c1=0;
 FILE *out_glucosa;
         AnsiString name="glucosa_"+FloatToStr(comida)+".m";
         out_glucosa= fopen(name.c_str(), "w+");

  //Vector que se crea para guardar el nombre de las variables en la impresin en el archivo de salida
  char line[10], line2[10];
  AnsiString imp[2]={"g_i_","g_s_"};


// Iteracin
for (i=0; i<t_simul; i++)
{



        // Concentracin de glucosa en sangre
       // if ((i-b5)<0)
       //        g[1][i+1]=Gb;
       // else
               g[1][i+1]=g[1][i]*(1-b1*h)+(b7-b4*g[2][i]*g[1][i])*h;

        // Concentracn de insulina en plasma
        //g[2][i+1]=g[2][i]+h*g[3][i];

        // Derivada de la concentracin de insulina en plasma
        //if (i>b5)
        //        g[3][i+1]=g[3][i]*(1-b2*h)+h*(b6/b5)*(g[1][i]-(g[1][i-b5]))+(g[5][i+1]/Vi);
        //else    g[3][i+1]=0;


        // Insulina
        g[5][i+1]=0;
        if((i>=t_insu)&&(canti_insulina>0))
        g[5][i+1]=insulina[canti_insulina-1][i+1+3614];

        // Calculo de I con sumatoria
        sum=0;
        for (z=0;z<i;z++)
        {sum=g[2][z]+sum;}
        g[2][i+1]=g[2][i]*(1-b2*h)+h*((b6/b5)*sum)+(g[5][i+1]/Vi);

        // Absorcin de glucosa
        abs_glucosa_impulsional(ingesta,i,t_comida,&g[4][i+1]);



}// end for i



  // Archivo de salida de datos de Glucosa
  c1=0;
  for (m=0; m<2; m++)
   {

       if (variacion==0)
       {fprintf(out_glucosa, "%s",imp[m]+FloatToStr(canti_insulina)+"_"+FloatToStr(t_comida)+"=[");
        fprintf(out_glucosa, " ");}

     for (l=0; l<(t_simul/multi); l++)
     {
       if (marca==0)
          {
           if (variacion==0)
           {       fprintf(out_glucosa, "%E", g[1+c1][l*multi+1].Inf);
                   fprintf(out_glucosa, " ");}
           if((c1!=10))
           {g[1+c1][l*multi+1].Inf=0;}
           }
       else
          {
          if (variacion==0)
           {    fprintf(out_glucosa, "%E", g[1+c1][l*multi+1].Sup);
                fprintf(out_glucosa, " ");
           if((c1!=10))
            g[1+c1][l*multi+1].Sup=0;
          }
          }
     } // Finaliza for l
      if (marca==0)
        {
                marca=1;
        }
        else
        {
                marca=0;
                c1=c1+1;
                if (c1==6)
                   c1=c1+2;
        }

        if (variacion==0)
        {  fprintf(out_glucosa, "];");
           fprintf(out_glucosa, "\n");}


  } // Finaliza for n



  fclose(out_glucosa);
  delete g;
  ShowMessage("Proceso Terminado");

}


//---------------------------------------------------------------------------

void __fastcall TForm1::PanunziClick(TObject *Sender)
{
int  i, z, comida, variacion,  b5, t_comida, BW;
//double b1, b2, b3, b4,  b6, b7, Gb, Ib, Vg, Vi;
int t_insu, canti_insulina;
ivalDb ingesta, sum, b0, Kxgi, vcomida, incert[5],temporal;
double Vg, Id,  gamma, G, Tgh, Ib, Gb, Tigmax, Kxi, Vi;
int tg, multi;
double t_simul, n_montecarlos;
int tipo_ingesta;

double G1[4][12], h_i[4];  // Variables para guardar el valor de glucosa y el tiempo en las mtricas
int glu0=0, glu1=0, glu2=0, glu3=0, t_comi, cant_insulina, t_ins, k, s;
double cant_insul, cant_insul1, cant_insul2, t_com, t_com1, t_com2;


tipo_ingesta=1;         // 1: Hovorka   // 2: DallaMan

// Introduce el tiempo de simulacin en minutos
AnsiString  iter= InputBox("Input Box", "Tiempo de simulacin en minutos", "0");

multi=1; //Valor dado por el paso de discretizacin
h=1;     // Paso de discretizacin

t_simul=StrToInt(iter)*multi; //Tiempo de simulacin, afectado por el paso de discretizacin

     for(k=0;k<4; k++)
       {
       for(s=0; s<12; s++) // Variable para la impresin de las mtricas
        {G1[k][s]=0;}
         h_i[k]=0;
       }
         s=0; k=0;


// La matriz es declarada como intervalo
// Las filas identifican la variable y las columnas cada minuto

int fila=6;
int columna=t_simul+1;
ivalDb** p;
    p = new ivalDb* [fila];
    for (int m = 0; m < fila; m++)
      p[m] = new ivalDb [columna];
    //Matriz con el nombre de cada variable
    //p[1][i]=G p[2][i]=I  p[3][i]=D   p[4][i]=Iex


ivalDb** insulina;
    // Matriz con los valores de cada inyeccin de insulina
    insulina = new ivalDb* [40]; // Guarda 40 Valores de Iex
    for (int m = 0; m < 40; m++)
      insulina[m] = new ivalDb [columna+3630];

ivalDb* dal;
dal= new ivalDb [columna];          

   // Modelo Insulina Exgena (UPV)

        ///Modelo de Insulina // Guarda los valores de Iex
        // Valores de 1 a 25IU de Insulina Exogena (Basal+Bolus)
        int cont1=0, cont2=0;
        double ins;
        long length;
        char dosis[100];
        FILE *fileinsulina;
        AnsiString archivoi="dosificacion_trabajo_bolus_25_5U.txt";
        fileinsulina= fopen(archivoi.c_str(), "r");
        if(!fileinsulina)
                 ShowMessage(" no existe");
           for (cont1=0; cont1<(t_simul+3615); cont1++)
                for(cont2=0; cont2<40; cont2++)
                {
               // fscanf(fileinsulina, "%s\t%s\t%s\t%s\t%s", dosis0, dosis1, dosis2, dosis3, dosis4);
                   length = ftell(fileinsulina);
                   fseek(fileinsulina, length, SEEK_SET);
                   fscanf(fileinsulina,  "%s", dosis);
                   insulina[cont2][cont1+1]=StrToFloat(dosis);
                }
        fclose(fileinsulina);
        

  // Datos tomados del Modelo Gastrointestinal de DallaMan
   if (tipo_ingesta==2)
        {
        ///Modelo de DallaMan// Guarda los valores de Ra
        int cont3=0;
        char comidali[100], comidals[100];
        FILE *filedallaman;
        AnsiString archivod="comida_dallaman_5.txt";
        filedallaman= fopen(archivod.c_str(), "r");
        if(!filedallaman)
                 ShowMessage(" no existe");
           for (cont3=0; cont3<(t_simul); cont3++)
                //for(cont4=0; cont4<2; cont4++)

           //(!feof(fileinsulina))
                {
                fscanf(filedallaman, "%s\t%s", comidali, comidals);
                   dal[cont3].Inf=StrToFloat(comidali);
                   dal[cont3].Sup=StrToFloat(comidals);
                }
        fclose(filedallaman);
        }

// Parmetros del modelo
Vg=0.152;       // (L kg/Bw)
Id=41.79;       // (pM mM-1)
//Id=0;       // (pM mM-1)
tg=19*multi;      // (min)
Kxgi=1.43*1e-4; // (min-1 pM-1)
Kxi=0.101;      // (min-1)
gamma=2.464;    // (#)
G=9;            // (mM)
Vi=0.25;        // L(kgBW-1)





// Parmetros modelo gastrointestinal Hovorka

ag=0.8;              // Biodisponibilidad de carbohidratos (unitless)
tmg=40;              // Tasa de aparicin mxima de glucosa en el compartimiento accesible de glucosa (min)


// Entrada
comida=60;
vcomida=comida;
t_comida=00;
variacion=0;
t_insu=0;
canti_insulina=9;
//BW=67.53;  // peso del paciente en kg
BW=66;  // peso del paciente en kg

n_montecarlos=000;


//ingesta=(0.33*BW)*(1000/180);
ingesta=(comida*1000/180)/BW; // Conversin de los CHO (gr) a mmol

// Considerando incertidumbre en la sensibilidad insulnica Kxgi
//Kxgi=ivalDb(Kxgi.Inf*(1-(8.7e-5/100)),Kxgi.Sup*(1+(8.7e-5/100)));
//Kxgi=ivalDb(Kxgi.Inf*0.9,Kxgi.Sup*1.1);
//Kxgi=ivalDb(Kxgi.Inf*0.9,Kxgi.Sup*0.9);
ingesta=ivalDb(ingesta.Inf*0.95, ingesta.Inf*1.05);




// Modelo Glucosa

// Valores iniciales

        //Gb=4.54;        // (mM)
        Gb=4.44;        // (mM)
        Ib=10;       // (pM)

        //Tgh=Kxgi*Ib*Gb*Vg;
        //Tigmax=Kxi*Ib*Vi*(1+(1/pow((Gb/G),gamma)));
        Tigmax=Kxi*Ib*Vi*(pow((G/Gb),gamma)+1);


        //p[1][0]=Gb+(ingesta/Vg);
        p[1][0]=Gb;
        //p[1][0]=5;//para prueba
        //p[2][0]=Ib+(Id*(ingesta/Vg));
        p[2][0]=Ib;
        p[3][0]=0;
        p[4][0]=0;

        p[5][0]=0;

////////////////////////   Salida Datos  //////////////////////////////////////
 // Archivo de salida de datos de glucosa
 // Archivo en el cual se guardan los resultados y se imprime el infimo y supremo de la matriz c de cada variable
 int  marca=0, m=0, l=0, c1=0;
 FILE *out_glucosa;
         AnsiString name="glucosa_"+FloatToStr(comida)+".m";
         out_glucosa= fopen(name.c_str(), "w+");

  //Vector que se crea para guardar el nombre de las variables en la impresin en el archivo de salida
  char line[10], line2[10];
  AnsiString imp[2]={"g_i_","g_s_"};


// Archivo de salida de los datos generados con Montecarlo
        FILE *out_montecarlo, *out_montecarlo1;
// Impresin datos montecarlo
        AnsiString name1="montecarlo_"+FloatToStr(comida)+".m";
        out_montecarlo= fopen(name1.c_str(), "w+");



 // Clculo de dosis e instante de inyeccin inicial
 dosis_inicial(p[1][0].Inf, vcomida.Inf, &cant_insul, &t_com);
 t_ins=0;

// Determina en que rango de cantidad de insulina e instante de inyeccin realiza la bsqueda
if (cant_insul>3){  cant_insul1=((cant_insul*2)-1)-(3*2); cant_insul2=((cant_insul*2)-1)+(3*2)+1; } else if (cant_insul==3) {cant_insul1=1; cant_insul2=12;} else {cant_insul1=(cant_insul*2)-1; cant_insul2=((cant_insul*2)-1)+(3*2)+1;}
if (t_com>30){ t_com1=t_com-30;  } else { t_com1=0; };     // Tiempo Inicial para la comida
if (t_com<90) t_com2=t_com+35; else t_com2=125;            // Tiempo Final para la comida



// Datos para prueba (Clculo con una sola cantidad de insulina e instante de inyeccin)
//cant_insul1=9; cant_insul2=10;
//t_com1=0; t_com2=65; // Original
//t_com1=0; t_com2=10; // Prueba
//t_ins=0; //Para cuando hay hipoglucemia


for (canti_insulina=cant_insul1; canti_insulina<cant_insul2; canti_insulina++)// Tres inyecciones de insulina bolus
{
for (t_comi=t_com1; t_comi<t_com2; t_comi=(t_comi+15))  // Variacin en Sid, Sie,Dg. Puntual
{
for (variacion=0; variacion<=n_montecarlos; variacion++)  // Calcula n_montecarlos
{

                       if (t_ins==1) // Asigna los instantes de insulina
                        {
                         t_insu=t_comi;
                         t_comida=0;
                        }
                else
                        {
                         t_comida=t_comi;
                         t_insu=t_ins;
                        }


// Iteracin
for (i=0; i<t_simul; i++)
{

        // Concentracin de glucosa en sangre
        p[1][i+1]=p[1][i]*(1-(Kxgi*p[2][i]*h))+(Du(Kxgi)*p[2][0]*p[1][0]*h)+(p[3][i]/Vg);

        // Insulina
        p[4][i+1]=0;
        if((i>=t_insu)&&(canti_insulina>0))
        p[4][i+1]=insulina[canti_insulina-1][i+1+3614]/6;

        /*
        if (i==0)
                p[5][1]=0*(1-h*Kxgi*p[2][0])+(h*Kxgi*p[2][0]*p[1][0]);
        else    p[5][i+1]=p[5][i]*(1-h*Kxgi*p[2][i-1])-(h*p[1][i-1]*p[2][i-1])+(h*Kxgi*p[2][0]*p[1][0]);
        */

        //p[5][i+1]=p[5][i]*(1-h*Kxgi*p[2][i])-(h*p[1][i]*p[2][i])+(h*p[2][0]*p[1][0]);

        //p[5][i+1]=-p[1][i]*p[2][i]+(Ib*Gb);

        // Concentracin de Insulina en plasma
        if (i>=tg)
                {
                 //p[2][i+1]=p[2][i]*(1-Kxi*h)+(Tigmax/Vi)*(1/((1/(pow((Du(p[1][i-tg])/G),gamma)))+1))+(p[4][i]/Vi);     
                 p[2][i+1]=p[2][i]*(1-Kxi*h)+(Tigmax/Vi)*(1/(pow(G/(Du(p[1][i-tg])),gamma)+1))+(p[4][i]/Vi); // Simplificado


                 }
        else    {p[2][i+1]=p[2][i]*(1-Kxi*h)+(Tigmax/Vi)*(1/(pow(G/(p[1][0]),gamma)+1))+(p[4][i]/Vi); // Simplificado
                //p[2][i+1]=p[2][i]*(1-Kxi*h)+(Tigmax/Vi)*(1/((1/(pow((Gb/G),gamma)))+1))+(p[4][i]/Vi);
                }

        // Comida
        if(tipo_ingesta==1)
                abs_glucosa_impulsional(ingesta,i,t_comida,&p[3][i+1]);
        else    if (tipo_ingesta==2)
              {
                if (i>=t_comida)
                      p[3][i+1]=dal[i-t_comida]/180.0;
                else  p[3][i+1]=0;
              }


        // Generacin del infimo y el superior para cada parametro o variable que contenga incertidumbre
        if ((variacion==0)&&(i==0)&&(n_montecarlos>0))
        {
                incert[0]=Kxgi; incert[1]=0;  incert[2]=0; incert[3]=0;  incert[4]=ingesta;

                fprintf(out_montecarlo, "%s", "monte_"+FloatToStr(canti_insulina)+"_"+FloatToStr(t_comida)+"=[");
                fprintf(out_montecarlo, " ");

        }


        // Generacin de Montecarlos
        if((variacion>0)&&(i==0))
        {
                montecarlo (incert[0], incert[1],  incert[2], incert[3], incert[4], 0,
                            0, variacion, &Kxgi, &temporal, &temporal, &temporal, &ingesta, &temporal, &temporal);

        } // Fin if variacion



                                       //Validacin Mtrica1
                                if((p[1][i+1].Inf<=2)&&(h_i[0]==0))//hipoglucemia severa inicial
                                   { h_i[0]=1; G1[0][glu0]=p[1][i+1].Inf; glu0++; G1[0][glu0]=i+1; glu0++;}

                                if((p[1][i+1].Inf>2)&&(h_i[0]==1)&&(p[1][i+1].Inf<2.4))
                                    { h_i[0]=0; G1[0][glu0]=p[1][i].Inf; glu0++; G1[0][glu0]=i; glu0++;}    //hipoglucemia severa final
                                else if((p[1][i+1].Inf>2)&&(h_i[1]==0)&&(p[1][i+1].Inf<=3.9))
                                   { h_i[1]=1; G1[1][glu1]=p[1][i+1].Inf; glu1++; G1[1][glu1]=i+1; glu1++;} //hipoglucemia moderada inicial

                                if(((p[1][i+1].Inf>3.9)&&(h_i[1]==1)&&(p[1][i+1].Inf<4.3))||((p[1][i+1].Inf<=2)&&(h_i[1]==1)))
                                   { h_i[1]=0; G1[1][glu1]=p[1][i].Inf; glu1++;  G1[1][glu1]=i; glu1++; }   //hipoglucemia moderada final

                               if((p[1][i+1].Sup>=13.9) && (h_i[2]==0))
                                   { h_i[2]=1; G1[2][glu2]=p[1][i+1].Sup; glu2++; G1[2][glu2]=i+1; glu2++;} //hiperglucemia severa inicial

                               if((p[1][i+1].Sup<13.9)&&(h_i[2]==1) && (p[1][i+1].Sup>12))
                                   { h_i[2]=0; G1[2][glu2]=p[1][i].Sup; glu2++; G1[2][glu2]=i; glu2++;}     //hiperglucemia severa final

                               else if((p[1][i+1].Sup>=8.39)&&(h_i[3]==0)&&(p[1][i+1].Sup<13.9))
                                   { h_i[3]=1; G1[3][glu3]=p[1][i+1].Sup; glu3++; G1[3][glu3]=i+1; glu3++;} //hiperglucemia moderada inicial

                                if(((p[1][i+1].Sup<8.39)&&(h_i[3]==1)&&(p[1][i+1].Sup>8))||((p[1][i+1].Sup>13.9*18)&&(h_i[3]==1)))
                                   { h_i[3]=0; G1[3][glu3]=p[1][i].Sup; glu3++; G1[3][glu3]=i; glu3++;}     //hiperglucemia moderada final



}// end for i



  // Archivo de salida de datos de Glucosa
  c1=0;
  for (m=0; m<2; m++)
   {

       if (variacion==0)
       {fprintf(out_glucosa, "%s",imp[m]+FloatToStr(canti_insulina)+"_0_"+FloatToStr(t_comida)+"=[");
        fprintf(out_glucosa, " ");}

     for (l=0; l<(t_simul/multi); l++)
     {
       if (marca==0)
          {
           if (variacion==0)
           {       fprintf(out_glucosa, "%E", p[1+c1][l*multi+1].Inf);
                   fprintf(out_glucosa, " ");}
           else {  // Impresin datos Montecarlo
                   fprintf(out_montecarlo, "%E", p[1+c1][l*multi+1].Inf);
                   fprintf(out_montecarlo, " ");}
           if((c1!=10))
           {p[1+c1][l*multi+1].Inf=0;}
           }
       else
          {
          if (variacion==0)
           {    fprintf(out_glucosa, "%E", p[1+c1][l*multi+1].Sup);
                fprintf(out_glucosa, " ");
           if((c1!=10))
            p[1+c1][l*multi+1].Sup=0;
          }
          }
     } // Finaliza for l
      if (marca==0)
        {
                marca=1;
        }
        else
        {
                marca=0;
                c1=c1+1;
                if (c1==6)
                   c1=c1+2;
        }


     if (variacion==0)
        {  fprintf(out_glucosa, "];");
           fprintf(out_glucosa, "\n");}
      // Impresin datos Montecarlo
     else if ((marca==0)&&(variacion<(n_montecarlos)))
        {  fprintf(out_montecarlo, ";");
           fprintf(out_montecarlo, " ");}
     else if ((variacion==n_montecarlos)&&(marca==0))
             {  fprintf(out_montecarlo, "]");
           fprintf(out_montecarlo, "\n");}

  } // Finaliza for n

        if (variacion==0)
               fprintf(out_glucosa, "%s", "datos_int_"+FloatToStr(canti_insulina)+"_0_"+FloatToStr(t_comi)+"=[ ");


       k=0;
       for(k=0; k<4; k++)
        {
        for(s=0; s<12; s++)
         {
          if(variacion==0)
                {fprintf(out_glucosa, "%E", G1[k][s]);
                 fprintf(out_glucosa, " ");
                 G1[k][s]=0;
                 }
         } // Finaliza for s
         if (variacion==0)
                fprintf(out_glucosa, ";");
          h_i[k]=0;
         } // Finaliza for k
         if (variacion==0)
                fprintf(out_glucosa, "];");
 

          k=0; s=0; glu0=0; glu1=0; glu2=0; glu3=0;


 }// Finaliza for variacion

} //Finaliza for t_comi
          

} //Finaliza for cant_insulina


  fclose(out_glucosa);
  delete p;
  ShowMessage("Proceso Terminado");        
}
//---------------------------------------------------------------------------

