//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "repere.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

repere::repere ()
{};
//---------------------------------------------------------------------------

repere::repere (TForm* f,double xmin,double xmax,double ymin,double ymax)
{ interval_x=ivalDb(xmin,xmax);
  interval_y=ivalDb(ymin,ymax);
  form=f;
};
//---------------------------------------------------------------------------

void repere::Clean()
{  
   form->Canvas->Brush->Color=clWhite;
   form->Canvas->Pen->Color=clWhite;
   form->Canvas->Rectangle (0,0,form->ClientWidth,form->ClientHeight);
}
//---------------------------------------------------------------------------

void repere::DrawBox (box& P,TColor couleurin,TColor couleurout,TBrushStyle pinceau)
{  
 int XDim=P.GetXIndex();
 int YDim=P.GetYIndex();
 ivalDb x,y;
 x=P[XDim].GetIval();
 if(P.GetVars().size()>1)
 {y=P[YDim].GetIval();}
 else{y=ivalDb(-1,1);}
 form->Canvas->Brush->Style=pinceau;
 form->Canvas->Brush->Color=couleurin;
 form->Canvas->Pen->Color=couleurout;
 float ax=form->ClientWidth/(Width(interval_x));
 float bx=-ax*Inf(interval_x);
 float ay=form->ClientHeight/(-Width(interval_y));
 float by=-ay*Sup(interval_y);
 double cx=ax*Inf(x)+bx;
 double cy=ay*Inf(y)+by;
 double wx=ax*Sup(x)+bx+1;
 double wy=ay*Sup(y)+by-1;
 //form->Canvas->Rectangle(ax*Inf(x)+bx,ay*Inf(y)+by,ax*Sup(x)+bx+1,ay*Sup(y)+by-1);
 form->Canvas->Rectangle(cx,cy,wx,wy);
}//-----------------------------------------------------------------------------

void repere::DrawCadre (box& P,TColor couleur,TPenStyle crayon,int epais=1)
{int XDim=P.GetXIndex();
 int YDim=P.GetYIndex();
 ivalDb x,y;
 x=P[XDim].GetIval();
 if(P.GetVars().size()>1)
 {y=P[YDim].GetIval();}
 else{y=ivalDb(-1,1);}
 DrawLine(Inf(x),Inf(y),Inf(x),Sup(y),couleur,crayon,epais);
 DrawLine(Inf(x),Inf(y),Sup(x),Inf(y),couleur,crayon,epais);
 DrawLine(Sup(x),Sup(y),Inf(x),Sup(y),couleur,crayon,epais);
 DrawLine(Sup(x),Sup(y),Sup(x),Inf(y),couleur,crayon,epais);
}//-----------------------------------------------------------------------------

void repere::DrawLine (double x1,double y1,double x2, double y2,TColor couleur,TPenStyle crayon,int taille)
{
 form->Canvas->Pen->Color=couleur;
 form->Canvas->Pen->Style=crayon;
 form->Canvas->Pen->Width=taille;
 float ax=form->ClientWidth/(Width(interval_x));
 float bx=-ax*Inf(interval_x);
 float ay=form->ClientHeight/(-Width(interval_y));
 float by=-ay*Sup(interval_y);
 form->Canvas->MoveTo (ax*x1+bx,ay*y1+by);
 form->Canvas->LineTo (ax*x2+bx,ay*y2+by);
 form->Canvas->Pen->Width=1;
}//-----------------------------------------------------------------------------


void repere::DrawArrow (double x1,double y1,double x2, double y2,TColor couleur,TPenStyle crayon,int taille)
{
 form->Canvas->Pen->Color=couleur;
 form->Canvas->Pen->Style=crayon;
 form->Canvas->Pen->Width=taille;
 float ax=form->ClientWidth/(Width(interval_x));
 float bx=-ax*Inf(interval_x);
 float ay=form->ClientHeight/(-Width(interval_y));
 float by=-ay*Sup(interval_y);
 double nx1=ax*x1+bx;
 double ny1=ay*y1+by;
 double nx2=ax*x2+bx;
 double ny2=ay*y2+by;
 form->Canvas->MoveTo(nx1,ny1);
 form->Canvas->LineTo(nx2,ny2);


/*
 double d=FDLIBM::sqrt(FDLIBM::pow(nx2-nx1,2)+FDLIBM::pow(ny2-ny1,2));
 double nx3,ny3,nx4,ny4;
 double r=0.05;
 if(nx2-nx1>=0) nx3=nx2-r*d*cos(1.5708);
 else nx3=nx2+r*d*cos(1.5708);
 if(ny2-ny2>=0) ny3=ny2-r*d*sin(1.5708);
 else ny3=ny2+r*d*sin(1.5708);
 nx4
*/
 form->Canvas->Pen->Width=1;
}//-----------------------------------------------------------------------------


void repere::XPoly(vector<double>& X,vector<double>& Y,TColor couleur,TPenStyle crayon,int taille)
{
 form->Canvas->Pen->Color=couleur;
 form->Canvas->Pen->Style=crayon;
 form->Canvas->Pen->Width=taille;
 float ax=form->ClientWidth/(Width(interval_x));
 float bx=-ax*Inf(interval_x);
 float ay=form->ClientHeight/(-Width(interval_y));
 float by=-ay*Sup(interval_y);

 form->Canvas->MoveTo(ax*X[0]+bx,ay*Y[0]+by);

 for(int i=1;i<X.size();i++)
 {form->Canvas->LineTo(ax*X[i]+bx,ay*Y[i]+by);}

 form->Canvas->Pen->Width=1;
}//-----------------------------------------------------------------------------

void repere::DrawCadre (box& P,TColor couleur,TPenStyle crayon)
{ DrawCadre (P,couleur,crayon,1);
}//---------------------------------------------------------------------------

void repere::ConvertToBitmap(TForm* Form,string& File)
{
Graphics::TBitmap* Bitmap = new Graphics::TBitmap();
Bitmap->Width = Form->ClientWidth;
Bitmap->Height = Form->ClientHeight;
Bitmap->Canvas->CopyRect( Form->ClientRect, Form->Canvas, Form->ClientRect );
string ImageFile= File + "Image.bmp";
Bitmap->SaveToFile(ImageFile.c_str());
delete Bitmap;
}//-----------------------------------------------------------------------------



