 /*!****************************************************************************
 *    \file iboolean.cpp
 *    This file contains the definition of the iboolean class.
 *    Author: Luc Jaulin.
 *    LISA - Universit d'Angers.
 ******************************************************************************/

#include "iboolean.h"

////////////////////////////////////////////////////////////////////////////////
// Constructors                                                               //
////////////////////////////////////////////////////////////////////////////////

/** Default Constructor.
  \fn iboolean::iboolean ()*/
iboolean::iboolean ()
{value = iperhaps;
}//-----------------------------------------------------------------------------

iboolean::iboolean (bool b)
{if (b) value=itrue; else value=ifalse;
}//-----------------------------------------------------------------------------

iboolean::iboolean (IBOOLEAN tt)
{value = tt;
}//-----------------------------------------------------------------------------

iboolean::iboolean (const iboolean& t)
{*this = t;
}//-----------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
// Binary Operators                                                     //
////////////////////////////////////////////////////////////////////////////////

/** \fn iboolean operator&& (iboolean x, iboolean y)
    Overloaded && operator*/
iboolean operator&& (iboolean x, iboolean y)
{
	if ( (x.value==ifalse) || (y.value==ifalse) ) return iboolean(ifalse);
	if ( (x.value==itrue) && (y.value==itrue) ) return iboolean(itrue);
	return iboolean(iperhaps);
}//-----------------------------------------------------------------------------

/** \fn iboolean operator|| (iboolean& x, iboolean& y)
    Overloaded || operator*/
iboolean operator|| (iboolean& x, iboolean& y)
{	if ( (x.value==itrue) || (y.value==itrue) ) return iboolean(itrue);
	if ( (x.value==iperhaps) || (y.value==iperhaps) ) return iboolean(iperhaps);
	return iboolean(ifalse);
}//-----------------------------------------------------------------------------

/** \fn bool operator== (iboolean x, iboolean y)
    Overloaded == operator*/
bool operator== (iboolean x, iboolean y)
{	return (x.value==y.value);
}//-----------------------------------------------------------------------------

/** \fn bool operator!= (iboolean x, iboolean y)
    Overloaded  != operator*/
bool operator!= (iboolean x, iboolean y)
{	return (x.value!=y.value);
}//-----------------------------------------------------------------------------

/** \fn iboolean operator! (iboolean& x)
    Overloaded ! operator*/
iboolean operator! (iboolean& x)
{	if (x.value == itrue) return iboolean(ifalse);
	if (x.value == ifalse) return iboolean(itrue);
	return iboolean(iperhaps);
}//-----------------------------------------------------------------------------

/** \fn iboolean Inter(iboolean a, iboolean b)
    Makes the intersection between two iboolean intervals.*/
iboolean Inter(iboolean a, iboolean b)
{	if ((a.value == itrue)&&(a.value == ifalse)) return iboolean(empty);
	if ((a.value == itrue)||(a.value == itrue)) return iboolean(itrue);
	if ((a.value == ifalse)||(a.value == ifalse)) return iboolean(ifalse);
	return iboolean(iperhaps);
}//-----------------------------------------------------------------------------

ostream& operator<<(ostream & out, const iboolean &x)
{
 if(x==itrue) out << "itrue";
 else if(x==ifalse) out << "ifalse";
 else out << "iperhaps";
 return out;
}//-----------------------------------------------------------------------------



