/*******************************************************************************
 *    node.cpp: Syntactic Tree Node
 *    29/12/2002
 *    By Pau Herrero Vias
 ******************************************************************************/

#include "node.h"
//#include "interval.h"

extern int NameVarCounter;
list<node> Global_NodesStock;          // Global Node Stock (WARNING!!!!!)

////////////////////////////////////////////////////////////////////////////////
// Constructors                                                               //
////////////////////////////////////////////////////////////////////////////////

node::node()
{
 Type="?";
 Ival=Infinity();
 Const=0;
 PInc=NULL;
 PVars=NULL;
 NameVar="Aux";
 LNode=NULL;
 RNode=NULL;
 VarIndex=-1;
 Quantified="F";
}//-----------------------------------------------------------------------------

node::node(int I)
{
 Type="const";
 Ival=ivalDb(I);
 Const=I;
 PInc=NULL;
 PVars=NULL;
 NameVar="const";
 LNode=NULL;
 RNode=NULL;
 VarIndex=-1;
 Quantified="U";
}//-----------------------------------------------------------------------------

node::node(double D)
{
 Type="const";
 Ival=ivalDb(D);
 PInc=NULL;
 PVars=NULL;
 NameVar="const";
 LNode=NULL;
 RNode=NULL;
 VarIndex=-1;
 Quantified="U";
}//-----------------------------------------------------------------------------

node::node(ivalDb& IV)
{
 Type="const";
 Ival=IV;
 PInc=NULL;
 PVars=NULL;
 NameVar="const";
 LNode=NULL;
 RNode=NULL;
 VarIndex=-1;
 Quantified="U";
}//-----------------------------------------------------------------------------

node::node(string& NV)
{
 Type="var";
 Ival=Infinity();
 PInc=NULL;
 PVars=NULL;
 NameVar=NV;
 LNode=NULL;
 RNode=NULL;
 VarIndex=-1;
 Quantified="F";
}//-----------------------------------------------------------------------------

node::node(const ivalDb& IV,string NV)
{
 Type="var";
 Ival=IV;
 PInc=NULL;
 PVars=NULL;
 NameVar=NV;
 LNode=NULL;
 RNode=NULL;
 VarIndex=-1;
 Quantified="?";
}//-----------------------------------------------------------------------------

node::node(const ivalDb& IV,string NV,string Q)
{
 Type="var";
 Ival=IV;
 PInc=NULL;
 PVars=NULL;
 NameVar=NV;
 LNode=NULL;
 RNode=NULL;
 VarIndex=-1;
 Quantified=Q;
}//-----------------------------------------------------------------------------

node::node(incidence** I)
{
 Type="var";
 PInc=I;
 PVars=NULL;
 NameVar="?";
 LNode=NULL;
 RNode=NULL;
 VarIndex=-1;
 Quantified="F";
}//-----------------------------------------------------------------------------

node::node(const node &N)
{
 Type=N.Type;
 Ival=N.Ival;
 Const=N.Const;
 PVars=N.PVars;
 NameVar=N.NameVar;
 PNodeVars=N.PNodeVars;
 PInc=N.PInc;
 LNode=N.LNode;
 RNode=N.RNode;
 VarIndex=N.VarIndex;
 Quantified=N.Quantified;
 MeasureIndex=N.MeasureIndex;
 //PNodesStock=N.PNodesStock;
}//-----------------------------------------------------------------------------

// Node assigment
node& node::operator=(const node &N)
{Type=N.Type;
 Ival=N.Ival;
 Const=N.Const;
 PVars=N.PVars;
 PNodeVars=N.PNodeVars;
 NameVar=N.NameVar;
 PInc=N.PInc;
 LNode=N.LNode;
 RNode=N.RNode;
 VarIndex=N.VarIndex;
 Quantified=N.Quantified;
 MeasureIndex=N.MeasureIndex;
 //PNodesStock=N.PNodesStock;
 return *this;
}//-----------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
// Destructor                                                               //
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Acces to members                                                           //
////////////////////////////////////////////////////////////////////////////////

string& node::GetType()
{return Type;
}//-----------------------------------------------------------------------------

ivalDb& node::GetIval()
{return Ival;
}//-----------------------------------------------------------------------------

node* node::GetLNode()
{return LNode;
}//-----------------------------------------------------------------------------

node* node::GetRNode()
{return RNode;
}//-----------------------------------------------------------------------------

vars* node::GetPVars()
{return PVars;
}//-----------------------------------------------------------------------------

int node::GetVarIndex()
{return VarIndex;
}//-----------------------------------------------------------------------------

incidence** node::GetPInc()
{return PInc;
}//-----------------------------------------------------------------------------

string& node::GetNameVar()
{return NameVar;
}//-----------------------------------------------------------------------------

deque<node>* node::GetPNodeVars()
{return PNodeVars;
}//-----------------------------------------------------------------------------

double node::GetConst()
{return Const;
}//-----------------------------------------------------------------------------

list<node*>& node::GetNodesList()
{return NodesList;
}//-----------------------------------------------------------------------------

string& node::GetQuantified()
{return Quantified;
}//-----------------------------------------------------------------------------

/*
list<node>* node::GetPNodesStock()
{return this->PNodesStock;
}//-----------------------------------------------------------------------------
*/

void node::SetType(string& Tp)
{Type=Tp;
}//-----------------------------------------------------------------------------

void node::SetIval(ivalDb& Iv)
{Ival=Iv;
}//-----------------------------------------------------------------------------

void node::SetLNode(node* LN)
{LNode=LN;
}//-----------------------------------------------------------------------------

void node::SetRNode(node* RN)
{RNode=RN;
}//-----------------------------------------------------------------------------

void node::SetPVars(vars* PVS)
{PVars=PVS;
}//-----------------------------------------------------------------------------

void node::SetVarIndex(int VI)
{VarIndex=VI;
}//-----------------------------------------------------------------------------

void node::SetPInc(incidence** PI)
{PInc=PI;
}//-----------------------------------------------------------------------------

void node::SetNameVar(string& NV)
{NameVar=NV;
}//-----------------------------------------------------------------------------

void node::SetPNodeVars(deque<node>* PNV)
{PNodeVars=PNV;
}//-----------------------------------------------------------------------------

void node::SetConst(double C)
{Const=C;
}//-----------------------------------------------------------------------------

void node::SetNodesList(list<node*>& NL)
{NodesList=NL;
}//-----------------------------------------------------------------------------

void node::SetQuantified(string& Q)
{Quantified=Q;
}//-----------------------------------------------------------------------------

/*
void node::SetPNodesStock(list<node>* PNS)
{this->PNodesStock=PNS;
}//-----------------------------------------------------------------------------
*/

bool node::IsProp(void)
{
 return this->Ival.IsProp();
}//-----------------------------------------------------------------------------

bool node::IsImpr(void)
{
 return this->Ival.IsImpr();
}//-----------------------------------------------------------------------------

node* node::CreateNode(void)
{
 if(this->Type=="var") return this->CreateVar();
 else if(this->Type=="const") return this->CreateConst();
 else return this;
}//-----------------------------------------------------------------------------

node* node::CreateVar(void)
{int s;
 node* N=this->NewNode();
 *N=*this;
 incidence* Inc=NULL;
 int i=0;
 while(i < this->GetPNodeVars()->size())
 {if(N->NameVar == N->GetPNodeVars()->operator[](i).GetNameVar())
  {N->VarIndex=i;
   if(this->Quantified=="M")
    {N->MeasureIndex=N->GetPNodeVars()->operator[](i).MeasureIndex;}      // SQT: Copy Measure Index
   N->PVars->operator[](i).push_back(Inc);
   N->PInc=&N->PVars->operator[](i).back();
   break;}
  i++;
 }
 return N;
}//-----------------------------------------------------------------------------

node* node::CreateConst(void)
{
 node* C=this->NewNode();
 *C=*this;
 return C;
}//-----------------------------------------------------------------------------

void node::AssignNameAuxVar(void)
{
 NameVarCounter++;

 char buffer [33];
 itoa (NameVarCounter,buffer,10);

 this->NameVar=this->NameVar + buffer;
}//-----------------------------------------------------------------------------

iboolean node::SelectNonUnifMonoNodes(list<node*>& NonUnifMonoNodes)
{
 iboolean Optimal=itrue;

 if(this==NULL)
 {Optimal=itrue;}

 else
 {iboolean OptLeft=this->LNode->SelectNonUnifMonoNodes(NonUnifMonoNodes);
  iboolean OptRigth=this->RNode->SelectNonUnifMonoNodes(NonUnifMonoNodes);

  if(this->Type=="*" || this->Type=="/")
  {
     if(OptLeft==ifalse || OptRigth==ifalse || OptLeft==iperhaps || OptRigth==iperhaps)
     {Optimal=ifalse;
      NonUnifMonoNodes.push_front(this);}
     else
     {Optimal=iperhaps;}
  }

  else if(this->Type=="+" || this->Type=="-")
  {
    if(OptLeft==ifalse || OptRigth==ifalse)
     {Optimal=ifalse;}
    else
     {Optimal=iperhaps;}
  }

  else if(this->Type=="cos" || this->Type=="sin" || this->Type=="tan" ||
          this->Type=="sqr" || (this->Type=="pow" && FDLIBM::fmod(int(this->Const),2)==0) )
  {
   if(OptLeft==ifalse || OptLeft==iperhaps)
     {Optimal=ifalse;
      this->LNode->Type;
      this->RNode->Type;
      NonUnifMonoNodes.push_front(this);}
     else
     {//Optimal=iperhaps;
      Optimal=itrue;}
  }

  else if(this->Type=="exp" || this->Type=="log" ||
          (this->Type=="pow" && FDLIBM::fmod(int(this->Const),2)!=0) )
  {
     if(OptLeft==ifalse)
     {Optimal=ifalse;}
     else if(OptLeft==iperhaps)
     {Optimal=iperhaps;}
     else
     {Optimal=itrue;}
  }

  else
  {
     Optimal=itrue;
  }
 }
 return Optimal;
}//-----------------------------------------------------------------------------

void node::EvaluateNodesList(void)
{
 list<node*>::iterator Node;
 for (Node=this->NodesList.begin(); Node != this->NodesList.end(); Node++)
 {(*Node)->Evaluate("Prop",false,false,itrue,'?');}
}//-----------------------------------------------------------------------------

void node::CreatreNewIncidences(void)
{
incidence* Inc;

if(this==NULL){}
else if(this->Type=="const"){}
else if(this->Type=="var")
{
 this->PVars->operator[](this->VarIndex).push_back(Inc);
 this->PInc=&this->PVars->operator[](this->VarIndex).back();
}
else
{
this->LNode->CreatreNewIncidences();
if(this->RNode!=NULL){this->RNode->CreatreNewIncidences();}
}
}//-----------------------------------------------------------------------------

// Copy Tree
/*
node* node::Copy(void)
{
node* Node=this->NewNode();

if(this!=NULL)
{
  *Node=*this;
  if(this->RNode!=NULL)
  {Node->RNode=this->RNode->Copy();}
  if(this->LNode!=NULL)
  {Node->LNode=this->LNode->Copy();}
}
return Node;
}//-----------------------------------------------------------------------------
*/

// Evaluate Tree Function
void node::Evaluate(string &Mode,bool StripTOptim,bool CellTOptim,iboolean &Consistency,char Point)
{
 if(this==NULL){}
 else if(this->Type=="var")
  {
   incidence* Inc=(*this->PInc);
   ivalDb Ivalue=Inc->GetIvalVar();

   if(Mode=="Out")
   {
      if(Ivalue.IsProp())
      {bool TotMono=Inc->GetTotalMonoVar();
       if(TotMono && (Inc->GetMono() != Inc->GetMonoVar()))
       {this->Ival=Du(Ivalue);}
       else
        {this->Ival=Ivalue;}
      }
      else if(Ivalue.IsImpr())
      {
       if(Inc->GetTotalMonoVar() && Consistency==itrue)
       {
         if(Inc->GetMono() != Inc->GetMonoVar())
          {this->Ival=Du(Ivalue);}
         else {this->Ival=Ivalue;}
       }
       else
       {
        if(CellTOptim && Inc->GetUniIncVar() && Consistency==itrue)   // Canvi!!!!!!
        {this->Ival=Ivalue;}
        else
        {if(Point=='c')this->Ival=Center(Ivalue);
         else if(Point=='i')this->Ival=Ivalue.GetInf();
         else if(Point=='s') this->Ival=Ivalue.GetSup();}
       }
      }
   } // end (Mode=="Out")

   else if(Mode=="Inn")
   {
      if(Ivalue.IsImpr())
      {
       if(Inc->GetTotalMonoVar() && (Inc->GetMono() != Inc->GetMonoVar()))
       {this->Ival=Du(Ivalue);}
       else
        {this->Ival=Ivalue;}
      }
      else if(Ivalue.IsProp())
      {
       if(Inc->GetTotalMonoVar() && Consistency==itrue)
       {
        if(Inc->GetMono() != Inc->GetMonoVar())
         {this->Ival=Du(Ivalue);}
        else {this->Ival=Ivalue;}
       }
       else
       {if(StripTOptim && Inc->GetUniIncVar() && Consistency==itrue)  // Canvi!!!!!!
        {this->Ival=Ivalue;}
        else
         {if(Point=='c')this->Ival=Center(Ivalue);
          else if(Point=='i')this->Ival=Ivalue.GetInf();
          else if(Point=='s') this->Ival=Ivalue.GetSup();}
       }
      }
    this->Ival=Du(this->Ival);      // Make dual because of the rounding
   } // End (Mode=="Inner")

   else if(Mode=="Prop")
    { this->Ival=Prop(Ivalue);
      bool TotMono=Inc->GetTotalMonoVar();
      if(TotMono && (Inc->GetMono() != Inc->GetMonoVar()))
       {this->Ival=Du(Ivalue);}
    }

   else if(Mode=="Impr")
     {this->Ival=Impr(Ivalue);
      bool TotMono=Inc->GetTotalMonoVar();
      if(TotMono && (Inc->GetMono() != Inc->GetMonoVar()))
       {this->Ival=Du(Ivalue);}
     }

   else if(Mode=="Der")
    {this->Ival=Prop(Ivalue);}

  }

 else if(this->Type=="const")
 {if(Mode=="Inn"){this->Ival=Du(this->Ival);}}
 else if(this->Type=="aux")
 {if(Mode=="Inn"){this->Ival=Prop(this->Ival);}
  else if(Mode=="Out"){this->Ival=Impr(this->Ival);}}
 else if(this->Type=="one"){}
 else if(this->Type=="minus")
 {this->Ival=this->Ival=-this->LNode->Ival;}
 else
 {

   if(this->LNode!=NULL && this->RNode!=NULL)     // Binary operator
    {
     if(this->Type== "+" ) this->Ival=this->LNode->Ival + this->RNode->Ival;
     else if(this->Type== "-" ) this->Ival=this->LNode->Ival - this->RNode->Ival;
     else if(this->Type== "*" ) this->Ival=this->LNode->Ival * this->RNode->Ival;
     else if(this->Type== "/" ) this->Ival=this->LNode->Ival / this->RNode->Ival;
     else if(this->Type== "=" ) this->Ival=this->LNode->Ival && this->RNode->Ival;
     else if(this->Type== "^" ) this->Ival=this->LNode->Ival^this->Const;
     else if(this->Type== ">=" ) this->Ival=this->LNode->Ival - ivalDb(PInfinity(),0);
     else if(this->Type== "<=" ) this->Ival=this->LNode->Ival - ivalDb(0,MInfinity());
     else if(this->Type== ">" ) this->Ival=this->LNode->Ival - ivalDb(PInfinity(),0);
     else if(this->Type== "<" ) this->Ival=this->LNode->Ival - ivalDb(0,MInfinity());
     else if(this->Type== "min" ) this->Ival=min(this->LNode->Ival,this->RNode->Ival);
     else if(this->Type== "max" ) this->Ival=max(this->LNode->Ival,this->RNode->Ival);
     else if(this->Type== "minmax" )
         {if(Mode=="Out") this->Ival=this->LNode->Ival || this->RNode->Ival;
          else this->Ival=this->LNode->Ival && this->RNode->Ival;}
          //this->Ival=minmax(this->LNode->Ival,this->RNode->Ival);

    }
   else if(this->LNode!=NULL)           // Monary operator
    {
     if(this->Type== "exp" ) this->Ival=exp(this->LNode->Ival);
     else if(this->Type== "log" ) this->Ival=log(this->LNode->Ival);
     else if(this->Type== "Abs" ) this->Ival=abs(this->LNode->Ival);
     else if(this->Type== "sqr" ) this->Ival=sqr(this->LNode->Ival);
     else if(this->Type== "sqrt" ) this->Ival=sqrt(this->LNode->Ival);
     else if(this->Type== "cbrt" ) this->Ival=cbrt(this->LNode->Ival);
     else if(this->Type== "root" ) this->Ival=root(this->LNode->Ival,this->Const);
     else if(this->Type== "cos" ) this->Ival=cos(this->LNode->Ival);
     else if(this->Type== "sin" ) this->Ival=sin(this->LNode->Ival);
     else if(this->Type== "tan" ) this->Ival=tan(this->LNode->Ival);
     else if(this->Type== "acos" ) this->Ival=acos(this->LNode->Ival);
     else if(this->Type== "asin" ) this->Ival=asin(this->LNode->Ival);
     else if(this->Type== "atan" ) this->Ival=atan(this->LNode->Ival);
     else if(this->Type== "cosh" ) this->Ival=cosh(this->LNode->Ival);
     else if(this->Type== "sinh" ) this->Ival=sinh(this->LNode->Ival);
     else if(this->Type== "tanh" ) this->Ival=tanh(this->LNode->Ival);
     else if(this->Type== "log10" ) this->Ival=log10(this->LNode->Ival);
     else if(this->Type== "sign" ) this->Ival=sign(this->LNode->Ival);
     else if(this->Type== "step" ) this->Ival=step(this->LNode->Ival);
     else if(this->Type== "pow" ) this->Ival=pow(this->LNode->Ival,this->Const);

    }
}
}//-----------------------------------------------------------------------------

int node::GetIndex(incidence* Inc)
{int Index=-1;
 int i=0;
 incidence* AuxInc;
 bool Stop=false;
 while(i<this->PVars->size() && !Stop)
 {int j=0;
  while(j<this->PVars->operator [](i).size() && !Stop)
  {AuxInc=this->PVars->operator [](i).operator [](j);
   if(AuxInc==Inc)
   {Stop=true;}
   Index=j;
   j++;
  }
 i++;
 }
 return Index;
}//-----------------------------------------------------------------------------

void node::Print(fstream &fout,bool Symbolic)
{
 if(this==NULL){fout << "NULL";}
 else if(this->Type=="var")
 {if(Symbolic) {fout << this->NameVar << "[" << GetIndex(*this->PInc) << "]";}
  else {fout << (*this->PInc)->GetIvalVar();}
 }
 else if(this->Type=="const" || this->Type=="aux")
 {fout << this->Ival;}
 else if(this->Type=="one")
 {fout << 1;}
 else if(this->Type=="minus")
 {fout << "-" << "(";
  this->LNode->Print(fout,Symbolic);
  fout << ")";}
 else if(this->LNode==NULL && this->RNode==NULL)
 {fout << this->Type;}
 else if(this->RNode==NULL)
 {fout << this->Type;
  fout << "(";
  this->LNode->Print(fout,Symbolic);
  if(this->Type=="pow") {fout << "," << this->Const;}
  fout << ")";}
 else if(this->Type=="min" || this->Type=="max" || this->Type=="minmax")
 {
 fout << this->Type;
 fout << "(";
 this->LNode->Print(fout,Symbolic);
 fout << ",";
 this->RNode->Print(fout,Symbolic);
 fout << ")";
 }
 else
 {fout << "(";
  this->LNode->Print(fout,Symbolic);
  fout << ")";
  fout << this->Type;
  fout << "(";
  this->RNode->Print(fout,Symbolic);
  fout << ")";
  }
}//-----------------------------------------------------------------------------

void node::PrintPrimitive(fstream &fout,int &Counter)
{
  if(this->Type!="var" && this->Type!="const" && this->Type!="aux")
  {
   fout << "Primitive " << Counter << ": ";
   fout << this->NameVar << ":" << this->Ival << "=";
   if(this->LNode!=NULL && this->RNode!=NULL)
   {fout << this->LNode->NameVar << ":" << this->LNode->Ival;
    fout << this->Type;
    fout << this->RNode->NameVar << ":" << this->RNode->Ival;}
   else if(this->LNode!=NULL && this->RNode==NULL)
   {fout << this->Type << "(" << this->LNode->NameVar << ":" << this->LNode->Ival << ")";}
   fout << endl;
   Counter++;
  }
}//-----------------------------------------------------------------------------

node* node::Copy(void)
{
list<node*> NList;
node* INode;
node* Node=this->NewNode();
node* LN;
node* RN;

*Node=*this;
NList.push_back(Node);

while(!NList.empty())
{
 INode=NList.front();
 if(INode->LNode!=NULL)
  {LN=this->NewNode();
   *LN=*(INode->LNode);
   NList.push_back(LN);
   INode->LNode=LN;}
 if(INode->RNode!=NULL)
  {RN=this->NewNode();
   *RN=*(INode->RNode);
   NList.push_back(RN);
   INode->RNode=RN;}
 NList.pop_front();
}
return Node;
}//-----------------------------------------------------------------------------

// Differentiation Routine
node* node::Diff(incidence* Inc,int IndexVar,string &Scope)
{
node* ROOT;
node* LN1;
node* RN1;
node* LN2;
node* RN2;
node* AN1;
node* AN2;
node* LN3;
node* RN3;
node* LN4;
node* RN4;
node* LN5;
node* LN6;

if(this->Type=="const" || this->Type=="aux")
{ROOT=NULL;}

else if(this->Type=="var")
{
  if((Scope=="Global" && this->VarIndex==IndexVar) || (Scope=="Local" && *this->PInc == Inc) )
    {ROOT=this->NewNode();
     ROOT->Type="one";
     ROOT->Ival=ivalDb(1,1);
     ROOT->LNode=NULL;
     ROOT->RNode=NULL;}
  else
    {ROOT=NULL;}
}

else if(this->Type=="=" || this->Type=="<" || this->Type==">" || this->Type=="<=" || this->Type==">=" )
{
 ROOT=this->NewNode();
 ROOT=this->LNode->Diff(Inc,IndexVar,Scope);
}

else if(this->Type=="+")
{
 ROOT=this->NewNode();
 ROOT->Type="+";
 ROOT->LNode=this->LNode->Diff(Inc,IndexVar,Scope);
 ROOT->RNode=this->RNode->Diff(Inc,IndexVar,Scope);
}

else if(this->Type=="-")
{
 ROOT=this->NewNode();
 ROOT->Type="-";
 ROOT->LNode=this->LNode->Diff(Inc,IndexVar,Scope);
 ROOT->RNode=this->RNode->Diff(Inc,IndexVar,Scope);
}

else if(this->Type=="*")
 {ROOT=this->NewNode();
  LN1=this->NewNode();
  RN1=this->NewNode();
  ROOT->Type="+";
  LN1->Type="*";
  RN1->Type="*";
  ROOT->LNode=LN1;
  ROOT->RNode=RN1;
  LN1->LNode=this->LNode->Diff(Inc,IndexVar,Scope);
  LN1->RNode=this->RNode;
  RN1->LNode=this->LNode;
  RN1->RNode=this->RNode->Diff(Inc,IndexVar,Scope);
}

else if(this->Type=="/")
 {
  ROOT=this->NewNode();
  LN1=this->NewNode();
  RN1=this->NewNode();
  LN2=this->NewNode();
  RN2=this->NewNode();
  ROOT->Type="/";
  LN1->Type="-";
  RN1->Type="sqr";
  LN2->Type="*";
  RN2->Type="*";
  ROOT->LNode=LN1;
  ROOT->RNode=RN1;
  LN1->LNode=LN2;
  LN1->RNode=RN2;
  RN1->LNode=this->RNode;
  RN1->RNode=NULL;
  LN2->LNode=this->LNode->Diff(Inc,IndexVar,Scope);
  LN2->RNode=this->RNode;
  RN2->LNode=this->LNode;
  RN2->RNode=this->RNode->Diff(Inc,IndexVar,Scope);
}

else if(this->Type=="minus")
{
 ROOT=this->NewNode();
 ROOT->Type="minus";
 ROOT->LNode=this->LNode->Diff(Inc,IndexVar,Scope);
 ROOT->RNode=NULL;
}

else if(this->Type=="exp")
{
 ROOT=this->NewNode();
 LN1=this->NewNode();
 ROOT->Type="*";
 LN1->Type="exp";
 ROOT->LNode=LN1;
 ROOT->RNode=this->LNode->Diff(Inc,IndexVar,Scope);
 LN1->LNode=this->LNode;
 LN1->RNode=NULL;
}

else if(this->Type== "log" )
{
 ROOT=this->NewNode();
 ROOT->Type="/";
 ROOT->LNode=this->LNode->Diff(Inc,IndexVar,Scope);
 ROOT->RNode=this->LNode;
}

else if(this->Type== "pow" )
{
 ROOT=this->NewNode();
 LN1=this->NewNode();
 RN1=this->NewNode();
 LN2=this->NewNode();
 ROOT->Type="*";
 ROOT->LNode=LN1;
 ROOT->RNode=RN1;
 LN1->Type="const";
 LN1->Ival=ivalDb(this->Const);
 RN1->Type="*";
 RN1->LNode=LN2;
 RN1->RNode=this->LNode->Diff(Inc,IndexVar,Scope);
 LN2->Type="pow";
 LN2->LNode=this->LNode;
 LN2->Const=this->Const-1;
 LN2->RNode=NULL;
}

else if(this->Type== "sqr" )
{
 ROOT=this->NewNode();
 LN1=this->NewNode();
 RN1=this->NewNode();
 LN2=this->NewNode();
 ROOT->Type="*";
 ROOT->LNode=LN1;
 ROOT->RNode=this->LNode->Diff(Inc,IndexVar,Scope);;
 LN1->Type="*";
 LN2->Type="const";
 LN2->Ival=ivalDb(2);
 LN1->LNode=LN2;
 LN1->RNode=this->LNode;
}


else if(this->Type== "sqrt" )
{
 ROOT=this->NewNode();
 LN1=this->NewNode();
 RN1=this->NewNode();
 LN2=this->NewNode();
 LN3=this->NewNode();
 ROOT->Type="*";
 LN1->Type="const";
 LN1->Ival=ivalDb(0.5);
 RN1->Type="*";
 ROOT->LNode=LN1;
 ROOT->RNode=RN1;
 LN2->Type="sqrt";
 RN1->LNode=LN2;
 RN1->RNode=this->LNode->Diff(Inc,IndexVar,Scope);
 LN2->LNode=this->LNode;
 LN2->RNode=NULL;
}

else if(this->Type== "cbrt" )
{
}

else if(this->Type== "root" )
{
}

else if(this->Type== "cos" )
{ROOT=this->NewNode();
 LN1=this->NewNode();
 RN1=this->NewNode();
 ROOT->Type="*";
 LN1->Type="-";
 RN1->Type="sin";
 ROOT->LNode=LN1;
 LN1->LNode=NULL;
 LN1->RNode=RN1;
 RN1->LNode=this->LNode;
 RN1->RNode=NULL;
 ROOT->RNode=this->LNode->Diff(Inc,IndexVar,Scope);
}

else if(this->Type== "sin" )
{
 LN1=this->NewNode();
 ROOT=this->NewNode();
 ROOT->Type="*";
 LN1->Type="cos";
 ROOT->LNode=LN1;
 LN1->LNode=this->LNode;
 LN1->RNode=NULL;
 ROOT->RNode=this->LNode->Diff(Inc,IndexVar,Scope);
}

else if(this->Type== "tan" )
{
 ROOT=this->NewNode();
 RN1=this->NewNode();
 LN2=this->NewNode();
 ROOT->Type="/";
 ROOT->LNode=this->LNode->Diff(Inc,IndexVar,Scope);
 ROOT->RNode=RN1;
 RN1->Type="sqr";
 RN1->LNode=LN2;
 RN1->RNode=NULL;
 LN2->Type="cos";
 LN2->LNode=this->LNode;;
 LN2->RNode=NULL;
}

else if(this->Type== "acos" )
{
 ROOT=this->NewNode();
 LN1=this->NewNode();
 RN1=this->NewNode();
 LN2=this->NewNode();
 LN3=this->NewNode();
 LN4=this->NewNode();
 RN4=this->NewNode();
 ROOT->Type="/";
 ROOT->LNode=LN1;
 ROOT->RNode=RN1;
 LN1->Type="minus";
 LN1->LNode=this->LNode->Diff(Inc,IndexVar,Scope);
 ROOT->RNode=RN1;
 LN1->RNode=NULL;
 RN1->Type="sqrt";
 RN1->LNode=LN3;
 RN1->RNode=NULL;
 LN3->Type="-";
 LN3->LNode=LN4;
 LN3->RNode=RN4;
 LN4->Type="const";
 LN4->Ival=ivalDb(1);
 RN4->Type="sqr";
 RN4->LNode=this->LNode;
 RN4->RNode=NULL;
}

else if(this->Type== "asin" )
{
 ROOT=this->NewNode();
 LN1=this->NewNode();
 RN1=this->NewNode();
 LN2=this->NewNode();
 LN3=this->NewNode();
 LN4=this->NewNode();
 RN4=this->NewNode();
 ROOT->Type="/";
 ROOT->LNode=this->LNode->Diff(Inc,IndexVar,Scope);
 ROOT->RNode=RN1;
 LN1->RNode=NULL;
 RN1->Type="sqrt";
 RN1->LNode=LN3;
 RN1->RNode=NULL;
 LN3->Type="-";
 LN3->LNode=LN4;
 LN3->RNode=RN4;
 LN4->Type="const";
 LN4->Ival=ivalDb(1);
 RN4->Type="sqr";
 RN4->LNode=this->LNode;
 RN4->RNode=NULL;
}

else if(this->Type== "atan" )
{
 ROOT=this->NewNode();
 RN1=this->NewNode();
 RN2=this->NewNode();
 LN2=this->NewNode();
 ROOT->Type="/";
 ROOT->LNode=this->LNode->Diff(Inc,IndexVar,Scope);
 ROOT->RNode=RN1;
 RN1->Type="+";
 RN1->LNode=LN2;
 RN1->RNode=RN2;
 LN2->Type="const";
 LN2->Ival=ivalDb(1);
 RN2->Type="sqr";
 RN2->LNode=this->LNode;
 RN2->RNode=NULL;
}

else if(this->Type== "cosh" )
{
}

else if(this->Type== "ainh" )
{
}

else if(this->Type== "tanh" )
{
}

else if(this->Type== "log10" )
{
}

else if(this->Type== "Abs" )
{
 LN1=this->NewNode();
 ROOT=this->NewNode();
 ROOT->Type="*";
 LN1->Type="sign";
 ROOT->LNode=LN1;
 LN1->LNode=this->LNode;
 LN1->RNode=NULL;
 ROOT->RNode=this->LNode->Diff(Inc,IndexVar,Scope);
}

else if(this->Type== "min" )
{
 ROOT=this->NewNode();
 LN1=this->NewNode();
 LN2=this->NewNode();
 LN3=this->NewNode();
 LN4=this->NewNode();
 LN5=this->NewNode();
 LN6=this->NewNode();
 RN1=this->NewNode();

 ROOT->Type="+";
 LN1->Type="*";
 RN1->Type="*";
 LN2->Type="step";
 LN3->Type="step";
 LN4->Type="-";
 LN5->Type="-";

 ROOT->LNode=LN1;
 ROOT->RNode=RN1;

 LN1->LNode=LN2;
 LN1->RNode=this->LNode->Diff(Inc,IndexVar,Scope);
 LN2->LNode=LN4;
 LN2->RNode=NULL;
 LN4->LNode=this->RNode;
 LN4->RNode=this->LNode;

 RN1->LNode=LN3;
 RN1->RNode=this->RNode->Diff(Inc,IndexVar,Scope);
 LN3->LNode=LN5;
 LN3->RNode=NULL;
 LN5->LNode=this->LNode;
 LN5->RNode=this->RNode;
}

else if(this->Type== "max" )
{
 ROOT=this->NewNode();
 LN1=this->NewNode();
 LN2=this->NewNode();
 LN3=this->NewNode();
 LN4=this->NewNode();
 LN5=this->NewNode();
 LN6=this->NewNode();
 RN1=this->NewNode();

 ROOT->Type="+";
 LN1->Type="*";
 RN1->Type="*";
 LN2->Type="step";
 LN3->Type="step";
 LN4->Type="-";
 LN5->Type="-";

 ROOT->LNode=LN1;
 ROOT->RNode=RN1;

 LN1->LNode=LN2;
 LN1->RNode=this->LNode->Diff(Inc,IndexVar,Scope);
 LN2->LNode=LN4;
 LN2->RNode=NULL;
 LN4->LNode=this->LNode;
 LN4->RNode=this->RNode;

 RN1->LNode=LN3;
 RN1->RNode=this->RNode->Diff(Inc,IndexVar,Scope);
 LN3->LNode=LN5;
 LN3->RNode=NULL;
 LN5->LNode=this->RNode;
 LN5->RNode=this->LNode;
}

return ROOT;
}//-----------------------------------------------------------------------------

// Simplify Tree
void Simplify(node *&Node)
{
node* ALN;
node* ARN;

if(Node==NULL){}
else if(Node->Type=="var" || Node->Type=="const" || Node->Type=="one"){}
else if(Node->Type=="+" || Node->Type=="min" || Node->Type=="max")
{
 Simplify(Node->LNode);
 Simplify(Node->RNode);

 if(Node->LNode==NULL && Node->RNode==NULL)
 {//delete [] Node;
  Node=NULL;}
 else if(Node->LNode==NULL || Node->LNode->Ival.IsZero())
 {ALN=Node->LNode;
  ARN=Node->RNode;
  *Node=*Node->RNode;
  //delete [] ALN;
  //delete [] ARN;
  }
 else if(Node->RNode==NULL || Node->RNode->Ival.IsZero())
 {ALN=Node->LNode;
  ARN=Node->RNode;
  *Node=*Node->LNode;
  //delete [] ALN;
  //delete [] ARN;
  }
}

else if(Node->Type=="-")
{
 Simplify(Node->LNode);
 Simplify(Node->RNode);

 if(Node->LNode==NULL && Node->RNode==NULL)
 {//delete [] Node;
  Node=NULL;}
 else if(Node->LNode==NULL || Node->LNode->Ival.IsZero())
 {Node->Type="minus";
  Node->LNode=Node->RNode;

// Correccin Pau para problema de parser matlab
  Simplify(Node->LNode);
//

  Node->RNode=NULL;
  }
 else if(Node->RNode==NULL  || Node->RNode->Ival.IsZero())
 {
  ALN=Node->LNode;
  ARN=Node->RNode;
  *Node=*Node->LNode;
  //delete [] ALN;
  //delete [] ARN;
  }
}

else if(Node->Type=="*")
{
 Simplify(Node->LNode);
 Simplify(Node->RNode);
 if(Node->LNode==NULL || Node->RNode==NULL)
 {//delete [] Node;
  Node=NULL;}
 else if(Node->LNode->Type=="one")
 {ALN=Node->LNode;
  ARN=Node->RNode;
  *Node=*Node->RNode;
  //delete [] ALN;
  //delete [] ARN;
 }
 else if(Node->RNode->Type=="one")
 {ALN=Node->LNode;
  ARN=Node->RNode;
  *Node=*Node->LNode;
  //delete [] ALN;
  //delete [] ARN;
 }
 else if(Node->LNode->Ival.IsZero())
 {ALN=Node->LNode;
  ARN=Node->RNode;
  *Node=*Node->LNode;
  //delete [] ALN;
  //delete [] ARN;
 }
 else if(Node->RNode->Ival.IsZero())
 {ALN=Node->LNode;
  ARN=Node->RNode;
  *Node=*Node->RNode;
  //delete [] ALN;
  //delete [] ARN;
 }
}

else if(Node->Type=="/")
{
 Simplify(Node->LNode);
 Simplify(Node->RNode);

 if(Node->LNode==NULL || Node->RNode==NULL)
 {//delete [] Node;
  Node=NULL;}

 else if(Node->RNode->Type=="one")
 {ALN=Node->LNode;
  ARN=Node->RNode;
  *Node=*Node->LNode;
  //delete [] ALN;
  //delete [] ARN;
 }
 else if(Node->LNode->Ival.IsZero())
 {ALN=Node->LNode;
  ARN=Node->RNode;
  *Node=*Node->LNode;
  //delete [] ALN;
  //delete [] ARN;
  }
}

else if(Node->Type=="pow" && Node->Const==1)
{
 Simplify(Node->LNode);
 ALN=Node->LNode;
 *Node=*Node->LNode;
  //delete [] ALN;
}

else if((Node->Type=="Abs" || Node->Type=="pow" || Node->Type=="sin" || Node->Type=="cos" || Node->Type=="tan"
        || Node->Type=="exp" || Node->Type=="log" || Node->Type=="acos" || Node->Type=="asin"
        || Node->Type=="atan" || Node->Type=="minus" || Node->Type=="sign" || Node->Type=="step") && Node->LNode==NULL)
{
 ALN=Node->LNode;
 Node=NULL;
 //delete [] ALN;
}

else
{
 Simplify(Node->LNode);
 Simplify(Node->RNode);
}
}//-----------------------------------------------------------------------------

// Delete Node
void DeleteNode(node *&Node)
{Node->Type;
 Node->Ival;
 if(Node==NULL){}
 else if(Node->LNode==NULL && Node->RNode==NULL)
  {delete [] Node;}
 else
  {if(Node->LNode!=NULL){DeleteNode(Node->LNode);}
   if(Node->RNode!=NULL){DeleteNode(Node->RNode);}
   }
}//-----------------------------------------------------------------------------

/*
void node::AddToList(list<node*> &L)
{
 if(this==NULL){}
 else
 {string T=this->Type;
  L.push_front(this);
  this->LNode->AddToList(L);
  this->RNode->AddToList(L);}
}//-----------------------------------------------------------------------------
*/

void node::AddToList(list<node*> &List)
{
 list<node*> AList;
 bool Fill=true;
 AList.push_front(this);
 node* Node=NULL;

 while(!AList.empty())
 {
  Node=AList.front();
  if(Node->LNode!=NULL)
   {AList.push_back(Node->LNode);}
  if(Node->RNode!=NULL)
   {AList.push_back(Node->RNode);}
  List.push_front(Node);
  AList.pop_front();
 }
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Create New Node
//------------------------------------------------------------------------------
node* node::NewNode(void)
{Global_NodesStock.push_back(*this);
 Global_NodesStock.back().Quantified="F";
 Global_NodesStock.back().NameVar="?";
 return &Global_NodesStock.back();
}//-----------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
// Operators                                                                  //
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Monary Operators and Functions                                             //
////////////////////////////////////////////////////////////////////////////////

node& node::operator-()
{node* NN=this->NewNode();
 NN->AssignNameAuxVar();
 NN->Type="minus";
 NN->LNode=this;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------


/*##############################################################################
  Binary Operators
/#############################################################################*/

node& operator==(const node& LN,const node& RN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="=";
 NN->LNode=const_cast<node*> (&LN);
 NN->RNode=const_cast<node*> (&RN);
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NN->RNode->CreateNode();
 return *NN;
}//-----------------------------------------------------------------------------

node& operator<<=(const node& LN,const node& RN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="<=";
 NN->LNode=const_cast<node*> (&LN);
 NN->RNode=const_cast<node*> (&RN);
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NN->RNode->CreateNode();
 return *NN;
}//-----------------------------------------------------------------------------

node& operator>>=(const node& LN,const node& RN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type=">=";
 NN->LNode=const_cast<node*> (&LN);
 NN->RNode=const_cast<node*> (&RN);
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NN->RNode->CreateNode();
 return *NN;
}//-----------------------------------------------------------------------------

node& operator<<(const node& LN,const node& RN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="<";
 NN->LNode=const_cast<node*> (&LN);
 NN->RNode=const_cast<node*> (&RN);
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NN->RNode->CreateNode();
 return *NN;
}//-----------------------------------------------------------------------------

node& operator>>(const node& LN,const node& RN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type=">";
 NN->LNode=const_cast<node*> (&LN);
 NN->RNode=const_cast<node*> (&RN);
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NN->RNode->CreateNode();
 return *NN;
}//-----------------------------------------------------------------------------

// Sum
node& operator+(const node &LN,const node &RN)
{node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="+";
 NN->LNode=const_cast<node*> (&LN);
 NN->RNode=const_cast<node*> (&RN);
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NN->RNode->CreateNode();
 return *NN;
}// ----------------------------------------------------------------------------

// Rest
node& operator-(const node& LN,const node& RN)
{node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="-";
 NN->LNode=const_cast<node*> (&LN);
 NN->RNode=const_cast<node*> (&RN);
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NN->RNode->CreateNode();
 return *NN;
}// ----------------------------------------------------------------------------

// Product
node& operator*(const node& LN,const node& RN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="*";
 NN->LNode=const_cast<node*> (&LN);
 NN->RNode=const_cast<node*> (&RN);
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NN->RNode->CreateNode();
 return *NN;
}// ----------------------------------------------------------------------------

// Division
node& operator/(const node& LN,const node& RN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="/";
 NN->LNode=const_cast<node*> (&LN);
 NN->RNode=const_cast<node*> (&RN);
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NN->RNode->CreateNode();
 return *NN;
}// ----------------------------------------------------------------------------

// ----------------------------------------------------------------------------
// ^ Operator
// ----------------------------------------------------------------------------
node& operator^(node& LN, const int n)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="pow";
 NN->Const=n;
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}// ----------------------------------------------------------------------------

/*##############################################################################
  Functions
/#############################################################################*/

// Dual
node& Du(node& N)
{
 node* NN=N.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="du";
 NN->LNode=&N;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Absolute Value: Abs(x)
node& abs(node& LN)
{node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="Abs";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Power: Pow(x,n)
node& pow(node& LN, int n)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="pow";
 NN->Const=n;
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Square: Sqr(x)
node& sqr(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="sqr";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Square NN: Sqrt(x)
node& sqrt(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="sqrt";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

 // Cubic NN: Cbrt(x)
node& cbrt(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="cbrt";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Generic Root: Root(x)
node& root(node& LN,int n)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="root";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Cosine: Cos(x)
node& cos(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="cos";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Sine: Sin(x)
node& sin(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="sin";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Tangent: Tan(x)
node& tan(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="tan";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Acosine: Acos(x)
node& acos(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="acos";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Asine: Asin(x)
node& asin(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="asin";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Atangent: Atan(x)
node& atan(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="atan";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Hyperbolic Cosine: Cosh(x)
node& cosh(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="cosh";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Hyperbolic Sine: Sinh(x)
node& sinh(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="sinh";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Hyperbolic Tangent: Tanh(x)
node& tanh(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="tanh";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Hyperbolic Acos: Acosh(x)
node& acosh(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="acosh";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Hyperbolic Asin: Asinh(x)
node& asinh(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="asinh";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Hyperbolic Atan: Atanh(x)
node& atanh(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="atanh";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Exponential: Exp(x)
node& exp(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="exp";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Logarithm: Log(x)
node& log(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="log";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Logarithm 10: Log10(x)
node& log10(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="log10";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Sign
node& sign(node& LN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="sign";
 NN->LNode=&LN;
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NULL;
 return *NN;
}//-----------------------------------------------------------------------------

// Max
node& max(const node& LN,const node& RN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="max";
 NN->LNode=const_cast<node*> (&LN);
 NN->RNode=const_cast<node*> (&RN);
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NN->RNode->CreateNode();
 return *NN;
}// ----------------------------------------------------------------------------

// Min
node& min(const node& LN,const node& RN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="min";
 NN->LNode=const_cast<node*> (&LN);
 NN->RNode=const_cast<node*> (&RN);
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NN->RNode->CreateNode();
 return *NN;
}// ----------------------------------------------------------------------------

// Min
node& minmax(const node& LN,const node& RN)
{
 node* NN=LN.NewNode();
 NN->AssignNameAuxVar();
 NN->Type="minmax";
 NN->LNode=const_cast<node*> (&LN);
 NN->RNode=const_cast<node*> (&RN);
 NN->LNode=NN->LNode->CreateNode();
 NN->RNode=NN->RNode->CreateNode();
 return *NN;
}// ----------------------------------------------------------------------------


////////////////////////////////////////////////////////////////////////////////
// I/O Stream Operators                                                       //
////////////////////////////////////////////////////////////////////////////////

ostream& operator<<(ostream & out, node& N)
{
 out << "{" << N.Type << "," << N.Ival << "}";
 return out;
}//-----------------------------------------------------------------------------

bool operator<(const node &N1, const node &N2)
{
 bool Small=false;
 if(N1.IsProp() && N2.IsImpr()) {Small=true;}
 else if(N2.IsProp() && N1.IsImpr()) {Small=false;}
 else if((N1.IsProp() && N2.IsProp()) && Width(N1.GetIval()) < Width(N2.GetIval())) {Small=true;}
 else if((N1.IsImpr() && N2.IsImpr()) && Width(N1.GetIval()) < Width(N2.GetIval())) {Small=true;}
 return Small;
}//-----------------------------------------------------------------------------


void node::ToLatex(fstream &fout)
{
if (this==NULL) return;

if (this->Type=="var")
 {fout <<  " \\pstree{\\Tr{ " << "$" << this->NameVar << "_" << "{" << GetIndex(*this->PInc) << "}" << "$" <<  "}} { \n" ;}
// {fout <<  " \\pstree{\\Tr{ " << "$" << (*this->PInc)->GetIvalVar() << "$" <<  "}} { \n" ;}
else if (this->Type=="const")
 {fout <<  " \\pstree{\\Tr{ " << this->Ival <<  "}} { \n" ;}
else if (this->Type=="aux")
 {fout <<  " \\pstree{\\Tr{ " << this->Ival <<  "}} { \n" ;}
else
 {fout <<  " \\pstree{\\Tr{ " << this->Type <<  " }} { \n" ;}
if(this->LNode!=NULL) this->LNode->ToLatex(fout);
if(this->RNode!=NULL) this->RNode->ToLatex(fout);
fout << "}" << endl;

}//-----------------------------------------------------------------------------


node* node::Replicate(int Step, deque< deque<node*> >& Measurements)
{
node* Node;
var Var;
incidence* Inc=NULL;
string VarName;

if(this!=NULL) {
  if(this->Quantified=="S")           // State Node
   {Node=this->CreateVar();}
  else if(this->Quantified=="P")      // Parameter Node
   {Node=this->CreateVar();}

  else if(this->Quantified=="M")      // Measurement Node
  {
     int Size=Measurements[this->MeasureIndex].size();
     if(Size==Step)    // Create New Incidence
      {
       this->AssignName(Step);
       Node=this->CreateVar();}
     else                               // Create New variable
     {
      Node=this->NewNode();
      *Node=*this;
      this->PNodeVars->push_back(*Node);
      Node->AssignName(Step);
      this->PVars->push_back(Var);
      Node->VarIndex=this->PVars->size()-1;
      Node->PVars->operator[](Node->VarIndex).push_back(Inc);
      Node->PInc=&Node->PVars->operator[](Node->VarIndex).back();
      Measurements[this->MeasureIndex].push_back(&this->PNodeVars->back());
     }
  }
  else                                          // Operator Node
   {Node=this->NewNode();
    *Node=*this;}

  if(this->LNode!=NULL)
   {Node->LNode=this->LNode->Replicate(Step,Measurements);}
  if(this->RNode!=NULL)
   {Node->RNode=this->RNode->Replicate(Step,Measurements);}
}
return Node;
}//-----------------------------------------------------------------------------

void node::FindStateNodes(deque<node*>& States)
{
if(this!=NULL)
{
  this->Type;
  this->NameVar;
  if(this->Type=="var" && this->Quantified=="S")
   {States.push_back(this);}

  if(this->LNode!=NULL){this->LNode->FindStateNodes(States);}
  if(this->RNode!=NULL){this->RNode->FindStateNodes(States);}
}
}//-----------------------------------------------------------------------------

void node::AssignName(int Step)
{char buffer [33];
 int pos = this->NameVar.find("@",0);
 if(pos>0)
 {this->NameVar.erase(pos);}
 
 itoa(Step-1,buffer,10);
 this->NameVar=this->NameVar + "@" + buffer;

}//-----------------------------------------------------------------------------



//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

/*
void IntervalToIvalDb(interval& X,ivalDb& Y)
{
 Y.Inf=X.inf;
 Y.Sup=X.sup;
}//-----------------------------------------------------------------------------

void Contract0Interface(char code, ivalDb& Z, ivalDb& Y, ivalDb& X, int sens)
{
 interval iZ(Z.Inf,Z.Sup);
 interval iY(Y.Inf,Y.Sup);
 interval iX(X.Inf,X.Sup);

 Contract0(code,iZ,iY,iX,sens);

 IntervalToIvalDb(iZ,Z);
 IntervalToIvalDb(iY,Y);
 IntervalToIvalDb(iX,X);
}//-----------------------------------------------------------------------------

void Contract0Interface(char code, ivalDb& Y, ivalDb& X, int sens)
{
 interval iY(Y.Inf,Y.Sup);
 interval iX(X.Inf,X.Sup);

 Contract0(code,iY,iX,sens);

 IntervalToIvalDb(iY,Y);
 IntervalToIvalDb(iX,X);
}//-----------------------------------------------------------------------------

void Contract0Interface(char code, ivalDb& Y, ivalDb& X,int n, int sens)
{
 interval iY(Y.Inf,Y.Sup);
 interval iX(X.Inf,X.Sup);

 Contract0(code,iY,iX,n,sens);

 IntervalToIvalDb(iY,Y);
 IntervalToIvalDb(iX,X);
}//-----------------------------------------------------------------------------

void node::EvaluateFPropagation(string &Mode)
{
 if(this==NULL){}
 else if(this->Type=="const" || this->Type=="aux" || this->Type=="one"){}
 else if(this->Type=="var")
  {
   incidence* Inc=(*this->PInc);
   ivalDb Ivalue=Prop(Inc->GetIvalVar());

  if(this->Quantified=="F")              // Free Variable
   {this->Ival=Ivalue;}

  else if(this->Quantified=="U")              // Universally Quantified Variable
   {bool TotMono=Inc->GetTotalMonoVar();
    if(TotMono)
    {
    if(Inc->GetMonoVar()==1)
     {
      if(Mode=="minmax")this->Ival=Ivalue.GetInf();
      else if(Mode=="maxmin")this->Ival=Ivalue.GetSup();
     }
    else if(Inc->GetMonoVar()==-1)
     {
      if(Mode=="minmax")this->Ival=Ivalue.GetSup();
      else if(Mode=="maxmin")this->Ival=Ivalue.GetInf();
     }
    }
    else
    {this->Ival=Center(Ivalue);}
  }

  else if(this->Quantified=="E")       // Existencially Quantified Variable
  {
   if(Inc->GetTotalMonoVar())
   {
     if(Inc->GetMonoVar()==1)
      {
       if(Mode=="minmax")this->Ival=Ivalue.GetSup();
       else if(Mode=="maxmin")this->Ival=Ivalue.GetInf();
      }
     else if(Inc->GetMonoVar()==-1)
     {
      if(Mode=="minmax") this->Ival=Ivalue.GetInf();
      else if(Mode=="maxmin")this->Ival=Ivalue.GetSup();
     }
   }
   else {this->Ival=Ivalue;}
  }
  }

 else            // Operator
 {
   if(this->Type== "-" && this->RNode->Type=="aux")
      {ivalDb Aux=Prop(RNode->Ival);
       //if(Aux.IsZero()){}
       //else
       {
        if(Mode=="minmax") Aux=ivalDb(0,PInfinity());
        else if(Mode=="maxmin") Aux=ivalDb(MInfinity(),0);
       }
       Contract0Interface('=',LNode->Ival,Aux,1);}

   else if(this->Type== "+" ) Contract0Interface('+', this->Ival,LNode->Ival,this->RNode->Ival,1);
   else if(this->Type== "-" ) Contract0Interface('-', this->Ival,LNode->Ival,this->RNode->Ival,1);
   else if(this->Type== "*" ) Contract0Interface('*', this->Ival,LNode->Ival,this->RNode->Ival,1);
   else if(this->Type== "/" ) Contract0Interface('/', this->Ival,LNode->Ival,this->RNode->Ival,1);
   else if(this->Type== "min" ) Contract0Interface('m', this->Ival,LNode->Ival,this->RNode->Ival,1);
   else if(this->Type== "max" ) Contract0Interface('M', this->Ival,LNode->Ival,this->RNode->Ival,1);

   else if(this->Type=="minus") Contract0Interface('_', this->Ival,LNode->Ival,1);
   else if(this->Type== "exp" ) Contract0Interface('E', this->Ival,LNode->Ival,1);
   else if(this->Type== "log" ) Contract0Interface('L', this->Ival,LNode->Ival,1);
   else if(this->Type== "Abs" ) Contract0Interface('B', this->Ival,LNode->Ival,1);
   else if(this->Type== "sqr" ) Contract0Interface('2', this->Ival,LNode->Ival,1);
   else if(this->Type== "sqrt" ) Contract0Interface('R', this->Ival,LNode->Ival,1);
   else if(this->Type== "cos" ) Contract0Interface('C', this->Ival,LNode->Ival,1);
   else if(this->Type== "sin" ) Contract0Interface('S', this->Ival,LNode->Ival,1);
   else if(this->Type== "tan" ) Contract0Interface('T', this->Ival,LNode->Ival,1);
   else if(this->Type== "atan" ) Contract0Interface('A', this->Ival,LNode->Ival,1);
   else if(this->Type== "pow" ) Contract0Interface('P', this->Ival,LNode->Ival,this->Const,1);    // Bugger!!!!
}
}//-----------------------------------------------------------------------------

void node::EvaluateBPropagation(void)
{
 incidence* Inc;
 ivalDb Ivalue,LIval,RIval;

 if(this==NULL){}
 else if(this->Type=="var" || this->Type=="const" || this->Type=="aux" || this->Type=="one"){}
 else
 {
   LIval=this->LNode->Ival;
   if(RNode!=NULL) RIval=this->RNode->Ival;

   if(this->Type== "-" && this->RNode->Type=="aux"){}

   else if(this->Type== "+" ) Contract0Interface('+', this->Ival,LIval,RIval,-1);
   else if(this->Type== "-" ) Contract0Interface('-', this->Ival,LIval,RIval,-1);
   else if(this->Type== "*" ) Contract0Interface('*', this->Ival,LIval,RIval,-1);
   else if(this->Type== "/" ) Contract0Interface('/', this->Ival,LIval,RIval,-1);
   else if(this->Type== "min" ) Contract0Interface('m', this->Ival,LIval,RIval,-1);
   else if(this->Type== "max" ) Contract0Interface('M', this->Ival,LIval,RIval,-1);

   else if(this->Type=="minus") Contract0Interface('_', this->Ival,LIval,-1);
   else if(this->Type== "exp" ) Contract0Interface('E', this->Ival,LIval,-1);
   else if(this->Type== "log" ) Contract0Interface('L', this->Ival,LIval,-1);
   else if(this->Type== "Abs" ) Contract0Interface('B', this->Ival,LIval,-1);
   else if(this->Type== "sqr" ) Contract0Interface('2', this->Ival,LIval,-1);
   else if(this->Type== "sqrt" ) Contract0Interface('R', this->Ival,LIval,-1);
   else if(this->Type== "cos" ) Contract0Interface('C', this->Ival,LIval,-1);
   else if(this->Type== "sin" ) Contract0Interface('S', this->Ival,LIval,-1);
   else if(this->Type== "tan" ) Contract0Interface('T', this->Ival,LIval,-1);
   else if(this->Type== "atan" ) Contract0Interface('A', this->Ival,LIval,-1);
   else if(this->Type== "pow" ) Contract0Interface('P', this->Ival,LIval,this->Const,-1);   // Bugger!!!!

   if(this->LNode->Type!="const" && this->LNode->Type!="aux" && this->LNode->Type!="one")
    {this->LNode->Ival=LIval;}
   if(this->RNode!=NULL && this->RNode->Type!="const" && this->RNode->Type!="aux" && this->RNode->Type!="one")
    {this->RNode->Ival=RIval;}

   this->RNode->NameVar;
   this->LNode->NameVar;

   if(this->RNode!=NULL && this->RNode->Type=="var" && this->RNode->Quantified=="F")        // Assign Contraction To Cell
   //if(this->RNode!=NULL && this->RNode->Type=="var")
   {
      Inc=(*(this->RNode)->PInc);
      Inc->GetIvalVar()=Inc->GetIvalVar() && this->RNode->Ival;
   }
   if(this->LNode!=NULL && this->LNode->Type=="var" && this->LNode->Quantified=="F")
   //if(this->LNode!=NULL && this->LNode->Type=="var")
   {
     Inc=(*(this->LNode)->PInc);
     Inc->GetIvalVar()=Inc->GetIvalVar() && this->LNode->Ival;
   }
 }
}//-----------------------------------------------------------------------------
*/
