 /*!****************************************************************************
 *    \file param.cpp
 *    This file contains the implementation of the param class belonging
 *    to the Star Algorithm.
 *    Date: 27/01/2003
 *    Author: Pau Herrero Vias.
 *    MiceLab - Universitat de Girona.
 ******************************************************************************/

#include "param.h"

////////////////////////////////////////////////////////////////////////////////
// Constructors                                                               //
////////////////////////////////////////////////////////////////////////////////

/** Default Constructor.
   \fn param::param()*/
param::param()
{Eps=0;
 Tol=0;
 Debug=0;
 Bisect=2;
 Optim=0;
 Finish="?";
 ScreenOut=false;
 Time=10e300;
 Solution=false;
 Plot=false;
 Contract=false;
 Inclusion=0;
 XPlotIndex=0;
 YPlotIndex=0;
 Consistency=iperhaps;
 Cells=false;
 File="";
}//-----------------------------------------------------------------------------

/** Default Constructor.
   \fn param::param()*/
param::param(param &P)
{Eps=P.Eps;
 Tol=P.Tol;
 Debug=P.Debug;
 Bisect=P.Bisect;
 Optim=P.Optim;
 ScreenOut=P.ScreenOut;
 Time=P.Time;
 Solution=P.Solution;
 Plot=P.Plot;
 Contract=P.Contract;
 Inclusion=P.Inclusion;
 XPlotIndex=P.XPlotIndex;
 YPlotIndex=P.YPlotIndex;
 Consistency=P.Consistency;
 Cells=P.Cells;
 File=P.File;
}//-----------------------------------------------------------------------------

param& param::operator=(const param &P)
{Eps=P.Eps;
 Tol=P.Tol;
 Debug=P.Debug;
 Bisect=P.Bisect;
 Optim=P.Optim;
 Finish=P.Finish;
 ScreenOut=P.ScreenOut;
 Time=P.Time;
 Solution=P.Solution;
 Plot=P.Plot;
 Contract=P.Contract;
 Inclusion=P.Inclusion;
 XPlotIndex=P.XPlotIndex;
 YPlotIndex=P.YPlotIndex;
 Consistency=P.Consistency;
 Cells=P.Cells;
 File=P.File;
 return *this;
}//-----------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
// Acces to members                                                           //
////////////////////////////////////////////////////////////////////////////////

/** \fn
    \return . */
double param::GetEps() const
{return Eps;
}//-----------------------------------------------------------------------------

/** \fn
    \return . */
double param::GetTol() const
{return Tol;
}//-----------------------------------------------------------------------------

/** \fn
    \return . */
int param::GetDebug() const
{return Debug;
}//-----------------------------------------------------------------------------

/** \fn
    \return . */
int param::GetBisect() const
{return Bisect;
}//-----------------------------------------------------------------------------

/** \fn
    \return . */
double param::GetTime() const
{return Time;
}//-----------------------------------------------------------------------------

/** \fn
    \return . */
int param::GetOptim() const
{return Optim;
}//-----------------------------------------------------------------------------

/** \fn
    \return . */
char* param::GetFinish() const
{return Finish;
}//-----------------------------------------------------------------------------

/** \fn
    \return . */
bool param::GetScreenOut() const
{return ScreenOut;
}//-----------------------------------------------------------------------------

/** \fn
    \return . */
bool param::GetSolution() const
{return Solution;
}//-----------------------------------------------------------------------------

/** \fn
    \return . */
bool param::GetPlot() const
{return Plot;
}//-----------------------------------------------------------------------------

/** \fn
    \return . */
bool param::GetContract() const
{return Contract;
}//-----------------------------------------------------------------------------

/** \fn
    \return . */
int param::GetInclusion() const
{return Inclusion;
}//-----------------------------------------------------------------------------

string& param::GetPlotX()
{return PlotX;
}//-----------------------------------------------------------------------------

string&  param::GetPlotY()
{return PlotY;
}//-----------------------------------------------------------------------------

int param::GetXPlotIndex()
{return XPlotIndex;
}//-----------------------------------------------------------------------------

int  param::GetYPlotIndex()
{return YPlotIndex;
}//-----------------------------------------------------------------------------

iboolean& param::GetConsistency()
{return Consistency;
}//-----------------------------------------------------------------------------

/** \fn
    \return . */
bool param::GetCells() const
{return Cells;
}//-----------------------------------------------------------------------------

/** \fn
    \return . */
string& param::GetFile()
{return File;
}//-----------------------------------------------------------------------------

/*
vector<double>& param::GetEpsilons()
{return this->Epsilons;
}//-----------------------------------------------------------------------------
*/

vector<double>& param::GetXWidths()
{return this->XWidths;
}//-----------------------------------------------------------------------------

/** \fn
    \brief. */
void param::SetEps(double EPS)
{Eps=EPS;
}//-----------------------------------------------------------------------------

/** \fn
    \brief. */
void param::SetTol(double TOL)
{Tol=TOL;
}//-----------------------------------------------------------------------------

/** \fn
    \brief. */
void param::SetDebug(int DB)
{Debug=DB;
}//-----------------------------------------------------------------------------

/** \fn
    \brief. */
void param::SetBisect(int BisNum)
{Bisect=BisNum;
}//-----------------------------------------------------------------------------

/** \fn
    \brief. */
void param::SetTime(double TimLim)
{Time=TimLim;
}//-----------------------------------------------------------------------------

/** \fn
    \brief. */
void param::SetOptim(int Opt)
{Optim=Opt;
}//-----------------------------------------------------------------------------

/** \fn
    \brief. */
void param::SetFinish(char* Stop)
{Finish=Stop;
}//-----------------------------------------------------------------------------

/** \fn
    \brief. */
void param::SetScreenOut(bool SO)
{ScreenOut=SO;
}//-----------------------------------------------------------------------------

/** \fn
    \brief. */
void param::SetSolution(bool S)
{Solution=S;
}//-----------------------------------------------------------------------------

/** \fn
    \brief. */
void param::SetPlot(bool P)
{Plot=P;
}//----------------------------------------------------------------------------- /** \fn

/** \fn
    \brief. */
void param::SetContract(bool C)
{Contract=C;
}//----------------------------------------------------------------------------- /** \fn

/** \fn
    \brief. */
void param::SetInclusion(int INC)
{Inclusion=INC;
}//-----------------------------------------------------------------------------

void param::SetPlotX(string& X)
{PlotX=X;
}//-----------------------------------------------------------------------------

void param::SetPlotY(string& Y)
{PlotY=Y;
}//-----------------------------------------------------------------------------

void param::SetXPlotIndex(int X)
{XPlotIndex=X;
}//-----------------------------------------------------------------------------

void param::SetYPlotIndex(int Y)
{YPlotIndex=Y;
}//-----------------------------------------------------------------------------

void param::SetConsistency(iboolean& C)
{Consistency=C;
}//-----------------------------------------------------------------------------

/** \fn
    \brief. */
void param::SetCells(bool C)
{Cells=C;
}//-----------------------------------------------------------------------------

/** \fn
    \brief. */
void param::SetFile(string& F)
{File=F;
}//-----------------------------------------------------------------------------
/*
void param::SetEpsilons(vector<double>& Eps)
{this->Epsilons=Eps;
}//-----------------------------------------------------------------------------
*/
void param::SetXWidths(vector<double>& XW)
{this->XWidths=XW;
}//-----------------------------------------------------------------------------

