/*******************************************************************************
 *    tree.cpp: Syntactic Tree Node
 *    29/12/2002
 *    By Pau Herrero Vias
 ******************************************************************************/

#include "tree.h"

////////////////////////////////////////////////////////////////////////////////
// Constructors                                                               //
////////////////////////////////////////////////////////////////////////////////

tree::tree()
{
 Root=NULL;
}//-----------------------------------------------------------------------------

tree::tree(node* N)
{
 Root=N;
}//-----------------------------------------------------------------------------

tree::tree(const tree &T)
{
  Root=T.Root;
  Vars.resize(T.Vars.size());
  for(int i=0; i<T.Vars.size();i++)
  {Vars[i].resize(T.Vars[i].size());
   Vars[i]=T.Vars[i];}
  Ders.resize(T.Ders.size());
  for(int i=0; i<T.Ders.size();i++)
  {Ders[i].resize(T.Ders[i].size());
   Ders[i]=T.Ders[i];}
  FunctList=T.FunctList;
  DersLists.resize(T.DersLists.size());
  for(int i=0; i<T.DersLists.size();i++)
  {DersLists[i].resize(T.DersLists[i].size());
   DersLists[i]=T.DersLists[i];}
  NodeVars.resize(T.NodeVars.size());
  NodeVars=T.NodeVars;
  Result=T.Result;
  TOptimal=T.TOptimal;
  XpIndexes=T.XpIndexes;
  XiIndexes=T.XiIndexes;
}//-----------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
// Destructor                                                               //
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Assign Operator                                                               //
////////////////////////////////////////////////////////////////////////////////

// Tree assigment
tree& tree::operator=(const tree &T)
{ Root=T.Root;
  Vars.resize(T.Vars.size());
  for(int i=0; i<T.Vars.size();i++)
  {Vars[i].resize(T.Vars[i].size());
   Vars[i]=T.Vars[i];}
  Ders.resize(T.Ders.size());
  for(int i=0; i<T.Ders.size();i++)
  {Ders[i].resize(T.Ders[i].size());
   Ders[i]=T.Ders[i];}
  FunctList=T.FunctList;
  DersLists.resize(T.DersLists.size());
  for(int i=0; i<T.DersLists.size();i++)
  {DersLists[i].resize(T.DersLists[i].size());
   DersLists[i]=T.DersLists[i];}
  NodeVars=T.NodeVars;
  Result=T.Result;
  XpIndexes=T.XpIndexes;
  XiIndexes=T.XiIndexes;
  TOptimal=T.TOptimal;
  return *this;
}//-----------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
// Acces to members                                                           //
////////////////////////////////////////////////////////////////////////////////

node* tree::GetRoot()
{return Root;
}//-----------------------------------------------------------------------------

vars& tree::GetVars()
{return Vars;
}//-----------------------------------------------------------------------------

ders& tree::GetDers()
{return Ders;
}//-----------------------------------------------------------------------------

deque<node>& tree::GetNodeVars()
{return NodeVars;
}//-----------------------------------------------------------------------------

ivalDb& tree::GetResult(void)
{return Result;
}//-----------------------------------------------------------------------------

list<node*>&  tree::GetFunctList(void)
{return FunctList;
}//-----------------------------------------------------------------------------

derlist&  tree::GetDersLists(void)
{return DersLists;
}//-----------------------------------------------------------------------------

list<node*>& tree::GetNonUnifMonoNodes(void)
{return NonUnifMonoNodes;
}//-----------------------------------------------------------------------------

vector<int>& tree::GetXpUniIndexes(void)
{return this->XpUniIndexes;
}//-----------------------------------------------------------------------------

vector<int>& tree::GetXiUniIndexes(void)
{return this->XiUniIndexes;
}//-----------------------------------------------------------------------------

bool tree::GetUniIncident(void)
{return this->UniIncident;
}//-----------------------------------------------------------------------------

bool tree::GetUniModal(void)
{return this->UniModal;
}//-----------------------------------------------------------------------------

bool tree::GetTOptimal(void)
{return this->TOptimal;
}//-----------------------------------------------------------------------------

deque<int>& tree::GetXpIndexes(void)
{return this->XpIndexes;
}//-----------------------------------------------------------------------------

deque<int>& tree::GetXiIndexes(void)
{return this->XiIndexes;
}//-----------------------------------------------------------------------------

vector< deque<int> >& tree::GetXCrossDers(void)
{return this->XCrossDers;
}//-----------------------------------------------------------------------------

list<node>& tree::GetNodesStock()
{return this->NodesStock;
}//-----------------------------------------------------------------------------

void tree::SetRoot(node* R)
{Root=R;
}//-----------------------------------------------------------------------------

void tree::SetVars(vars& V)
{Vars=V;
}//-----------------------------------------------------------------------------

void tree::SetDers(ders& D)
{Ders=D;
}//-----------------------------------------------------------------------------

void tree::SetNodeVars(deque<node>& NV)
{NodeVars.resize(NV.size());
 NodeVars=NV;
}//-----------------------------------------------------------------------------

void tree::SetResult(ivalDb& R)
{Result=R;
}//-----------------------------------------------------------------------------

void tree::SetFunctList(list<node*>& FL)
{FunctList=FL;
}//-----------------------------------------------------------------------------

void tree::SetDersLists(derlist& DL)
{DersLists=DL;
}//-----------------------------------------------------------------------------

void tree::SetNonUnifMonoNodes(list<node*>& NUMN)
{NonUnifMonoNodes=NUMN;
}//-----------------------------------------------------------------------------

void tree::SetXpUniIndexes(vector<int>& INDXS)
{this->XpUniIndexes=INDXS;
}//-----------------------------------------------------------------------------

void tree::SetXiUniIndexes(vector<int>& INDXS)
{this->XiUniIndexes=INDXS;
}//-----------------------------------------------------------------------------

void tree::SetUniIncident(bool UI)
{this->UniIncident=UI;
}//-----------------------------------------------------------------------------

void tree::SetUniModal(bool UM)
{this->UniModal=UM;
}//-----------------------------------------------------------------------------

void tree::SetTOptimal(bool TO)
{this->TOptimal=TO;
}//-----------------------------------------------------------------------------

void tree::SetXCrossDers(vector< deque<int> >& XCD)
{this->XCrossDers=XCD;
}//-----------------------------------------------------------------------------

void tree::SetNodesStock(list<node>& NS)
{this->NodesStock=NS;
}//-----------------------------------------------------------------------------

void tree::AddNodeVar(node &NV)
{var Var;
 this->Vars.push_back(Var);
 NV.SetPVars(&this->Vars);
 NV.SetPNodeVars(&this->NodeVars);
 //NV.SetPNodesStock(&this->NodesStock);
 this->NodeVars.push_back(NV);

 deque<node*> Aux;                     // SQT source----------------------------
 string Kind,Name;
 int Index;
 node* N=&this->NodeVars.back();

 Kind=N->GetQuantified();
 if(Kind=="S")                        // If State
 {
  this->StateVar=N;
  this->StateVar->SetVarIndex(this->NodeVars.size()-1);
 }
 else if(Kind=="M")                   // If Measurement
 {
  Name=N->GetNameVar();
  this->Measurements.push_back(Aux);       // Add New measurement
  this->Measurements.back().push_back(N);
  Index=this->Measurements.size()-1;
  N->MeasureIndex=Index;
  }
}//-----------------------------------------------------------------------------

void tree::Diff(void)
{
//  this->ToLatex("Tree.tex");
  node* Dx;
  this->Ders.resize(this->Vars.size());
  for(int i=0;i<this->Vars.size();i++)
  {
    this->Ders[i].resize(this->Vars[i].size());
    for(int j=0;j<this->Vars[i].size();j++)
     {Dx=this->Root->Diff(this->Vars[i][j],-1,"Local");
      Simplify(Dx);
      Simplify(Dx);
      this->Ders[i][j]=Dx;
     }
  }

}//-----------------------------------------------------------------------------

node* tree::Diff(string &VarName)
{
  node* Dx;
  int Index=this->GetVarIndex(VarName);

  Dx=this->Root->Diff(NULL,Index,"Global");
  Simplify(Dx);
  return Dx;
}//-----------------------------------------------------------------------------


ivalDb tree::EvaluateFunct(string& Mode,bool STOpt,bool CTOpt,iboolean &Consist,char Point)
{
   list<node*>::iterator Node;
   for (Node=this->FunctList.begin(); Node != this->FunctList.end(); Node++)
   {(*Node)->Evaluate(Mode,STOpt,CTOpt,Consist,Point);}

   this->Result=this->FunctList.back()->GetIval();
   return  this->FunctList.back()->GetIval();
}//-----------------------------------------------------------------------------

void tree::EvaluateDers(string &Mode)
{ list<node*>::iterator Node;
  bool MonoFlag;
  ivalDb MonoDom;

  for(int i=0;i<this->Vars.size();i++)
  {  MonoFlag=true;

    if(Mode=="Xi" && this->Vars[i][0]->IsProp()){} // No compute proper variables' monotony
    else
     {
       for(int j=0;j<this->Vars[i].size();j++)
       {
        if(MonoFlag && DersLists.size()>0)      // If not monotonic is not necessary to compute the other occurences
        {
          for(Node=this->DersLists[i][j].begin(); Node != this->DersLists[i][j].end(); Node++)
          {
           (*Node)->Evaluate("Der",false,false,itrue,'c');
          }

          MonoDom=DersLists[i][j].back()->GetIval();
          this->Vars[i][j]->SetMonoDom(MonoDom);
          if(IsIn(0,MonoDom))
             {MonoFlag=false;}
        }
        else {this->Vars[i][j]->SetMonoDom(Infinity());}
       }
     }
  }
}//-----------------------------------------------------------------------------

void tree::DeleteTree(void)
{
  DeleteNode(this->Root);

  if(this->Ders.size()>0)
  {
    for(int i=0;i<this->Ders.size();i++)
    {
       for(int j=0;j<this->Ders[i].size();j++)
       {
        DeleteNode(this->Ders[i][j]);
       }
    }
  }
}//-----------------------------------------------------------------------------

void tree::PrintTrees(void)
{ bool Symbolic=true;

  fstream fout;
  fout.open("Tree.txt",fstream::out);

  fout << "Function: ";
  this->Root->Print(fout,Symbolic); fout << endl;

  if(this->Ders.size()>0)
  {
    fout << "Derivatives: " << endl;
    for(int i=0;i<this->Vars.size();i++)
    {
       for(int j=0;j<this->Vars[i].size();j++)
       {
        fout << "df/" << this->NodeVars[i].GetNameVar() << "[" << j << "]: ";
        this->Ders[i][j]->Print(fout,Symbolic); fout << endl ;
       }
    }
  }
  fout.close();
}//-----------------------------------------------------------------------------

void tree::PrintLists(void)
{ list<node*>::iterator Node;
  bool Symbolic=true;

  fstream fout;
  fout.open("Lists.txt",fstream::out);

  fout << "Function list: " << endl;
  for (Node=this->FunctList.begin(); Node != this->FunctList.end(); Node++)
   {fout << *(*Node) << " ; ";}
  fout << endl;

  fout << "Derivatives Lists: " << endl;
  for(int i=0;i<this->Vars.size();i++)
  {
     for(int j=0;j<this->Vars[i].size();j++)
     {
       for(Node=this->DersLists[i][j].begin(); Node != this->DersLists[i][j].end(); Node++)
      {fout << *(*Node) << " ; ";}
      fout << endl;
     }
  }

  list<node*>::iterator Node1;
  fout << "Non Uniformaly Monotonic Nodes List: " << endl;
  for (Node=this->NonUnifMonoNodes.begin(); Node != this->NonUnifMonoNodes.end(); Node++)
   {
    for (Node1=(*Node)->GetNodesList().begin(); Node1 != (*Node)->GetNodesList().end(); Node1++)
    {fout << *(*Node1) << " ; ";}
    fout << endl;
    }
  fout << endl;
  
  fout.close();
}//-----------------------------------------------------------------------------

void tree::ConvertTreesToLists(void)
{
  this->Root->AddToList(this->FunctList);

  if(this->Ders.size()>0)
  {
    this->DersLists.resize(this->Vars.size());
    for(int i=0;i<this->Vars.size();i++)
    {
      this->DersLists[i].resize(this->Vars[i].size());
      for(int j=0;j<this->Vars[i].size();j++)
       {
        this->Ders[i][j]->AddToList(this->DersLists[i][j]);
       }
    }
  }
}//-----------------------------------------------------------------------------

// Select Non Uniformly Monotonic Nodes and Store to them their tree
void tree::AssignNonUnifNodes(void)
{
  this->Root->SelectNonUnifMonoNodes(this->NonUnifMonoNodes);

  list<node*>::iterator Node;
  for(Node=this->NonUnifMonoNodes.begin();Node!=this->NonUnifMonoNodes.end();Node++)
  {
     (*Node)->AddToList((*Node)->GetNodesList());
  }
}//-----------------------------------------------------------------------------

void tree::AssignTOptimality(void)
{
 if(this->NonUnifMonoNodes.empty() || this->UniModal)
 {this->TOptimal=true;}
 else {this->TOptimal=false;}
}//-----------------------------------------------------------------------------

bool tree::IsDomainTOptimal(void)
{
 bool Optimal=true;
 ivalDb Ival,LIval, RIval;
 string Type;

 if(this->NonUnifMonoNodes.empty())
 {Optimal=true;}
 else
 {
  list<node*>::iterator Node;
  for(Node=this->NonUnifMonoNodes.begin();Node!=this->NonUnifMonoNodes.end();Node++)
  {
   (*Node)->EvaluateNodesList();

   LIval=(*Node)->GetLNode()->GetIval();

   Type=(*Node)->GetType();

   if(Type=="sqr" || (Type=="pow" && FDLIBM::fmod(int((*Node)->GetConst()),2)==0))
   {
    if(IsIn(0,LIval))
      {Optimal=false;
       break;}
   }
   else if(Type=="cos" || Type=="sin")
   {
    if(Type=="sin") {LIval-PI05();}
    if(Width(LIval)>PI())
    {Optimal=false;
     break;}
    else
    {int klb,khb;
     if(LIval.Inf>0) {klb=Integer((LIval/PI()).Inf);}
     else {klb=Integer((LIval/PI()).Inf)-1;}
     if(LIval.Sup>0) {khb=Integer((LIval/PI()).Sup);}
     else {khb=Integer((LIval/PI()).Sup)-1;}
     ivalDb LBIval,HBIval;
     LBIval=LIval.GetInf()-klb*PI();
     HBIval=LIval.GetSup()-khb*PI();
     LIval.SetInf(LBIval.GetInf());
     LIval.SetSup(HBIval.GetSup());
     if(IsIn(PI(),LIval))
     {Optimal=false;
      break;}
    }

   }
   else if(Type=="tan")
   {
    if(Width(LIval)>PI05())
    {Optimal=false;
     break;}
    else
    {int klb,khb;
     if(LIval.Inf>=0) klb=int((LIval/PI05()).Inf);
     else klb=int((LIval/PI05()).Inf)-1;
     if(LIval.Sup>=0) khb=int((LIval/PI05()).Sup);
     else khb=int((LIval/PI05()).Sup)-1;
     ivalDb LBIval,HBIval;
     LBIval=LIval.GetInf()-klb*PI05();
     HBIval=LIval.GetSup()-khb*PI05();
     LIval.SetInf(LBIval.GetInf());
     LIval.SetSup(HBIval.GetSup());
     if(IsIn(PI05(),LIval))
     {Optimal=false;
      break;}
    }
   }

   else   // binari operators
   {
     if(IsIn(0,LIval))
     {Optimal=false;
      break;}
     else
     {RIval=(*Node)->GetRNode()->GetIval();
      if(IsIn(0,RIval))
       {Optimal=false;
        break;}
      else
      {
       if((LIval>=0 && RIval>=0) || (LIval<=0 && RIval<=0))
       {Optimal=true;}
       else
       {Optimal=false;
        break;}
      }
     }
   }
  } // End For

 } // End else
  return Optimal;
}//-----------------------------------------------------------------------------

int tree::GetVarIndex(string &NameVar)
{
  int Index;
  bool Match=false;
  int i=0;
  while(i<this->NodeVars.size() && !Match)
  {
   if(this->NodeVars[i].GetNameVar() == NameVar)
   {Index=i;
    Match=true;}
   i++;
  }
 return Index;
}//-----------------------------------------------------------------------------

// N(X)=X-F(X)/F'(X)
void tree::CreateBoxContractor(string &VarName)
{
  // Create F'(X)
  node* FX=this->Diff(VarName);
  //Simplify(FX);
  //Simplify(FX);
  FX->CreatreNewIncidences();

  // Create X
  node* NodeX=new node[1];
  incidence* Inc;
  int Index=GetVarIndex(VarName);
  *NodeX = this->NodeVars[Index];
  NodeX->GetPVars()->operator[](Index).push_back(Inc);
  NodeX->SetPInc(&NodeX->GetPVars()->operator[](Index).back());

  // Create X-F(X)/F'(X)
  node* AuxN=this->Root;

  node* DivisionN=new node[1];
  node* RestN=new node[1];

  DivisionN->SetType("/");
  RestN->SetType("-");

  DivisionN->SetLNode(AuxN);
  DivisionN->SetRNode(FX);

  RestN->SetLNode(NodeX);
  RestN->SetRNode(DivisionN);

  this->SetRoot(RestN);
}//-----------------------------------------------------------------------------


void tree::NormalizeConstraint(param& Pars)
{
   node* LNode;
   node* RNode;
   string Type=this->Root->GetType();

   if(Type=="=" || Type=="<=" || Type=="<" || Type==">=" || Type==">")
   {
     LNode=this->Root->GetLNode();
     RNode=this->Root->GetRNode();

     if(!RNode->GetIval().IsZero())
     {
       node* NLNode=new node[1];
       NLNode->AssignNameAuxVar();
       node* NRNode=new node[1];
       NLNode->SetType("-");
       NLNode->SetLNode(LNode);
       NLNode->SetRNode(RNode);
       Root->SetLNode(NLNode);
       NRNode->SetNameVar("const");
       NRNode->SetType("const");
       NRNode->SetIval(Zero());
       Root->SetRNode(NRNode);
     }
   }

//if(!Pars.GetContract())
{
   if(Type=="=")
   {
   /*
     node* ANode;
     ANode=Root;
     LNode=this->Root->GetLNode();
     RNode=this->Root->GetRNode();
     Root=LNode;
     delete [] ANode;
     delete [] RNode;
   */
     RNode=this->Root->GetRNode();
     Root->SetType("-");
     RNode->SetType("aux");
     RNode->SetIval(Ival(0,0));
     Pars.SetOptim(0);
   }

   else if(Type==">" || Type==">=")
    {
     RNode=this->Root->GetRNode();
     Root->SetType("-");
     RNode->SetType("aux");
     RNode->SetIval(Ival(PInfinity(),0));
     Pars.SetOptim(1);
    }
   else if(Type=="<" || Type=="<=")
    {
     RNode=this->Root->GetRNode();
     Root->SetType("-");
     RNode->SetType("aux");
     RNode->SetIval(Ival(0,MInfinity()));
     Pars.SetOptim(2);
    }
}
}//-----------------------------------------------------------------------------

void tree::Negate(void)
{
  if(this->Root->GetRNode()->GetType()=="aux")
  {ivalDb Ival=this->Root->GetRNode()->GetIval();
   this->Root->GetRNode()->SetIval(Impr(-Ival));
   Ival=this->Root->GetRNode()->GetIval();
  }
}//-----------------------------------------------------------------------------

void tree::AssignModes(bool Mode,param &Pars)
{
if(Mode)
{Pars.SetInclusion(1);}
else
{Pars.SetInclusion(2);}

if(this->Root->GetRNode()->GetType()=="aux")
{
 if(this->Root->GetRNode()->GetIval().GetInf()==PInfinity())
 {Pars.SetOptim(1);}
 else if(this->Root->GetRNode()->GetIval().GetInf()==MInfinity())
 {Pars.SetOptim(2);}
 else
{Pars.SetOptim(0);}
}
}//-----------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
// Operators                                                                  //
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Monary Operators and Functions                                             //
////////////////////////////////////////////////////////////////////////////////


/*##############################################################################
  Binary Operators
/#############################################################################*/


////////////////////////////////////////////////////////////////////////////////
// Auxiliar functions
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// I/O Stream Operators                                                       //
////////////////////////////////////////////////////////////////////////////////

ostream& operator<<(ostream & out, tree& T)
{return out;
}//-----------------------------------------------------------------------------


void tree::ToLatex(char * filename)
{
fstream fout;
fout.open(filename,fstream::out);

fout << "\\documentclass[a4paper,11pt]{article}" << endl;
fout << "\\usepackage[french]{babel}" << endl;
fout << "\\usepackage[T1]{fontenc}" << endl;
fout << "\\usepackage[latin1]{inputenc}" << endl;
fout << "\\usepackage{theorem}" << endl;
fout << "\\usepackage{amsfonts}" << endl;
fout << "\\usepackage[pdftex]{graphicx}" << endl;
fout << "\\usepackage{pst-all}" << endl;
fout << "\\psset{levelsep=20pt,nodesep=2pt,linecolor=blue}" << endl << endl;
fout << "\\begin{document}" << endl;

//fout << "\section(Objective Function)" << endl;

fout << "\\begin{tiny}" << endl;

this->Root->ToLatex(fout);

for(int i=0;i<this->Ders.size();i++)
{
//fout << "\section(Derivate)" << endl;

 for(int j=0;j<this->Ders[i].size();j++)
 {fout << "\\\\\\";
  this->Ders[i][j]->ToLatex(fout);
 }
}

fout << "\\end{tiny}" << endl;

fout << " \\end{document}" << endl;
fout.close();
}//-----------------------------------------------------------------------------


void tree::AssignStateMeasurements(void)
{
 deque<node*> Aux;
 string Kind,Name;
 int Index;

 for(int i=0;i<this->NodeVars.size();i++)
 {
  Kind=this->NodeVars[i].GetQuantified();
  if(Kind=="S")
   {this->StateVar=&this->NodeVars[i];
    this->StateVar->SetVarIndex(i);
    }
  else if(Kind=="M")
   {
    Name=this->NodeVars[i].GetNameVar();
    this->Measurements.push_back(Aux);
    this->Measurements.back().push_back(&this->NodeVars[i]);
    Index=this->Measurements.size()-1;
    this->NodeVars[i].MeasureIndex=Index;
    }
 }
}//-----------------------------------------------------------------------------


void tree::BuildWindowTree(int WindowLength)
{
 deque<node*> States;                                                      
 node* AuxNode;

 node* AuxRoot=Root->Copy();

 node* Node;
 for(int Step=2;Step<=WindowLength-1;Step++)
 {
  this->StateVar->GetPVars()->operator [](this->StateVar->GetVarIndex()).clear();  // Clear State Incidences

  States.clear();
  Root->FindStateNodes(States);           // Look for and store State Nodes

  for(int j=0;j<States.size();j++)
  {
   Node=AuxRoot->Replicate(Step,this->Measurements);
   string NameVar1=this->Measurements[0].front()->GetNameVar();
   *States[j]=*Node;}
 }
// DeleteNode(AuxRoot);
}//-----------------------------------------------------------------------------


//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// Constraint Propagation
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

void tree::InitializeNodes()
{
 list<node*>::iterator Node;
 for (Node=this->FunctList.begin(); Node != this->FunctList.end(); Node++)
 {
  if((*Node)->GetType()!="one" && (*Node)->GetType()!="const" && (*Node)->GetType()!="aux")
  {(*Node)->SetIval(Infinity());}
 }
}//-----------------------------------------------------------------------------

void tree::ForwardPropagation(fstream &fout,int &Counter,string &Mode)
{
// fout << "Forward Propagation" << endl << endl;

 list<node*>::iterator Node;
 for (Node=this->FunctList.begin(); Node != this->FunctList.end(); Node++)
 {
  (*Node)->EvaluateFPropagation(Mode);
//  (*Node)->PrintPrimitive(fout,Counter);
 }
// fout << endl << endl;
}//-----------------------------------------------------------------------------


void tree::BackwardPropagation(fstream &fout,int &Counter)
{
// fout << "Backward Propagation" << endl << endl;

 list<node*>::reverse_iterator Node;
 for (Node=this->FunctList.rbegin(); Node != this->FunctList.rend(); Node++)
 {
  if((*Node)->GetType()!="var" && (*Node)->GetType()!="const" && (*Node)->GetType()!="aux")
  {
  (*Node)->EvaluateBPropagation();
//  (*Node)->PrintPrimitive(fout,Counter);
  Counter--;
  Counter--;
  }
 }

//  fout << endl << endl;
}//-----------------------------------------------------------------------------

