

#ifndef COLORHLS_H
#define COLORHLS_H

class TColorHLS {
private:

public:

  double Hue;         // 0.0 .. 360.0  // angle
  double Luminance;   // 0.0 .. 1.0    // percent
  double Saturation;  // 0.0 .. 1.0    // percent
  int  Red;
  int  Green;
  int  Blue;

  TColorHLS();
  TColorHLS(int r, int g, int b);
  TColorHLS(double hue, double luminance, double saturation);

  // RGB - functions
  //
  void  SetRed(int red);     // 0..255
  void  SetGreen(int green); // 0..255
  void  SetBlue(int blue);   // 0..255
  void  SetRGB(int red, int green, int blue);
  // HLS - functions
  //
  void  SetHue(double hue);               // 0.0 .. 360.0
  void  SetLuminance(double lumi);   // 0.0 .. 1.0
  void  SetSaturation(double sat); // 0.0 .. 1.0
  void  SetHLS(double hue, double luminance, double saturation);
  double GetHue() const;        // 0.0 .. 360.0
  double GetLuminance() const;  // 0.0 .. 1.0
  double GetSaturation() const; // 0.0 .. 1.0

  friend TColorHLS RGBToHLS(int r, int g, int b);
  friend int HLSToRGB(const TColorHLS& colorHLS);

};


// ************************** inlines *****************************************
//long GetTcolor(const TColorHLS& cl);


#endif
