//----------------------------------------------------------------------------
//  Project Colorhls
//  
//  Copyright  1999. All Rights Reserved.
//
//  SUBSYSTEM:    Colorhls Application
//  FILE:         colorhlsapp.cpp
//  AUTHOR:       Dieter Windau
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TColorhlsApp (TApplication).
//
//----------------------------------------------------------------------------
#include <owl/pch.h>

#include <stdio.h>

#include "colorhlsapp.h"
#include "colorhlsdlgclient.h"

//{{TColorhlsApp Implementation}}

//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TColorhlsApp, TApplication)
//{{TColorhlsAppRSP_TBL_BEGIN}}
  EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
//{{TColorhlsAppRSP_TBL_END}}
END_RESPONSE_TABLE;

//--------------------------------------------------------
// TColorhlsApp
//
TColorhlsApp::TColorhlsApp() : TApplication(_T("Colorhls"))
{
  // INSERT>> Your constructor code here.
}

TColorhlsApp::~TColorhlsApp()
{
  // INSERT>> Your destructor code here.
}

//--------------------------------------------------------
// TColorhlsApp
// ~~~~~
// Application intialization.
//
void TColorhlsApp::InitMainWindow()
{
  if (nCmdShow != SW_HIDE)
    nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  TSDIDecFrame* frame = new TSDIDecFrame(0, GetName(), 0, false);
  frame->SetFlag(wfShrinkToClient);
  frame->ModifyStyle(WS_THICKFRAME,0);

  // Assign icons for this application.
  //
  frame->SetIcon(this, IDI_SDIAPPLICATION);
  frame->SetIconSm(this, IDI_SDIAPPLICATION);

  SetMainWindow(frame);
}

//{{TSDIDecFrame Implementation}}

TSDIDecFrame::TSDIDecFrame(TWindow* parent, LPCTSTR title,
  TWindow* clientWnd, bool trackMenuSelection, TModule* module)
:
  TDecoratedFrame(parent, title, !clientWnd ? new TColorhlsDlgClient(
    (TWindow*)0) : clientWnd, trackMenuSelection, module)
{
  // INSERT>> Your constructor code here.
}

TSDIDecFrame::~TSDIDecFrame()
{
  // INSERT>> Your destructor code here.
}

//--------------------------------------------------------
// TColorhlsApp
// ~~~~~~~~~~~
// Menu Help About Colorhls command
//
void TColorhlsApp::CmHelpAbout()
{
}

int OwlMain(int, LPTSTR [])
{
  TColorhlsApp   app;
  return app.Run();
}

void TColorhlsApp::InitInstance()
{
  TApplication::InitInstance();

  // INSERT>> Your code here.
  int caps = TWindowDC(GetMainWindow()->HWindow).GetDeviceCaps(RASTERCAPS);
  if ((caps & RC_PALETTE) == RC_PALETTE)
  {
#if (OWLInternalVersion >= 0x06000000L)
    owl_string str = LoadString(IDS_PALETTE_NOT_SUPPORTED);
#else
    string str = LoadString(IDS_PALETTE_NOT_SUPPORTED);
#endif
    GetMainWindow()->MessageBox(str.c_str());
  }
}

