//----------------------------------------------------------------------------
//  Project Colorhls
//
//  Copyright  1999. All Rights Reserved.
//
//  SUBSYSTEM:    Colorhls Application
//  FILE:         colorhlsdlgclient.h
//  AUTHOR:       Dieter Windau
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TColorhlsDlgClient (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(colorhlsdlgclient_h)
#define colorhlsdlgclient_h

#include "colorhlsapp.rh"


#include <owl/commctrl.h>
#if !defined(OWL_SLIDER_H)
#include <owl/slider.h>
#endif
#if !defined(OWL_STATIC_H)
#include <owl/static.h>
#endif

//{{TDialog = TColorhlsDlgClient}}

class TColorhlsDlgClient : public TDialog
{
  public:
    TColorhlsDlgClient(TWindow* parent, TResId resId = IDD_CLIENT,
      TModule* module = 0);
    virtual ~TColorhlsDlgClient();

//{{TColorhlsDlgClientVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{TColorhlsDlgClientVIRTUAL_END}}

  protected:
    THSlider*  HSlider;
    THSlider*  LSlider;
    THSlider*  SSlider;
    TStatic*   RGBStatic;
    TStatic*   HLSStatic;
    TRect      CircleRect;
    TMemoryDC* HiddenDC;
    TBitmap*   HiddenBitmap;

  protected:
    void DrawColorCircle(TDC& dc);

    void UpdateColorInformation(TColor color);

//{{TColorhlsDlgClientRSP_TBL_BEGIN}}
  protected:
    bool EvEraseBkgnd(HDC dc);
    void EvHScroll(uint scrollCode, uint thumbPos, THandle hWndCtl);
    void EvPaint();
    void EvMouseMove(uint modKeys, TPoint& point);
    void BNClicked();
//{{TColorhlsDlgClientRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TColorhlsDlgClient);
};    //{{TColorhlsDlgClient}}

#endif  // colorhlsdlgclient_h sentry.
