const double PI_1 = N_PI;
const double PI_2 = N_PI_05;
const double TROIS_PI_2 = 3*N_PI_05;
const double CINQ_PI_2 = 5*N_PI_05;
const double SEPT_PI_2 = 7*N_PI_05;
const double DEUX_PI = 4*N_PI_05;


////////////////////////////////////////////////////////////////////////////////
// Primitive Constraints                                                      //
////////////////////////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------
// Auxiliary Functions
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
bool In(double a,const ivalDb& b)
{   //if (b.isEmpty) return false;
    //ivalDb z=Inflate(b,1e-6);
    //return (z.Inf<=a && a<=z.Sup);
    return (b.Inf<=a && a<=b.Sup);
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
iboolean In(const ivalDb& F, const ivalDb& Y)
{
//return IsIn(F,Y);
//    if (Disjoint (F,Y)) return false;
//    if (Subset   (F,Y)) return true;
//    return iboolean(iperhaps);
}//-----------------------------------------------------------------------------

ivalDb Pow (const ivalDb& x, int num, int den)
/* [x]^(num/den) */
{    if (x.isEmpty) return ivalDb();
     if (num*den>0)
        { double a1=min(x.Inf,x.Sup), a2=max(x.Inf,x.Sup);
          double n=num, m=den;
          if (den%2==0)
             { if ((a1>=0)||(a1*a2<=0))
                   return ivalDb(-FDLIBM::pow(a2,n/m),FDLIBM::pow(a2,n/m));
               else return ivalDb();
             }
          else
             { if (a1*a2<=0)
                  return ivalDb(-FDLIBM::pow(FDLIBM::fabs(a1),n/m),FDLIBM::pow(a2,n/m));
               if (a1>0) return ivalDb(FDLIBM::pow(a1,n/m),FDLIBM::pow(a2,n/m));
               else return ivalDb(-FDLIBM::pow(FDLIBM::fabs(a1),n/m),-FDLIBM::pow(FDLIBM::fabs(a2),n/m));
             }
        }
     else return ivalDb(1.0)/Pow(x,FDLIBM::fabs(num),FDLIBM::fabs(den));
}
//----------------------------------------------------------------------

ivalDb PowRoot (const ivalDb& x, int num, int den)
/* [x]^(num/den) */
{    if (x.isEmpty) return ivalDb();
     if (num*den>0)
        { double a1=min(x.Inf,x.Sup), a2=max(x.Inf,x.Sup), n=num, m=den;
          if (den%2==0)
             { if (a1>=0) return ivalDb(FDLIBM::pow(a1,n/m),FDLIBM::pow(a2,n/m));
               if (a1*a2<=0) return ivalDb(0,FDLIBM::pow(a2,n/m));
               else return ivalDb(); }
          else
             { if (a1*a2<=0) return ivalDb(-FDLIBM::pow(FDLIBM::fabs(a1),n/m),FDLIBM::pow(a2,n/m));
               if (a1>0) return ivalDb(FDLIBM::pow(a1,n/m),FDLIBM::pow(a2,n/m));
               else return ivalDb(-FDLIBM::pow(FDLIBM::fabs(a1),n/m),-FDLIBM::pow(FDLIBM::fabs(a2),n/m)); }
        }
     else return ivalDb(1.0)/Pow(x,abs(num),abs(den));
}
//----------------------------------------------------------------------

//----------------------------------------------------------------------
// Unary Constraints
//----------------------------------------------------------------------

//----------------------------------------------------------------------
// Integer Constraint
//----------------------------------------------------------------------
void Cinteger(ivalDb& X)
{ ivalDb A1(FDLIBM::ceil(X.Inf),FDLIBM::floor(X.Sup));
  X=Meet(X,A1);
}//-----------------------------------------------------------------------------

//----------------------------------------------------------------------
// Boolean Constraint
//----------------------------------------------------------------------
void Cboolean(ivalDb& X)
{ ivalDb nul(0), one(1);
  ivalDb A1=Meet(nul,X);
  ivalDb A2=Meet(one,X);
  ivalDb A=Join(A1,A2);
  X=Meet(X,A);
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Binary Constraints
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Y=sin(X)    =>  sens=1;
// X=sin-1(Y)  =>  sens=-1;
//------------------------------------------------------------------------------
void Csin(ivalDb& Y, ivalDb& X, int sens)
{
if (sens==1)
 {Y=Meet(Y,sin(X));}

if (sens==-1)
{
  Y=Meet(Y, ivalDb(-1,1));
  //ivalDb Y1=Meet(Inflate(Y,1e-5), ivalDb(-1,1));
  ivalDb Y1=Meet(Y, ivalDb(-1,1));

  double amoins=-999, aplus=-999,
  hmoins=FDLIBM::asin(Y1.Inf), hplus=FDLIBM::asin(Y1.Sup);
  int k;

 if (In(FDLIBM::sin(X.Inf),Y1)) {amoins=X.Inf;}
 else  { // calcul de a-
         k=FDLIBM::ceil((X.Inf-hmoins)/DEUX_PI);
         amoins=hmoins+(k*DEUX_PI);
         k=FDLIBM::ceil((X.Inf+hmoins-PI_1)/DEUX_PI);
         amoins=min(amoins, PI_1-hmoins+(k*DEUX_PI));
         k=FDLIBM::ceil((X.Inf-hplus)/DEUX_PI);
         amoins=min(amoins, hplus+(k*DEUX_PI));
         k=FDLIBM::ceil((X.Inf+hplus-PI_1)/DEUX_PI);
         amoins=min(amoins, PI_1-hplus+(k*DEUX_PI));
        }
  if (amoins>X.Sup) {X=ivalDb();}
  else
   { if (In(FDLIBM::sin(X.Sup),Y1)) {aplus=X.Sup;}
     else {//calcul de a+
           k=FDLIBM::floor((X.Sup-hmoins)/DEUX_PI);
           aplus=hmoins+(k*DEUX_PI);
           k=FDLIBM::floor((X.Sup+hmoins-PI_1)/DEUX_PI);
           aplus=max(aplus, PI_1-hmoins+(k*DEUX_PI));
           k=FDLIBM::floor((X.Sup-hplus)/DEUX_PI);
           aplus=max(aplus, hplus+(k*DEUX_PI));
           k=FDLIBM::floor((X.Sup+hplus-PI_1)/DEUX_PI);
           aplus=max(aplus, PI_1-hplus+(k*DEUX_PI));
           }
   }
  X=Meet(X, ivalDb(amoins,aplus));}
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Y=Cos(X)    =>  sens=1;
// X=Cos-1(Y)  =>  sens=-1;
//------------------------------------------------------------------------------
void Ccos(ivalDb& Y, ivalDb& X, int sens)
{ if (sens==1)  {Y=Meet(Y, cos(X));}
  if (sens==-1) {ivalDb X0=X+PI_2; Csin(Y,X0,-1); X=Meet(X,X0-PI_2);}
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Y=sinc(X)=sin(X)/X      =>  sens=1;
// X=sinc-1(X)             =>  sens=-1;
//------------------------------------------------------------------------------
void Csinc(ivalDb& Y, ivalDb& X, int sens)
{
/*
 ivalDb Z(-oo,oo);
  if (sens==1)   { ivalDb U(-oo,oo), V(-oo,oo), W(-oo,oo);
                   ivalDb un(1);
                   Csqr(U,X,1); Cmoins(V,U,1); Cplus(W,V,un,1);
                   Y=Meet(Y,ivalDb(-0.3,1));
                   if (!W.isEmpty) Y=Meet(Y,ivalDb(W.Inf,oo));
                   Csin(Z,X,1); Cdiv(Y,Z,X,1); }
  if (sens==-1) { Cdiv(Y,Z,X,-1); Csin(Z,X,-1);}
*/
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Y=Exp(X)           =>  sens=1;
// X=EXP-1(Y)=Log(Y)  =>  sens=-1;
//------------------------------------------------------------------------------
void Cexp(ivalDb& Y, ivalDb& X, int sens)
{ if (sens==1)  {Y=Meet(Y,exp(X));}
  if (sens==-1) {X=Meet(X,log(Y));}
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Y=log(X)           =>  sens=1;
// X=log-1(Y)=Exp(Y)  =>  sens=-1;
//------------------------------------------------------------------------------
void Clog(ivalDb& Y, ivalDb& X, int sens)
{ if (sens==1)  {Y=Meet(Y,log(X));}
  if (sens==-1) {X=Meet(X,exp(Y));}
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Y=Tan(X)           =>  sens=1;
// X=Tan-1(Y)=Atan(Y)  =>  sens=-1;
//------------------------------------------------------------------------------
void Ctan(ivalDb& Y, ivalDb& X, int sens)
{ if (sens==1)
  {Y=Meet(Y,tan(X));}

  if (sens==-1)
  {
    double amoins=-999, aplus=-999;
    ivalDb AtanY=atan(Y);
    double hmoins=AtanY.Inf;
    double hplus=AtanY.Sup;

    if(In(FDLIBM::tan(X.Inf),Y)) amoins=X.Inf;
    else amoins=hmoins+(FDLIBM::ceil((X.Inf-hmoins)/PI_1)*PI_1);

    if (amoins>X.Sup) X=ivalDb();
    else { if (In(FDLIBM::tan(X.Sup),Y)) aplus=X.Sup;
           else aplus=hplus+(FDLIBM::floor((X.Sup-hplus)/PI_1)*PI_1); }
     X=Meet(X,ivalDb(amoins,aplus));
  }
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Y=atan(X)                  =>  sens=1;
// X=atan-1(Y)=tan(Y)         =>  sens=-1;
//------------------------------------------------------------------------------
void Catan(ivalDb& Y, ivalDb& X, int sens)
{ Ctan(X,Y,-sens);
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Y=sqr(X)           =>  sens=1;
// X=sqr-1(Y)         =>  sens=-1;
//------------------------------------------------------------------------------
void Csqr(ivalDb& Y, ivalDb& X, int sens)
{
   ivalDb Yd, Yg;
   ivalDb Xd=Meet(X, ivalDb(0,oo));
   ivalDb Xg=Meet(X,ivalDb(-oo,0));
   if (!Xd.isEmpty)
    {Xd=Meet(Xd,sqrt(Y));  Yd=Meet(Y,sqr(Xd));}
   if (!Xg.isEmpty)
    {Xg=Meet(Xg,-sqrt(Y)); Yg=Meet(Y,sqr(Xg));}
   if (sens==1)     {Y=Meet(Y,Join(Yd,Yg));}
   else             {X=Meet(X,Join(Xd,Xg));}
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Y=sqrt(X)           =>  sens=1;
// X=sqrt-1(Y)         =>  sens=-1;
//------------------------------------------------------------------------------
void Csqrt(ivalDb& Y, ivalDb& X, int sens)
{ if (sens==1) Y=Meet(Y,sqrt(X));
  if (sens==-1) Csqr(X,Y,-sens);
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
//   Y=Power(X,n)        =>   sens=1;
//   X=Power(Y,1/n)      =>   sens=-1;
//------------------------------------------------------------------------------
void Cpower(ivalDb& Y, ivalDb& X, int n, int sens)
{
  if (n>0)
      { ivalDb Yd, Yg;
        ivalDb Xd=Meet(X,ivalDb(0,oo)), Xg=Meet(X,ivalDb(-oo,0));

        if(!Xd.isEmpty)
                  { Xd=Meet(Xd,PowRoot(Y,1,n));
                    Yd=Meet(Y,pow(Xd,n)); }

        if(!Xg.isEmpty)
                   { if (n%2==0) Xg=Meet(Xg,-PowRoot(Y,1,n));
                     else Xg=Meet(Xg,PowRoot(Y,1,n));
                     Yg=Meet(Y,pow(Xg,n)); }

        if (sens==1)  Y=Meet(Y,Join(Yd,Yg));
        else X=Meet(X,Join(Xd,Xg));  }

   else { ivalDb Z=pow(X,FDLIBM::fabs(n)), I(1);
          if (sens==1) { Cpower(Z,X,FDLIBM::fabs(n),1); Cdiv(Y,I,Z,1); }
          else { Cdiv(Y,I,Z,-1); Cpower(Z,X,FDLIBM::fabs(n),-1); }
        }
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Y=-X           =>  sens=1;
// X=-Y           =>  sens=-1;
//------------------------------------------------------------------------------
void Cmoins(ivalDb& Y, ivalDb& X, int sens)
{if (sens==1)  Y=Meet(Y,-X);
 if (sens==-1) X=Meet(X,-Y);
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Y=X           =>  sens=1;
// X=Y           =>  sens=-1;
//------------------------------------------------------------------------------
void Cegal(ivalDb& Y, ivalDb& X, int sens)
{if (sens==1)   Y=Meet(Y,X);
 if (sens==-1)  X=Meet(X,Y);
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Y=|X|=max(X,-X)     =>     sens=1
// X=Abs-1(Y)          =>     sens=-1
//------------------------------------------------------------------------------
void Cabs (ivalDb& Y, ivalDb& X, int sens)
{  ivalDb Xd=Meet(X, ivalDb(0,oo)), Xg=Meet(X,ivalDb(-oo,0));
   if (sens==1)  { ivalDb Yd=Meet(Y,Xd), Yg=Meet(Y,-Xg); Y=Join(Yd,Yg);}
   else          { Xd=Meet(Xd,Y); Xg=Meet(Xg,-Y); X=Join(Xd,Xg);}
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
/*
  Y=step(X)=1 if X.Inf>a
            =0 if X.Sup<a
            =[0,1] if X.Inf=<a<=X.Sup   =>  sens=1

   X=step-1(Y)=Empty if Meet(Y,[0,1])=Empty
              =Empty if X.Sup<a & 0 not in Y
              =Empty if X.Inf>a & 1 not in Y
              =X if X.Sup<a & 0 in Y
              =X if X.Inf>a & 1 in Y
              =X if X.Inf=<a<=X.Sup   =>  sens=-1
*/
//------------------------------------------------------------------------------
void Cstep(ivalDb& Y, ivalDb& X, int sens, double a)
{
  ivalDb Z=Meet(ivalDb(0),Y);
  ivalDb W=Meet(ivalDb(1),Y);
  if (sens==1)
      { ivalDb U=Join(Z,W);
        if (X.isEmpty) Y=X;
            else {  if (Z.isEmpty && W.isEmpty) Y=Z;
                    else { Y=Meet(Y,Join(Z,W));
                           if (X.Inf>=a)  Y=Meet(Y,ivalDb(1));
                           else if (X.Sup<a) Y=Meet(Y,ivalDb(0)); }
                 }
       }
   if (sens==-1)
      {
        if (Z.isEmpty && W.isEmpty) X=Y=Z;
           else { if ((!Z.isEmpty)&&(!W.isEmpty)) X=Meet(X,ivalDb(-oo,oo));
                  if (Z.isEmpty) X=Meet(X,ivalDb(0,oo));
                  if (W.isEmpty) X=Meet(X,ivalDb(-oo,0)); }
      }
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
void Crect(ivalDb& Y, ivalDb& X, int sens)
{ ivalDb V(1);
  Crect(Y,X,V,sens);
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Ternary Constraints
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
void Crect(ivalDb& Z, ivalDb& X, ivalDb& Y, int sens)
{ ivalDb A1(-oo,oo), A2(-oo,oo), A3(-oo,oo), A4(-oo,oo), deux(2);
  X=Meet(X,ivalDb(0,oo));
  ivalDb aire=Y/deux;
  if (sens==1)
     { A1=Meet(A1,X+aire); Cstep(A2,A1,1);
       A3=Meet(A3,X-aire); Cstep(A4,A3,1);
       Z=Meet(Z,A2-A4); }
  if (sens==-1)
     { A2=Meet(A2,ivalDb(0,1)); A4=Meet(A4,ivalDb(0,1));
       A2=Meet(A2,Z+A4); A4=Meet(A4,A2-Z);
       Cstep(A2,A1,-1); Cplus(A1,X,aire,-1); Y=Meet(Y,deux*aire);
       aire=Meet(aire,Y/deux); Cstep(A4,A3,-1); Cmoins(A3,X,aire,-1);
       Y=Meet(Y,deux*aire);
     }
}//-----------------------------------------------------------------------------


//------------------------------------------------------------------------------
/* Z=Y+X         =>  sens=1;
   Y=Z-X; X=Z-Y  =>  sens=-1; */
//------------------------------------------------------------------------------
void Cplus(ivalDb& Z, ivalDb& Y, ivalDb& X, int sens)
{ if (sens==1)  {Z=Meet(Z,Y+X);}
  if (sens==-1) {Y=Meet(Y,Z-X); X=Meet(X,Z-Y);}
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
/* Z=Y-X           =>  sens=1;
   Y=Z+X; X=Y-Z    =>  sens=-1; */
//------------------------------------------------------------------------------
void Cmoins(ivalDb& Z, ivalDb& Y, ivalDb& X, int sens)
{ if (sens==1)  {Z=Meet(Z,Y-X);}
  if (sens==-1) {Y=Meet(Y,Z+X); X=Meet(X,Y-Z);}
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
/*  Z=Y*X           =>  sens=1;
   Y=Z/X; X=Z/Y    =>  sens=-1;  */
//------------------------------------------------------------------------------
void Cprod(ivalDb& Z, ivalDb& Y, ivalDb& X, int sens)
{ if (sens==1)  {Z=Meet(Z,Y*X);}
  if (sens==-1) {

if (In(0,Z)==false)
{
  ivalDb Xd, Xg;
  ivalDb Yd, Yg;
  Yg=Meet(Y,ivalDb(-oo,0)), Yd=Meet(Y,ivalDb(0,oo));
  Xg=Meet(X,ivalDb(-oo,0)), Xd=Meet(X,ivalDb(0,oo));

  if (Z.Inf>0)
  {
        if (  Xd.Sup*Yd.Sup<Z.Inf)
        {
        Xd=ivalDb();
        Yd=ivalDb();
        }
        else
        {
                if ((Xd.Sup!=0)&&(Yd.Sup!=0))
                {
                        Xd=Meet(Xd,ivalDb(Z.Inf/Yd.Sup,oo));
                        Yd=Meet(Yd,ivalDb(Z.Inf/Xd.Sup,oo));
                }
        }
        if (  Xg.Inf*Yg.Inf<Z.Inf)
        {
                Xg=ivalDb();
                Yg=ivalDb();
        }
        else
        {       if ((Xg.Inf!=0)&&(Yg.Inf!=0))
                {
                        Xg=Meet(Xg,ivalDb(Z.Inf/Yg.Inf,-oo));
                        Yg=Meet(Yg,ivalDb(Z.Inf/Xg.Inf,-oo));
                }
        }
  X=Meet(X,Join(Xd,Xg));
  Y=Meet(Y,Join(Yd,Yg));
  }
  if (Z.Sup<0)
  {
        if (  Xg.Inf*Yd.Sup>Z.Sup)
        {
                Xg=ivalDb();
                Yd=ivalDb();
        }
        else
        {
                if ((Xg.Inf!=0)&&(Yd.Sup!=0))
                {
                        Xg=Meet(Xg,ivalDb(Z.Sup/Yd.Sup,-oo));
                        Yd=Meet(Yd,ivalDb(Z.Sup/Xg.Inf,oo));
                }
        }
        if (  Xd.Sup*Yg.Inf>Z.Sup)
        {
                Xd=ivalDb();
                Yg=ivalDb();
        }
        else
        {
                if ((Xd.Sup!=0)&&(Yg.Inf!=0))
                {
                        Xd=Meet(Xd,ivalDb(Z.Sup/Yg.Inf,oo));
                        Yg=Meet(Yg,ivalDb(Z.Sup/Xd.Sup,-oo));
                }
        }
        X=Meet(X,Join(Xd,Xg));
        Y=Meet(Y,Join(Yd,Yg));
  }
}

  Y=Meet(Y,Z/X); X=Meet(X,Z/Y); //Y=Meet(Y,Z/X);
                }
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Z=Y/X           =>  sens=1;
// Y=Z*X; X=Y/Z    =>  sens=-1;
//------------------------------------------------------------------------------
void Cdiv(ivalDb& Z, ivalDb& Y, ivalDb& X, int sens)
{ if (sens==1)   Z=Meet(Z,Y/X);
  if (sens==-1) {Y=Meet(Y,Z*X); X=Meet(X,Y/Z);}
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
/* a=min(b,c)                       =>  sens=1;
   b=min-1(a,c); c=min-1(a,b)       =>  sens=-1; */
//------------------------------------------------------------------------------
void Cmin (ivalDb& a, ivalDb& b, ivalDb& c, int sens)
{   if ((a.isEmpty||b.isEmpty)||c.isEmpty) a=b=c=ivalDb();
    if (sens==1)   { a=Meet(a,min(b,c)); }
    if (sens==-1)  { if (Disjoint(a,b)) c=Meet(c,a);
                     else     {if (Disjoint(a,c)) b=Meet(b,a);}
                     ivalDb temp(a.Inf,oo);
                     b=Meet(b,temp); c=Meet(c,temp);}
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
/* a=max(b,c)                       =>  sens=1;
   b=max-1(a,c); c=max-1(a,b)       =>  sens=-1; */
//------------------------------------------------------------------------------
void Cmax (ivalDb& a, ivalDb& b, ivalDb& c, int sens)
{   if (sens==1)   { a=Meet(a,max(b,c)); }
    if (sens==-1)  { if (Disjoint(a,b)) c=Meet(c,a);
                     else { if (Disjoint(a,c)) b=Meet(b,a);}
                                ivalDb temp(-oo,a.Sup);
                                b=Meet(b,temp); c=Meet(c,temp);}
}//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------
//             PROCEDURES DE CONTRACTION ELEMENTAIRE
//-----------------------------------------------------------------------
/* Ceci est le code choisit pour dsigns chacune des fontions lementaires
ABS    <=>   'B'   ?
COS    <=>   'C'
SIN    <=>   'S'
TAN    <=>   'T'
ATAN   <=>   'A'     ?
EXP    <=>   'E'
LOG    <=>   'L'      ?
SQR    <=>   '2'
SQRT   <=>   'R'
MAX    <=>   'M'       ?
MIN    <=>   'm'       ?
POWER  <=>   'P'
-Unaire <=>  '_'
Integer <=>  'z'        ?
Boolean <=>  'b'        ?
door
rect
step
sinC
*/
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
void Contract0 (char code, ivalDb& Y)
{  if (code=='b')    {Cboolean(Y);    return;}
   if (code=='z')    {Cinteger(Y);   return;}
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
   /* Procdure de propagation de contraintes binaires sur les
     ivalDbles, cette procdure est charge de faire appel  une
     des fonctions binaires.
     exemple:  Y=sin(X)     =>   Contract0('S',Y,X,1)
               X=sin-1(Y)   =>   Contract0('S',Y,X,-1) */
//------------------------------------------------------------------------------
void Contract0 (char code, ivalDb& Y, ivalDb& X, int sens)
{  if (code=='S')   {Csin(Y,X,sens);     return;}
   if (code=='C')   {Ccos(Y,X,sens);     return;}
   if (code=='E')   {Cexp(Y,X,sens);     return;}
   if (code=='T')   {Ctan(Y,X,sens);     return;}
   if (code=='2')   {Csqr(Y,X,sens);     return;}
   if (code=='R')   {Csqrt(Y,X,sens);    return;}
   if (code=='L')   {Clog(Y,X,sens);     return;}
   if (code=='A')   {Catan(Y,X,sens);    return;}
   if (code=='_')   {Cmoins(Y,X,sens);   return;}
   if (code=='=')   {Cegal(Y,X,sens);    return;}
   if (code=='B')   {Cabs(Y,X,sens);     return;}
   if (code=='D')   {Crect(Y,X,sens);    return;}
   if (code=='s')   {Csinc(Y,X,sens);     return;}
   if (code=='B')   {Cpower(Y,X,2,sens); return;}
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
   /* Procdure de propagation de contraintes ternaires sur les
     ivalDbles, cette procdure est charge de faire appel aux
     fonctions ternaires.
     exemple:  Z=Y+X         =>  Contract0('+',Z,Y,X,1)
               Y=Z-X; X=Z-Y  =>  Contract0('+',Z,Y,X,-1) */

//------------------------------------------------------------------------------
void Contract0 (char code, ivalDb& Z, ivalDb& Y, ivalDb& X, int sens)
{  if (code=='+')    {Cplus(Z,Y,X,sens);    return;}
   if (code=='-')    {Cmoins(Z,Y,X,sens);   return;}
   if (code=='*')    {Cprod(Z,Y,X,sens);    return;}
   if (code=='/')    {Cdiv(Z,Y,X,sens);     return;}
   if (code=='m')    {Cmin(Z,Y,X,sens);     return;}
   if (code=='M')    {Cmax(Z,Y,X,sens);     return;}
}//-----------------------------------------------------------------------------

/*
//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
void ShowContraction (ivalDb& Xcd,ivalDb& Xcg,ivalDb& X,ivalDb& Xc)
{
if (Xc.isEmpty) {Xcd=Xcg=Xc; return;}
Xcd=ivalDb(X.Inf,Xc.Inf);
Xcg=ivalDb(Xc.Sup,X.Sup);
}//-----------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
void IntButterfly (ivalDb& Y,ivalDb Yo,ivalDb dY,ivalDb& X,ivalDb Xo,int sens)
{
ivalDb z1(-oo,+oo);
ivalDb z2(-oo,+oo);

Cmoins(z1,X,Xo,1);
Cprod(z2,dY,z1,1);
Cplus(Y,Yo,z2,1);

Cplus(Y,Yo,z2,-1);
Cprod(z2,dY,z1,-1);
Cmoins(z1,X,Xo,-1);
}//-----------------------------------------------------------------------------
*/

     /*
     if(this->Type== "+" ) this->Ival=this->LNode->Ival + this->RNode->Ival;
     else if(this->Type== "-" ) this->Ival=this->LNode->Ival - this->RNode->Ival;
     else if(this->Type== "*" ) this->Ival=this->LNode->Ival * this->RNode->Ival;
     else if(this->Type== "/" ) this->Ival=this->LNode->Ival / this->RNode->Ival;
     else if(this->Type== "=" ) this->Ival=this->LNode->Ival && this->RNode->Ival;
     else if(this->Type== "^" ) this->Ival=this->LNode->Ival^this->Const;
     else if(this->Type== ">=" ) this->Ival=this->LNode->Ival - ivalDb(PInfinity(),0);
     else if(this->Type== "<=" ) this->Ival=this->LNode->Ival - ivalDb(0,MInfinity());
     else if(this->Type== ">" ) this->Ival=this->LNode->Ival - ivalDb(PInfinity(),0);
     else if(this->Type== "<" ) this->Ival=this->LNode->Ival - ivalDb(0,MInfinity());
     else if(this->Type== "min" ) this->Ival=min(this->LNode->Ival,this->RNode->Ival);
     else if(this->Type== "max" ) this->Ival=max(this->LNode->Ival,this->RNode->Ival);
     */


     /*
     if(this->Type== "exp" ) this->Ival=exp(this->LNode->Ival);
     else if(this->Type== "log" ) this->Ival=log(this->LNode->Ival);
     else if(this->Type== "Abs" ) this->Ival=abs(this->LNode->Ival);
     else if(this->Type== "pow" ) this->Ival=pow(this->LNode->Ival,this->Const);
     else if(this->Type== "sqr" ) this->Ival=sqr(this->LNode->Ival);
     else if(this->Type== "sqrt" ) this->Ival=sqrt(this->LNode->Ival);
     else if(this->Type== "cbrt" ) this->Ival=cbrt(this->LNode->Ival);
     else if(this->Type== "root" ) this->Ival=root(this->LNode->Ival,this->Const);
     else if(this->Type== "cos" ) this->Ival=cos(this->LNode->Ival);
     else if(this->Type== "sin" ) this->Ival=sin(this->LNode->Ival);
     else if(this->Type== "tan" ) this->Ival=tan(this->LNode->Ival);
     else if(this->Type== "acos" ) this->Ival=acos(this->LNode->Ival);
     else if(this->Type== "asin" ) this->Ival=asin(this->LNode->Ival);
     else if(this->Type== "atan" ) this->Ival=atan(this->LNode->Ival);
     else if(this->Type== "cosh" ) this->Ival=cosh(this->LNode->Ival);
     else if(this->Type== "sinh" ) this->Ival=sinh(this->LNode->Ival);
     else if(this->Type== "tanh" ) this->Ival=tanh(this->LNode->Ival);
     else if(this->Type== "log10" ) this->Ival=log10(this->LNode->Ival);
     else if(this->Type== "sign" ) this->Ival=sign(this->LNode->Ival);
     else if(this->Type== "step" ) this->Ival=step(this->LNode->Ival);
     */

     //else if(this->Type== "cbrt" ) Contract0Interface('', this->Ival,LNode->Ival,-1);
     //else if(this->Type== "root" ) Contract0Interface('', this->Ival,LNode->Ival,-1);
     //else if(this->Type== "acos" ) Contract0Interface('', this->Ival,LNode->Ival,-1);
     //else if(this->Type== "asin" ) Contract0Interface('', this->Ival,LNode->Ival,-1);
     //else if(this->Type== "log10" ) Contract0Interface('', this->Ival,LNode->Ival,-1);
     //else if(this->Type== "sign" ) Contract0Interface('', this->Ival,LNode->Ival,-1);
     //else if(this->Type== "step" ) Contract0Interface('', this->Ival,LNode->Ival,-1);



