//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "DadesTaula.h"
#include <stdio.h>
#include <stdlib.h>
#include "Unit1.h"
#include "DadesGlucosa.h"
#include "DadesOptimitzacio.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

void GuardarInformeResum(AnsiString);
Graphics::TBitmap *LedVerdBmp;
Graphics::TBitmap *LedVermellBmp;
Graphics::TBitmap *LedTaronjaBmp;

TF_Dades *F_Dades;
//---------------------------------------------------------------------------
__fastcall TF_Dades::TF_Dades(TComponent* Owner)
        : TForm(Owner)
{
        F_Dades->WindowState= wsMaximized;

        //Carrega el bitmap del led verd rectangular
        LedVerdBmp = new Graphics::TBitmap;
        LedVerdBmp->LoadFromFile("LedRecVerd.bmp");
        //Carrega el bitmap del led vermell rectangular
        LedVermellBmp = new Graphics::TBitmap;
        LedVermellBmp->LoadFromFile("LedRecVermell.bmp");
        //Carrega el bitmap del led vermell rectangular
        LedTaronjaBmp=new Graphics::TBitmap;
        LedTaronjaBmp->LoadFromFile("LedRecTaronja.bmp");
}

//---------------------------------------------------------------------------
void __fastcall TF_Dades::Btn2_TancarClick(TObject *Sender)
{
        Close();
}

//---------------------------------------------------------------------------
// Funci que crea documents .txt amb els resultats dels experiments
void GuardarInformeResum(AnsiString PathInformer)
{
        FILE *TaulaInforme;
        TaulaInforme= fopen(PathInformer.c_str(), "w");
        for (int i=0;i<61;i++)
        {
                for (int j=0;j<31;j++)
                {
                        if(j<30)
                        {
                                fprintf(TaulaInforme, "%s", F_Dades->SG_TaulaResmExperiment->Cells[j][i]+"\t");
                        }
                        else
                        {
                                fprintf(TaulaInforme, "%s", F_Dades->SG_TaulaResmExperiment->Cells[j][i]+"\n");
                        }
                }
        }
        fclose(TaulaInforme);
}

//---------------------------------------------------------------------------
void __fastcall TF_Dades::Btn2_GuardarClick(TObject *Sender)
{
        if (SaveDialog1->Execute())
        {
                AnsiString PathInforme = SaveDialog1->FileName;
                GuardarInformeResum(PathInforme);
        }
}
//---------------------------------------------------------------------------

void __fastcall TF_Dades::Btn_VisualGlucosaClick(TObject *Sender)
{
        F_GlucosaSang->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TF_Dades::Btn_VisualOptClick(TObject *Sender)
{
        if (F_Optimitzacio->SG_Optimitzacio->ColCount==4)
        {
                F_Optimitzacio->Width=445;
        }
        else
        {
                F_Optimitzacio->Width=345;
        }
        F_Optimitzacio->Show();
}
//---------------------------------------------------------------------------

void __fastcall TF_Dades::SG_TaulaResmExperimentDrawCell(TObject *Sender,
      int Col, int Row, TRect &Rect, TGridDrawState State)
{
        //Dibuixa els semfors
        //No s definitiu, caldria saber sota quines condicions hauria d'aparixer el semfor
        if ( Col != 4 || Row == 0) return;
        if (Row<55)
        {
                if (10>F_Dades->SG_TaulaResmExperiment->Cells[4][Row].ToDouble()>0 || 10>F_Dades->SG_TaulaResmExperiment->Cells[5][Row].ToDouble()>0)
                {
                        F_Dades->SG_TaulaResmExperiment->Canvas->Draw(Rect.Left, Rect.Top,LedTaronjaBmp);
                }
                if (F_Dades->SG_TaulaResmExperiment->Cells[4][Row].ToDouble()>10 && F_Dades->SG_TaulaResmExperiment->Cells[5][Row].ToDouble()>10)
                {
                        F_Dades->SG_TaulaResmExperiment->Canvas->Draw(Rect.Left, Rect.Top,LedVermellBmp);
                }
                if (F_Dades->SG_TaulaResmExperiment->Cells[4][Row].ToDouble()==0 && F_Dades->SG_TaulaResmExperiment->Cells[5][Row].ToDouble()==0)
                {
                        F_Dades->SG_TaulaResmExperiment->Canvas->Draw( Rect.Left, Rect.Top, LedVerdBmp);
                }
        }
}
//---------------------------------------------------------------------------


