/**************************************************************************
* Eina de detecci d'hipos i generaci d'un ndex de risc                 *
* ltima data de modificaci 18/05/2015                                   *
*    .**......,*\                                              *
*    \   MiceLab   2015    \                                             *
*     \.**....,..,\                                            *
*      \                                                                  *
*   ()/                                                                  *
*   /|                                                                    *
*   / \   Aniol Gallego Soler   Joan Oliva Gratacos                       *
*                                                                         *
**************************************************************************/

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include <stdio.h>
#include <stdlib.h>
#include "DadesTaula.h"
#include <math.h>
#include "ivaldb.h"
#include "DadesGlucosa.h"
#include "DadesOptimitzacio.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TF_Principal *F_Principal;
                          
double MatriuExperiment[12][54]; //Cont les dades llegides del fitxer obtingut de les simulacions del labview
AnsiString VecLletresMenjars[54]; //Cont el tipus de menjar A,B,C,D,E,F que es fa servir a l'experiment
AnsiString MatriuResultat[31][54]; //Cont totes les dades resultants d'executar el programa i les prvies
AnsiString MatriuResultatGlucosa[162][300];// Cont els valors de glucosa per graficar
double VecPacients[12]; //Cont les dades del pacient utilitzat en l'actual simulaci
double MatriuGlucosaExp[54][300]; //Cont les dades de glucosa amb els resultats reals
double VecThresholdIR[20]; //Cont els valors dels thresholds dels IR
AnsiString StrVecThresholdIR[20]; //Cont els valors dels thresholds dels IR en string
double MatriuRoc[20][6]; //Cont els valors dels VN,FP,FN,VP
int VecAmpleColumna[31]={80,80,60,60,40,110,110,100,110,90,90,90,90,90,90,90,90,90,90,90,90,90,90,90,90,90,90,125,125,125,125}; //Cont els amples de columna de la taula de resultats
AnsiString VecCapTaulaGlucosa[4]={"Temps (s)", "Mn. Glucosa Sim. n", "Mx. Glucosa Sim. n", "Glucosa pacient exp."}; //Cont les capaleres de la taula de glucosa del pacient
AnsiString VecNomsCapcaleresTG[12]={"N experiment","Classe Menjar","I Bolus","CHO","Hipo?","rea hipo real","rea hipo simulada","Threshold ","rea hipo m.","rea hipo s.","rea hiper m.", "rea hiper s."};
AnsiString VecNomsRoc[6]={"VN","FP","FN","VP","Sens.","1-Espec."};
double VecPonderacions[5]={0.5,0.75,1,1.25,1.5}; //vector que cont les ponderacions segons el temps de les hipers
double MatriuParamOpt[7][391]; //Cont els valors de Tmax,Si i J (rea reduida)
AnsiString VecCapOptimitzacio[5]={"Tmax","Mitjana Si","Sumatori d'rees","J Esp.","J Sens."};
double MatriuPonOptim[3][3]={0,1,2,1,0,1,2,1,0};    //Matriu qualitativa Petit, Mitj, Gran {P,M,G,M,P,M,G,M,P} amb els valors que s'han decidit

void CParametresPacient(int);
int CParametresExperiments(AnsiString);
void CParametresMenjarsMixtes (AnsiString);
void BolDadesTaules();
void abs_insulina_hovorka(double ,ivalDb, ivalDb, ivalDb);
void AbsRAHovorka(ivalDb,double,double,int,ivalDb);
void ModEndogenBergman(ivalDb ,ivalDb, ivalDb,double, int,ivalDb ,double ,double , ivalDb);
void CalcAreesIRisc(int);
void CalcThrIR();
void Optimitzacio(double,double,int,double,double,double);
void ClassificarVal(double,double,int,int);

int DadesPacientCarregades=0,DadesExperimentCarregades=0,DadesGlucosaCarregades=0; // Variables que comproven que les dades han estat carregades correctament

int NombreExperiments=54,QuantitatPacients=10,TempsSimulacio=300;  // Cont la quantitat d'experiments per prova,temps de simulaci,nombre de pacient que cont el fitxer de pacients

int NumPacient;

/* u: administraci d'insulina rpida   s1:insulina al compartiment S1 a l'instant anterior
s2: insulina al compartiment S2 a l'instant anterior   Ui:insulina absorbida*/
double u;
ivalDb s1,s2, S1, S2,Ui;

//Variables globals clcul IR
double AHiperS=0,AHiperM=0,AHipoS=0,AHipoM=0;     //Variables on es va acomulant l'rea del la corba de glucosa
double ThrHipoM=70,ThrHipoS=40,ThrHiperM=150,ThrHiperS=250;   //Threshold de hipo moderada,severa,hiper moderada i severa

//Variables globals model endgen de Bergman
ivalDb gBergman[300];
double IncertesaS=30,IncertesaG=7,IncertesaTmi=0,IncertesaHovorka=5; //incertesa del parmetre Si del model de Bergman,incertesa del parmetre glucosa bassal del model de Bergman i el tmi de Hovorka
ivalDb I[301];              //Vector d'insulina en plasma
ivalDb X[301];              //Vector d'insulina remota
ivalDb G[301];              //Vector de glucosa en plasma

int IntClasseMenjar;
double h=1;   //Variable que cont el valor del temps de mostreig (1min)

//Continguts de les columnes;
int ColNExp=0,ColClasseMenjar=1, ColIbolus=2,ColCHO=3,ColHipo=4,ColIREdu=5,ColIR=6,ColAHipoM=27,ColAHipoS=28,ColAHiperM=29,ColAHiperS=30,ColThres=7;
int VN=0,FP=1,FN=2,VP=3,S=4,E=5; //Columnes per la MatriuRoc

int ModeCalcul=0; //Permet fer clcul amb optimitzaci o amb valors puntuals
int ModeOptimitzacio; //Cont el valor de l'operaci per optimitzar

//---------------------------------------------------------------------------
__fastcall TF_Principal::TF_Principal(TComponent* Owner)
        : TForm(Owner)
{
        if (DadesPacientCarregades==1 && DadesExperimentCarregades==1 && DadesGlucosaCarregades==1)
        {
                F_Principal->Txt_InfoUsuari->Text="CARREGADES DADES DEL PACIENT " + IntToStr(NumPacient);
                F_Principal->Btn_Visualitzacio->Enabled=1;
        }
        else
        {
                F_Principal->Txt_InfoUsuari->Text="NO HI HA DADES CARREGADES";
                F_Principal->Btn_Visualitzacio->Enabled=0;
        }
        TB_Sens->Text="1,0";
        TB_Tmax->Text="35,0";
        RB_Optimitzar->Checked=1;
}
//---------------------------------------------------------------------------

//Carrega els parmetres del model de pacient utilitzat a l'array VecPacient
 void CParametresPacient (int NumPacient)
{
        char ChVecPacient[11];
        FILE *fileParametresPacients;
        AnsiString fitxerTxtPacients= "parametros_bergman_ajustados.txt";
        fileParametresPacients= fopen(fitxerTxtPacients.c_str(),"r");
        if (fileParametresPacients == NULL){
                ShowMessage("No s'ha trobat l'arxiu de dades de pacients");
        }
        else
        {
                for (int i =0; i<12; i++) //Es recorren els 11 parmetres
                {
                        for (int j=0; j<QuantitatPacients+1; j++)  //Es recorren els 10 pacients i la columna de capaleres
                        {
                                long lenght = ftell(fileParametresPacients);
                                fseek(fileParametresPacients, lenght, SEEK_SET);
                                fscanf(fileParametresPacients, "%s", ChVecPacient);
                                if (j==NumPacient && i>0)  //Es seleccionen noms les dades del pacient que estem treballant
                                {
                                        VecPacients[i-1] = atof(ChVecPacient);
                                }
                        }
                }
                DadesPacientCarregades=1;
                fclose(fileParametresPacients);
        }
}
//---------------------------------------------------------------------------
//Carrega els parmetres de l'experiment a la matriu MatriuExperiment
int CParametresExperiments(AnsiString PathExperiment)
{
        char vecExperiment[100];
        int NumeroPacient;
        FILE *fileParametresExperiment;
        fileParametresExperiment= fopen(PathExperiment.c_str(),"r");
        if (fileParametresExperiment == NULL){
                ShowMessage("No s'ha trobat arxiu de dades de l'experiment");
        }
        else
        {
                for (int i=0; i<NombreExperiments+1; i++) //Es recorren 54 files + 1 de capaleres.
                {
                        for (int j=0; j<12; j++)  //Es recorren 11 columnes
                        {
                                long lenght = ftell(fileParametresExperiment);
                                fseek(fileParametresExperiment, lenght, SEEK_SET);
                                fscanf(fileParametresExperiment, "%s", vecExperiment);
                                if (i>0) //La primera fila no es guarda (fila d'encapalaments)
                                {
                                        if (j==2) // Si la columna s la 2 (tipus de menjar) es guarda la lletra de la classe de menjar a la matriu
                                        {
                                                VecLletresMenjars[i-1]=vecExperiment;
                                        }
                                        else
                                        {
                                                MatriuExperiment[j][i-1] = atof(vecExperiment);
                                        }
                                }
                        }
                }
                NumeroPacient = MatriuExperiment[1][0];
                DadesExperimentCarregades=1;
                fclose(fileParametresExperiment);
        }
        return NumeroPacient;
}
//---------------------------------------------------------------------------
//Carrega l'evoluci de la glucosa del pacient real a la matriu MatriuGlucosaExp
void CParametresGlucosa(AnsiString PathGlucosa)
{
        char vecGlucosa[100];
        FILE *fileParametresGlucosa;
        fileParametresGlucosa= fopen(PathGlucosa.c_str(),"r");
        if (fileParametresGlucosa == NULL){
                ShowMessage("No s'ha trobat arxiu de dades de glucosa");
        }
        else
        {
                for (int i =0; i<TempsSimulacio; i++) //Es recorren 300 files.
                {
                        for (int j=0; j<NombreExperiments; j++)  //Es recorren 54 columnes
                        {
                                long lenght = ftell(fileParametresGlucosa);
                                fseek(fileParametresGlucosa, lenght, SEEK_SET);
                                fscanf(fileParametresGlucosa, "%s", vecGlucosa);
                                MatriuGlucosaExp[j][i] = atof(vecGlucosa);
                                DadesGlucosaCarregades=1;
                        }
                }
        }
        fclose(fileParametresGlucosa);
}

//---------------------------------------------------------------------------
// Executa l'algoritme d'Hovorka d'absorci d'insulina
void AbsInsulinaHovorka(double u,ivalDb s1, ivalDb s2, ivalDb tmi) //p 58 Tesis Maira
{
        S1=s1+h*(u-Du(s1)/tmi);        //S1 Absorci d'insulina de curta acci. h=1 interval de temps
        S2=s2+h/tmi*(s1-Du(s2));  //S2 Absorcin de insulina de corta accin administrada subcutneamente
        Ui=s2/tmi;              // Absorcin de Insulina con Hovorka
}

//---------------------------------------------------------------------------
// Executa l'algoritme d'Hovorka d'entrada de RA
void AbsRAHovorka(ivalDb D,double TmaxG,double AG, int t,ivalDb *RA) //p 55 Tesis Maira
{
        *RA=(D*AG*t*exp(-t/TmaxG))/pow(TmaxG,2.0);
}

//---------------------------------------------------------------------------
//Executa l'algoritme del model endogen de Bergman
void ModEndogenBergman(ivalDb Ui1,ivalDb RA, ivalDb Vg,double n, int i,ivalDb p1,double p2,double p4, ivalDb Si)
{
        G[i+1]=p1*h*(G[0]-Du(G[i]))+G[i]*(1-X[i]*h)+(h*RA/Vg);    // Concentraci de glucosa en plasma
        X[i+1]=X[i]*(1-p2*h)+p2*Si*h*(I[i]-I[0]);              // Concentraci d'insulina en el compartiment remot
        I[i+1]=I[i]*(1-n*h)+(p4*Ui1*h);                     // Concentraci d'insulina en plasma
}
//---------------------------------------------------------------------------
// Calcula les rees de les corbes de glucosa aproximant-la per trapezis
void CalcAreesIRisc(int i){
        double HmAct=0;
        double HsAct=0;
        double hmAct=0;
        double hsAct=0;
        if (G[i+1].Sup>=ThrHiperM && G[i+1].Sup<ThrHiperS)
        {
                HmAct= h*(G[i].Sup+G[i+1].Sup)/2.0 - ThrHiperM*h;    //Clcul de l'rea actual de la hiper moderada
        }
        else
        {
                if (G[i+1].Sup>=ThrHiperS)
                {
                        HsAct= h*(G[i].Sup+G[i+1].Sup)/2.0 - ThrHiperS*h;    //Clcul de l'rea actual de la hiper severa
                        HmAct=(ThrHiperS-ThrHiperM)*h;                      //Suma del rectangle d'hiper moderada mentre hi ha hiper severa
                }
        }
        if (G[i+1].Inf<=ThrHipoM && G[i+1].Inf>ThrHipoS && ((G[i].Inf+G[i+1].Inf)/2.0)<=70 )
        {
                hmAct= ThrHipoM*h-h*(G[i].Inf+G[i+1].Inf)/2.0;      //Clcul de l'rea actual de la hipo moderada
        }
         else
        {
                if (G[i+1].Inf<=ThrHipoS && ((G[i].Inf+G[i+1].Inf)/2.0)<=70 )
                {
                        hsAct= ThrHipoS*h-h*(G[i].Inf+G[i+1].Inf)/2.0;      //Clcul de l'rea actual de la hipo severa
                        hmAct= (ThrHipoM-ThrHipoS)*h;                       //Suma del rectangle d'hipo moderada mentre hi ha hipo severa
                }
        }
        //Es ponderen les rees de les hipers segons el pes en el temps. Es normalitzen totes les rees
        AHiperM= AHiperM+(HmAct*VecPonderacions[int(floor(i/60))]/(ThrHiperS-ThrHiperM));
        AHiperS= AHiperS+(HsAct*VecPonderacions[int(floor(i/60))]/(ThrHiperS-ThrHiperM));
        AHipoM= AHipoM+hmAct/(ThrHipoM-ThrHipoS);
        AHipoS= AHipoS+hsAct/(ThrHipoM-ThrHipoS);
}
//---------------------------------------------------------------------------
//Classifica les rees segons la mida
void  ClassificarVal(double AExpLV,double ASim,int *Ind1,int *Ind2)
{
        if (AExpLV>=10)
        {
                *Ind1=2;
        }
        else
        {
                if (AExpLV<3)
                {
                        *Ind1=0;
                }
                else
                {
                        *Ind1=1;
                }
        }
        if (ASim>=10)
        {
                *Ind2=2;
        }
        else
        {
                if (ASim<3)
                {
                        *Ind2=0;
                }
                else
                {
                        *Ind2=1;
                }
        }
}
//---------------------------------------------------------------------------
//Executa el mtode d'optimitzaci
void Optimitzacio(double AreaExpLV,double AreaSim ,int numOptimitzacio,double *SumAreesPon, double *JEsp, double *JSens)
{
        double ValIntermig=0;
                switch  (numOptimitzacio)
                {
                        case 0:
                                if (AreaExpLV>AreaSim)       //L'rea real s ms gran que la simulada
                                {
                                        *JEsp=*JEsp*(AreaExpLV-AreaSim);
                                }
                                else
                                {
                                        *JSens=*JSens*(AreaSim-AreaExpLV);
                                }
                                break;
                        case 1:
                                ValIntermig=pow(AreaExpLV,2.0)-pow(AreaSim,2.0);
                                if (ValIntermig<0)
                                {
                                        ValIntermig=ValIntermig*-1;
                                }

                                ValIntermig=sqrt(ValIntermig);
                                break;
                        case 2:
                                int Ind1, Ind2;
                                ClassificarVal(AreaExpLV,AreaSim,&Ind1,&Ind2);
                                if (AreaExpLV>AreaSim)       //L'rea real s ms gran que la simulada
                                {
                                        *JEsp= *JEsp+MatriuPonOptim[Ind1][Ind2];
                                }
                                else
                                {
                                        *JSens=*JSens+MatriuPonOptim[Ind1][Ind2];
                                }
                                break;
                        case 3:
                                ValIntermig=pow(AreaExpLV,2.0)-pow(AreaSim,2.0);
                                if (ValIntermig<0)
                                {
                                        ValIntermig=ValIntermig*-1;
                                }
                                if (ValIntermig>=1)
                                {
                                        ValIntermig=log10(sqrt(ValIntermig));
                                }
                                else
                                {
                                        ValIntermig=0;
                                }
                                break;
                }
        *SumAreesPon=*SumAreesPon+ValIntermig;
        }
//}

//---------------------------------------------------------------------------
//Funci que determina quins thresholds s'han d'utilitzar, tamb fa els clculs per dibuixar la corba roc.
void CalcThrIR()
{
        double ValorMaxThr=10.0;  //Threshold mxim de 10 en el cas que no hi hagi hipos
        double ValorMinThr=1.0;
        for (int m=0;m<53;m++)
        {
                if (ValorMaxThr<MatriuResultat[ColIR][m])
                {
                        ValorMaxThr= MatriuResultat[ColIR][m].ToDouble();  //Determinem el mxim threshold que necessitarem
                }
        }
        double VecThresholdIR[20];
        VecThresholdIR[0]=log10(ValorMinThr);
        VecThresholdIR[19]=log10(ValorMaxThr);
        for (int p=1;p<19;p++)
        {
                VecThresholdIR[p]=(VecThresholdIR[19]-VecThresholdIR[0])/20.0*((double)p); //Es fan 20 thresholds amb escala logartmica
        }
        for (int p=0;p<20;p++)
        {
                VecThresholdIR[p]= pow(10.0, VecThresholdIR[p]);  //es passen els thresholds d'escala logartmica a decimal
                StrVecThresholdIR[p].sprintf("%.3f",VecThresholdIR[p]); //Es preparen les capaleres pels IR
        }
        for (int thre=0;thre<20;thre++)
        {
                for (int j=0;j<NombreExperiments;j++)
                {
                       if(MatriuResultat[ColIR][j].ToDouble()<=VecThresholdIR[thre])
                       {
                                MatriuResultat[ColThres+thre][j]=0; //NO HI HA PREDICCI D'HIPO
                                if (MatriuResultat[ColHipo][j]=="0")
                                {
                                        MatriuRoc[thre][VN]=MatriuRoc[thre][VN]+1;      //Realment no hi ha hipo i a la predicci no hi ha hipo
                                }
                                else
                                {
                                        MatriuRoc[thre][FN]=MatriuRoc[thre][FN]+1;      //Realment hi ha hipo i a la predicci no hi ha hipo
                                }
                       }
                       else
                       {
                                MatriuResultat[ColThres+thre][j]=1; //HI HA PREDICCI D'HIPO
                                if (MatriuResultat[ColHipo][j]=="0")
                                {
                                        MatriuRoc[thre][FP]=MatriuRoc[thre][FP]+1;      //Realment no hi ha hipo i a la predicci hi ha hipo
                                }
                                else
                                {
                                        MatriuRoc[thre][VP]=MatriuRoc[thre][VP]+1;      //Realment hi ha hipo i a la predicci hi ha hipo
                                }
                        }
                }
        }

}
//---------------------------------------------------------------------------
//Funci que carrega les dades a la taula per visualitzar-les
void BolDadesTaules()
{
        for (int i=0; i<7;i++)
        {
                F_Dades->SG_TaulaResmExperiment->Cells[i][0] =VecNomsCapcaleresTG[i];  //s'escriuen les 6 primeres capaleres
        }
        for (int i=7;i<27;i++)
        {
                F_Dades->SG_TaulaResmExperiment->Cells[i][0] =VecNomsCapcaleresTG[7]+StrVecThresholdIR[i-7];  //s'escriuen les 20 capaleres de threshold
        }
        for (int i=27;i<31;i++)
        {
                F_Dades->SG_TaulaResmExperiment->Cells[i][0] =VecNomsCapcaleresTG[i-19]; //s'escriuen les ltimes capaleres fins a 31
        }
        for (int i =0; i<NombreExperiments; i++)
        {
                for (int j=0;j<31;j++)
                {
                        F_Dades->SG_TaulaResmExperiment->ColWidths[j]=VecAmpleColumna[j]; //s'estableixen els amples de columna
                        F_Dades->SG_TaulaResmExperiment->Cells[j][i+1] =MatriuResultat[j][i];  //s'escriuen els resultats obtinguts
                }
        }
        for (int i=0;i<20;i++) // Es construeix la part de la taula amb les dades per fer la corba ROC
        {
                for (int j=0; j<6;j++)
                {
                        F_Dades->SG_TaulaResmExperiment->Cells[6][55+j]=VecNomsRoc[j];
                        F_Dades->SG_TaulaResmExperiment->Cells[7+i][55+j]=MatriuRoc[i][j];
                }
        }
        for (int i=0;i<163;i=i+3)// Es construeix la taula de la glucosa del pacient
        {
                 if (i==0)
                {
                        F_GlucosaSang->SG_GlucosaSang->Cells[0][0]= VecCapTaulaGlucosa[0];
                }
                else
                {
                        F_GlucosaSang->SG_GlucosaSang->Cells[i-2][0]= VecCapTaulaGlucosa[1]+i/3;
                        F_GlucosaSang->SG_GlucosaSang->Cells[i-1][0]= VecCapTaulaGlucosa[2]+i/3;
                        F_GlucosaSang->SG_GlucosaSang->Cells[i][0]= VecCapTaulaGlucosa[3]+i/3;
                }
        }
        //Imprimir les dades de glucosa
        for (int i=0;i<163;i++)
        {
                for (int j=1; j<301; j++)
                {
                        if (i==0)
                        {
                                F_GlucosaSang->SG_GlucosaSang->Cells[0][j]=j-1;
                        }
                        if (i>0)
                        {
                                F_GlucosaSang->SG_GlucosaSang->Cells[i][j]=MatriuResultatGlucosa[i-1][j-1];
                        }
                }
        }
        //Imprimir les dades de l'optimitzaci de les corbes
        if (ModeCalcul==0)
        {
                F_Dades->Btn_VisualOpt->Enabled=1;
                if (ModeOptimitzacio==0 || ModeOptimitzacio==2)
                {
                        F_Optimitzacio->SG_Optimitzacio->ColCount=4;
                }
                else
                {
                        F_Optimitzacio->SG_Optimitzacio->ColCount=3;

                }
                for (int i=0; i<391; i++)
                {
                        if (ModeOptimitzacio==0 || ModeOptimitzacio==2)
                        {
                                if (i==0)
                                {
                                        F_Optimitzacio->SG_Optimitzacio->Cells[0][i]= VecCapOptimitzacio[0];
                                        F_Optimitzacio->SG_Optimitzacio->Cells[1][i]= VecCapOptimitzacio[1];
                                        F_Optimitzacio->SG_Optimitzacio->Cells[2][i]= VecCapOptimitzacio[3];
                                        F_Optimitzacio->SG_Optimitzacio->Cells[3][i]= VecCapOptimitzacio[4];
                                }
                                F_Optimitzacio->SG_Optimitzacio->Cells[0][i+1]= MatriuParamOpt[0][i];
                                F_Optimitzacio->SG_Optimitzacio->Cells[1][i+1]= MatriuParamOpt[1][i];
                                F_Optimitzacio->SG_Optimitzacio->Cells[2][i+1]= MatriuParamOpt[5][i];
                                F_Optimitzacio->SG_Optimitzacio->Cells[3][i+1]= MatriuParamOpt[6][i];
                        }
                        else
                        {
                                if (i==0)
                                {
                                        F_Optimitzacio->SG_Optimitzacio->Cells[0][i]= VecCapOptimitzacio[0];
                                        F_Optimitzacio->SG_Optimitzacio->Cells[1][i]= VecCapOptimitzacio[1];
                                        F_Optimitzacio->SG_Optimitzacio->Cells[2][i]= VecCapOptimitzacio[2];
                                }
                                F_Optimitzacio->SG_Optimitzacio->Cells[0][i+1]= MatriuParamOpt[0][i];
                                F_Optimitzacio->SG_Optimitzacio->Cells[1][i+1]= MatriuParamOpt[1][i];
                                F_Optimitzacio->SG_Optimitzacio->Cells[2][i+1]= MatriuParamOpt[2][i];
                        }
                }
        }
        else
        {
                F_Dades->Btn_VisualOpt->Enabled=0;
        }
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//Esdeveniment que genera tots els resultats de l'experiment i permet la seva visualitzaci
void __fastcall TF_Principal::Btn_VisualitzacioClick(TObject *Sender)
{
//DECLARACI DE VARIABLES

//Variables infusi insulina Hovorka 04
u=0; s1=0; s2=0; Ui=0; S1=0; S2=0;
double QuantInsulina;
//double ke=0.138;        // Eliminaci d'insulina en plasma (min^-1)
double Ub;             // Insulina bassal
double TempsInfusio=20.0;  // Temps d'infusi de la insulina (min)
ivalDb tmi=ivalDb(55,55); //temps d'absorci insulina mnim
int LoopSens;

//Variables i inicialitzaci Model Endgen Bergman
ivalDb p1= ivalDb((VecPacients[0]*(1-12/100.0)),(VecPacients[0]*(1+12/100.0)));// min^-1 Taxa constant insulnica independent de glucosa en msuls, fetge i teixit edips
double p2=VecPacients[1]; // min^-1 Taxa de dismiuci del consum de glucosa en el teixit
//double p3=VecPacients[2]; L/mU min^2 Taxa constant de l'increment insulinicodependent de la capacitat de consum en el teixit
double p4=VecPacients[3]; // 1/ml Volum de distribuci d'insulina
double n=VecPacients[4];  // 1/min Desaparci d'insulina
ivalDb Si;  //p3/p2
ivalDb Vg=ivalDb(VecPacients[6]); //dl Espai de distribuci de la glucosa

//Variables clcul IR
double HmAct; //hiper moderada
double HsAct; //hiper severa
double hmAct; //hipo moderada
double hsAct; //hipo severa
double IR;
double AG=0.9; //Tan per 1 d'absorci de glucosa

//Variables Hovorka model buidat gstric
ivalDb RA;
double TmaxG;
int TRapid=30;
int TLent=30;

double sens; //sensibilitat corba Roc
double espec; //1-especificitat corba Roc

double SumAreesPon=0,JEsp=0,JSens=0; //Sumatori de les rees

int LoopTmaxG=18; //nombre de repeticions pel loop de tmaxG+1

RG_TipusOptimitzacio->Enabled=false;    //S'inhabiliten els radio buttons
RB_Optimitzar->Enabled=false;
RB_ValorsPuntuals->Enabled=false;

if (ModeCalcul==1) //En el cas de clcul puntual, s'assignen els valors de les caselles a les variables corresponents
{
        LoopTmaxG=1;
        LoopSens=1;
        try
        {
                TmaxG=TB_Tmax->Text.ToDouble();
                Si=ivalDb((TB_Sens->Text.ToDouble()*10E-05*(1-IncertesaS/100.0)),(TB_Sens->Text.ToDouble()*10E-05*(1+IncertesaS/100.0)));
        }
        catch(EConvertError &err)
        {
                ShowMessage("Els valors entrats no sn correctes.");
                TB_Tmax->Text="40,0";
                TB_Sens->Text="1,0";
                TmaxG= 40.0;
        }
}

ModeOptimitzacio=RG_TipusOptimitzacio->ItemIndex;   //Es llegeix quin mode d'optimitzaci s'ha seleccionat
Btn_Visualitzacio->Enabled=false;

////////////////////////LOOP D'OPTIMITZACI/////////////////////////////////////////////////////////////
for (int k=0; k<LoopTmaxG;k++) //Loop del tmax. 8 repeticions + 1 pel resultat maximitzat
{
        if (k<LoopTmaxG-1 && ModeCalcul==0)
        {
                LoopSens=23;
        }
        if (k==LoopTmaxG-1 && ModeCalcul==0)
        {
                LoopSens=1;
        }
        for (int l=0; l<LoopSens;l++) //Loop de la sensibilitat. 13 repeticions + 1 pel resultat maximitzat
        {
                if (LoopSens>1 && ModeCalcul==0)
                {
                        
                        Si=ivalDb((VecPacients[5]*(0.1+(l*0.1))*(1-IncertesaS/100.0)),(VecPacients[5]*(0.1+(l*0.1))*(1+IncertesaS/100.0)));
                }
                SumAreesPon=0;
                JEsp=0;
                JSens=0;
                for (int j=0; j<NombreExperiments; j++) //nombre d'experiments (54 dies)
                {
                        if (LoopSens>1 && ModeCalcul==0)
                        {
                        if (VecLletresMenjars[j]== "R") //Es selecciona el TmaxG segons la velocitat del menjar i s'hi aplica l'increment de l'optimitzaci
                        {
                                TmaxG= TRapid+5*k;
                        }
                        else
                        {
                                TmaxG= TLent+5*k;
                        }
                        }

                        //Inicialitzacions Model d'absorci d'insulina d'Hovorka
                        Ub=MatriuExperiment[5][j];   //Flux de Insulina Basal en mU/min
                        double QuantInsulina= MatriuExperiment[3][j];
                        s1=Ub*tmi; //Inicialitzaci de s1
                        s2=s1;     //Inicialitzaci de s2
                        //Inicialitzacions Model endgen Bergman
                        X[0]=0;              //Insulina remota inicial
                        I[0]=Ub*p4/n; //Insulina en plasma inicial en mU/ml
                        G[0]=ivalDb((MatriuExperiment[6][j]*(1-IncertesaG/100.0)),(MatriuExperiment[6][j]*(1+IncertesaG/100.0)));//Concentraci de glucosa en plasma inicial
                        AHiperS=0,AHiperM=0,AHipoS=0,AHipoM=0;     //Reset rees corba glucosa

                        for (int i=0; i<TempsSimulacio; i++)      //300 minuts de simulaci
                        {
//CLCUL DE LA INFUSI D'INSULINA (HOVORKA 04) p58 Tesis Maira
                                if ((i>=0)&&(i<=TempsInfusio))
                                {
                                        u =Ub+(QuantInsulina*1000.0)/TempsInfusio; // Es passen les unitats d'insulina a mu d'insulina/min^-1
                                        AbsInsulinaHovorka(u,s1,s2,tmi);
                                }
                                else
                                {
                                        u=Ub;   // Noms afecta la insulina bassal
                                        AbsInsulinaHovorka(u,s1,s2,tmi);
                                }
                                s1=S1;
                                s2=S2;

//MODEL D'ABSORCI DE RA D'HOVORKA
                                ivalDb D= ivalDb((MatriuExperiment[4][j]*1000*(1-IncertesaHovorka/100.0)),(MatriuExperiment[4][j]*1000*(1+IncertesaHovorka/100.0)));
                                AbsRAHovorka(D,TmaxG,AG,i,&RA);
//CLCUL AMB EL MODEL ENDGEN DE BERGMAN p79 Tesis Maira
                                ModEndogenBergman(Ui,RA,Vg,n,i,p1,p2,p4,Si);
//CLCUL DE LES REES PER L'NDEX DE RISC p109 Tesis Maira
                                CalcAreesIRisc(i);
//Es guarden els resultats que s'obtenen de glucosa noms quan hi ha la iteraci que interessa
                                if ((LoopTmaxG==1 || k==LoopTmaxG-1) && LoopSens==1)
                                {
                                        /*MatriuResultatGlucosa[j*3][i]= Ui.Inf;
                                        MatriuResultatGlucosa[j*3+1][i]=Ui.Sup;*/
                                        MatriuResultatGlucosa[j*3][i]= G[i].Inf;
                                        MatriuResultatGlucosa[j*3+1][i]=G[i].Sup;
                                        /*MatriuResultatGlucosa[j*3][i]= RA.Inf;
                                        MatriuResultatGlucosa[j*3+1][i]=RA.Sup;*/
                                        MatriuResultatGlucosa[j*3+2][i]=MatriuGlucosaExp[j][i];
                                }
                        }       //TANCA EL LOOP DE 300MIN
////////////////////////////////////////////////////////////////////////////////
        //Resultats a la matriu. Noms es carreguen quan hi ha la iteraci que interessa
                        if ((LoopTmaxG==1 || k==LoopTmaxG-1) && LoopSens==1)
                        {
                                MatriuResultat[ColNExp][j]=MatriuExperiment[0][j];
                                MatriuResultat[ColClasseMenjar][j]=VecLletresMenjars[j];
                                MatriuResultat[ColIbolus][j]=MatriuExperiment[3][j];
                                MatriuResultat[ColCHO][j]=MatriuExperiment[4][j];
                                MatriuResultat[ColHipo][j]=MatriuExperiment[7][j];
                                MatriuResultat[ColIR][j]=AHipoS+AHipoM;
                                MatriuResultat[ColIREdu][j]=MatriuExperiment[8][j]+MatriuExperiment[9][j];
                                MatriuResultat[ColAHipoM][j]= AHipoM;
                                MatriuResultat[ColAHipoS][j]= AHipoS;
                                MatriuResultat[ColAHiperM][j]= 0.0625*AHiperM;
                                MatriuResultat[ColAHiperS][j]= 0.25*AHiperS;
                        }
                        //Clcul dels parmetres per l'optimitzaci de les hipos
                        if (ModeCalcul==0) //Noms s'executa si estem en mode de optimitzaci
                        {
                                Optimitzacio(MatriuExperiment[8][j]+MatriuExperiment[9][j],AHipoS+AHipoM, ModeOptimitzacio,&SumAreesPon,&JEsp,&JSens);
                        }
                } //TANCA EL LOOP DE 54 DIES

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

                if (ModeCalcul==0) //Noms s'executa si estem en mode de normalitzaci
                {
                        if (k<LoopTmaxG-1) //Es guarden les deades que interessen
                        {
                                if (ModeOptimitzacio==0 || ModeOptimitzacio==2)
                                {
                                        MatriuParamOpt[0][k*23+l]=TmaxG;
                                        MatriuParamOpt[1][k*23+l]=(Si.Sup-Si.Inf)/2+Si.Inf;
                                        MatriuParamOpt[2][k*23+l]=(JEsp+JSens)/2;
                                        MatriuParamOpt[3][k*23+l]=Si.Inf;
                                        MatriuParamOpt[4][k*23+l]=Si.Sup;
                                        MatriuParamOpt[5][k*23+l]=JEsp;
                                        MatriuParamOpt[6][k*23+l]=JSens;
                                }
                                else
                                {
                                        MatriuParamOpt[0][k*23+l]=TmaxG;
                                        MatriuParamOpt[1][k*23+l]=(Si.Sup-Si.Inf)/2+Si.Inf;
                                        MatriuParamOpt[2][k*23+l]=SumAreesPon;
                                        MatriuParamOpt[3][k*23+l]=Si.Inf;
                                        MatriuParamOpt[4][k*23+l]=Si.Sup;
                                }
                        }
                        if (k==LoopTmaxG-2 && l==22) //Es busca el tmax i Si que optimitzen al mxim les corbes de glucosa quan s'ha acabat el recorregut
                        {
                                int ValCompt=0;
                                double AreaMinima=MatriuParamOpt[2][0];
                                        for (int i=1; i<391; i++)
                                        {
                                                if (AreaMinima>MatriuParamOpt[2][i])
                                                {
                                                        AreaMinima=MatriuParamOpt[2][i];
                                                        ValCompt=i;
                                                }
                                        }
//S'assignen els valors que permeten la mxima optimitzaci per extreure les dades en l'ltim loop
                                Si= ivalDb(MatriuParamOpt[3][ValCompt],MatriuParamOpt[4][ValCompt]);
                                TmaxG=MatriuParamOpt[0][ValCompt];
                        }
                }
                ProgressBar1->Position=k*23+l; //Es dibuixa el progrs a la progress bar
        } //TANCA EL LOOP DE Si
}//TANCA EL LOOP DE TmaxG

//Reset de la Matriu Roc:
        for (int i=0; i<20;i++)
        {
                for (int j=0; j<6;j++)
                {
                        MatriuRoc[i][j]=0;
                }
        }
//Clcul dels thresholds i preparatius per calcular els parmetres de la corba Roc
        CalcThrIR();
//Clcul dels parmetres per la corba Roc
        for (int thres=0; thres<20;thres++)
        {
                MatriuRoc[thres][S]=MatriuRoc[thres][VP]/(MatriuRoc[thres][VP]+MatriuRoc[thres][FN]);
                MatriuRoc[thres][E]=MatriuRoc[thres][FP]/(MatriuRoc[thres][FP]+MatriuRoc[thres][VN]);
        }
////////////////////////////////////////////////////////////////////////////////
        BolDadesTaules();
        Btn_Visualitzacio->Enabled=true;
        RG_TipusOptimitzacio->Enabled=true;
        RB_Optimitzar->Enabled=true;
        RB_ValorsPuntuals->Enabled=true;
        F_Dades->Caption="Resultats experiments pacient "+IntToStr(NumPacient)+" amb Si="+((Si.Sup-Si.Inf)/2+Si.Inf)+" i TmaxG="+TmaxG;
        F_Dades->ShowModal();
        ProgressBar1->Position=0; //Es reseteja el progrs a la progress bar
}
//---------------------------------------------------------------------------
//Funci que carrega les dades dels 4 fitxers de .txt i comprova si es carreguen correctament
void __fastcall TF_Principal::Carregardades1Click(TObject *Sender)
{
        if (OpenDialog1->Execute())
        {
                AnsiString PathExperiment = OpenDialog1->FileName;
                NumPacient = CParametresExperiments(PathExperiment);
                CParametresPacient(NumPacient);
        }
        if (OpenDialog2->Execute())
        {
                AnsiString PathGlucosa = OpenDialog2->FileName;
                CParametresGlucosa(PathGlucosa);
        }
        if (DadesPacientCarregades==1 && DadesExperimentCarregades==1 && DadesGlucosaCarregades==1)
        {
                F_Principal->Txt_InfoUsuari->Text="CARREGADES DADES DEL PACIENT " + IntToStr(NumPacient);
                F_Principal->Btn_Visualitzacio->Enabled=1;
        }
        else
        {
                F_Principal->Txt_InfoUsuari->Text="NO HI HA DADES CARREGADES";
                F_Principal->Btn_Visualitzacio->Enabled=0;
        }
}
//---------------------------------------------------------------------------

void __fastcall TF_Principal::Sortir1Click(TObject *Sender)
{
        Close();
}
//---------------------------------------------------------------------------
// Message Box amb l'ajuda pel programa
void __fastcall TF_Principal::Ajuda1Click(TObject *Sender)
{
        Application->MessageBox("1-Executar el programa.\n2-Carregar el fitxer de dades amb els resultats"
                        " de l'experiment i el fitxer amb les dades de glucosa.\nIMPORTANT:  el  programa"
                        "  carrega  3  fitxers  .txt,  els  dos  ja  mencionats i  el  'parametros_bergman_ajustados'"
                        ". Tots tres han d'estar  en el mateix path.\n"
                        "3-Seleccionar si es vol fer un clcul amb optimitzaci o puntual.\n"
                        "4-Seleccionar el procediment d'optimitzaci.\n"
                        "5-Generar i visualitzar els resultats.","Procediment d'utilitzaci del programa",
			NULL | NULL);
}
//---------------------------------------------------------------------------

void __fastcall TF_Principal::RB_OptimitzarClick(TObject *Sender)
{
        ModeCalcul=0; //Es selecciona per fer un clcul amb optimitzaci
        TB_Tmax->Enabled=0;    //Es deshabiliten els text box per entrar Tmax i Si
        TB_Sens->Enabled=0;
        TB_Tmax->Color=TColor(RGB(230, 230, 230));
        TB_Sens->Color=TColor(RGB(230, 230, 230));
        F_Principal->RG_TipusOptimitzacio->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TF_Principal::RB_ValorsPuntualsClick(TObject *Sender)
{
        ModeCalcul=1; //Es selecciona per fer un clcul sense optimitzaci
        TB_Tmax->Enabled=1;
        TB_Sens->Enabled=1;
        TB_Tmax->Color=TColor(RGB(255, 255, 255));
        TB_Sens->Color=TColor(RGB(255, 255, 255));
        F_Principal->RG_TipusOptimitzacio->Enabled=false;
}
//---------------------------------------------------------------------------



